<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*+NOPTRALIAS*>
<*CPU="PENTIUM"*>
<*-DOREORDER *>
<*+CHECKNIL *>
<*+CHECKINDEX*>
<*+CHECKSET*>
<* IF __GEN_C__ THEN *>
  <*+COMMENT*>
  <*+GENCTYPES*>
  <*-GENDEBUG*>
  <*-LINENO*>
  <*-GENHISTORY*>
<* ELSE *>
  <*-PROCINLINE*>
  <*-GENDEBUG*>
  <*-LINENO*>
  <*-GENHISTORY*>
<* END *>

MODULE afskmodem; (* (a)fsk -  kiss/axudp stereo soundcard afsk/fsk multimodem by OE5DXL *)

IMPORT ptty, lpt, soundctl, udp;
FROM fcntl IMPORT creat, open;
FROM osi IMPORT WrLn, WrStr, WrStrLn, WrInt, WrHex, Close, WrFixed,
                remove, oRDWR, oNONBLOCK; 
FROM aprsstr IMPORT StrToCard, StrToInt;
FROM SYSTEM IMPORT ADR, INT16, CAST, SHIFT, CARD8, ADDRESS;
FROM RealMath IMPORT cos, pi, ln;
FROM symlink IMPORT symblink;
FROM mlib IMPORT ioctl, TIOCM_RTS, TIOCM_DTR, TIOCMBIC, TIOCMBIS,
                 termios, TCSANOW, tcgetattr, tcsetattr;
FROM Select IMPORT Usleep;
FROM Lib IMPORT Random, NextArg;
FROM Storage IMPORT ALLOCATE;
FROM TimeConv IMPORT time;
FROM unistd IMPORT write, read;

TYPE TIME=CARDINAL;

CONST MAXLEN=256+7*9+20;
      MAXMODEMS=8;
      TXBUFLEN=60;                         (* default kiss buffers *)
      ADCBUFLEN=4096;
      BAUDSAMP=65536;
      PLLSHIFT=BAUDSAMP DIV 16;
      DEFTIMEOUT=60;                       (* then unsent frames are discarded *) 

      AFIRLEN=32;                          (*32, 64*)
      AOVERSAMP=16;                        (*16*)

      DFIRLEN=64;
      DOVERSAMP=16;

      TFIRLEN=64;   SHIFTBITS=6;           (* 2^ *)    (*32/5*)
      TFIRFINE=128;
      MAXVOL=25000.0;                      (* max dac / overswing *)

      POLYNOM=BITSET{3,10,15};
      CRCINIT=BITSET{0..15};
      CRCRESULT=BITSET(40715);
      MINFLEN=16;
      STUFFLEN=5;


      FEND=192;
      FESC=219;
      TFEND=220;
      TFESC=221;

TYPE  pKISSNEXT=POINTER TO KISSBUF;
      KISSBUF=RECORD
               next:pKISSNEXT;
               port:CHAR;
               time:TIME; 
               len:CARDINAL;
               data:ARRAY[0..MAXLEN+1] OF CHAR;       (* +2 byte crc *)
             END;

     TXFIRTAB=ARRAY[0..TFIRFINE-1] OF ARRAY[0..TFIRLEN-1] OF REAL;

     SET8=SET OF [0..7];
     SET32=SET OF [0..31];
     FILENAME=ARRAY[0..1023] OF CHAR;

     ADCWORD=INT16;
     MONITOR=(off, noinfo, normal, passall);
     CHANNELS=(LEFT, RIGHT); 

     DFIRTAB=ARRAY[0..DFIRLEN*DOVERSAMP-1] OF REAL;
     DFIR=ARRAY[0..DFIRLEN-1] OF REAL;
     AFIRTAB=ARRAY[0..AFIRLEN*AOVERSAMP-1] OF REAL;
     UDPPORT=CARDINAL;
     IPNUM=CARDINAL;
 
     MPAR=RECORD
       ch                                   : CHANNELS;  
       baudfine, pllshift                   : INTEGER;
       left, tcnt, freq, afskmidfreq, clamp : REAL;
       squelchdcd, noise                    : REAL;
       afshift, afmid, txvolum, afskhighpass: REAL; 
       monitor                              : MONITOR;
       sqmed                                : ARRAY[FALSE..TRUE] OF REAL;
       dfin                                 : CARDINAL;
       dfirtab                              : DFIRTAB;
       dfir                                 : DFIR;
       afirtab                              : AFIRTAB;
       afsk, cbit, oldd, plld, scramb, data1: BOOLEAN;
       rxstuffc, rxbyte, rxbitc, rxp, 
       demodbaud, txbaud, port16, dcdclockm, bertc, berterr,
       txdel, txtail                        : CARDINAL;
       rxcrc, scrambler                     : BITSET;
       rxbuf                                : ARRAY[0..MAXLEN-1] OF CHAR;
       txbufin, txbufout                    : pKISSNEXT;
       timeout                              : TIME;
       configbaud, configtxdel, configtxtail, txdelpattern,
       configafskshift, configafskmid, confignyquist: CARDINAL;
       configequalizer, leveldcd, bert      : INTEGER;
       configured, kissignore               : BOOLEAN;

       udpsocket                            : INTEGER;
       udpport, udpbind                     : UDPPORT;
       udpip                                : IPNUM;  
       anyip                                : BOOLEAN;
     END; 

     TXSTATE=(receiv, slotwait, sendtxdel, senddata, sendtxtail);
     DUPLEX=(simplex, shiftdigi, fullduplex);      

     CHAN=RECORD
       gmqtime,
       gmcnt,                                                    (* gm900 quiet tx time after ptt *)
       dcdclock,
       pttsoundbufs,
       dds, txbaudgen, addrandom, 
       tbyte, tbytec                          : CARDINAL;
       txstuffc, tbitc, lptpttbit             : INTEGER;
       pttstate, tnrzi                        : BOOLEAN;
       state                                  : TXSTATE;
       duplex                                 : DUPLEX;
       persist, hipasscap                     : REAL;
       tscramb                                : BITSET;
       adcmax, actmodem                       : INTEGER;  
       configpersist                          : CARDINAL;
       afir                                   : ARRAY[0..AFIRLEN-1] OF REAL;
     END;


VAR pipefd, ttyfd, soundfd, debfd : INTEGER;
    esc, closetty,abortonsounderr : BOOLEAN; 
    getst, i, afin, 
    soundbufs, 
    maxsoundbufs, adcrate, 
    adcbuflen, adcbytes, fragmentsize, 
    extraaudiodelay,
    parporttyp,
    clock             : CARDINAL;
    systime:TIME;
    maxchannels       : CHANNELS;
    chan:ARRAY[LEFT..RIGHT] OF CHAN;
    pTxFree, pGetKiss : pKISSNEXT;
    TFIR              : TXFIRTAB;
    modpar            : ARRAY[0..MAXMODEMS-1] OF MPAR;
    SIN:ARRAY[0..32767] OF REAL;

    CRCL, CRCH: ARRAY[0..255] OF SET8;
    ttyfn, lptfn, soundfn:FILENAME;

tfd, tii:INTEGER;


PROCEDURE Error(text:ARRAY OF CHAR);
BEGIN
  WrStr(text); WrStrLn(" error abort");
  HALT
END Error;

PROCEDURE SetStatLine(fd:INTEGER; rts, dtr:BOOLEAN):BOOLEAN;
VAR arg : ARRAY[0..255] OF CARDINAL;
    r:INTEGER;
BEGIN
  arg[0]:=TIOCM_RTS;
  IF rts THEN r:=ioctl(fd, TIOCMBIS, ADR(arg)) ELSE r:=ioctl(fd, TIOCMBIC, ADR(arg)) END;
  IF r>=0 THEN
    arg[0]:=TIOCM_DTR;
    IF dtr THEN r:=ioctl(fd, TIOCMBIS, ADR(arg)) ELSE r:=ioctl(fd, TIOCMBIC, ADR(arg)) END;
  END;
  RETURN r>=0
END SetStatLine;


PROCEDURE Hamming(VAR f:ARRAY OF REAL);
VAR i:CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(f) DO f[i]:=f[i]*(0.54+0.46*cos(pi*(FLOAT(i)/FLOAT(1+HIGH(f))))) END;
END Hamming;

PROCEDURE initdfir(VAR dfirtab:DFIRTAB; fg:CARDINAL);

VAR i,f:CARDINAL;
    t:ARRAY[0..DFIRLEN*DOVERSAMP DIV 2-1] OF REAL;
    f1, e:REAL;
BEGIN
  FOR i:=0 TO HIGH(t) DO t[i]:=0.5 END;

  f1:=FLOAT(fg*DFIRLEN)/FLOAT(adcrate);
  FOR f:=1 TO TRUNC(f1)+1 DO
    e:=1.0;
    IF f=TRUNC(f1)+1 THEN e:=f1-FLOAT(TRUNC(f1)) END;
    FOR i:=0 TO HIGH(t) DO t[i]:=t[i]+e*cos(pi*FLOAT(i*f)/FLOAT(HIGH(t)+1)) END;
  END;

(*
  FOR f:=1 TO fg*DFIRLEN DIV adcrate DO
    FOR i:=0 TO HIGH(t) DO t[i]:=t[i]+cos(pi*FLOAT(i*f)/FLOAT(HIGH(t)+1)) END;
  END;
*)
  Hamming(t);
  FOR i:=0 TO HIGH(t) DO t[i]:=t[i]*(0.54+0.46*cos(pi*(FLOAT(i)/FLOAT(1+HIGH(t))))) END;
  FOR i:=0 TO HIGH(t) DO dfirtab[HIGH(t)+i]:=t[i]; dfirtab[HIGH(t)-i]:=t[i]; END;

(*
IO.WrLn;
FOR i:=0 TO HIGH(dfirtab) DO IO.WrFixed(dfirtab[i], 2,8) END;
IO.WrLn;
*)

(*
fd:=FIO.Create("/tmp/td.raw");
FOR i:=0 TO HIGH(dfirtab) DO n:=VAL(INTEGER, dfirtab[i]*2000.0); FIO.WrBin(fd,n,2) END;
FIO.Close(fd);
*)
END initdfir;




PROCEDURE initafir(VAR atab:AFIRTAB; F0, F1:CARDINAL; eq:REAL);
VAR i,f:CARDINAL;
    t:ARRAY[0..AFIRLEN*AOVERSAMP DIV 2-1] OF REAL;
    e,f0,f1:REAL;
BEGIN
  f0:=FLOAT(F0*AFIRLEN)/FLOAT(adcrate);
  f1:=FLOAT(F1*AFIRLEN)/FLOAT(adcrate);

  FOR i:=0 TO HIGH(t) DO t[i]:=0.0 END;

  FOR f:=TRUNC(f0) TO TRUNC(f1)+1 DO
    e:=1.0 + eq*(FLOAT(f)/(FLOAT((F0+F1)*AFIRLEN)/FLOAT(adcrate))*2.0-1.0);
(*
    e:=1.0 + eq*(FLOAT(f)/FLOAT((F0+F1)*AFIRLEN DIV adcrate)*2.0-1.0);
*)
    IF e<0.0 THEN e:=0.0 END;
    IF f=TRUNC(f0) THEN e:=e*(1.0-(f0-FLOAT(TRUNC(f0)))) END;
    IF f=TRUNC(f1)+1 THEN e:=e*(f1-FLOAT(TRUNC(f1))) END;
(*
IF eq<>0 THEN IO.WrFixed(e,2,2);IO.WrLn; END;
*)
    IF f=0 THEN
      FOR i:=0 TO HIGH(t) DO t[i]:=t[i]+e*0.5 END;
    ELSE
      FOR i:=0 TO HIGH(t) DO t[i]:=t[i] + e*cos(pi*FLOAT(i*f)/FLOAT(HIGH(t)+1)) END;
    END;
  END;

  Hamming(t);
  FOR i:=0 TO HIGH(t) DO atab[HIGH(t)+i]:=t[i]; atab[HIGH(t)-i]:=t[i]; END;


  IF F0>0 THEN          (* make dc level zero *)
    e:=0.0;
    FOR i:=0 TO HIGH(atab) DO e:=e+atab[i] END;
    e:=e/FLOAT(HIGH(atab)+1);
    FOR i:=0 TO HIGH(atab) DO atab[i]:=atab[i]-e END;
  END;


(*
IO.WrLn;
FOR i:=0 TO HIGH(atab) DO IO.WrFixed(atab[i], 2,8) END;
IO.WrLn;
*)

(*
IF eq<>0.0 THEN
debfd:=FIO.Create("/tmp/ta.raw");
FOR i:=0 TO HIGH(atab) DO f:=VAL(INTEGER, atab[i]*1000.0); FIO.WrBin(debfd,f,2) END;
FIO.Close(debfd);
END;
*)

END initafir;



PROCEDURE initTFIR;
VAR i,j,f,b:CARDINAL;
    sym:ARRAY[0..TFIRFINE DIV 2*SHIFTBITS-1] OF REAL;
    sum:ARRAY[0..TFIRFINE-1] OF REAL;
    s:ARRAY[0..TFIRFINE*SHIFTBITS-1+SHIFTBITS] OF REAL;
    fr, k, max:REAL;

BEGIN
  FOR i:=0 TO HIGH(sym) DO sym[i]:=0.5 END;
  fr:=FLOAT(SHIFTBITS)*4800.0/10000.0;
  FOR f:=1 TO TRUNC(fr)+1 DO
    IF f=TRUNC(fr)+1 THEN k:=fr-FLOAT(TRUNC(fr)) ELSE k:=1.0 END; 
    FOR i:=0 TO HIGH(sym) DO sym[i]:=sym[i] + k*cos(pi*FLOAT(i*f)/FLOAT(HIGH(sym)+1)) END;
  END;

  Hamming(sym);
  FOR i:=0 TO HIGH(s) DO s[i]:=0.0 END;
  max:=0.0; 
  FOR i:=0 TO HIGH(sym) DO 
    s[HIGH(sym)+i+SHIFTBITS DIV 2]:=sym[i];
    s[HIGH(sym)-i+SHIFTBITS DIV 2]:=sym[i];
    IF ABS(sym[i])>max THEN max:=ABS(sym[i]) END;
  END;

  max:=2.0/max;
  FOR j:=0 TO TFIRLEN-1 DO
    FOR i:=0 TO HIGH(sum) DO sum[i]:=0.0 END;
    FOR b:=0 TO SHIFTBITS-1 DO       
      FOR i:=0 TO HIGH(sum) DO 
        sum[i]:=sum[i] + s[i+b*TFIRFINE]*(FLOAT(ORD(b IN CAST(BITSET, j)))-0.5);
      END;
    END;
    FOR i:=0 TO TFIRFINE-1 DO TFIR[i][j]:=sum[i]*max END;
  END;

END initTFIR;

PROCEDURE SetMixer(mixfn:ARRAY OF CHAR; chan, left, right:CARDINAL);
VAR fd:INTEGER;
BEGIN
  fd:=open(mixfn, oRDWR);
  IF fd>=0 THEN
    IF chan=255 THEN chan:=soundctl.recnum() END;
    soundctl.setmixer(fd, chan, ASH(right, 8) + left);
  ELSE WrStr(mixfn); Error(" open") END
END SetMixer;


PROCEDURE OpenSound;
VAR i,s:INTEGER;
BEGIN
  soundfd:=open(soundfn, oRDWR);
  IF soundfd>=0 THEN
    i:=soundctl.samplesize(soundfd, 16);             (* 8, 16 *)
    i:=soundctl.channels(soundfd, ORD(maxchannels)+1);  (* 1, 2  *)
    i:=soundctl.setfragment(soundfd, fragmentsize);     (* 2^bufsize * 65536*bufs*)
    IF i<>0 THEN WrStr("sound setfragment returns "); WrInt(i,1); WrLn END;
    i:=soundctl.sampelrate(soundfd, adcrate);        (* 8000..48000 *)
    s:=soundctl.getsampelrate(soundfd);
    IF s<>VAL(INTEGER, adcrate) THEN
      WrStr("sound device returns "); WrInt(s,1); WrStrLn("Hz!");
(*
      IF s>=0 THEN Error("") END;
*)
    END;
  ELSIF abortonsounderr THEN WrStr(soundfn); Error(" open") END;
END OpenSound;


PROCEDURE ttypar(fn:ARRAY OF CHAR);
VAR term     : termios;
    res, fd  : INTEGER;
BEGIN
  fd:=open(fn, oNONBLOCK);
  IF fd>=0 THEN
    res:=tcgetattr (fd, term);
(*
    term.c_lflag:=CAST(CARDINAL, CAST(BITSET, term.c_lflag) - CAST(BITSET, ECHO));
*)
    term.c_lflag:=0;

    res:=tcsetattr (fd, TCSANOW, term);
(*
    res:=tcsetattr (fd, 0, term);
*)
  END;
  Close(fd);
END ttypar;



PROCEDURE Opentty(linkname:ARRAY OF CHAR):INTEGER;
VAR fd:INTEGER;
    ptsname:ARRAY[0..4095] OF CHAR;
BEGIN
  fd:=open("/dev/ptmx",  oRDWR+oNONBLOCK);
  IF fd<0 THEN Error("/dev/ptmx open") END;
  IF ptty.getptsname(fd, ADR(ptsname), SIZE(ptsname))<>0 THEN Error("no ttyname") END;
(*
  IO.WrStr(ptsname); IO.WrLn;
*)
  IF ptty.grantpts(fd)<>0 THEN Error("ptty grant") END;
  IF ptty.unlockpts(fd)<>0 THEN Error("ptty unlock") END;
  ttypar(ptsname);

(*make link*)
  remove(linkname);
  IF symblink(ADR(ptsname), ADR(linkname))<>0 THEN 
    WrStr("cannot create link <"); WrStr(linkname);
    WrStrLn(">, starting without kiss interface");
    Close(fd);
    fd:=-1;
  END;
  RETURN fd
END Opentty;



PROCEDURE Makekissbufs(n:CARDINAL);
VAR pt:pKISSNEXT;
BEGIN
  pTxFree:=NIL;
  pGetKiss:=NIL;
  i:=0;
  LOOP
    IF i>=n THEN EXIT END; 
    ALLOCATE(pt, SIZE(pt^));
    INC(i); 
    IF pt=NIL THEN EXIT END;                  (* out of memory *)
    pt^.next:=pTxFree;
    pTxFree:=pt;
  END; 
END Makekissbufs;


PROCEDURE StoBuf(m:INTEGER; p:pKISSNEXT);
BEGIN
  WITH modpar[m] DO
    IF configured & (pTxFree<>NIL) THEN
      p^.next:=NIL;
      IF txbufin=NIL THEN txbufin:=p ELSE txbufout^.next:=p END;
      txbufout:=p;
    ELSE p^.next:=NIL; pTxFree:=p END;                         (* discard frame, out of memory *)
  END;
END StoBuf;



PROCEDURE ExtractWord(VAR w,s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
BEGIN
  w[0]:=0C;
  i:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) & (s[i]<>":") DO
    IF i<=HIGH(w) THEN w[i]:=s[i] END;
    INC(i);
  END;
  
  IF i<=HIGH(w) THEN w[i]:=0C END;

  j:=0;
  IF (i<=HIGH(s)) & (s[i]<>0C) THEN 
    INC(i);
    WHILE (i<=HIGH(s)) & (s[i]<>0C) DO
      s[j]:=s[i];
      INC(i);
      INC(j);
    END;
  END;
  s[j]:=0C;
END ExtractWord;

PROCEDURE Config;
VAR i:INTEGER;
    c:CHANNELS;
BEGIN
  FOR c:=LEFT TO RIGHT DO
    WITH chan[c] DO
      persist:=FLOAT(configpersist*adcrate*(ORD(maxchannels)+1) DIV adcbuflen)*0.001;  (* ms *)
    END;
  END;

  FOR i:=0 TO HIGH(modpar) DO
    WITH modpar[i] DO
      txbaud:=configbaud*BAUDSAMP DIV adcrate;
      demodbaud:=txbaud*2;
      txdel:=configbaud*configtxdel DIV 8000;
      txtail:=2+2*ORD(scramb)+configbaud*configtxtail DIV 8000;

      afskmidfreq:=FLOAT(configafskmid)*2.0/FLOAT(adcrate);
      afshift:=0.5*FLOAT(configafskshift*(HIGH(SIN)+1))/FLOAT(adcrate);

      afmid:=FLOAT(configafskmid*(HIGH(SIN)+1))/FLOAT(adcrate);

      IF afsk THEN
        initafir(afirtab, configafskmid-configafskshift DIV 2-configbaud DIV 4, configafskmid+configafskshift DIV 2+configbaud DIV 4, VAL(REAL,configequalizer)/100.0);
        initdfir(dfirtab, configbaud*confignyquist DIV 100);
      ELSE initafir(afirtab, 0, configbaud*confignyquist DIV 100, VAL(REAL, configequalizer)/100.0) END;

      baudfine:=0;
      left:=0.0;
      tcnt:=0.0;
      freq:=0.0;
      dfin:=0;
      cbit:=FALSE;
      rxp:=0;
      rxbitc:=0;
      rxcrc:=CRCINIT;
    END;
  END;

END Config;


PROCEDURE GetIp(h:ARRAY OF CHAR; VAR ip:IPNUM; VAR dp, lp:UDPPORT; VAR fd:INTEGER; VAR check:BOOLEAN):INTEGER;
VAR i, p, n:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  n:=0;
  FOR i:=0 TO 5 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;
      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":")OR (n>255) THEN RETURN -1 END;
    ELSIF i=4 THEN
      check:=h[p]="/";
      IF (h[p]<>":") & (h[p]<>"/") OR (n>65535) THEN RETURN -1 END;
      dp:=n;
    ELSIF n>65535 THEN RETURN -1 END;
    lp:=n;
    INC(p);
  END;  

  fd:=udp.openudp();
  IF (fd<0) OR (udp.bindudp(fd, lp)<0) (*OR (udp.udpnonblock(fd)<0)*) THEN RETURN -1 END;
  RETURN 0

END GetIp;



PROCEDURE bufree():CARDINAL;
VAR p:pKISSNEXT;
    i:CARDINAL;
BEGIN
  p:=pTxFree;
  i:=0;
  WHILE p<>NIL DO INC(i); p:=p^.next END;
  RETURN i
END bufree;



PROCEDURE bertstart;
VAR p:pKISSNEXT;
    i:CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(modpar) DO
    WITH modpar[i] DO
      IF (bert>0) & (pTxFree<>NIL) THEN
        p:=pTxFree;
        pTxFree:=pTxFree^.next;
        p^.port:=CHR(i);
        p^.len:=0;
        p^.time:=MAX(TIME);
        StoBuf(i, p);
      END;
    END;
  END;
END bertstart;



PROCEDURE Parms;
VAR err:BOOLEAN;
    h, h1, mixfn, pipefn:FILENAME;
    kissbufs, cnum, left, right: CARDINAL;
    channel, modem, inum  : INTEGER;
    c:CHANNELS;
BEGIN
  err:=FALSE;
  abortonsounderr:=FALSE;  
  adcrate:=16000;
  adcbytes:=2;
  adcbuflen:=256;
  fragmentsize:=9;
  maxchannels:=LEFT;
  extraaudiodelay:=1;
  debfd:=-1;
  parporttyp:=0;

  FOR cnum:=0 TO HIGH(SIN) DO
    SIN[cnum]:=cos(FLOAT(cnum)*2.0*pi/FLOAT(HIGH(SIN)+1));
  END;

  FOR c:=LEFT TO RIGHT DO
    WITH chan[c] DO
      state:=receiv;
      pttsoundbufs:=0;
      dds:=0;
      duplex:=simplex;
      persist:=800.0;
      actmodem:=-1;
      lptpttbit:=0;
      configpersist:=800;
      tscramb:={0};         (* for bert *)
      gmqtime:=0;
    END;
  END;

  FOR cnum:=0 TO HIGH(modpar) DO
    WITH modpar[cnum] DO
      configured:=cnum=0;
      configbaud:=1200;
      configtxdel:=300;
      configtxtail:=20;
      configafskshift:=1000;
      configafskmid:=1700;
      confignyquist:=75;
      configequalizer:=0;
      kissignore:=FALSE;
      leveldcd:=10;
      pllshift:=PLLSHIFT;
      ch:=LEFT;
      afsk:=TRUE;
      monitor:=normal;
      scramb:=FALSE;
      clamp:=0.996;
      port16:=cnum*16;
      squelchdcd:=0.14;
      txbufin:=NIL;
      bert:=0;
      txdelpattern:=126;
      txvolum:=MAXVOL;
      afskhighpass:=0.0; 
      timeout:=DEFTIMEOUT;

      udpsocket:=-1;
    END;
  END;

  kissbufs:=TXBUFLEN;
  channel:=-1;
  modem:=-1;
  ttyfn[0]:=0C;
  COPY("/dev/parport0", lptfn);
  COPY("/dev/dsp", soundfn);
  pipefn[0]:=0C;
  COPY("/dev/mixer", mixfn);
  maxsoundbufs:=10;
  ttyfd:=-1;
  closetty:=FALSE;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN

      IF h[1]="a" THEN
        IF modem>=0 THEN modpar[modem].afsk:=FALSE
        ELSIF channel<=0 THEN abortonsounderr:=TRUE
        ELSE Error("need modem number -M before -a") END;
      
      ELSIF h[1]="b" THEN
        NextArg(h);
        IF modem>=0 THEN
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          IF cnum>=adcrate THEN Error("sampelrate -f too low for this baud") END;
          modpar[modem].configbaud:=cnum;
        ELSIF channel>=0 THEN
          IF NOT StrToInt(h, inum) THEN err:=TRUE END;
          inum:=ABS(inum)+1;
          IF inum>8 THEN Error("bit -7..7") END;
          IF h[0]="-" THEN inum:=-inum END; 
          chan[VAL(CHANNELS, channel)].lptpttbit:=inum;
        ELSE
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          maxsoundbufs:=cnum;
        END;

      ELSIF h[1]="B" THEN
        NextArg(h);
        IF NOT StrToInt(h, inum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].bert:=inum*8000;
        ELSE Error("need modem number -M before -B") END;

      ELSIF h[1]="C" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF cnum>1 THEN Error("channel 0 to 1") END;
        channel:=cnum;

      ELSIF h[1]="c" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN 
          IF cnum>ORD(maxchannels) THEN Error("channel too high") END;
          modpar[modem].ch:=VAL(CHANNELS, cnum);
        ELSE 
          IF (cnum<1) OR (cnum>2) THEN Error("maxchannels 1..2") END;
          maxchannels:=VAL(CHANNELS, cnum-1);
        END; 

      ELSIF h[1]="D" THEN
        NextArg(h1); debfd:=creat(h1, 644B);

      ELSIF h[1]="d" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].squelchdcd:=FLOAT(cnum)/400.0;
        ELSE Error("need modem number -M before -d") END;

      ELSIF h[1]="e" THEN
        NextArg(h);
        IF modem>=0 THEN
          IF NOT StrToInt(h, inum) THEN err:=TRUE END;
          IF ABS(inum)>999 THEN Error("equalizer -999..999") END;
          modpar[modem].configequalizer:=inum;
        ELSIF channel>=0 THEN Error("need modem number -M before -e");
        ELSIF NOT StrToCard(h, extraaudiodelay) THEN err:=TRUE 
        END;
            
      ELSIF h[1]="f" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].configafskmid:=cnum;
        ELSIF channel>=0 THEN
          IF cnum>2 THEN Error("duplex 0..2") END;
          chan[VAL(CHANNELS, channel)].duplex:=VAL(DUPLEX, cnum);
        ELSE  
          IF (cnum<8000) OR (cnum>96000) THEN Error("sampelrate 8000..96000") END;
          adcrate:=cnum; 
        END;

      ELSIF h[1]="g" THEN
        IF modem>=0 THEN modpar[modem].scramb:=TRUE;
        ELSIF channel>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) OR (cnum>999) THEN Error("-g <ms>") END;
          chan[VAL(CHANNELS, channel)].gmqtime:=cnum*adcrate DIV 1000;
        ELSE Error("need modem number -M before -g") END;

      ELSIF h[1]="H" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].afskhighpass:=FLOAT(cnum)*0.01;
        ELSE Error("need modem number -M before -H") END;

      ELSIF h[1]="i" THEN
        IF modem>=0 THEN modpar[modem].kissignore:=TRUE;
        ELSE NextArg(pipefn) END;

      ELSIF h[1]="k" THEN 
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN
          IF cnum>7 THEN Error("kissports 0..7") ELSE modpar[modem].port16:=cnum*16 END;
        ELSE kissbufs:=cnum END;

      ELSIF h[1]="l" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF (cnum>=16) & (cnum<=ADCBUFLEN) THEN adcbuflen:=cnum 
        ELSE Error("sound buffer out of range") END;

      ELSIF h[1]="M" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF cnum>HIGH(modpar) THEN Error(">maxmodems") END;
        modem:=cnum;
        modpar[modem].configured:=TRUE;

      ELSIF h[1]="m" THEN
        NextArg(h);
        IF (modem<0) & (channel<0) THEN
          WHILE h[0]<>0C DO
            ExtractWord(h1,h);
            IF h1[0]="/" THEN 
              COPY(h1, mixfn);
            ELSE
              IF NOT StrToCard(h1, cnum) THEN err:=TRUE END;
              ExtractWord(h1,h);
              IF NOT StrToCard(h1, left) THEN err:=TRUE END;
              ExtractWord(h1,h);
              IF NOT StrToCard(h1, right) THEN err:=TRUE END;
              IF NOT err THEN SetMixer(mixfn, cnum, left, right) END;
            END;
          END;
        ELSE
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          IF cnum>3 THEN Error("monitor 0..3") END;
          IF modem>=0 THEN modpar[modem].monitor:=VAL(MONITOR, cnum)
          ELSE Error("need modem number -M before -m") END;
        END;

      ELSIF h[1]="n" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].confignyquist:=cnum;
        ELSE Error("need modem number -M before -n") END;

      ELSIF h[1]="o" THEN NextArg(soundfn);

      ELSIF h[1]="p" THEN 
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          modpar[modem].pllshift:=cnum*256;
        ELSE 
          NextArg(lptfn);
          parporttyp:=1;
        END;

      ELSIF h[1]="P" THEN
        IF modem<0 THEN
          NextArg(lptfn);
          parporttyp:=2;
        ELSE Error("need pp065 portname before -M") END;


      ELSIF h[1]="q" THEN
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          modpar[modem].leveldcd:=cnum;
        ELSE Error("need modem number -M before -q") END;

      ELSIF h[1]="r" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF channel>=0 THEN
          IF NOT StrToCard(h, chan[VAL(CHANNELS, channel)].configpersist) THEN err:=TRUE END;
        ELSE Error("need channel number -C before -r")END;

      ELSIF h[1]="s" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].configafskshift:=cnum;
        ELSE fragmentsize:=cnum END;

      ELSIF h[1]="t" THEN 
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          modpar[modem].configtxdel:=cnum;
        ELSE NextArg(ttyfn) END;

      ELSIF h[1]="u" THEN closetty:=TRUE;

      ELSIF h[1]="U" THEN 
        IF modem>=0 THEN
          NextArg(h);
          WITH modpar[modem] DO
            IF GetIp(h, udpip, udpport, udpbind, udpsocket, anyip)<0 THEN Error("cannot open udp socket") END;
          END; 
        ELSE Error("need modem number -M before -U") END;

      ELSIF h[1]="v" THEN
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          IF cnum>100 THEN cnum:=100 END;
          modpar[modem].txvolum:=FLOAT(cnum)*(MAXVOL/100.0);
        ELSE Error("need modem number -M before -w") END;

      ELSIF h[1]="T" THEN
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          modpar[modem].timeout:=cnum;
        ELSE Error("need modem number -M before -T") END;

      ELSIF h[1]="w" THEN
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          modpar[modem].txdelpattern:=cnum;
        ELSE Error("need modem number -M before -w") END;

      ELSIF h[1]="x" THEN
        IF modem>=0 THEN
          NextArg(h);
          IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
          modpar[modem].configtxtail:=cnum;
        ELSE Error("need modem number -M before -x") END;

      ELSIF h[1]="z" THEN
        NextArg(h);
        IF NOT StrToCard(h, cnum) THEN err:=TRUE END;
        IF modem>=0 THEN modpar[modem].clamp:=FLOAT(cnum)/1000.0;
        ELSE Error("need modem number -M before -z") END;

      ELSIF h[1]="h" THEN

        WrStrLn("first for all modems");
        WrStrLn(" -a             abort on sounddevice error else retry to open");
        WrStrLn(" -b <num>       tx dacbuffers (10) (more to avoid underruns)");
        WrStrLn(" -c <num>       maxchannels (1) (1=mono, 2=stereo)");
        WrStrLn(" -D <filename>  (debug) write raw soundcard input data to file or pipe");
        WrStrLn(" -e <num>       extra audio delay ptt hold time (1) in soundframes");
        WrStrLn(" -f <num>       adcrate (16000) (8000..96000)");
        WrStrLn(" -h             help");
        WrStrLn(" -i <filename>  kiss pipename (/dev/kiss/soundmodem)");
        WrStrLn(" -k <num>       tx kiss bufs (60)");
        WrStrLn(" -l <num>       adcbuflen (256) more: lower system load but slower reaction");
        WrStrLn(" -m [<mixername>:]<channel>:<left>:<right> (0..255) ossmixer (/dev/mixer)");
        WrStrLn(" -o <filename>  oss devicename (/dev/dsp)");
        WrStrLn(" -p <filename>  pttport  (/dev/parport0) (may be shared with more modems)");
        WrStrLn(" -P <filename>  pp065port  (/dev//dev/pp065mb) (may be shared with more modems)");
        WrStrLn(" -s <num>       fragment size in 2^n (9)");
        WrStrLn(" -t <filename>  pttport  (/dev/ttyS0)");
        WrStrLn(" -u             close ptt-tty file between switch actions, may not work on USB tty");
(*
        WrStrLn("#-w <num>       adcbits ( 8/16)");
*)
        WrLn;
        WrStrLn("repeat for each channel -C ... :");
        WrStrLn("  -C <num>  (0..1) channel parameters follow (repeat for each channel)");
        WrStrLn("  -b <num>  pttbit on lpt port for 1 channel 0..7 (-0..-0 invertet)");
        WrStrLn("  -f <num>  fullduplex  (0) (0=halfduplex, 1=master fullduplex, 2=all fullduplex)");
        WrStrLn("  -g <ms>   GM900 audio quiet time after ptt on (0)");
        WrStrLn("  -r <num>  max random wait time after dcd before start tx (ms) (800)");

        WrLn;
        WrStrLn("repeat for each modem -M ... :");
        WrStrLn("   -M <num> (0..7) modem parameters follow (repeat for each modem)");
        WrStrLn("   -a       afsk off, fsk on (on)");
        WrStrLn("   -b <num> baud (1200) (1..32000)");
        WrStrLn("   -B <kbyte> send BERT, (negative bytes receive only)");
        WrStrLn("   -c <num> use stereo channel 0=left (or mono), 1=right");
        WrStrLn("   -d <num> dcdlevel (56) (0..100)");
        WrStrLn("   -e <num> demod equalizer (0) 100=6db/oct highpass   (-999..999)");
        WrStrLn("   -f <num> afsk mid frequency, tx and rx (hz) (1700)");
        WrStrLn("   -g       g3ruh scrambler on (off)");
        WrStrLn("   -H <num> afsk tx highpass (0) (0..100)");
        WrStrLn("   -i       ignore modem parameters from kiss (off)");
        WrStrLn("   -k <num> received data send to this kiss port (0) (0..7)");
(*
        WrStrLn("#  -l <num> filterlow (hz)");
*)
        WrStrLn("   -m <num> monitor (2) (0=off, 1=header, 2=all, 3=passall)");
        WrStrLn("   -n <num> nyquist filter baseband -6db point in % of baudrate (65) (0..100)");
        WrStrLn("   -p <num> receive clock pll aquisition speed (16) (num/256 of bit time)");
        WrStrLn("   -q <num> quiet adc level to save cpu or avoid reciption of channel crosstalk (0)");
(*
        WrStrLn("#  -r       rzi -1 1");
*)
        WrStrLn("   -s <num> afsk shift tx (for rx bandfilter width) (1000) (hz)");
        WrStrLn("   -t <num> txdelay (300) (ms)");
        WrStrLn("   -T <seconds> timeout for tx buffered frame (60) (s)");
(*
        WrStrLn("#  -u       filterup  (hz)");
*)

        WrStrLn("   -U <x.x.x.x:destport:listenport> use axudp instead of kiss /listenport no check ip");
        WrStrLn("   -v <num> tx loudness (100)");
        WrStrLn("   -w <num> txdelay pattern before 1 flag (126) (0..255)");
        WrStrLn("   -x <num> txtail (20) (ms), ptt hold for fullduplex");
        WrStrLn("   -z <num> fsk rx baseband dc regeneration clamp speed (996) (0=off, 1=fast, 999=slow)");
        WrStrLn("example: nice -n -19 aoss ./afskmodem -t /dev/ttyS0 -f 32000 -c 2 -M 0 -c 0 -b 1200 -M 1 -c 1 -b 9600 -a -g -U 127.0.0.1:6001:1093");

        HALT

      ELSE err:=TRUE END;
(*
      h[0]:=0C;
*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN WrStr(">"); WrStr(h); WrStrLn("< use -h"); HALT END;
 
  Config;

  OpenSound;
  pipefd:=-1;
  IF pipefn[0]<>0C THEN pipefd:=Opentty(pipefn) END; 
  Makekissbufs(kissbufs);
  bertstart;
END Parms;




PROCEDURE AppCRC(VAR frame:ARRAY OF CHAR; size:INTEGER);
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-1 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  frame[size  ]:=CAST(CHAR, l);
  frame[size+1]:=CAST(CHAR, h);
END AppCRC;


PROCEDURE Kisscmd;
VAR cmd, x  : CARDINAL;
    modem   : INTEGER;
BEGIN
  
  cmd:=ORD(pGetKiss^.port);
  modem:=ASH(cmd, -4) MOD 8;
  cmd:=cmd MOD 16;

WrStr("p="); WrInt(modem,1); WrLn; 

  WITH modpar[modem] DO 
    IF configured & NOT kissignore THEN
      x:=ORD(pGetKiss^.data[0]);
      IF    cmd=1 THEN configtxdel:=x*10;
WrStr("txdel="); WrInt(configtxdel, 1); WrLn;

      ELSIF cmd=2 THEN chan[modpar[modem].ch].configpersist:=10*(255-x);
WrStr("persist="); WrInt(chan[modpar[modem].ch].configpersist,1); WrLn;

      (*3 SlotTime*)
      ELSIF cmd=4 THEN configtxtail:=x*10;
WrStr("txtail="); WrInt(configtxtail,1); WrLn;

      ELSIF cmd=5 THEN 
        IF x<=2 THEN chan[modpar[modem].ch].duplex:=VAL(DUPLEX, x) END;
WrStr("duplex="); WrInt(x,1); WrLn;  

      END;
      Config; 
    END;
  END;      
END Kisscmd; 



PROCEDURE getkiss;
VAR b:ARRAY[0..1023] OF CHAR;
    l, i:INTEGER;
    m:INTEGER;
BEGIN
  LOOP
    IF pipefd<0 THEN EXIT END;

    l:=read(pipefd, ADR(b), SIZE(b));
    IF l<=0 THEN EXIT END;

    FOR i:=0 TO l-1 DO

(*allocate buffer*)
      IF pGetKiss=NIL THEN
        IF pTxFree=NIL THEN EXIT END;       (* out of memory discard data *)

        pGetKiss:=pTxFree;
        pTxFree:=pTxFree^.next;
      END;
(*allocate buffer*)


      IF b[i]=CHR(FEND) THEN
        esc:=FALSE;
        IF getst>2 THEN
          pGetKiss^.len:=getst-2;
          getst:=0;

(*store frame*)

          m:=ASH(ORD(pGetKiss^.port), -4) MOD 8;        
          IF m<=HIGH(modpar) THEN

            IF ORD(pGetKiss^.port) MOD 16=0 THEN        (* data frame *)
              pGetKiss^.port:=CHR(m);
              AppCRC(pGetKiss^.data, pGetKiss^.len);
              pGetKiss^.time:=systime+modpar[m].timeout;
              StoBuf(m, pGetKiss);
              pGetKiss:=NIL;

            ELSE Kisscmd END;                          (* kiss parameter frame *)
          END; 

(*store frame*)

        ELSE getst:=1 END;

      ELSIF (b[i]=CHR(FESC)) & (getst>0) THEN esc:=TRUE

      ELSE
        IF esc THEN
          IF b[i]=CHR(TFESC) THEN b[i]:=CHR(FESC)
          ELSIF b[i]=CHR(TFEND) THEN b[i]:=CHR(FEND) END;
          esc:=FALSE;
        END;
        IF getst=1 THEN pGetKiss^.port:=b[i]; getst:=2;
        ELSIF (getst>=2) & (getst-2<MAXLEN) THEN
          pGetKiss^.data[getst-2]:=b[i];
          INC(getst);
        END;
      END;
    END;
  END;

END getkiss;


PROCEDURE getudp;
VAR p:pKISSNEXT;
    i:CARDINAL;
    ulen:INTEGER;
    fromport:UDPPORT;
    fromip:IPNUM; 
    crc1, crc2:CHAR;
BEGIN
  FOR i:=0 TO HIGH(modpar) DO
    WITH modpar[i] DO
      IF (udpsocket>=0) & (pTxFree<>NIL) THEN
        ulen:=udp.udpreceive(udpsocket, pTxFree^.data, SIZE(pTxFree^.data), fromport, fromip);
        IF (ulen>2) & (ulen<SIZE(pTxFree^.data)) & (anyip OR (fromip=udpip)) THEN
          crc1:=pTxFree^.data[ulen-2];
          crc2:=pTxFree^.data[ulen-1];
          AppCRC(pTxFree^.data, ulen-2);
          IF (crc1=pTxFree^.data[ulen-2]) & (crc2=pTxFree^.data[ulen-1]) THEN
            p:=pTxFree;
            pTxFree:=pTxFree^.next;
            p^.port:=CHR(i);
            p^.len:=ulen-2;
            p^.time:=systime+timeout;
            StoBuf(i, p);
          END;                        (* else crc error *) 
        END;                          (* else wrong len or source ip *)
      END;
    END;
  END;
END getudp;



PROCEDURE sendkiss(VAR data:ARRAY OF CHAR; len:INTEGER; port16:CARDINAL);
VAR b:ARRAY[0..MAXLEN*2+4] OF CHAR;
    l, i:INTEGER;
    d:CHAR;
    po:CARDINAL;
BEGIN
(*
FOR i:=0 TO len-1 DO IO.WrHex(ORD(data[i]),3) END; IO.WrLn; 
*)
  po:=ASH(port16, -4) MOD 8;
  IF (po<=HIGH(modpar)) & (modpar[po].udpsocket>=0) THEN
    WITH modpar[po] DO
      i:=udp.udpsend(udpsocket, data, len+2, udpport, udpip); 
    END;  

  ELSIF pipefd>=0 THEN
    b[0]:=CHR(FEND);
    b[1]:=CHR(port16);
    l:=2;
    FOR i:=0 TO len-1 DO
      d:=data[i];
      IF    d=CHR(FEND) THEN b[l]:=CHR(FESC); INC(l); b[l]:=CHR(TFEND); 
      ELSIF d=CHR(FESC) THEN b[l]:=CHR(FESC); INC(l); b[l]:=CHR(TFESC);
      ELSE b[l]:=d END;
      INC(l);
    END;
    b[l]:=CHR(FEND);
    INC(l);
    i:=write(pipefd, ADR(b), l);
  END;
END sendkiss;

PROCEDURE WrQuali(q:REAL);
BEGIN
  IF q>0.0 THEN
    q:=100.5-q*200.0;
    IF q<0.0 THEN q:=0.0 END;
    WrStr(" q:"); WrInt(TRUNC(q), 1);
  END;
END WrQuali;

PROCEDURE WrdB(volt:INTEGER);
BEGIN
  IF volt>0 THEN WrFixed(ln(FLOAT(volt))*8.685889638-96.4, 1,6); WrStr("dB"); END;
END WrdB;

PROCEDURE WCh(c:CHAR);
BEGIN
  IF c<>15C THEN
    IF (c<" ") OR (c>=177C) THEN WrStr(".") ELSE WrStr(c) END;
  END;
END WCh;

PROCEDURE ShowCall(VAR f:ARRAY OF CHAR; pos:CARDINAL);
VAR i,e:CARDINAL;
BEGIN
  e:=pos;
  FOR i:=pos TO pos+5 DO 
    IF f[i]<>100C THEN e:=i END;
  END; 
  FOR i:=pos TO e DO WCh(CHR(ASH(ORD(f[i]), -1))) END;
  IF ASH(ORD(f[pos+6]), -1) MOD 16 <> 0 THEN
    WrStr("-"); WrInt(ASH(ORD(f[pos+6]), -1) MOD 16, 1);
  END;
END ShowCall;


PROCEDURE Showctl(com, cmd:CARDINAL);
CONST UA = {0,1,5,6};
      DM = {0,1,2,3};
      SABM={0,1,2,3,5};
      DISC={0,1,6};
      FRMR={0,1,2,7};
      UI = {0,1};
      RR = {0};
      REJ= {0,3};
      RNR= {0,2};

VAR cm:BITSET;
    PF:ARRAY[0..3] OF CHAR;

BEGIN
  WrStr(" ctl ");
  cm:=CAST(BITSET, cmd) - {4};
  IF cm * {0,1,2,3} = RR THEN
    WrStr("RR");
    WrStr(CHR(48+ASH(cmd, -5)));
  ELSIF cm * {0,1,2,3} = RNR THEN
    WrStr("RNR");
    WrStr(CHR(48+ASH(cmd, -5)));
  ELSIF cm * {0,1,2,3} = REJ THEN
    WrStr("REJ");
    WrStr(CHR(48+ASH(cmd, -5)));
  ELSIF cm * {0} = {} THEN
    WrStr("I");
    WrStr(CHR(48+ASH(cmd, -5)));
    WrStr(CHR(48+ASH(cmd, -1) MOD 8));
  ELSIF cm = UI THEN WrStr("UI")
  ELSIF cm = DM THEN WrStr("DM");
  ELSIF cm = SABM THEN WrStr("SABM")
  ELSIF cm = DISC THEN WrStr("DISC")
  ELSIF cm = UA THEN WrStr("UA")
  ELSIF cm = FRMR THEN WrStr("FRMR")
  ELSE WrHex(cmd,1) END;
  PF:="v^-+";
  IF (com=0) OR (com=3) THEN WrStr("v1")
  ELSE WrStr(PF[com MOD 2 + 2*ORD(4 IN CAST(BITSET, cmd))]) END;
END Showctl;


PROCEDURE ShowFrame(VAR f:ARRAY OF CHAR; len, port:CARDINAL; q:REAL; volt:INTEGER; noinfo:BOOLEAN);
VAR i:CARDINAL;
    v, d:BOOLEAN;
BEGIN
  i:=0;
  WHILE NOT ODD(ORD(f[i])) DO 
    INC(i);
    IF i>len THEN RETURN END;           (* no address end mark found *)
  END;
  IF i MOD 7 <> 6 THEN RETURN END;      (* address end not modulo 7 error *)

  WrStr(CHR(port MOD 8+48));
  WrStr(":fm ");
  ShowCall(f, 7);
  WrStr(" to ");
  ShowCall(f, 0);
  i:=14;
  v:=TRUE;
  WHILE (i+6<len) & NOT ODD(ORD(f[i-1])) DO
    IF v THEN WrStr(" via"); v:=FALSE END;
    WrStr(" ");
    ShowCall(f, i);
    IF (ORD(f[i+6])>=128) & (ODD(ORD(f[i+6])) OR (ORD(f[i+13])<128)) THEN WrStr("*") END;
    INC(i,7);
  END;  
(*
  IO.WrStr(" ctl "); IO.WrHex(ORD(f[i]),1);
*)
  Showctl(ORD(7 IN CAST(SET8, f[6])) + 2*ORD(7 IN CAST(SET8,f[13])), ORD(f[i]));
  INC(i);

  IF i<len THEN WrStr(" pid "); WrHex(ORD(f[i]),1) END;
  INC(i);

  WrQuali(q);
  WrdB(volt);
(*
IO.WrCard(bufree(), 3);
*)
  WrLn;

  IF NOT noinfo THEN
    d:=FALSE;
    WHILE i<len DO
      IF f[i]<>15C THEN WCh(f[i]); d:=TRUE;
      ELSIF d THEN WrLn; d:=FALSE END;
      INC(i);
    END;
    IF d THEN WrLn END;
  END;

(*
FOR i:=0 TO len-1 DO WrStr("\"); WrInt(ASH(ORD(f[i]), -6),1);
 IO.WrCard(ORD(f[i]) DIV 8 MOD 8,1);IO.WrCard(ORD(f[i]) MOD 8,1);
END;
IO.WrLn;
*)

END ShowFrame;



PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;







PROCEDURE Fir(in, sub, step:CARDINAL; VAR fir, firtab:ARRAY OF REAL):REAL;
VAR s:REAL;
    i:CARDINAL;
BEGIN
  s:=0.0;
  i:=sub;
  REPEAT
    s:=s + fir[in]*firtab[i];
    INC(in);
    IF in>HIGH(fir) THEN in:=0 END;
    INC(i, step);
  UNTIL i>HIGH(firtab);
  RETURN s
END Fir;


PROCEDURE noiselevel(m:CARDINAL):REAL;             (* 0.0 perfect, ~0.25 noise only*)
BEGIN
  WITH modpar[m] DO
    IF sqmed[TRUE]=sqmed[FALSE] THEN RETURN 0.0
    ELSE RETURN noise/(sqmed[TRUE]-sqmed[FALSE]) END;
  END;
END noiselevel;




PROCEDURE demodbit(m:INTEGER; d:BOOLEAN);
VAR xor:BOOLEAN;
BEGIN
  WITH modpar[m] DO

(*descrambler*)
    IF scramb THEN
(*
      scrambler:=CAST(BITSET, CAST(CARDINAL, scrambler)*2 + ORD(d)); 
*)
      scrambler:=SHIFT(scrambler, 1);
      IF d THEN INCL(scrambler, 0) END; 
      d:=(0 IN scrambler) = ((12 IN scrambler) = (17 IN scrambler));  (*result is xor bit 0 12 17*)
    END; 

(*nrzi*)
    xor:=d;
    d:=d=data1;
    data1:=xor;
(*
IO.WrCard(ORD(d),1);
*)

(*bert*)
    IF bert<>0 THEN
      IF NOT d THEN INC(berterr) END;
      INC(bertc);
      IF bert<0 THEN                                      (* receive only *)
        INC(bert);
        IF bert=0 THEN WrStrLn("---- end BERT") END;
      END;
      IF bertc>2000 THEN
        WrInt(berterr, 4);
        WrInt(m, 2);
        WrQuali(noiselevel(m));
        WrdB(chan[ch].adcmax);
        WrLn;
        bertc:=0;
        berterr:=0;
      END; 
    END;


    IF rxstuffc<STUFFLEN THEN
(*bit to byte*)
      rxbyte:=rxbyte DIV 2 + ASH(ORD(d), 7);
      INC(rxbitc);

(*crc*)
      xor:=d <> (0 IN rxcrc);                                 (*databit xor crcbit0*)
(* 
      rxcrc:=CAST(BITSET, CAST(CARDINAL, rxcrc) DIV 2);       (*shift right crc register*)
*)
      rxcrc:=SHIFT(rxcrc, -1);
      IF xor THEN rxcrc:=rxcrc/POLYNOM END;                   (*xor with polinom*)

(*byte to frame*)
      IF rxbitc>=8 THEN

(*
IO.WrStr(" <");IO.WrHex(rxbyte, 1);IO.WrStr("> ");
*)
        IF rxp<MAXLEN THEN
          rxbuf[rxp]:=CHR(rxbyte);
          INC(rxp);
        END;                                                  (*else frame too long error*)
        rxbitc:=0;
      END;

    ELSIF rxstuffc>STUFFLEN THEN                              (*flag*)
(*flag*)

      IF NOT d                                                (*0111111x 0 is flag else abort*)
      & (rxbitc=STUFFLEN+1)                                   (*bits modulo 8 ?*)
      & (rxp>=MINFLEN) THEN                                   (*frame long enough ?*)

        IF rxcrc=CRCRESULT THEN sendkiss(rxbuf, rxp-2, port16) END;
        IF (monitor=passall) OR (rxcrc=CRCRESULT) & (monitor<>off) THEN 
          ShowFrame(rxbuf, rxp-2, ASH(port16, -4), noiselevel(m), chan[ch].adcmax, monitor=noinfo);
        END;
      END;

      rxp:=0;
      rxbitc:=0;
      rxcrc:=CRCINIT;                                         (*init crc register*)
    END;
    IF d THEN INC(rxstuffc) ELSE rxstuffc:=0 END;
(*destuffing*)
  END;
END demodbit;





PROCEDURE demod(u:REAL; m:INTEGER);
VAR d:BOOLEAN;
BEGIN
  d:=u>=0.0;
  WITH modpar[m] DO
    IF cbit THEN
      demodbit(m, d); 
      IF d<>oldd THEN

        IF d=plld THEN INC(baudfine, pllshift) ELSE DEC(baudfine, pllshift) END;

        oldd:=d;
      END; 

(*squelch*)
      sqmed[d]:=sqmed[d] + (u-sqmed[d])*0.05;
      noise:=noise + (ABS(u-sqmed[d])-noise)*0.05; 
(*squelch*)

    ELSE plld:=d END;
    cbit:=NOT cbit;
  END;
END demod;

(*
PROCEDURE Afsk(m:INTEGER);
VAR right, mid, d, a, b, ff:REAL;
BEGIN
  WITH modpar[m] DO
    right:=Fir(afin, 0, AOVERSAMP, chan[ch].afir, afirtab);
(*
tii:=VAL(INTEGER, right/3.0); 
FIO.WrBin(tfd, tii, 2);
*)
    IF (left<0.0)<>(right<0.0) THEN
      d:=left/(left-right);
      a:=FLOAT(TRUNC(d*FLOAT(AOVERSAMP)+0.5));
      b:=a * (1.0/FLOAT(AOVERSAMP));
      IF (TRUNC(a)>0) & (TRUNC(a)<AOVERSAMP) THEN
        mid:=Fir(afin, AOVERSAMP-TRUNC(a), AOVERSAMP, chan[ch].afir, afirtab);
        IF (left<0.0)<>(mid<0.0) THEN d:=left/(left-mid)*b;
        ELSE d:=b + mid/(mid-right)*(1.0-b) END; 
      END;
(*
IO.WrStr(" left=");IO.WrFixed(left, 0,1);
IO.WrStr(" mid="); IO.WrFixed(mid, 0,1);
IO.WrStr(" right=");IO.WrFixed(right, 0,1);
IO.WrStr(" d=");IO.WrFixed(d, 2,1);
IO.WrStr(" a=");IO.WrFixed(a, 2,1);
IO.WrLn;
*)

(*
mid:=Fira(afin, AOVERSAMP DIV 2)-left;   
right:=right-left;
b:=right*0.5 - mid;
a:=(right*0.25 - mid)/b;
d:=sqrt(a*a - left/b);
IF a>=0.0 THEN d:=-d END;
d:=(d+a)*0.5;
*)
      IF tcnt+d<>0.0 THEN freq:=1.0/(tcnt+d) END;
      tcnt:=0.0-d;
    END;

    tcnt:=tcnt+1.0;
    left:=right;
    dfir[dfin]:=freq - afskmidfreq;   
    dfin:=(dfin+1) MOD DFIRLEN;
    INC(baudfine, demodbaud);
    IF baudfine>=BAUDSAMP THEN
      DEC(baudfine, BAUDSAMP);  
      ff:=Fir(dfin, DOVERSAMP - baudfine DIV (BAUDSAMP DIV DOVERSAMP), DOVERSAMP, dfir, dfirtab);
      demod(ff, m);  
    END;
  END;
END Afsk;
*)

PROCEDURE Afsk(m:INTEGER);
VAR right, mid, d, a, b, ff:REAL;
BEGIN
  WITH modpar[m] DO
    right:=Fir(afin, 0, AOVERSAMP, chan[ch].afir, afirtab);
    IF (left<0.0)<>(right<0.0) THEN
      d:=left/(left-right);
      a:=FLOAT(TRUNC(d*FLOAT(AOVERSAMP)+0.5));
      b:=a * (1.0/FLOAT(AOVERSAMP));
      IF (TRUNC(a)>0) & (TRUNC(a)<AOVERSAMP) THEN
        mid:=Fir(afin, AOVERSAMP-TRUNC(a), AOVERSAMP, chan[ch].afir, afirtab);
        IF (left<0.0)<>(mid<0.0) THEN d:=left/(left-mid)*b;
        ELSE d:=b + mid/(mid-right)*(1.0-b) END; 
      END;
      IF tcnt+d<>0.0 THEN freq:=1.0/(tcnt+d) END;
      tcnt:=0.0-d;
    END;

    tcnt:=tcnt+1.0;
    left:=right;
    dfir[dfin]:=freq - afskmidfreq;   
    dfin:=(dfin+1) MOD DFIRLEN;
    INC(baudfine, demodbaud);
    IF baudfine>=BAUDSAMP THEN
      DEC(baudfine, BAUDSAMP);  
      IF baudfine<BAUDSAMP THEN       (* normal alway true *)
        ff:=Fir(dfin, DOVERSAMP - baudfine DIV (BAUDSAMP DIV DOVERSAMP), DOVERSAMP, dfir, dfirtab);
        demod(ff, m);  
      END;
    END;
  END;
END Afsk;



PROCEDURE Fsk(m:INTEGER);
VAR ff:REAL;
    lim:INTEGER;
BEGIN
  WITH modpar[m] DO 
    lim:=demodbaud;
    LOOP
      IF baudfine>=BAUDSAMP THEN
        DEC(baudfine, BAUDSAMP);
        ff:=Fir(afin, baudfine MOD BAUDSAMP DIV (BAUDSAMP DIV AOVERSAMP), AOVERSAMP, chan[ch].afir, afirtab);
        demod(ff-(left+freq)*0.5, m);
(*clamp*)
        IF NOT cbit THEN 
          IF ff>left THEN left:=left+(ff-left)*1.0 END;
          IF ff<freq THEN freq:=freq+(ff-freq)*1.0 END;
          left:=left*clamp;
          freq:=freq*clamp;
        END;
(*clamp*)
      END;
      INC(baudfine, lim);
      lim:=0;
      IF baudfine<BAUDSAMP*2 THEN EXIT END;

    END;
  END;
END Fsk;


(*pp065*)
PROCEDURE setppout(fd:INTEGER; mask:SET32):BOOLEAN;
CONST PORTCFG=40026206H;

VAR pc:SET32;
    r:CARDINAL;
BEGIN
  r:=100;
  LOOP
    pc:=SET32{30};
    IF ioctl(fd, CAST(INTEGER, PORTCFG), ADR(pc))=0 THEN EXIT END;
    DEC(r);
    IF r=0 THEN pc:=SET32{}; EXIT END;
  END;
  pc:=pc*SET32{0..15}+SET32{31}+mask+SHIFT(mask,1);
  RETURN ioctl(fd, CAST(INTEGER, PORTCFG), ADR(pc))=0;
END setppout;

PROCEDURE ppbitset(fd:INTEGER; port:CARDINAL; on:BOOLEAN);
CONST PARWR=40026207H;
VAR res:INTEGER;
BEGIN
--IO.WrInt(port, 3); IO.WrInt(ORD(on) , 3); IO.WrStrLn("ppout");
  res:=ioctl(fd, CAST(INTEGER, PARWR), CAST(ADDRESS,SET32{port+ORD(NOT on)*8}));
END ppbitset;
(*pp065*)



PROCEDURE Ptt;
VAR lptfd, b:INTEGER;
    map, mask:SET8;
    c:CHANNELS;
    ppmask:SET32;
BEGIN
--WrInt(ORD(chan[LEFT].pttstate),2); WrInt(ORD(chan[RIGHT].pttstate),1);WrStrLn("=ptts");
(*tty*)
  IF ttyfn[0]<>0C THEN
(*
    IF ttyfd<0 THEN ttyfd:=FIO.OpenMode(ttyfn, FIO.oRDWR+FIO.oNONBLOCK) END;
*)
    IF ttyfd<0 THEN ttyfd:=open(ttyfn, 0) END;
    IF ttyfd>=0 THEN

      IF NOT SetStatLine(ttyfd, chan[LEFT].pttstate, chan[RIGHT].pttstate)
      OR closetty THEN
        Close(ttyfd);
        ttyfd:=-1;
      END;                                      (* else keep open for alzheimer usb devices *)
    ELSE WrStrLn("tty port open error") END;
  END;
(*tty*)

  IF parporttyp=1 THEN
(*parport*)
    mask:=SET8{};
    map:=SET8{};
    FOR c:=LEFT TO RIGHT DO 
      b:=chan[c].lptpttbit;
      IF b<>0 THEN
        IF chan[c].pttstate=(b>=0) THEN INCL(map, ABS(b)-1) END;
        INCL(mask, ABS(b)-1);
      END;
    END; 
      IF mask<>SET8{} THEN
      lptfd:=open(lptfn, oRDWR);
      IF (lptfd<0) OR (lpt.ppclaim(lptfd)<0) THEN WrStrLn("lpt port open error");
      ELSE 
        map:=(CAST(SET8, lpt.ppdevrdata(lptfd))-mask) + map;
        lpt.ppdevdata(lptfd, CAST(CHAR, map));
      END;
      IF (lptfd>=0) THEN Close(lptfd) END;
    END;
(*parport*)

  ELSIF parporttyp=2 THEN
(*pp065*)
    lptfd:=open(lptfn, oRDWR);
    IF lptfd>=0 THEN 
      ppmask:=SET32{};
      FOR c:=LEFT TO RIGHT DO
        b:=chan[c].lptpttbit;
        IF b<>0 THEN INCL(ppmask, (ABS(b)-1)*2) END;
      END;
      IF setppout(lptfd, ppmask) THEN
        FOR c:=LEFT TO RIGHT DO
          b:=chan[c].lptpttbit;
          IF b<>0 THEN
            ppbitset(lptfd, ABS(b)-1, chan[c].pttstate=(b>=0));
          END;
        END;
      END;
      Close(lptfd);
    ELSE WrStr(lptfn); WrStrLn(" port open error") END;
  END; 
(*pp065*)


END Ptt;


PROCEDURE repairsound;                                  (* (usb) soundcard died *)
VAR i:CARDINAL;
BEGIN
--  pttok:=FALSE;
  Ptt;
  IF abortonsounderr THEN Error("Sounddevice Failure");
  ELSE
    Close(soundfd);
    Usleep(100000);
--WrStrLn("openA");
    OpenSound;
  END;
END repairsound;


PROCEDURE getadc;
VAR buf:ARRAY[0..ADCBUFLEN-1] OF ADCWORD;
    l, i, m, sl, maxl, minl, maxr, minr:INTEGER;
    c: CHANNELS;
BEGIN
  l:=read(soundfd, ADR(buf), adcbuflen*adcbytes);
  FOR m:=0 TO HIGH(modpar) DO modpar[m].noise:=modpar[m].noise*0.99 END; (* clear dcd on silence *)

  IF l<0 THEN repairsound; RETURN END; 

  IF debfd>=0 THEN i:=write(debfd, ADR(buf), l) END;
  l:=VAL(CARDINAL, l) DIV adcbytes; 
  FOR c:=LEFT TO RIGHT DO chan[c].adcmax:=ASH(chan[c].adcmax*15, -4) END;
  maxl:=MIN(ADCWORD);
  maxr:=MIN(ADCWORD);
  minl:=MAX(ADCWORD);
  minr:=MAX(ADCWORD);
  i:=0;
  WHILE i<l DO
    sl:=buf[i];
    chan[LEFT].afir[afin]:=VAL(REAL, sl);
    IF sl>maxl THEN maxl:=sl END;
    IF sl<minl THEN minl:=sl END;
    IF maxl-minl>chan[LEFT].adcmax THEN chan[LEFT].adcmax:=maxl-minl END; 
    IF maxchannels>LEFT THEN
      sl:=buf[i+1];
      chan[RIGHT].afir[afin]:=VAL(REAL, sl);
      IF sl>maxr THEN maxr:=sl END;
      IF sl<minr THEN minr:=sl END;
      IF maxr-minr>chan[RIGHT].adcmax THEN chan[RIGHT].adcmax:=maxr-minr END;
    END;
    afin:=(afin+1) MOD AFIRLEN;

    FOR m:=0 TO HIGH(modpar) DO
      WITH modpar[m] DO
        IF configured & (chan[ch].adcmax>=leveldcd)
        & (NOT chan[ch].pttstate OR (chan[ch].duplex<>simplex)) THEN    (* save cpu and echo reception *)
          IF afsk THEN Afsk(m) ELSE Fsk(m) END;
(*
IF (m=0) & (clock MOD 64=0) THEN IO.WrInt(chan[modpar[m].ch].adcmax,6); IO.WrLn; END;
*)
          IF noiselevel(m)<squelchdcd THEN 
            chan[ch].dcdclock:=clock;                (* tx wise dcd *)             
            dcdclockm:=clock;                        (* modem wise dcd for shift digi*)
          END;
        ELSE rxp:=0 END;                             (* delete frame for savety *) 
      END;
    END;
    INC(i, ORD(maxchannels)+1);
  END;
END getadc;


PROCEDURE txmon(pf:pKISSNEXT);
BEGIN
  IF (pf<>NIL) & (modpar[ORD(pf^.port)].monitor<>off) THEN
    ShowFrame(pf^.data, pf^.len, ORD(pf^.port), 0.0, 0, modpar[ORD(pf^.port)].monitor=noinfo);
  END;
END txmon;


PROCEDURE Phasemod(VAR uc:REAL; u, hp:REAL):REAL;
VAR ud:REAL;
BEGIN
  ud:=u-uc;
  uc:=uc+ud*hp;
  RETURN ud
END Phasemod;

PROCEDURE Free(VAR tb:pKISSNEXT);
VAR ph:pKISSNEXT;
BEGIN
  IF tb<>NIL THEN
    ph:=tb^.next;
    tb^.next:=pTxFree;
    pTxFree:=tb;
    tb:=ph;
  END;
END Free;

PROCEDURE frames2tx(modem:INTEGER):BOOLEAN;
BEGIN
  IF modpar[modem].txbufin=NIL THEN RETURN FALSE END;

  IF modpar[modem].txbufin^.time>systime THEN RETURN TRUE END;

  Free(modpar[modem].txbufin);                                     (* frame too old *)
  RETURN FALSE
END frames2tx;


PROCEDURE sendmodem;

VAR buf:ARRAY[0..ADCBUFLEN-1] OF ADCWORD;
    i:INTEGER;     
    clk:CARDINAL;
    samp:REAL;
    c:CHANNELS;
    ph:pKISSNEXT;
BEGIN
  IF soundbufs>0 THEN DEC(soundbufs) END;
  FOR c:=LEFT TO maxchannels DO
    WITH chan[c] DO
      IF pttsoundbufs>0 THEN DEC(pttsoundbufs) END;
      IF state=receiv THEN
        FOR i:=0 TO HIGH(modpar) DO                                (* has any modem data? *)
(*
          IF modpar[i].txbufin<>NIL THEN
            IF c=modpar[i].ch THEN actmodem:=i END;  
          END;
*)
          IF frames2tx(i) & (c=modpar[i].ch) THEN actmodem:=i END;  

        END;
(*
        IF (actmodem<0) OR (modpar[actmodem].txbufin=NIL) THEN     (* no data to send *)
*)
        IF (actmodem<0) OR NOT frames2tx(actmodem) THEN            (* no data to send *)
(*
IF soundctl.getoutfilled(soundfd)<=0 THEN soundctl.pcmsync(soundfd) END;
IF soundctl.getoutfilled(soundfd)>0 THEN IO.WrInt(soundctl.getoutfilled(soundfd),1); IO.WrLn; END;
*)
          IF pttstate & (pttsoundbufs=0) 
          THEN pttstate:=FALSE; Ptt END;                           (* guess all sound buffers are sent*) 
        ELSIF pttstate THEN                                        (* more data, ptt is on*)
          state:=sendtxdel;
          tbitc:=0;
          tbytec:=0;
          txmon(modpar[actmodem].txbufin);
        ELSE                                                       (* data ptt off *) 
          tbytec:=0;
          state:=slotwait;
          addrandom:=2+TRUNC(Random()*persist);                    (* store ramdom wait *)
          dcdclock:=clock;                                         (* start txwait after we sent *)
        END;
      END;

      IF state=slotwait THEN
        IF duplex=shiftdigi THEN 
          clk:=modpar[actmodem].dcdclockm;   (* use dcd of this modulation *)
        ELSE clk:=dcdclock END;              (* use dcd of latest heard modulation *)

        IF (duplex=fullduplex) OR (clock-clk > addrandom) THEN
          IF frames2tx(actmodem) THEN
            txmon(modpar[actmodem].txbufin);
            chan[c].pttstate:=TRUE; Ptt;

            chan[c].gmcnt:=chan[c].gmqtime;
            pttsoundbufs:=soundbufs+extraaudiodelay;
            state:=sendtxdel;
            tbitc:=0;
            tbytec:=0;
          ELSE state:=receiv END;                                 (* data timed out *)
        END; 
      END;
    END;
  END;

  WHILE (soundbufs<maxsoundbufs) & ((chan[LEFT].state>=sendtxdel) OR (chan[RIGHT].state>=sendtxdel)) DO
    FOR i:=0 TO VAL(INTEGER, adcbuflen-1) DO
      IF maxchannels=RIGHT THEN c:=VAL(CHANNELS, i MOD 2) ELSE c:=LEFT END;
      WITH chan[c] DO

        IF state>=sendtxdel THEN
          samp:=TFIR[txbaudgen DIV (BAUDSAMP DIV TFIRFINE)][CAST(CARDINAL, tscramb) MOD TFIRLEN];

          IF modpar[actmodem].afsk THEN
            dds:=(dds + VAL(CARDINAL, samp*modpar[actmodem].afshift + modpar[actmodem].afmid)) MOD (HIGH(SIN)+1);
            buf[i]:=VAL(INTEGER, Phasemod(hipasscap, SIN[dds]*modpar[actmodem].txvolum, modpar[actmodem].afskhighpass));
          ELSE buf[i]:=VAL(INTEGER, samp*modpar[actmodem].txvolum) END;

          IF gmcnt>0 THEN buf[i]:=0; DEC(gmcnt) END;

          txbaudgen:=txbaudgen + modpar[actmodem].txbaud;
          IF txbaudgen>=BAUDSAMP THEN
            DEC(txbaudgen, BAUDSAMP);

(*send next bit *)

            IF tbitc<=0 THEN
              tbitc:=8;
              IF state=sendtxdel THEN
                IF modpar[actmodem].bert>0 THEN 
                  tbyte:=255;
                  DEC(modpar[actmodem].bert, 8);
                ELSE
                  tbyte:=modpar[actmodem].txdelpattern;
                  INC(tbytec);
                END;
                IF tbytec>=modpar[actmodem].txdel THEN tbyte:=126 END;  (* 1 flag minimum *)
                IF tbytec>modpar[actmodem].txdel THEN
                  state:=senddata;
                  tbytec:=0;
                  txstuffc:=0;
                END;
              END;
              IF state=sendtxtail THEN
                tbyte:=126;
                INC(tbytec);
(*next frame*)
                IF modpar[actmodem].txbufin<>NIL THEN    (* same modem *)
                  tbytec:=0;
                  state:=senddata;
                  txstuffc:=0;
                  txmon(modpar[actmodem].txbufin);
                ELSIF tbytec>modpar[actmodem].txtail THEN state:=receiv END; (* no data for this modem *)
              END;

              IF state=senddata THEN
                WITH modpar[actmodem] DO
                  IF (txbufin=NIL) OR (tbytec>=txbufin^.len+2) THEN
(*frame sent*) 
                    Free(txbufin);
                    state:=sendtxtail;
                    tbyte:=126;
                    tbytec:=0;
                  ELSE 
                    tbyte:=ORD(txbufin^.data[tbytec]);
                    INC(tbytec);
                  END; 
                END;
              END;
            END;
(*stuff*)
            IF ODD(tbyte) & (state=senddata) THEN
              INC(txstuffc);
              IF txstuffc>=5 THEN 
                INC(tbyte,tbyte-1);
                INC(tbitc);
                txstuffc:=0;
              END;
            ELSE txstuffc:=0 END;
(*stuff*)
(* nrzi *)
            IF NOT ODD(tbyte) THEN tnrzi:=NOT tnrzi END;
(*
            IF modpar[actmodem].scramb THEN
              tscramb:=CAST(BITSET, CAST(CARDINAL, tscramb)*2+ORD(tnrzi <> ((11 IN tscramb) <> (16 IN tscramb))));
            ELSE tscramb:=CAST(BITSET, CAST(CARDINAL, tscramb)*2+ORD(tnrzi)) END;
*)
            tscramb:=SHIFT(tscramb, 1);
            IF modpar[actmodem].scramb THEN
              IF tnrzi <> ((12 IN tscramb) <> (17 IN tscramb)) THEN INCL(tscramb, 0) END;
            ELSIF tnrzi THEN INCL(tscramb, 0) END;

            tbyte:=ASH(tbyte, -1);
            DEC(tbitc);
          END;
        ELSE buf[i]:=0 END;
      END;
    END;
--    WrBin(soundfd, buf, adcbuflen*adcbytes);
    i:=write(soundfd, ADR(buf), adcbuflen*adcbytes);

    FOR c:=LEFT TO RIGHT DO
      WITH chan[c] DO
        IF state>=sendtxdel THEN INC(pttsoundbufs) END;
      END;
    END; 
    INC(soundbufs);

  END;
END sendmodem;


BEGIN
  Parms;
  Gencrctab;
  initTFIR;
(*
tfd:=FIO.Create("/tmp/t.raw");
*)
  getst:=0;
  esc:=FALSE;
  afin:=0;
  soundbufs:=0;
  LOOP
    getadc;
    INC(clock);
    IF clock MOD 64=0 THEN

      Ptt;                                            (* sync ptt to hardware somtime *)
      systime:=time();
    END;
    getkiss;
    getudp;
    sendmodem;
(*
IO.WrStr("len="); IO.WrCard(txbuf[txp].len, 1); IO.WrStr("cmd="); IO.WrHex(ORD(txbuf[txp].cmd), 1);

FOR i:=1 TO txbuf[txp].len DO IO.WrHex(ORD(txbuf[txp].data[i-1]), 3) END;
IO.WrLn;   
*)
  END;
(*
  FIO.Close(pipefd);
*)
(*
FIO.Close(tfd);
*)
END afskmodem.

(* 
modprobe -a snd-pcm-oss und modprobe -a snd-mixer-oss

echo -ne "\300\000\000?123\300" > /dev/kiss/soundmodem
echo -ne "\300\000\236\212\152\260\204\230\140\236\212\152\210\260\230\141\003\360\124\145\163\164\300\300\000\236\212\152\260\204\230\140\236\212\152\210\260\230\141\003\160\164\145\163\164\300" > /dev/kiss/soundmodem
echo -ne "\300\000\174\100\100\100\100\100\340\236\212\152\210\260\230\140\236\212\144\260\264\244\140\236\212\152\260\204\230\143\003\360\164\145\163\164\300" > /dev/kiss/soundmodem
./afskmodem -t /dev/ttyS0 -m /dev/mixer:0:80:80:255:64:0 -f 16000 -c 2 -M 0 -b 1200 -c 0 -M 1 -b 9600 -a -g -c 0 -M 2 -b 1200 -c 1 -e 100 -M 3 -b 9600 -a -g -c 1
volume=0 pcm=4 line=6 mic=7 igain=12 ogain=13
    halfrate fir
    8/16 bit adc
    dcd led
    invert tty ptt
    -b 9600 default to fsk scambler -g 0 for scrambler off
    fir len
    tx equalizer
    clamp peak median
    revers clock regenerator
    exceptions
    ramdom ok ?
    send flags on empty channel
*) 
