<*+M2EXTENSIONS *>
<*-DOREORDER*>
<*+COMMENT*>
<* IF __GEN_C__ THEN *>
  <*+GENCTYPES*>
<* END *>

IMPLEMENTATION MODULE aprsdecode; (* connect to aprs-is gateway and decode data for archive and map by OE5DXL *)

FROM osi IMPORT WrStr, WrLn, WrInt, WrStrLn, FdValid, File, NextArg,
                RdBin, WrBin, CloseSock, Close, OpenAppend, OpenRead, OpenWrite,
                readsock, sendsock, connectto, openudp, bindudp, socknonblock,
                udpreceive, udpsend, SOCKET, Exists, DIRSEP,
                stoptxrx, getunack;

FROM xosi IMPORT beep, headmh, StartProg, PROCESSHANDLE;
FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8, FILL, INT16, CARD16;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM TimeConv IMPORT time; 
FROM aprspos IMPORT POSITION, distance, rad, GetPos, GetSym, KNOTS, WKNOTS, PI2, posvalid;
FROM aprsstr IMPORT TIME, Assign, Append, Length, IntToStr, StrToFix, mon2raw, ipv4tostr,
                    cleanfilename, HashCh, AppCRC, raw2mon, IPNUM, UDPPORT, GetIp2,
                    DateToStr, SET8, InStr, StrCmp, Delstr, Caps, FixToStr, TimeToStr,
                    StrToCard, Extractword;

FROM useri IMPORT CONFSET, xerrmsg, debugmem, textautosize, nextmsg, refresh, isupdated,
                  confstr, confappend, configon, confstrings, configbool, AddConfLine,
                  conf2int, TILEBRIGHTNESS, beaconediting, beaconed, encerr, clrmsgtext,
                  conf2real, conf2str, confflags, beaconimported, wrheap;



FROM aprstext IMPORT degtopos, deghtopos, listin, postostr, FtoC;

CONST CALLLEN=7;
      HASHSIZE=65536;
      GATECONNDELAY=30;
      WATCH=180;
      QMAXTIME=15;
      MIDMOD=62;
      HOLDT=MAX(TIME);
      BEEPINVERVALL=5;                         (* min time between beeps *)
      TICKEROFFTIME=60;                        (* switch off window headline ticker after no data*) 
TYPE  
      SET256=SET OF [0..255];
      CHSET=SET OF [0C..177C];


      BEACON=RECORD
               bintervall: TIME;
               bfile     : FILENAME;
               btime     : TIME;
             END;

      TICKERCALL=ARRAY[0..30] OF CHAR;

CONST 
      cUSERMESSAGE=":";
      cTHIRDPARTY="}";
VAR 
    sentemptymsg,
    callsrc               : BOOLEAN;

    uptime                : TIME;
    logframename          : FILENAME;
--    netbeaconintervall, 
    beaconrandomstart,
    nextbeep,
    rfbecondone,
    lastmsgtx,
    qwatchtime,
    connecttime           : TIME;
    cycleservers,
    qas, qasc             : CARDINAL;
    logframes             : INTEGER;
--    passwd                : ARRAY[0..5] OF CHAR;
    trygate               : CARDINAL;
--    actudp                : pUDPSOCK;

    ungate                : ARRAY[0..6] OF MONCALL;
    timehash              : ARRAY[0..HASHSIZE-1] OF TIME;
    rfbeacont,
    dupetime              : TIME;
    msgmid                : CARDINAL;
    frameticker           : ARRAY[0..19] OF TICKERCALL;    (* calls in ticker headline *) 
    tickertime            : TIME;

PROCEDURE Err(text-:ARRAY OF CHAR);
BEGIN
  WrStr("aprsmap: "); WrStr(text); WrStrLn(" error abort");
  HALT
END Err;


PROCEDURE trunc(r:REAL):CARDINAL;
BEGIN 
  IF r<=0.0 THEN RETURN 0 ELSIF r>=MAX(INTEGER) THEN RETURN MAX(INTEGER) ELSE RETURN TRUNC(r) END;
EXCEPT
  WrStrLn("error in TRUNC() ");
  RETURN 0
END trunc;


(*
PROCEDURE trunc(r:REAL):CARDINAL;
VAR n:CARDINAL;
BEGIN
WrStrLn(" t1 ");
  IF r<=0.0 THEN n:=0 ELSIF r>=MAX(INTEGER) THEN n:=MAX(INTEGER) ELSE n:=TRUNC(r) END;
WrStrLn(" t2 ");
  RETURN n
END trunc;
*)

PROCEDURE floor(r:REAL):REAL;
VAR f:REAL;
BEGIN 
  f:=VAL(REAL, VAL(INTEGER, r));
  IF f>r THEN f:=f-1.0 END;
  RETURN f 
END floor;


PROCEDURE posinval(VAR pos:POSITION);
BEGIN pos.long:=0.0; pos.lat:=0.0 END posinval;

PROCEDURE Watchclock(VAR t:TIME; intervall:TIME):BOOLEAN;
VAR tn:TIME;
BEGIN
--WrInt(t, 10); WrInt(intervall, 10); WrLn;
  IF (intervall>0) OR (t=0) THEN                 (* send once *)
    tn:=realtime;
    IF t<=tn THEN
      INC(t, intervall);
      IF t<=tn THEN t:=tn+intervall END;
      RETURN TRUE
    ELSIF t>tn+intervall THEN t:=tn+intervall END;   (* if intervall changed to smaller *)
  END;
  RETURN FALSE
END Watchclock; 

PROCEDURE beeplim(lev:INTEGER; hz:CARDINAL; ms:CARDINAL);    (* beep with minimum quiet time *)
BEGIN
  IF realtime>=nextbeep THEN 
    beep(lev, hz, ms);
    nextbeep:=realtime+BEEPINVERVALL;
  END;
END beeplim;

PROCEDURE filepath(VAR s:ARRAY OF CHAR);                     (* get path out of path + filename *)
VAR i, j:CARDINAL;
BEGIN
  i:=0;
  j:=0;
  WHILE (i<HIGH(s)) & (s[i]<>0C) DO
    IF s[i]=DIRSEP THEN j:=i END;                            (* strip off at last dir separator *)
    INC(i);
  END;
  s[j]:=0C;
END filepath;



PROCEDURE alfanum(VAR s:ARRAY OF CHAR);                      (* clean received call to filename *)
VAR i,j:CARDINAL;
    c:CHAR;
BEGIN
  i:=0;
  j:=0;
  WHILE (i<HIGH(s)) & (s[i]<>0C) DO
    c:=CAP(s[i]);
    IF (c>="A") & (c<="Z") OR (c>="0") & (c<="9") OR (c="-") THEN s[j]:=c; INC(j) END;
    INC(i);
  END;
  IF j<=HIGH(s) THEN s[j]:=0C END;
END alfanum;


PROCEDURE GetNum(h:ARRAY OF CHAR; VAR p, n:CARDINAL):INTEGER;
VAR ok:BOOLEAN;
BEGIN
  h[HIGH(h)]:=0C;
  n:=0;
  ok:=FALSE;
  WHILE (h[p]>="0") & (h[p]<="9") DO
    ok:=TRUE;
    n:=n*10+ORD(h[p])-ORD("0");
    INC(p);
  END;
  IF NOT ok THEN RETURN -1 END;
  RETURN 0
END GetNum;


PROCEDURE parms;
VAR h          : ARRAY[0..4095] OF CHAR;
    err        : BOOLEAN;
    lasth      : CHAR;
    i, n       : CARDINAL;
    gatecnt    : CARDINAL;
    ii         : INTEGER;
BEGIN
  err:=FALSE;
  verb:=FALSE;
  gatecnt:=0;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN
      lasth:=h[1];
(*
      IF (lasth="s") OR (lasth="S") THEN
        NextArg(h);
        Assign(servercall, h);
        IF (h[0]=0C) OR (h[0]="-") OR ((lasth="s") & NOT callok(h)) THEN Err("-s call-ssid") END;
*)
(*
      IF lasth="p" THEN
        NextArg(h);
        IF (h[0]>="0") & (h[0]<="9") THEN
          i:=0;  
          WHILE (i<=HIGH(passwd)) & (h[i]>=" ") DO passwd[i]:=h[i]; INC(i) END;
        ELSE
          fdf:=OpenRead(h);
          IF NOT FdValid(fdf) THEN Err("-p passcode or passwordfile") END;
          len:=RdBin(fdf, passwd, SIZE(passwd)-1);
          IF len>=0 THEN passwd[len]:=0C ELSE Err("-p error with password file") END;
          Close(fdf);
        END;
        passwd[HIGH(passwd)]:=0C;
        i:=0; 
        WHILE (passwd[i]>="0") & (passwd[i]<="9") DO INC(i) END;
        IF (i=0) OR (passwd[i]<>0C) THEN Err("-p invalid passcode") END;
*)
(*
      ELSIF lasth="n" THEN
        NextArg(h);
        i:=0;
        IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN
          netbeaconintervall:=n*60;
          INC(i);
          FOR n:=0 TO HIGH(netbeaconfn) DO
            IF i<=HIGH(h) THEN
              netbeaconfn[n]:=h[i];
              INC(i);
            END;
          END;
          IF netbeaconfn[0]<=" " THEN Err("-n netbeacon filename") END;
        ELSE Err("-n netbeacon format is minutes:file") END;
*)
(*
      IF lasth="f" THEN
        NextArg(h);
        Assign(serverrangefilter, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-f rangefilter") END;
        FOR i:=0 TO Length(serverrangefilter) DO
          IF serverrangefilter[i]="," THEN serverrangefilter[i]:=" " END;
        END;  

      IF lasth="G" THEN
        NextArg(h);
        WITH lums DO
         IF NOT StrToFix(gamma, h) OR (gamma<0.1) OR (gamma>10.0) THEN Err("-G gamma (0.1..10)") END;
        END;
*)
(*
      IF (lasth="R") OR (lasth="M") THEN
        NextArg(h);
        ALLOCATE(usock, SIZE(usock^)); debugmem.req:=SIZE(usock^); INC(debugmem.mon, debugmem.req);
        IF usock=NIL THEN Err("out of memory") END;

        FILL(usock, 0C, SIZE(usock^));
        WITH usock^ DO
          IF GetIp2(h, ip, dport, bindport, checkip)<0 THEN Err("-R or -M need ip:port:port") END;
          fds:=openudp();
          INC(udpch);
          chan:=udpch;
          rawread:=lasth="R";
          IF (CAST(INTEGER,fds)<0) OR (bindudp(fds, bindport)<0) THEN Err("-R or -M cannot bind udpport") END;

          len:=socknonblock(fds);
*)
(*
          fd:=fds; 
          ii:=InStr(h, "+");
          IF ii>0 THEN 
            i:=ii+1;
            IF (GetSec(h,i,n)>=0) THEN 
              maxbytes:=n;
              INC(i);
              IF (h[i-1]=":") & (GetSec(h,i,n)>=0) THEN torfradius:=FLOAT(n) END;
            END;
          END;
*)
(*
          next:=NIL;
        END;
        IF udpsocks=NIL THEN udpsocks:=usock;
        ELSE 
          ush:=udpsocks; 
          WHILE ush^.next<>NIL DO ush:=ush^.next END; 
          ush^.next:=usock;
        END; 
*)
      IF lasth="x" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n>=30) THEN initxsize:=n ELSE Err("-x xsize") END;

      ELSIF lasth="y" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n>=20) THEN initysize:=n ELSE Err("-y xsize") END;
 
      ELSIF lasth="z" THEN
        NextArg(h);
        IF NOT StrToFix(parmfinezoom, h) OR (parmfinezoom<=1.0) THEN Err("-z zoomlevel") END;
        n:=trunc(parmfinezoom);
        parmfinezoom:=1.0+parmfinezoom-FLOAT(n);
        parmzoom:=n;

      ELSIF lasth="m" THEN
        NextArg(h);
        IF NOT StrToFix(mappos.long, h) THEN Err("-m long lat") END;
        NextArg(h);
        IF NOT StrToFix(mappos.lat, h) THEN Err("-m long lat") END;
        mappos.long:=rad(mappos.long);
        mappos.lat:=rad(mappos.lat);
 

      ELSIF lasth="g" THEN
        NextArg(h);
        IF gatecnt>HIGH(gateways) THEN Err("-g gateway table full") END;
(*
        Assign(gateways[gatecnt].url, h);
        IF h[0]=0C THEN Err("-g url port") END;
        NextArg(h);
        Assign(gateways[gatecnt].port, h);
        IF h[0]=0C THEN Err("-g url port") END;
*)

        h[HIGH(h)]:=0C;
        IF h[0]="[" THEN
          ii:=1;
          WHILE (h[ii]<>0C) & (h[ii]<>"]") DO INC(ii) END;
          IF (h[ii]<>"]") OR (h[ii+1]<>":") THEN Err("-g [url]:port") END;

          h[ii]:=0C;
          i:=1;
          WHILE i<=HIGH(h) DO h[i-1]:=h[i]; INC(i) END;

        ELSE ii:=InStr(h, ":") END;
        IF ii>=0 THEN h[ii]:=0C END;
        Assign(gateways[gatecnt].url, h);
        IF ii>0 THEN                           (* port number *)
          INC(ii);
          i:=0;
          WHILE ii<=HIGH(h) DO h[i]:=h[ii]; INC(i); INC(ii) END;
        ELSE NextArg(h) END;

        h[HIGH(h)]:=0C;
        ii:=InStr(h, "#");
        IF ii>=0 THEN h[ii]:=0C END;
        IF h[0]=0C THEN Err("-g url:port") END;
        Assign(gateways[gatecnt].port, h);

        IF ii>0 THEN                           (* we have a filter string *)
          INC(ii);
          i:=0;
          WHILE ii<=HIGH(h) DO
            IF h[ii]="," THEN h[ii]:=" " END;
            h[i]:=h[ii];
            INC(i);
            INC(ii);
          END;
          Assign(gateways[gatecnt].filterst, h);
        END;





        INC(gatecnt);

      ELSIF lasth="h" THEN
        WrStrLn(" -g <url>:<port>#<filters> connect to APRS-IS gateway, repeat -g to other");
        WrStrLn("                gateways write favorites first for 1 activ link to the best");
        WrStrLn("                reachable and a polling link to revert immediately to preferred again");
        WrStrLn("                -g www.db0anf.de:14580#m/300 -g 127.0.0.1:3000 -g [::1]:3000");
        WrStrLn("                <filters> text sent to out connected server -f m/50");
        WrStrLn("                if blanks dont pass parameter settings use , (-f m/30,-d/CW)");
        WrStrLn("                ipv6 if enabled by kernel");
        WrStrLn(" -h             this");
        WrStrLn(" -M <ip>:<dport>/<lport>[+<byte/s>[:<radius>]]");
        WrStrLn("                udp rf port (monitor frame format) for local (t)rx");
        WrStrLn("                <dport>:<lport> read from any ip, dport=0 no tx");
        WrStrLn("                +byte/s enable inet to rf for services like WLNK, WHO-IS");
        WrStrLn("                :radius enable all inet to rf gate (from km around digi)");
        WrStrLn("                repeat -M for each radio port with a tx");
--        WrStrLn(" -n <min>:<file> netbeacon minutes:filename -n 10:netbeacon.txt");
--        WrStrLn("                beacon file like: !8959.00N/17959.00E&igate mars");
--        WrStrLn("                beacon file used by udpgate itself to find out own position");
        WrStrLn(" -o <outfile>   out file, delete after read");
--        WrStrLn(" -p <password>  login passwort for aprs-is servers -p 12345");
--        WrStrLn("                to hide password in commandline use file mode -p pass.txt");
        WrStrLn(" -R             same as -M but axudp format");
--        WrStrLn(" -s <call>      server call of this server -s MYCALL-10 (-S no callcheck)");
        WrStrLn(" -v             show frames and analytics on stdout");
        WrLn;

        HALT

      ELSIF lasth="C" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=100) THEN lums.centering:=n ELSE Err("-C center%") END;

      ELSIF lasth="X" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.sym:=n ELSE Err("-X symbollumen") END;

      ELSIF lasth="O" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.obj:=n ELSE Err("-O objectlumen") END;

      ELSIF lasth="W" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.waypoint:=n ELSE Err("-W waypointlumen") END;

      ELSIF lasth="A" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.text:=n ELSE Err("-A textlumen") END;

      ELSIF lasth="T" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.track:=n ELSE Err("-T tracklumen") END;

      ELSIF lasth="F" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n>0) THEN lums.firstdim:=n*60 ELSE Err("-F fadetime (min)") END;

      ELSIF lasth="V" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n>0) THEN lums.fps:=n ELSE Err("-V fps") END;

      ELSIF lasth="B" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n>0) THEN lums.maxdim:=n*60 ELSE Err("-B blanktime (min)") END;

      ELSIF lasth="P" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n>0) THEN lums.purgetime:=n*60 ELSE Err("-P purgetime (min)") END;

      ELSIF lasth="r" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.rf:=n ELSE Err("-r rftracklumen") END;

      ELSIF lasth="o" THEN
        NextArg(h);
        i:=0;
        IF (GetNum(h,i,n)>=0) & (n<=1024) THEN lums.map:=n ELSE Err("-o maplumen") END;

      ELSIF lasth="v" THEN
        verb:=TRUE;


      ELSE err:=TRUE END;
      (*h[0]:=0C;*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN Append(h, " ? use -h"); Err(h) END;
--  IF servercall[0]=0C THEN WrLn; WrStrLn("aprsmap: NO SERVERCALL ?"); WrLn; END;
END parms;


PROCEDURE getudp(usock:CARDINAL; VAR buf:FRAMEBUF):BOOLEAN;
VAR fromport     : UDPPORT;
    ipn          : IPNUM;
    crc1, crc2   : CHAR;
    len          : INTEGER;
    mlen         : CARDINAL;
    mbuf         : FRAMEBUF; 
    
BEGIN
  IF CAST(INTEGER, udpsocks[usock].fd)<0 THEN RETURN FALSE END;

  len:=udpreceive(udpsocks[usock].fd, buf, SIZE(buf), fromport, ipn);
  IF (len>2) & (len<CAST(INTEGER, SIZE(buf)))
  & (NOT udpsocks[usock].checkip OR (udpsocks[usock].ip=ipn)) THEN

--WrInt(udpsend(usock^.fd, buf, len, usock^.dport, usock^.ip), 1);WrStrLn(" us");

    buf[len]:=0C;
    IF udpsocks[usock].rawread THEN
      crc1:=buf[len-2];
      crc2:=buf[len-1];
      AppCRC(buf, len-2);
      IF (crc1<>buf[len-2]) OR (crc2<>buf[len-1]) THEN 
        IF verb THEN WrStrLn(" axudp crc error") END; 
        buf[0]:=0C;
      ELSE  
        raw2mon(buf, mbuf, len-2, mlen);
        buf:=mbuf;
      END; 
    END;

  ELSE RETURN FALSE END;
  RETURN TRUE
END getudp; 

PROCEDURE Gettcp(fd:SOCKET; VAR line, buf:FRAMEBUF; VAR pos:INTEGER):INTEGER;
VAR len,i,j:INTEGER;
BEGIN
  i:=pos;
  IF i>=SIZE(line) THEN i:=0 END;                             (* pos>SIZE is overflow mode *)
(*
  len:=RdBin(fd, line, SIZE(line)-i);
  IF len<=0 THEN RETURN -1 END;                               (* disconnected *)
*)
(*
  IF len<0 THEN len:=0 END;
*)
  len:=readsock(fd, line, SIZE(line)-i);

  IF len<0 THEN RETURN -1 END;

  IF pos>=SIZE(buf) THEN                                      (* hunt mode *)
    i:=0; 
    WHILE (i<len) & (line[i]<>12C) DO INC(i) END;
    IF i>=len THEN RETURN 0 END;                              (* no line start found *)
    pos:=0;
    INC(i);
    j:=0;
    WHILE i<len DO line[j]:=line[i]; INC(j); INC(i) END;
    len:=j;
  END;

  IF pos>0 THEN
    FOR i:=len-1 TO 0 BY -1 DO line[i+pos]:=line[i] END;      (* move up new *)
    FOR i:=0 TO pos-1 DO line[i]:=buf[i] END;                 (* ins buf before *)
    INC(len,pos);
    pos:=0;  
  END;

  i:=0;
  WHILE (i<len) & (line[i]<>12C) DO INC(i) END;
  IF i>=len THEN                                              (* no line end found *)
    WHILE pos<len DO buf[pos]:=line[pos]; INC(pos) END;       (* move to buf *)
    len:=0;  
  ELSE
    j:=i+1;
    WHILE j<len DO buf[pos]:=line[j]; INC(pos); INC(j) END;   (* move rest to buf *)  
    len:=i;
  END;
  line[len]:=0C;
  RETURN len
END Gettcp;

PROCEDURE saybusy(VAR fd:SOCKET; s:ARRAY OF CHAR);      (* send good by text and close tcp *)
VAR res:INTEGER;
BEGIN
  IF CAST(INTEGER,fd)>=0 THEN
    res:=sendsock(fd, s, Length(s));
    CloseSock(fd);
    fd:=CAST(SOCKET,-1);
  END;
END saybusy;

PROCEDURE saylinkbad(s:INTEGER);
VAR h,hh:ARRAY[0..100] OF CHAR;
BEGIN
  h:="AprsIs uplink delays ";
  IntToStr(s,1,hh); Append(h,hh); Append(h, "s");
  textautosize(0, 5, 6, 5, "r", h);
END saylinkbad; 

PROCEDURE WatchTXQ(sock:pTCPSOCK);
VAR qb, acked, rb, i, j, sent:INTEGER;
    rest:BOOLEAN;
BEGIN
  qb:=getunack(sock^.fd);                                   (* tcp unack sendqueue in byte *)
  IF qb=-1 THEN
    configbool(fALLOWGATE, FALSE);
    textautosize(0, 5, 6, 5, "r", "TCP-Stack on this OS not usable for Igate, gateing switched off");
  END; 
  sent:=sock^.txbytes-sock^.qwatch.lasttb;                  (* last second sent bytes *)
  IF (qb<=0) OR (sent<0) THEN sock^.qwatch.qsize:=0;        (* all ack or error so stop tracing *)
  ELSE                                                      (* we have unack bytes *)
    acked:=sock^.qwatch.lastqb-qb+sent;                     (* acked bytes in last s *)
    j:=0;
    rest:=FALSE;
    FOR i:=0 TO sock^.qwatch.qsize-1 DO
      rb:=sock^.qwatch.txbyte[i]-acked;
      sock^.qwatch.txbyte[j]:=rb;
      IF rb>0 THEN rest:=TRUE ELSE acked:=-rb END;
      IF rest THEN
        acked:=0;
        INC(j);
      END;
    END;
    sock^.qwatch.qsize:=j;
    IF sock^.qwatch.qsize<=HIGH(sock^.qwatch.txbyte) THEN
      sock^.qwatch.txbyte[sock^.qwatch.qsize]:=sent;
      INC(sock^.qwatch.qsize);
      IF sock^.qwatch.qsize>1 THEN saylinkbad(sock^.qwatch.qsize) END;
      IF sock^.qwatch.qsize>QMAXTIME THEN
        stoptxrx(sock^.fd, 2);                              (* delete unsent data *)
        saybusy(sock^.fd, CR+LF);                           (* close tcp immediately *)
        sock^.slowlink:=TRUE;                               (* for log message *)
      END;
    END;
  END;
  sock^.qwatch.lastqb:=qb;
  sock^.qwatch.lasttb:=sock^.txbytes;
END WatchTXQ;


PROCEDURE tickermon(port-:ARRAY OF CHAR; dir:CHAR; s-:ARRAY OF CHAR);
VAR dat:DAT;
    h, h1, h2:TICKERCALL;
    i, cnt:CARDINAL;    
BEGIN
  cnt:=conf2int(fWRTICKER, 0, 0, 99, 1);
--WrInt(cnt, 10); WrLn;
  IF (cnt>0) & (Decode(s, dat)>=0) THEN
    Assign(h2, port);
    h2[0]:=CAP(h2[0]);
    Append(h2, dir);
    Append(h2, dat.srccall);

    IF dat.wx.temp<>WXNIL THEN
      FixToStr(FtoC(dat.wx.temp) ,2, h);
      Append(h2, " ");
      Append(h2, h);
      Append(h2, "C");

    ELSIF (dat.altitude<MAX(INTEGER)) & (dat.altitude>=1000)
    & (dat.altitude>=conf2int(fALTMIN, 0, -10000, 65535, -10000)) THEN
      Append(h2, " "); IntToStr(dat.altitude, 1, h); Append(h2, h);
      Append(h2, "m");

    ELSIF (dat.speed>0) & (dat.speed<MAX(INTEGER)) THEN
      confstr(fKMH, h1);
      IF h1[0]<>0C THEN
        IntToStr(trunc(FLOAT(dat.speed)*KNOTS), 1, h);
        Append(h2, " ");  Append(h2, h); Append(h2, h1);
      END;

    END;

    FOR i:=HIGH(frameticker) TO 1 BY -1 DO frameticker[i]:=frameticker[i-1] END;
    frameticker[0]:=h2;
    IF tickertime<>realtime THEN
      Assign(headmh, h2);
      IF cnt>HIGH(frameticker) THEN cnt:=HIGH(frameticker) END;
      FOR i:=1 TO cnt-1 DO Append(headmh, "  *  "); Append(headmh, frameticker[i]) END;
      tickertime:=realtime;
    END;
  END;

END tickermon;

PROCEDURE Stopticker;
BEGIN
  Assign(headmh, CR);
  tickertime:=MAX(TIME)-TICKEROFFTIME;
  FILL(ADR(frameticker), 0C, SIZE(frameticker));
END Stopticker;


PROCEDURE wrmon(port:CARDINAL; dir:CHAR; s-:ARRAY OF CHAR);
VAR mcon:ARRAY[0..9] OF CHAR;
    ms:ARRAY[0..30] OF CHAR;
BEGIN
  IF port=0 THEN mcon:="n" ELSE IntToStr(port, 0, mcon) END;
 
  IF configon(fWRTICKER) THEN tickermon(mcon, dir, s) END;
--IF configon(fWRINCOM) THEN
    confstr(fWRINCOM, ms);
    IF InStr(ms, mcon)>=0 THEN
      Append(mcon, "+");
      listin(s, CAP(mcon[0]), dir, InStr(ms, mcon)>=0);
    END;
--END;
END wrmon;


PROCEDURE Sendtcp(to:pTCPSOCK; buf-:FRAMEBUF):BOOLEAN;
VAR len,i:INTEGER;
    ok:BOOLEAN;
BEGIN
  ok:=FALSE;
  IF to<>NIL THEN
    IF to^.connt>0 THEN wrmon(0, "<", buf) END;       (* do not mon the connected-test-transmissions *)
    len:=Length(buf);
    WITH to^ DO
      IF tlen+len<SIZE(tbuf) THEN
        FOR i:=0 TO len-1 DO tbuf[tlen]:=buf[i]; INC(tlen) END; 
        INC(txframes);
        INC(txbytes, len);
        lasttcptx:=realtime;
        ok:=TRUE;
      ELSIF verb THEN WrStrLn("tx buf overflow") END;
    END;
  END;
  RETURN ok
END Sendtcp;

PROCEDURE Sendudp(s-:ARRAY OF CHAR; uport:CARDINAL):BOOLEAN;
VAR len:INTEGER;
    raw:FRAMEBUF;
    ok:BOOLEAN;
BEGIN
  ok:=FALSE;
  IF (uport<=HIGH(udpsocks)) & (CAST(INTEGER,udpsocks[uport].fd)>=0)
  & (udpsocks[uport].dport>0) THEN
    mon2raw(s, raw, len);
    IF len>1 THEN
      len:=udpsend(udpsocks[uport].fd, raw, len, udpsocks[uport].dport, udpsocks[uport].ip);
      IF len>0 THEN
        wrmon(uport+1, "<", s);
        WITH udpsocks[uport] DO
          INC(txframes);
          INC(txbytes, len);
          lastudptx:=realtime;
          IF starttime=0 THEN starttime:=realtime END;
          ok:=TRUE;
        END;
      END;
    ELSIF verb THEN WrStrLn("wrong rf monitor format") END;
  END;
  RETURN ok
END Sendudp;

PROCEDURE getmypos(VAR pos:POSITION):BOOLEAN;
VAR s:ARRAY[0..20] OF CHAR;
BEGIN
  confstr(fMYPOS, s);
  deghtopos(s, pos);
  RETURN posvalid(pos)
END getmypos;


PROCEDURE beaconmacros(VAR s:ARRAY OF CHAR; path-, wdata:ARRAY OF CHAR; all:BOOLEAN);
CONST MSYM="\";
VAR i:CARDINAL;
    len,j:INTEGER;
    ds,ns:ARRAY[0..255] OF CHAR;
    fn:ARRAY[0..1023] OF CHAR;
    f:File;
    rw:CHAR;
BEGIN
  i:=0;
  ns[0]:=0C;
  WHILE (i<HIGH(s)) & (s[i]<>0C) DO
    IF (s[i]=MSYM) & (s[i+1]=MSYM) THEN
      INC(i, 2);
      IF (s[i]="z") & all OR (s[i]="Z") THEN   (* insert day, hour, min *)
        DateToStr(realtime, ds);
        ds[0]:=ds[8]; ds[1]:=ds[9]; ds[2]:=ds[11]; ds[3]:=ds[12]; ds[4]:=ds[14]; ds[5]:=ds[15];
        ds[6]:=0C;
        Append(ns, ds);

      ELSIF (s[i]="h") & all OR (s[i]="H") THEN        (* insert hour, min, s *)
        DateToStr(realtime, ds);
        ds[0]:=ds[11]; ds[1]:=ds[12]; ds[2]:=ds[14]; ds[3]:=ds[15]; ds[4]:=ds[17]; ds[5]:=ds[18];
        ds[6]:=0C;
        Append(ns, ds);

      ELSIF all THEN
     
        IF (s[i]="<") OR (s[i]=">") THEN        (* insert or write file *)
          rw:=s[i];
          fn[0]:=0C;
          INC(i);
          WHILE (i<HIGH(s)) & (s[i]<>0C) & (s[i]<>"<") & (s[i]<>">") DO
            Append(fn, s[i]);
            INC(i);
          END;
        
          IF rw="<" THEN                        (* read file *)
            f:=OpenRead(fn);
            IF FdValid(f) THEN
              len:=RdBin(f, ds, SIZE(ds)-1);
              Close(f);
              j:=0;
              WHILE (j<len) & (ds[j]<>CR) & (ds[j]<>LF) & (ds[j]<>0C) DO
                Append(ns, ds[j]);
                INC(j);
              END;
            ELSE
              Assign(s, "beacon macro file not readable "); Append(s, fn); 
              xerrmsg(s);
              s[0]:=0C;
              RETURN
            END;
          ELSIF wdata[0]<>0C THEN               (* write file *)
            f:=OpenWrite(fn);
            IF FdValid(f) THEN
              WrBin(f, wdata, Length(wdata));
              Close(f);
            END;
          END;

        ELSIF s[i]="\" THEN Append(ns, "\\");

        ELSIF s[i]="v" THEN Append(ns, VERS);

        ELSIF s[i]="l" THEN 
          confstr(fMYPOS, ds);
          Append(ns, ds);

        ELSIF s[i]="p" THEN
          Append(ns, path);

        ELSE
          Assign(s, "bad beacon macro "); Append(s, ns); Append(s, "???");
          xerrmsg(s);
          s[0]:=0C;
          RETURN
        END;
      ELSE Append(ns, MSYM+MSYM); Append(ns, s[i]) END;
    ELSE Append(ns, s[i]) END;
    INC(i);
  END;
  Assign(s, ns);
END beaconmacros;



PROCEDURE BuildNetBeacon(VAR h:ARRAY OF CHAR);      (* "!ddmm.mmNsdddmm.mms....." *)
VAR mypos:POSITION;
    h1, h2, h3:ARRAY[0..300] OF CHAR;
BEGIN
  confstr(fMYPOS, h1);
  confstr(fMYSYM, h3);
  confstr(fNBTEXT, h2);

  degtopos(h1, mypos);
  IF NOT posvalid(mypos) THEN xerrmsg("netbeacon: wrong my position"); h[0]:=0C; RETURN END;

  IF Length(h3)<>2 THEN xerrmsg("netbeacon: wrong symbol"); h[0]:=0C; RETURN END;

  Assign(h, "!");
  h1[8]:=h3[0];
  h1[18]:=h3[1];
  h1[19]:=0C;
  Append(h, h1);
  beaconmacros(h2, "", "", TRUE);
  Append(h, h2);
END BuildNetBeacon;

(*
PROCEDURE Testbeacon(b:ARRAY OF CHAR):BOOLEAN;
VAR dat:DAT;
BEGIN
  IF (b[0]=0C) OR (Decode(b, dat)<0) THEN RETURN FALSE END;
  IF dat.symt=0C THEN xerrmsg("Beacon: wrong Symbol"); RETURN FALSE END;
  RETURN TRUE
END Testbeacon;
*)

PROCEDURE SendNetBeacon(cp:pTCPSOCK; b-:FRAMEBUF):BOOLEAN;
VAR ret:INTEGER;
    dat:DAT;
BEGIN
  IF (b[0]=0C) OR (Decode(b, dat)<0) OR NOT Sendtcp(cp, b) THEN RETURN FALSE END;
 
  IF lums.logmode THEN ret:=Stoframe(ophist2, b, realtime, FALSE, dat)
  ELSE ret:=Stoframe(ophist, b, realtime, FALSE, dat) END;
  RETURN TRUE
END SendNetBeacon;

PROCEDURE SendNet(cp:pTCPSOCK; data-:ARRAY OF CHAR):BOOLEAN;  (* make net header append string and send *)
VAR s:FRAMEBUF;
    h:ARRAY[0..50] OF CHAR;
BEGIN
  confstr(fMYCALL, s);
  IF Length(s)<3 THEN xerrmsg("netbeacon: no mycall"); RETURN FALSE END;

  confstr(fMSGNETDEST, h);
  IF h[0]=0C THEN xerrmsg("netbeacon: no destination call"); RETURN FALSE END;

  Append(s, ">");
  Append(s, h);
  Append(s, ",TCPIP*:");
  Append(s, data);
  Append(s, CR+LF);
  RETURN SendNetBeacon(cp, s);
END SendNet;



PROCEDURE Timebeacon(cp:pTCPSOCK);
VAR h:FRAMEBUF;
    bt:TIME;
    ok:BOOLEAN;
BEGIN
--WrInt(ORD(configon(fALLOWNETTX)), 5); WrInt(ORD(configon(fCONNECT)), 5);WrStrLn(" tb1");
  bt:=conf2int(fNETBTIME, 0, 0, MAX(INTEGER), 0);
  IF configon(fALLOWNETTX) & configon(fCONNECT)
  & ((bt>=1) OR (cp^.beacont=0)) & Watchclock(cp^.beacont, bt) THEN
    IF (bt<60) & (bt>0) & (cp^.connt>0) THEN xerrmsg("Netbeacon: too fast") END;

(*
    qai:=TRUE; 
    IF (qas=1) OR (qas>qasc+1) THEN qai:=FALSE; INC(qasc) ELSE qasc:=0 END;
*)
    BuildNetBeacon(h);
    ok:=SendNet(cp, h);
  END;
END Timebeacon;


(*
PROCEDURE nibb(n:CARDINAL; VAR s:ARRAY OF CHAR);
BEGIN IF n<=9 THEN Append(s, CHR(n+ORD("0"))) ELSE Append(s,CHR(n+(ORD("a")-10))) END END nibb;
*)

PROCEDURE knottokmh(kn:INTEGER):INTEGER;
BEGIN 
  IF (kn>=0) & (kn<50000) THEN RETURN trunc(FLOAT(kn)*KNOTS + 0.5) ELSE RETURN 0 END;
END knottokmh;

PROCEDURE NoWX(VAR wx:WX);
BEGIN
  wx.gust:=WXNIL;
  wx.temp:=WXNIL;
  wx.rain1:=WXNIL;
  wx.rain24:=WXNIL;
  wx.raintoday:=WXNIL;
  wx.hygro:=WXNIL;
  wx.baro:=WXNIL;
  wx.lum:=WXNIL;
END NoWX;

PROCEDURE GetWX(VAR wx:WX; VAR course, speed:CARDINAL; buf-:ARRAY OF CHAR; VAR p:CARDINAL);
VAR wwind, wdir:REAL;

  PROCEDURE wpar(VAR v:REAL);
  VAR sn, dot, empty:BOOLEAN;
      c:CHAR;
      div, x:REAL;
  BEGIN
    dot:=FALSE;
    empty:=TRUE;
    sn:=buf[p]="t";
    x:=0.0;
    div:=1.0;
    LOOP
      INC(p);
      c:=buf[p];
      IF sn & (c="-") THEN div:=-div; empty:=FALSE;
      ELSIF (c>="0") & (c<="9") THEN 
        x:=x*10.0 + VAL(REAL, ORD(buf[p])-ORD("0"));
        IF x>100000.0 THEN RETURN END;

        IF dot THEN div:=div*0.1 END;
        empty:=FALSE;
      ELSIF empty THEN
        IF (c<>" ") & (c<>".") THEN EXIT END;
      ELSIF c="." THEN
        IF dot THEN EXIT ELSE dot:=TRUE END;
      ELSE EXIT END; 
      sn:=FALSE;
    END;
    IF NOT empty THEN v:=x*div END;
  END wpar;

BEGIN
  NoWX(wx);
  wwind:=WXNIL;
  wdir:=WXNIL;
  IF buf[p]="_" THEN INC(p, 9) END;     (* positionless wx *)
  LOOP
    CASE buf[p] OF
      "g": wpar(wx.gust);
     |"t": wpar(wx.temp);
     |"r": wpar(wx.rain1);
     |"p": wpar(wx.rain24);
     |"P": wpar(wx.raintoday);
     |"h": wpar(wx.hygro);
     |"b": wpar(wx.baro);
     |"L": wpar(wx.lum);
     |"l": wpar(wx.lum); wx.lum:=wx.lum+1000;
     |"c": wpar(wdir);
     |"s": wpar(wwind);
      ELSE EXIT 
    END;
  END;
  IF (wdir>=0.0)  & (wdir<360.0)   THEN course:=trunc(wdir) END;
  IF (wwind>=0.0) & (wwind<1000.0) THEN speed:=trunc(wwind) END;
END GetWX;


PROCEDURE wrlog(b-:ARRAY OF CHAR; time:TIME; wfn:ARRAY OF CHAR; good:INTEGER):BOOLEAN;
CONST DATELEN=15; 
VAR f:File;
    h:ARRAY[0..1000] OF CHAR;
    l, i:CARDINAL;
BEGIN
  IF wfn[0]=0C THEN 
(*
WrStrLn("--- wfn0");
FOR i:=0 TO HIGH(wfn) DO WrInt(ORD(wfn[i]), 4) END;
WrLn;
*)
 RETURN FALSE END;

  l:=Length(b);
  WHILE (l>0) & (b[l-1]<=15C) DO DEC(l) END;
  IF l>0 THEN

    cleanfilename(wfn);
    f:=OpenAppend(wfn);
    IF NOT FdValid(f) THEN f:=OpenWrite(wfn) END;
    IF NOT FdValid(f) THEN RETURN FALSE END;

    DateToStr(time, h);
    h[4]:=h[5];
    h[5]:=h[6];
    h[6]:=h[8];
    h[7]:=h[9];
    h[8]:=":";
    h[9]:=h[11];
    h[10]:=h[12];
    h[11]:=h[14];
    h[12]:=h[15];
    h[13]:=h[17];
    h[14]:=h[18];
    IF good>=0 THEN h[15]:=" " ELSE h[15]:="-" END;  

    IF l>=HIGH(h)-16 THEN l:=HIGH(h)-16 END;
    i:=0;
    REPEAT h[i+16]:=b[i]; INC(i) UNTIL i>=l;
    h[i+16]:=LF; INC(i);

    WrBin(f, h, i+16);
    Close(f);
  END;
  RETURN TRUE
END wrlog; 

PROCEDURE findop(call:MONCALL; online:BOOLEAN):pOPHIST;
VAR op:pOPHIST;
BEGIN
  IF online & lums.logmode THEN op:=ophist2 ELSE op:=ophist END;
  WHILE (op<>NIL) & (call<>op^.call) DO op:=op^.next END;
  RETURN op
END findop;

PROCEDURE poplogerr(fn:ARRAY OF CHAR);
VAR h:ARRAY[0..1000] OF CHAR;
BEGIN
  h:="logfile write error "; Append(h, fn);
  textautosize(0, 5, 6, 4, "e", h);
END poplogerr;


PROCEDURE savetrack;
VAR op:pOPHIST;
    pf:pFRAMEHIST;
    h:ARRAY[0..100] OF CHAR;
    fn:ARRAY[0..1000] OF CHAR;
    ap:BOOLEAN;
    name:MONCALL;
BEGIN
  name[0]:=0C;
  IF click.mhop[0]<>0C THEN name:=click.mhop
  ELSIF (click.entries>0) & (click.table[click.selected].opf<>NIL)
  THEN name:=click.table[click.selected].opf^.call END;

  IF name[0]<>0C THEN
    op:=findop(name, FALSE);
    IF op<>NIL THEN
      Assign(fn, op^.call);                                         (* make 0C terminated *)
      alfanum(fn);                                                  (* remove bad chars *)
      ap:=Exists(fn);
      pf:=op^.frames;
      WHILE pf<>NIL DO
        IF NOT wrlog(pf^.vardat^.raw, pf^.time, fn, 0) THEN poplogerr(fn); RETURN END;

        pf:=pf^.next;
      END;
      IF ap THEN h:="Append to logfile " ELSE h:="Write logfile " END; Append(h, fn);
      textautosize(0, 5, 6, 4, "b", h);
    END;
  END;
END savetrack;

PROCEDURE replyack(VAR rep, restack:ARRAY OF CHAR; ack-:ARRAY OF CHAR):BOOLEAN;
BEGIN 
  Assign(rep, ack);
  Assign(restack, ack);
  IF (Length(ack)>2) & (ack[2]=REPLYACK) THEN                         (* {xx}yy *)
    rep[0]:=ack[3];
    rep[1]:=ack[4];
    IF HIGH(rep)>=2 THEN rep[2]:=0C END;
    IF HIGH(restack)>=2 THEN restack[2]:=0C END;
    RETURN TRUE

  END;
  RETURN FALSE
END replyack;


PROCEDURE iscall(b-:MONCALL):BOOLEAN;
VAR li, nu, i:CARDINAL;
    c:CHAR;
BEGIN
  li:=0;
  nu:=0;
  FOR i:=0 TO 2 DO
    c:=b[i];
    IF (c>="A") & (c<="Z") THEN INC(li) ELSIF (c>="0") & (c<="9")
    THEN IF i=0 THEN INC(li) ELSE INC(nu) END END;     (* 0AA is no call *)
  END;
  RETURN (nu+li=3) & (nu>=1) & (nu<=2)
END iscall;



PROCEDURE viaghost(b-:ARRAY OF CHAR):BOOLEAN;   (* is WIDE digipeated *)
BEGIN
  RETURN (b[0]="W") & (b[1]="I") & (b[2]="D") & (b[3]="E")
       & (b[4]<>0C) & (b[4]<>b[6]);             (* WIDEn-x with n<>x *)
END viaghost;




PROCEDURE GetHRT(VAR pos:POSITION; VAR altitude:INTEGER; VAR speed:CARDINAL; buf-:ARRAY OF CHAR;
                 VAR compos:CARDINAL; VAR hrtposes:ARRAY OF HRTPOS; VAR hrtlen:CARDINAL;
                 VAR hrttime:TIME);

VAR p:CARDINAL;

  PROCEDURE num():REAL;
  VAR sig, c:CHAR;
      r, f:REAL;
  BEGIN
    r:=0.0;
    sig:=0C;
    f:=1.0;
    LOOP
      IF (p>HIGH(buf)) OR (ABS(r)>=FLOAT(MAX(INTEGER))) THEN EXIT END;

      c:=buf[p];
      IF (sig=0C) & (c="-") OR (c="+") THEN sig:=c;
      ELSIF (f>0.5) & (c=".") THEN f:=f*0.1;
      ELSIF (c>="0") & (c<="9") THEN
        IF f>0.5 THEN r:=r*10.0 + FLOAT(ORD(c) - ORD("0")) ELSE
          r:=r + FLOAT(ORD(c) - ORD("0"))*f;
          f:=f*0.1;
        END;
      ELSE EXIT END;

      INC(p);
      IF sig=0C THEN sig:=1C END;
    END;
    IF r>=FLOAT(MAX(INTEGER)) THEN r:=FLOAT(MAX(INTEGER)) END;
    IF sig="-" THEN r:=-r END;
    RETURN r
  END num; 

  PROCEDURE skip;
  BEGIN IF ((p<=HIGH(buf)) & (buf[p]=",")) THEN INC(p) END END skip;

  PROCEDURE corrtime(syst, mt, span:TIME):TIME;   (* complete modulo time to absolute *)
  BEGIN
    mt:=span + mt MOD span - syst MOD span;
    IF mt<span DIV 2 THEN INC(mt, span) ELSIF mt>span+span DIV 2 THEN DEC(mt, span) END;
    INC(mt, syst);
    IF mt>=span THEN DEC(mt, span) END;
    RETURN mt
  END corrtime;

CONST H=3600;
      DAY=H*24;
      DEGUNIT=PI2/360.0/100000.0;  (* 1/100000 deg = 1.1111m*)

VAR cmd:CHAR;
    wcnt, duration,crc,i:CARDINAL;
    unit, r:REAL;
    ts:TIME;
    posh:POSITION;
    dao:POSITION;
    newcompos:BOOLEAN; 
BEGIN

(* $HR[t46531u1.5p48.0235,13.1512a367d15,11w-479,622,33w-5,2-4w7+2-3ww4-1-5wg435644353-10c27001]
   t s utc modulo 24h modulo 1h or absolut since 1970
   p deg lat/long 
   a m altitude
   v m/s speed
   y m/s climb
   d deg lat/long dao
   w deg,deg,m,s lat long alt time
   u 0.00001 deg,m  unit
   g direct heard gateway
   c crc 
   q qrv mhz
   r rx freq mhz or hz
*)

--WrStrLn(buf);

  hrtlen:=0;  
  hrttime:=0;
  p:=compos;
  newcompos:=TRUE;
--WrInt(p, 10);WrStrLn(" compos");
  LOOP
    IF (p+3>HIGH(buf)) OR (buf[p]=0C) THEN RETURN END;
    IF (buf[p]="$") & (buf[p+1]="H")  & (buf[p+2]="R") & (buf[p+3]="[")
    THEN EXIT END;
--WrStrLn(" newcompos");

    INC(p);
    newcompos:=FALSE;
  END;
  INC(p, 4);

  ts:=systime;
  unit:=1.0;
  duration:=0;
  wcnt:=0;
  dao.lat:=0.0;
  dao.long:=0.0;
  FILL(ADR(hrtposes), 0C, SIZE(hrtposes));
  crc:=0;
  LOOP
    cmd:=buf[p];
    INC(p);
    IF (cmd=0C) OR (p>HIGH(buf)) THEN hrtlen:=0; RETURN            (* end of string? *)

    ELSIF cmd="t" THEN 
      ts:=trunc(num()+0.5);
      IF ts<H THEN ts:=corrtime(systime, ts, H);              (* move system time max +-30min *) 
      ELSIF ts<DAY+H THEN ts:=corrtime(systime, ts-H, DAY);   (* move system time max +-12h *)
      END;                                                    (* absolute time *)
      hrttime:=ts;

    ELSIF cmd="u" THEN unit:=num();

    ELSIF cmd="p" THEN                              (* take position from extension if correct *)
      posh.lat:=rad(num()); skip; posh.long:=rad(num());
      IF posvalid(posh) THEN pos:=posh END;

    ELSIF cmd="a" THEN                              (* take altitude from extension if correct *)
      r:=num();
      IF (r>-10000.0) & (r<50000.0) THEN altitude:=VAL(INTEGER, r+0.5) END;

    ELSIF cmd="v" THEN                              (* take speed from extension if correct *)
      r:=num();
      IF (r>0.0) & (r<50000.0) THEN speed:=VAL(INTEGER, r+0.5) END;

--  ELSIF cmd="i" THEN                              (* define constant time intervall *)
--    duration:=trunc(num()+0.5);

    ELSIF cmd="d" THEN                              (* DAO, correct position *)
      dao.lat:=num(); skip; dao.long:=num();

    ELSIF cmd="w" THEN                              (* waypoints, first is difference from now *)
      IF wcnt<=HIGH(hrtposes) THEN
        WITH hrtposes[wcnt] DO
          dlat :=num(); 
          skip;
          dlong:=num();
          skip;
          dalt :=num();
          notinterpolated:=(dlat<>0.0) OR (dlong<>0.0) OR (dalt<>0.0);   
          skip;
          r:=num();  
          dtime:=trunc(ABS(r)+0.5);
          IF r<0.0 THEN dtime:=0-dtime END;
        END;
        INC(wcnt);
      END;

    ELSIF cmd="c" THEN                              (* crc incl sender call and destination without ssid *)
      crc:=trunc(num()+0.5);

    ELSIF cmd="]" THEN EXIT

    END;

  END;

(*
  IF (wcnt>0) & (hrtposes[0].dtime>0) THEN
    r:=1.0/FLOAT(wcnt);
    kt:=r*FLOAT(hrtposes[0].dtime);
    kx:=r*hrtposes[0].dlong;
    ky:=r*hrtposes[0].dlat;
    kh:=r*hrtposes[0].dalt;
    FOR i:=1 TO wcnt-1 DO
      r:=FLOAT(wcnt-i); 
      hrtposes[i].dtime:=trunc(kt*r + 0.5)-hrtposes[i].dtime;  
      hrtposes[i].dlong:=hrtposes[i].dlong + kx*r;
      hrtposes[i].dlat :=hrtposes[i].dlat  + ky*r;
      hrtposes[i].dalt :=hrtposes[i].dalt  + kh*r;
    END;
 
    r:=unit*DEGUNIT; 
    pos.long:=pos.long + dao.long*r;
    pos.lat :=pos.lat  + dao.lat *r;

    FOR i:=0 TO wcnt-1 DO
      hrtposes[i].dtime:=ts - hrtposes[i].dtime;
      hrtposes[i].dlong:=pos.long + hrtposes[i].dlong*r;
      hrtposes[i].dlat :=pos.lat  + hrtposes[i].dlat*r;
      hrtposes[i].dalt :=VAL(REAL, altitude) + hrtposes[i].dalt*unit;
--WrInt(hrtposes[i].dtime, 6); WrFixed(r, 8,15); WrFixed(dao.lat*r, 8,15); WrFixed(hrtposes[i].dlat*360.0/PI2, 8,15); WrFixed(hrtposes[i].dlong*360.0/PI2, 8,15); WrInt(VAL(INTEGER, hrtposes[i].dalt), 6);WrStrLn("");

    END;
    hrtlen:=wcnt;
  END;
*)

  IF (wcnt>0) & (hrtposes[0].dtime>0) THEN
    FOR i:=1 TO wcnt-1 DO
      INC(hrtposes[i].dtime, hrtposes[i-1].dtime-hrtposes[i-1].dtime DIV (wcnt-i+1));
      IF hrtposes[i-1].dtime>0 THEN
        r:=FLOAT(hrtposes[i].dtime)/FLOAT(hrtposes[i-1].dtime);
        hrtposes[i].dlong:=hrtposes[i].dlong + hrtposes[i-1].dlong*r;
        hrtposes[i].dlat :=hrtposes[i].dlat  + hrtposes[i-1].dlat *r;
        hrtposes[i].dalt :=hrtposes[i].dalt  + hrtposes[i-1].dalt *r;
      END;   
    END;

    r:=unit*DEGUNIT;
    pos.long:=pos.long + dao.long*r;
    pos.lat :=pos.lat  + dao.lat *r;

    FOR i:=0 TO wcnt-1 DO
      hrtposes[i].dtime:=ts - hrtposes[i].dtime;
      hrtposes[i].dlong:=pos.long + hrtposes[i].dlong*r;
      hrtposes[i].dlat :=pos.lat  + hrtposes[i].dlat*r;
      hrtposes[i].dalt :=VAL(REAL, altitude) + hrtposes[i].dalt*unit;
--WrInt(hrtposes[i].dtime, 6); WrFixed(r, 8,15); WrFixed(dao.lat*r, 8,15); WrFixed(hrtposes[i].dlat*360.0/PI2, 8,15); WrFixed(hrtposes[i].dlong*360.0/PI2, 8,15); WrInt(VAL(INTEGER, hrtposes[i].dalt), 6);WrStrLn("");

    END;
    hrtlen:=wcnt;


  END;



  IF newcompos THEN compos:=p END;
--WrInt(compos, 10);WrStrLn(" composret");

END GetHRT;


PROCEDURE checksymb(symt, symb:CHAR):BOOLEAN;          (* true for bad symbol *)
BEGIN
  RETURN (symt<>"/") & (symt<>"\") & ((InStr("#&0>AW^_acnsuvz", symb)<0)
  OR ((symt<"0") OR (symt>"9")) & ((symt<"A") OR (symt>"Z")))
END checksymb;


PROCEDURE Decode(buf-:ARRAY OF CHAR; VAR dat:DAT):INTEGER;
VAR i,p,len,micedest, iv, payload, compos:CARDINAL;
BEGIN
  FILL(ADR(dat), 0C, SIZE(dat));
  dat.speed:=MAX(CARDINAL);
  dat.altitude:=MAX(INTEGER);
  NoWX(dat.wx);
  compos:=0;

  len:=0;
  WHILE (len<HIGH(buf)) & (buf[len]<>0C) & (buf[len]<>CR) DO INC(len) END;
  IF (len=0) OR (buf[0]="#") THEN RETURN -1 END;

  i:=0;
  REPEAT                                                          (* skip 3rd party headers *)
    p:=i;
    WHILE (i<len) & (buf[i]<>":") DO INC(i) END;
    INC(i,2);
  UNTIL (i>len) OR (buf[i-1]<>cTHIRDPARTY);  

  i:=0;
  WHILE buf[p]<>">" DO                                            (* source call *)
    IF (p>=len) OR (i>HIGH(dat.srccall)) THEN RETURN -1 END;

    dat.srccall[i]:=buf[p];
    INC(p);
    INC(i);
  END;

  INC(p);
  micedest:=p;
  i:=0;
  WHILE (buf[p]<>",") & (buf[p]<>":") DO                          (* dest call *)
    IF (p>=len) OR (i>HIGH(dat.dstcall)) THEN RETURN -1 END;
    dat.dstcall[i]:=buf[p];
    INC(p);
    INC(i);
  END;

  iv:=0;
  WHILE buf[p]="," DO
(*
    IF iv>HIGH(dat.viacalls) THEN RETURN -1 END;
*)
    IF iv>HIGH(dat.viacalls) THEN iv:=HIGH(dat.viacalls) END;

    INC(p);
    IF (buf[p]="q") & (buf[p+1]="A") & (buf[p+2]<>"C") THEN dat.igatep:=iv+1;
--      IF dat.igatep>HIGH(dat.viacalls) THEN dat.igatep:=0; RETURN -1 END;
    END;
    IF dat.igatep=iv THEN dat.igaterawp:=p END;
    i:=0;
    WHILE (buf[p]<>",") & (buf[p]<>":") DO 
      IF p>=len THEN RETURN -1 END;

      IF buf[p]="*" THEN 
        IF (dat.igatep=0) & (dat.hbitp=0) THEN dat.hbitp:=iv+1 END;
      ELSIF i<=HIGH(dat.viacalls[0]) THEN
        dat.viacalls[iv][i]:=buf[p];
        INC(i);
      END;
      INC(p);
    END;
    IF dat.igatep=iv THEN dat.igatelen:=p-dat.igaterawp END;
    INC(iv);
  END;

  IF (dat.hbitp>0) OR (iv>0) & viaghost(dat.viacalls[0]) THEN   (* maybe not direct *)
    i:=0;
    WHILE (i<HIGH(dat.viacalls)) & (i<dat.hbitp) & iscall(dat.viacalls[i]) DO INC(i) END;
    dat.hbitp:=i+1;
  ELSE dat.hbitp:=0 END;                                        (* sure direct *)

  IF (p+1>=len) OR (buf[p]<>":") THEN RETURN -1 END;
  INC(p);
  payload:=p;
  dat.typc:=buf[payload];

  CASE dat.typc OF
    34C, 35C, 47C, 140C:     dat.type:=MICE;  
   |"!", "$", "/", "=", "@": dat.type:=POS;
   |"#", "*":                dat.type:=WETH;
   |"_":                     dat.type:=PWETH; 
                             compos:=p; dat.sym:="_"; dat.symt:="/";     (* positionless wx *)
   |":":                     dat.type:=MSG;
   |";":                     dat.type:=OBJ;
   |")":                     dat.type:=ITEM;
   |"<":                     dat.type:=SCAP;
   |">":                     dat.type:=STAT;
   |"T":                     dat.type:=TELE;
   |"?":                     dat.type:=QUERY;
  ELSE                       dat.type:=UNKNOWN END;


  INC(p);
  IF dat.type=OBJ THEN                                              (* object *)
    IF (buf[p+9]="_") OR (buf[p+9]="*") THEN
      dat.objectfrom:=dat.srccall;
      i:=0;
      WHILE i<=HIGH(dat.srccall) DO 
        IF p+i>=len THEN RETURN -1 END;

        dat.srccall[i]:=buf[p+i];
        INC(i);
      END;
      IF buf[p+i]="_" THEN dat.objkill:="1" ELSIF buf[p+i]<>"*" THEN dat.type:=UNKNOWN END;
      dat.timestamp:=buf[p+16];
      WHILE (i>0) & (dat.srccall[i-1]<=" ") DO dat.srccall[i-1]:=0C; DEC(i) END; 
    ELSE dat.type:=UNKNOWN END;

  ELSIF dat.typc=")" THEN                                           (* item *)
    dat.objectfrom:=dat.srccall;
    i:=0;
    WHILE (buf[p+i]<>"!") & (buf[p+i]<>"_") DO 
      IF p+i>=len THEN RETURN -1 END;

      IF i<=HIGH(dat.srccall) THEN dat.srccall[i]:=buf[p+i] END;
      INC(i);
    END;
    IF i<=HIGH(dat.srccall) THEN dat.srccall[i]:=0C END;
    IF buf[p+i]="_" THEN dat.objkill:="1" END;

  ELSIF dat.typc=":" THEN                                           (* msg, bulletin *)
    IF buf[p+9]=":" THEN
      i:=0;
      WHILE (i<9) & (p<len) DO
        IF (i<=HIGH(dat.msgto)) & (buf[p]>" ") THEN dat.msgto[i]:=buf[p] END;
        INC(i);
        INC(p);
      END;
      IF dat.msgto=dat.srccall THEN dat.type:=TELE END;     (* msg to itself *) 
      INC(p);
      i:=0;

      IF (buf[p]="r") & (buf[p+1]="e") & (buf[p+2]="j") THEN dat.ackrej:=MSGREJ;       (* reject *) 
      ELSIF (buf[p]="a") & (buf[p+1]="c") & (buf[p+2]="k") THEN dat.ackrej:=MSGACK END;   (* ack *)
      IF dat.ackrej>MSGMSG THEN
        INC(p, 3);
        WHILE (i<=HIGH(dat.acktext)) & (buf[p]>" ") & (p<len) DO
          dat.acktext[i]:=buf[p];
          INC(i);
          INC(p);
        END;

      ELSE
        WHILE (i<=HIGH(dat.msgtext)) & (buf[p]<>"{") & (p<len) DO      (* message text *)
          dat.msgtext[i]:=buf[p];
          INC(i);
          INC(p);
        END;

        dat.ackrej:=MSGMSG;
        IF buf[p]="{" THEN                                            (* message ack *)
          i:=0;
          INC(p);
          WHILE (i<=HIGH(dat.acktext)) & (buf[p]>" ") & (p<len) DO
            dat.acktext[i]:=buf[p];
            INC(i);
            INC(p);
          END;
        END;
      END;
    END; 

  ELSIF dat.typc="?" THEN                                           (* general query *)
    i:=0;
    WHILE (i<9) & (buf[p]>" ") & (p<len) DO
      IF i<=HIGH(dat.msgto) THEN dat.msgto[i]:=buf[p] END;
      INC(i);
      INC(p);
    END;


  END;


  dat.course:=MAX(CARDINAL);
  IF dat.type IN TYPSET{MICE, POS, WETH, OBJ, ITEM} THEN
    GetPos(dat.pos, dat.speed, dat.course, dat.altitude, dat.sym, dat.symt,
           buf, micedest, payload, compos, dat.postyp);
    GetSym(dat.dstcall, dat.sym, dat.symt);
    IF checksymb(dat.symt, dat.sym) THEN dat.symt:=0C; dat.sym:=0C END;                                         (* wrong symbol *)
    IF compos=0 THEN compos:=payload END;
    GetHRT(dat.pos, dat.altitude, dat.speed, buf, compos, dat.hrtposes, dat.hrtlen, dat.hrttime);
  END;
  IF (dat.type IN TYPSET{POS, WETH, OBJ}) & (dat.sym="_") OR (dat.type=PWETH)  THEN
    GetWX(dat.wx, dat.course, dat.speed, buf, compos);
  END;

  i:=0;
  IF compos<>0 THEN p:=compos ELSE p:=payload+ORD(dat.type<>UNKNOWN) END;
  WHILE (p<len) & (i<=HIGH(dat.comment)) DO 
    dat.comment[i]:=buf[p];
    INC(p);
    INC(i);
  END;

  RETURN 0
END Decode;


PROCEDURE getbeaconparm(VAR s:ARRAY OF CHAR; VAR time:CARDINAL; VAR port:CHAR):BOOLEAN; (* time:port:rawframe *)
VAR i:CARDINAL;
BEGIN
  port:=s[0];
  IF (port<" ") OR (s[1]<>":") THEN RETURN FALSE END;
  time:=0;
  i:=2;
  WHILE (s[i]>="0") & (s[i]<="9") DO time:=time*10+ORD(s[i])-ORD("0"); INC(i) END;
  IF s[i]<>":" THEN RETURN FALSE END;

  Delstr(s, 0, i+1);
  RETURN TRUE
END getbeaconparm;


PROCEDURE getbeaconname(raw:ARRAY OF CHAR; VAR name:ARRAY OF CHAR; VAR symb:ARRAY OF CHAR;
                        VAR isobj, isdel, isbad:BOOLEAN); (* item object else src name *)
VAR dat:DAT;
    port:CHAR;
    time:CARDINAL;
BEGIN
  isobj:=FALSE;
  isdel:=FALSE;
  isbad:=TRUE;
  name[0]:=0C;
  IF getbeaconparm(raw, time, port) THEN
    beaconmacros(raw, "", "", FALSE);
    IF Decode(raw, dat)=0 THEN
      Assign(name, dat.srccall);
      Assign(symb, dat.symt); Append(symb, dat.sym);
      isobj:=(dat.type=OBJ) OR (dat.type=ITEM);
      isdel:=dat.objkill="1";
      isbad:=(dat.symt<" ") OR (name[0]<=" ");
    ELSE isbad:=TRUE END;
  END; 
END getbeaconname;

PROCEDURE extractbeacon(raw:ARRAY OF CHAR; withparm, macros:BOOLEAN);   (* monitor line to beacon config *)
VAR dat:DAT;
    port:CHAR;
    time, i:CARDINAL;
    j:INTEGER;
    s:ARRAY[0..999] OF CHAR;
BEGIN
  IF withparm THEN
    IF getbeaconparm(raw, time, port) THEN
      IF macros THEN beaconmacros(raw, "", "", FALSE) END;
      IntToStr(time, 0, s);
      AddConfLine(fRBTIME, 1, s); 
      AddConfLine(fRBPORT, 1, port);
    ELSE encerr("beacon syntax wrong, delete line!") END;
  END;
  IF Decode(raw, dat)=0 THEN
    IF (dat.type=OBJ) OR (dat.type=ITEM) THEN Assign(s, dat.srccall);
    ELSE confstr(fMYCALL, s) END;
    AddConfLine(fRBNAME, 1, s);

    IF posvalid(dat.pos) THEN postostr(dat.pos, "3", s); AddConfLine(fRBPOS, 1, s) END;

    AddConfLine(fRBCOMMENT, 1, dat.comment);

    s[0]:=dat.symt; s[1]:=dat.sym; s[2]:=0C; AddConfLine(fRBSYMB, 1, s);
    AddConfLine(fRBSPEED, 1, 0C);
    AddConfLine(fRBDIR, 1, 0C);
    IF (dat.speed>0) & (dat.speed<MAX(INTEGER)) THEN
      IntToStr(trunc(FLOAT(dat.speed)*KNOTS), 1, s);  AddConfLine(fRBSPEED, 1, s);
      IF dat.course<360 THEN IntToStr(dat.course, 1, s);  AddConfLine(fRBDIR, 1, s) END;
    END;
    IF dat.altitude<MAX(INTEGER) THEN IntToStr(dat.altitude, 1, s) ELSE s[0]:=0C END;
    AddConfLine(fRBALT, 1, s);

    s[1]:=0C;
    s[0]:="b";
    IF dat.type=OBJ THEN
      IF dat.timestamp="h" THEN s[0]:="H" ELSE s[0]:="O" END;
      IF dat.objkill="1" THEN s[0]:="P" END;
    ELSIF dat.type=ITEM THEN
      IF dat.objkill="1" THEN s[0]:="J" ELSE s[0]:="I" END;
    END;
    AddConfLine(fRBTYP, 1, s);

    AddConfLine(fRBPOSTYP, 1, dat.postyp);
    IF withparm THEN 
      s[0]:=0C;
      j:=InStr(dat.dstcall, "-");                                    (* move dest ssid to viapath *)
      IF j>=0 THEN
        Assign(s, dat.dstcall);
        Delstr(s, 0, j);
        dat.dstcall[j]:=0C;
      END;
      IF dat.type=MICE THEN dat.dstcall[0]:=0C END;                  (* not reimport mice dest *)
      AddConfLine(fRBDEST, 1, dat.dstcall);
      AddConfLine(fRBNAME, 1, dat.srccall);
      i:=0;
      WHILE (i<=HIGH(dat.viacalls)) & (dat.viacalls[i][0]<>0C) DO    (* make via path *)
        IF s[0]<>0C THEN Append(s, ",") END;
        Append(s, dat.viacalls[i]);
        INC(i);
      END;
      AddConfLine(fRBPATH, 1, s);
    ELSE AddConfLine(fRBDEST, 1, DESTCALL) END;
  END;
END extractbeacon;


PROCEDURE importbeacon(op:pOPHIST);                      (* op last pos frame to beacon config *)
VAR pf, pl:pFRAMEHIST;
BEGIN
  IF beaconediting & (op<>NIL) THEN
    pl:=NIL;
    pf:=op^.frames;
    WHILE pf<>NIL DO
      IF posvalid(pf^.vardat^.pos) THEN pl:=pf END;
      pf:=pf^.next;
    END; 
    IF pl<>NIL THEN 
      extractbeacon(pl^.vardat^.raw, FALSE, FALSE);
      beaconed:=TRUE;
      beaconimported:=TRUE;
    END;
  END;      
END importbeacon;



PROCEDURE beepmsg(isack:BOOLEAN);
BEGIN
  IF configon(fBEEPMSG) THEN
    beeplim(100, conf2int(fBEEPMSG, ORD(isack)*2, 20, 8000, 1000),
              conf2int(fBEEPMSG, ORD(isack)*2+1, 0,  5000, 250));
  END;
END beepmsg;



PROCEDURE popupmessage(from-, to-, txt-, ack-:ARRAY OF CHAR; time:TIME; port:CHAR; isquery:BOOLEAN);
VAR pm, pl:pMSGFIFO;
    cnt:INTEGER;
BEGIN
  ALLOCATE(pm, SIZE(pm^));
  IF pm=NIL THEN WrStrLn("msg out of memory"); RETURN END;

  Assign(pm^.from, from);
  Assign(pm^.to, to);
  Assign(pm^.txt, txt);
  Assign(pm^.ack, ack);
  pm^.time:=time;
  pm^.port:=port;
  pm^.query:=isquery;
  pm^.next:=NIL;
  cnt:=1;
  IF msgfifo=NIL THEN msgfifo:=pm
  ELSE 
    cnt:=2;
    pl:=msgfifo;
    WHILE pl^.next<>NIL DO pl:=pl^.next; INC(cnt) END;
    pl^.next:=pm;
  END;
--WrInt(nextmsg, 10); WrStrLn("nm");
  IF nextmsg=0 THEN
   IF configon(fPOPUPMSG) THEN nextmsg:=-cnt END;
  ELSE nextmsg:=-ABS(nextmsg) END;  (* - is new message arrived *)
END popupmessage;

PROCEDURE getactack(call-:MONCALL; VAR ack:ARRAY OF CHAR);       (* get actual message ack *)
VAR op:pOPHIST;
    pf:pFRAMEHIST;
    dat:DAT;
    aa, mid:ARRAY[0..1] OF CHAR;
    ok:BOOLEAN;
    my:MONCALL;
BEGIN
  ack[0]:=0C;
  op:=findop(call, FALSE);
  IF op<>NIL THEN
    confstr(fMYCALL, my);
    pf:=op^.frames;
    WHILE pf<>NIL DO
      IF (Decode(pf^.vardat^.raw, dat)>=0) & (dat.type=MSG) 
      & (dat.ackrej=MSGMSG) & (dat.msgto=my) THEN
        ok:=replyack(aa, mid, dat.acktext);
        IF mid[0]<>0C THEN Assign(ack, mid) END;
      END;
      pf:=pf^.next;
    END;   
  END;
END getactack;


PROCEDURE acknumstr(VAR aa:ARRAY OF CHAR; n:CARDINAL);

  PROCEDURE ch(n:CARDINAL):CHAR;
  BEGIN
    IF n<10 THEN INC(n, ORD("0"))
    ELSIF n<36 THEN INC(n, ORD("A")-10)
    ELSE INC(n, ORD("a")-36) END;
    RETURN CHR(n)
  END ch;

BEGIN
  aa[0]:=ch(n DIV MIDMOD MOD MIDMOD);
  aa[1]:=ch(n MOD MIDMOD);
  IF HIGH(aa)>=2 THEN aa[2]:=0C END;
END acknumstr;


PROCEDURE sendtxmsg(acknum:CARDINAL; to-:MONCALL; txt-:ARRAY OF CHAR;
                    port:CHAR; rfonly:BOOLEAN; ackcnt:CARDINAL; VAR errm:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
    rfs, s:FRAMEBUF;
    h, h1, am:ARRAY[0..50] OF CHAR;
BEGIN
  IF ackcnt=0 THEN am:="Ack " ELSE am:="Msg " END;
  errm[0]:=0C;
  IF to[0]=0C THEN RETURN FALSE END;

  confstr(fMYCALL, rfs);
  IF Length(rfs)<3 THEN Assign(errm, "Msg not sent (no valid Mycall)"); RETURN FALSE END;

  Append(rfs, ">");
  IF rfonly THEN confstr(fMSGRFDEST, h) ELSE confstr(fMSGNETDEST, h) END;
  Append(rfs, h);
  IF h[0]=0C THEN Assign(errm, am); Append(errm, "not sent (no Port set)"); RETURN FALSE END;

  IF (port="A") OR (port>="1") & (port<="9") THEN               (* radio so add via path *)
    confstr(fMSGPATH, h);
    IF (h[0]>="1") & (h[0]<="7") THEN Append(rfs, "-"); Append(rfs, h[0]);
    ELSIF h[0]<>0C THEN Append(rfs, ","); Append(rfs, h) END;
  END;
  Append(rfs, ":");
  s:=":";
  Append(s, to); FOR i:=Length(to) TO 8 DO Append(s, " ") END;
  Append(s, ":");
  IF ackcnt=0 THEN Append(s, "ack") END;
  Append(s, txt);

  IF acknum>0 THEN
    Append(s, "{");
    acknumstr(h, acknum); Append(s, h); Append(s, REPLYACK);
    getactack(to, h);
    IF h[0]<>0C THEN Append(s, h) END;
  END;

--WrInt(ORD(rfonly), 10);WrStrLn(port);
  Append(rfs, s);
  FOR i:=0 TO HIGH(udpsocks) DO                                      (* try the rf ports *)
    IF configon(VAL(CONFSET, ORD(fUDP1)+i)) 
    & ((port="A") OR (port=CHR(i+ORD("1")))) & Sendudp(rfs, i) THEN
      h:=am;
      IF ackcnt=1 THEN Append(h, "sent")
      ELSE Append(h, "resent("); IntToStr(ackcnt, 0, h1); Append(h, h1); Append(h, ")") END;  
      Append(h, " to "); Append(h, to); Append(h, " on Port "); Append(h, CHR(i+ORD("1")));
      textautosize(0, 0, 4, 2, "b", h);
      RETURN TRUE

    END;                                                      (* make it better *)
  END;

  IF NOT rfonly & (port="N") THEN
    IF configon(fCONNECT) & configon(fALLOWNETTX) THEN 
      IF SendNet(tcpsocks, s) THEN
        errm[0]:=0C;
        h:=am; Append(h, "(re)sent to "); Append(h, to); Append(h, " on Net");
        textautosize(0, 0, 4, 2, "b", h);
        RETURN TRUE

      ELSE Assign(errm, am); Append(errm, "not sent (Netport not conncted)"); RETURN FALSE END;

    ELSE Assign(errm, am); Append(errm, "not sent (Netport not configured for tx)"); RETURN FALSE END;

  ELSE Assign(errm, am); Append(errm, "not sent (no outgoing Port found)"); RETURN FALSE END;
END sendtxmsg;




PROCEDURE ackmsg(from-, rep-:ARRAY OF CHAR; rej:ACKREJ);
VAR pm:pTXMESSAGE;
    aa, bb:ARRAY[0..1] OF CHAR;
BEGIN
(*
  WrStr("replyack:");
  WrStr(from);
  WrStr("|");
  WrStr(rep);
  WrStr("|");
  WrLn;
*)


  IF rej=MSGMSG THEN
    IF NOT replyack(bb,aa,rep) THEN RETURN END;              (* message only *)

  ELSE Assign(bb, rep) END;
  pm:=txmessages;
  WHILE pm<>NIL DO
    IF (pm^.acktime=0) & (from=pm^.to) THEN
      acknumstr(aa, pm^.acknum);
      IF aa=bb THEN                                          (* message acked now *)
        pm^.acktime:=realtime;
        pm^.rej:=rej=MSGREJ;
        refresh:=TRUE;
--WrInt(ORD(rej), 10); WrStrLn("=rej");
        beepmsg(TRUE);
      END;
    END;  
    pm:=pm^.next;
  END;  

END ackmsg;

PROCEDURE showmsg(from-, to-, txt-, ack-:ARRAY OF CHAR; rej:ACKREJ; my, query:BOOLEAN; port:CHAR);

CONST QUERYRESPONSEWINDOW=30;  (* time after sending a msg to display already received query response *)

VAR op:pOPHIST;
    opf:pFRAMEHIST;
    rep, aack:ACKTEXT;
    call:MONCALL;
    dat:DAT;
    s:ARRAY[0..80] OF CHAR;
BEGIN
(*
  WrStr(from);
  WrStr(">");
  WrStr(to);
  WrStr("|");
  WrStr(txt);
  WrStr("|");
  WrStr(ack);
  WrLn;
*)
  opf:=NIL;
--WrStr(ack);WrStrLn("<a1");
  IF ack[0]<>0C THEN
--WrStr(ack);WrStrLn("<a2");
    Assign(call, from);
    op:=findop(call, TRUE);                                                (* find sender of msg *)
    IF op<>NIL THEN
      opf:=op^.frames;
      LOOP
        IF opf=NIL THEN EXIT END;                                          (* same msg not found *)
        IF (Decode(opf^.vardat^.raw, dat)>=0) & (dat.type=MSG) & (dat.ackrej=MSGMSG)
        & (dat.msgto=to) & (txt=dat.msgtext) THEN

          IF ack[0]=0C THEN
            IF lastmsgtx+QUERYRESPONSEWINDOW<realtime THEN EXIT END; (* we do not wait for a query response *)
--            OR (opf^.time+dupetime>=realtime) THEN EXIT END;               (* dupe of a response *)

          ELSIF (dat.acktext=ack) OR replyack(rep, aack, dat.acktext) & (aack=ack) THEN EXIT END;  (* we have this msg got before *)

        END;
        opf:=opf^.next;
      END;
    END;
  END;
  IF opf=NIL THEN
    IF my OR configon(fMSGALLSSID) & (NOT StrCmp(from, to) OR configon(fPASSSELFMSG)) THEN
      IF NOT configon(fPOPUPMSG) THEN
        IF query THEN s:="Query from " ELSE s:="Message from " END;
        Append(s, from); Append(s, " to "); Append(s, to);
        Append(s, " (click on M Button)");
        textautosize(0, 5, 6, 0, "y", s);
      END;
      popupmessage(from, to, txt, ack, realtime, port, query);
      INC(tracenew.winevent);
      beepmsg(FALSE);
    END;
  ELSIF verb THEN
    WrStr("seen msg:");WrStr(from);WrStr(">");WrStr(to);WrStr("|");
    WrStr(txt);WrStr("|");WrStr(ack);WrStr("|");WrStr(port);WrLn;
  END;
END showmsg;

PROCEDURE isquery(dat-:DAT; port:CHAR):BOOLEAN;
VAR i,j:CARDINAL;
    s,path,key, wdata, err:ARRAY[0..200] OF CHAR;
BEGIN
--  IF dat.msgtext[0]<>"?" THEN RETURN FALSE END;

  Assign(path, dat.srccall); Append(path, ">");
  Append(path, dat.dstcall);
  i:=0;
  WHILE dat.viacalls[i][0]<>0C DO
    Append(path, ","); Append(path, dat.viacalls[i]);
    IF i+2=dat.hbitp THEN Append(path, "*") END;
    INC(i);
  END;
 
  i:=0;
  LOOP
    confstrings(fQUERYS, i, FALSE, s);
    IF s[0]=0C THEN EXIT END;
    
    j:=InStr(s, ":");
    IF j>0 THEN
      Assign(key, s);
      key[j]:=0C;
      Delstr(s, 0, j+1);
      IF InStr(dat.msgtext, key)=0 THEN
        Assign(wdata, dat.msgtext);
        Delstr(wdata, 0, Length(key));
        beaconmacros(s, path, wdata, TRUE);
        IF s[0]=0C THEN RETURN TRUE END;

        IF NOT sendtxmsg(0, dat.srccall, s, port, port<>"N", 1, err) THEN
          xerrmsg(err);
          RETURN FALSE

        ELSE RETURN TRUE END;

      END;
    END;
    INC(i);
  END;
--WrStrLn(port);WrStrLn(dat.srccall);WrStrLn(dat.msgtext);

  RETURN FALSE
END isquery;


PROCEDURE getmessage(cp:pTCPSOCK; up:CARDINAL; dat-:DAT); (* if first: popup, if full match & lastack>10s: send ack *)
VAR i:CARDINAL;
    fit, query:BOOLEAN;
    h:ARRAY[0..99] OF CHAR;
    ch, port:CHAR;
    my:MONCALL;
BEGIN
  confstr(fMYCALL, my);
  IF Length(my)<3 THEN RETURN END; 

  Assign(h, dat.msgto);

  fit:=FALSE;
  i:=0;
  WHILE (h[i]=my[i]) & (h[i]<>0C) DO
    IF (h[i]="-") OR (my[i]="-") THEN fit:=TRUE END; 
    INC(i);
  END;
  IF i=0 THEN RETURN END;

  ch:=my[i];
  IF (h[i]=0C) & (ch="-") OR (h[i]="-") & (ch=0C) THEN fit:=TRUE END;

  IF cp<>NIL THEN port:="N" ELSE port:=CHR(up+ORD("0")) END;
  IF (ch=0C) & (h[i]=0C) THEN 
--    WrStr("my message ");
    IF dat.ackrej=MSGMSG THEN
--FOR i:=0 TO HIGH(dat.acktext) DO WrInt(ORD(dat.acktext[i]), 4); END; WrStrLn("=ack");
      query:=isquery(dat, port);
      showmsg(dat.srccall, dat.msgto, dat.msgtext, dat.acktext, dat.ackrej, TRUE, query, port);
      IF NOT query & (dat.acktext[0]<>0C) THEN
        IF NOT sendtxmsg(0, dat.srccall, dat.acktext, port, port<>"N", 0, h) THEN xerrmsg(h) END;
      END;
    END;
    IF dat.acktext[0]<>0C THEN ackmsg(dat.srccall, dat.acktext, dat.ackrej) END;
  
  ELSIF fit & (dat.ackrej=MSGMSG) THEN 
--  WrStr("other ssid message ");
    showmsg(dat.srccall, dat.msgto, dat.msgtext, dat.acktext, dat.ackrej, FALSE, FALSE, port);
  END;
END getmessage;


PROCEDURE deltxmsg(cmd, n:CARDINAL);            (* delete/edit tx message number *)
CONST SETPORT=2;
      DEL=6;
      KICK=5;
      RESTART=4;
      HOLD=3;
      EDIT=1;
VAR pm, po:pTXMESSAGE;
BEGIN
  pm:=txmessages;
  IF pm<>NIL THEN
    IF (cmd=DEL) OR (cmd=EDIT) THEN
      IF n=0 THEN txmessages:=txmessages^.next
      ELSE 
        REPEAT po:=pm; pm:=pm^.next; DEC(n) UNTIL (n=0) OR (pm=NIL);
        IF pm<>NIL THEN po^.next:=pm^.next END;
      END;
      IF pm<>NIL THEN 
        IF cmd=EDIT THEN
          AddConfLine(fMSGTEXT, 0, pm^.msgtext);
          AddConfLine(fMSGTO, 0, pm^.to);
          AddConfLine(fMSGPORT, 0, pm^.port);
        END;
        DEALLOCATE(pm, SIZE(pm^));
      END;

    ELSE
      WHILE (n>0) & (pm<>NIL) DO pm:=pm^.next; DEC(n) END;
      IF (pm<>NIL) & (pm^.acktime=0) THEN
        IF cmd=KICK THEN pm^.txtime:=0
        ELSIF cmd=RESTART THEN pm^.txtime:=0; pm^.acktime:=0; pm^.txcnt:=0; pm^.heard:=FALSE;
        ELSIF cmd=HOLD THEN pm^.txtime:=HOLDT
        ELSIF cmd=SETPORT THEN confstr(fMSGPORT, pm^.port) END;
      END;
    END;
  END;
END deltxmsg;


PROCEDURE makemsg(ack:BOOLEAN);
VAR pm, pn:pTXMESSAGE;
    po:CHAR;
    mes, hm, ht:ARRAY[0..100] OF CHAR;
    i:INTEGER;
    c:CHAR;
BEGIN 
  mes[0]:=0C;
  confstr(fMSGPORT, po);
  IF (po=" ") OR (CAP(po)="A") THEN po:="A"
  ELSIF (CAP(po)="N") OR (CAP(po)="I") THEN po:="N" ELSIF (po<"0") OR (po>"9")
  THEN mes:="need Port where to send" END;
  confstr(fMSGTO, ht);                               (* no destination call *)   
  IF ht[0]=0C THEN mes:="need call to send to" END;
  confstr(fMSGTEXT, hm);
  IF hm[0]=0C THEN                                   (* empty message line *)
    IF NOT sentemptymsg THEN mes:="send empty line? if so, enter again"; sentemptymsg:=TRUE;
    ELSE sentemptymsg:=FALSE END;
  ELSE sentemptymsg:=FALSE END;

  pn:=txmessages;                                    (* look for same msg pending *)
  WHILE pn<>NIL DO 
    IF ack & (pn^.acknum>0) & (pn^.acktime=0) & StrCmp(pn^.to, ht) & StrCmp(pn^.msgtext, hm)
    & (pn^.port=po) THEN mes:="same message pending, try [kick] or delete" END;
    pn:=pn^.next;
  END;

  IF mes[0]=0C THEN
    ALLOCATE(pm, SIZE(pm^));
    IF pm=NIL THEN Err("out of memory") END;

    FILL(pm, 0C, SIZE(pm^));
    WITH pm^ DO
      port:=po;
      confstr(fMSGTO, to);
      Caps(to);
      confstr(fMSGTEXT, msgtext);
      FOR i:=0 TO VAL(INTEGER, Length(msgtext))-1 DO 
        c:=msgtext[i];
        IF (c="|") OR (c="~") OR (c="{") THEN msgtext[i]:=" " END; 
      END;
      IF ack THEN 
        IF msgmid=0 THEN msgmid:=realtime MOD 68400 DIV 30 END; (* init msg number with 30s daytime *)
        msgmid:=(msgmid+1) MOD (MIDMOD*MIDMOD-1);
        acknum:=msgmid+1;                                       (* 0 is query with no ack *)
      END;
    END;

    pn:=txmessages;
    IF pn=NIL THEN txmessages:=pm;
    ELSE
      WHILE pn^.next<>NIL DO pn:=pn^.next END;
      pn^.next:=pm;
    END; 
    clrmsgtext(0C);
    textautosize(0, 5, 6, 5, "b", "Msg Stored");
  END;
  xerrmsg(mes);

END makemsg;


PROCEDURE sendmsg;
CONST MAXMSGTXTIME=3600;
      MAXMSGRETRY=20;
      MAXNOACKRETRY=1;
      MSGNOTXTIME=10;
      MSGTXTIME=15;

VAR pm, pn:pTXMESSAGE;
    t:TIME;
    tc, maxret:CARDINAL;
    port:CHAR; 
    sent:BOOLEAN;
    err:ARRAY[0..100] OF CHAR;

--    my:MONCALL;
BEGIN
  IF lastmsgtx>realtime THEN lastmsgtx:=realtime END;
--  confstr(fMYCALL, my);
--  IF (lastmsgtx+MSGNOTXTIME<realtime) & (Length(my)>=3) THEN
  IF lastmsgtx+MSGNOTXTIME<realtime THEN
    err[0]:=0C;
    pm:=txmessages;
    LOOP
      IF pm=NIL THEN EXIT END;

      IF pm^.acknum>0 THEN maxret:=MAXMSGRETRY ELSE maxret:=MAXNOACKRETRY END;
      IF (pm^.acktime=0) & (pm^.txtime<>HOLDT) & ((pm^.txcnt<maxret) OR (pm^.txtime=0)) THEN

        tc:=pm^.txcnt;
        t:=MSGTXTIME;
        LOOP
          IF tc<=1 THEN EXIT END;
          INC(t,t);
          DEC(tc);
          IF t>MAXMSGTXTIME THEN t:=MAXMSGTXTIME; EXIT END;
        END;
        IF pm^.txtime+t<=realtime THEN

          pn:=txmessages;
          WHILE (pn<>pm) & ((pn^.acknum=0) OR (pn^.acktime>0) OR (pn^.txcnt>=MAXMSGRETRY)
          OR NOT StrCmp(pn^.to, pm^.to) OR (pn^.txtime=HOLDT)) DO pn:=pn^.next END;
          IF pn=pm THEN                                     (* not older unacked msg to this call *)

            port:=pm^.port;
            sent:=FALSE;
            IF ((pm^.txcnt<=ORD(pm^.heard)) OR (pm^.txtime=0)) & ((port="N") OR (port="A")) THEN
              IF sendtxmsg(pm^.acknum, pm^.to, pm^.msgtext, "N", FALSE, pm^.txcnt+1, err)
              THEN sent:=TRUE END;
            END;
            IF (port="A") OR (port>="1") & (port<="9") THEN
              IF sendtxmsg(pm^.acknum, pm^.to, pm^.msgtext, port, sent OR (port<>"A"), pm^.txcnt+1, err)
              THEN sent:=TRUE ELSIF sent OR (pm^.txcnt>0) THEN err[0]:=0C END;
            END;

            IF sent THEN
              INC(pm^.txcnt);
              pm^.txtime:=realtime;
              lastmsgtx:=realtime;
              refresh:=TRUE;

              EXIT                                                        (* send 1 msg a time *)

            END;
          END;
        END;
      END;
      pm:=pm^.next;
    END;  
    xerrmsg(err);
  END;
END sendmsg;

PROCEDURE setmsgheard(us-:MONCALL);        (* set heard flag in tx msg if user heard now *)
VAR pm:pTXMESSAGE;
BEGIN
  pm:=txmessages;
  LOOP
    IF pm=NIL THEN EXIT END;

    IF (pm^.acktime=0) & (pm^.txcnt=1) & StrCmp(pm^.to, us) THEN pm^.heard:=TRUE; EXIT END;

    pm:=pm^.next;
  END;
END setmsgheard;

PROCEDURE selop():pOPHIST;
BEGIN
  IF click.entries>0 THEN RETURN click.table[click.selected].opf ELSE RETURN NIL END;
END selop;


PROCEDURE objsender(op:pOPHIST; VAR s:ARRAY OF CHAR);
VAR dat:DAT;
    f:pFRAMEHIST;
BEGIN
  s[0]:=0C;
  IF (op<>NIL) & (ISOBJECT IN op^.drawhints) THEN
    f:=op^.frames;
    IF f<>NIL THEN
      WHILE f^.next<>NIL DO f:=f^.next END;                         (* goto last frame *)
      IF (Decode(f^.vardat^.raw, dat)>=0) & ((dat.type=OBJ) OR (dat.type=ITEM))
      THEN Assign(s, dat.objectfrom) END;
    END;
  END;
END objsender;



PROCEDURE timespeed(lastf:pFRAMEHIST; pos1:POSITION; time1:CARDINAL; VAR err:ERRSET);
CONST MAXDELAY=30;       (* add seconds to time *)
VAR d:REAL;
    t:CARDINAL;
BEGIN
  IF (err*ERRSET{eDIST, eSPIKE, eDUPE, eSYMB}<>ERRSET{}) OR (lastf=NIL) 
  OR (lastf^.nodraw*ERRSET{eDIST, eSPIKE, eDUPE, eSYMB}<>ERRSET{})
  OR NOT posvalid(lastf^.vardat^.pos) OR NOT posvalid(pos1) THEN RETURN END;

  d:=distance(lastf^.vardat^.pos, pos1);
(*
  IF d>50.0 THEN INCL(err, eDIST) END;
*)
  IF lastf^.time>=time1 THEN t:=0 ELSE t:=time1-lastf^.time END;
  IF d*3600.0/FLOAT(t+MAXDELAY)>maxspeed THEN INCL(err, eSPEED) END;
END timespeed;

(* 1 wayout, delete before, 2 wayout join last good with last else delete before *)
PROCEDURE joinchunk(op:pOPHIST);

CONST MINHOP=20.0;
      HOPPART=0.5;

VAR pf, lpf, llpf, bad, lbad:pFRAMEHIST;
    v:pVARDAT;
    waylen, km, lastkm, d:REAL;
BEGIN
  waylen:=FLOAT(op^.lastkmh)*0.03 + MINHOP;
  lastkm:=0.0;
  llpf:=NIL;
  lpf:=NIL;
  pf:=op^.frames;
  bad:=NIL;
  lbad:=NIL;
  WHILE pf<>NIL DO
    v:=pf^.vardat;
    IF posvalid(v^.pos) & (pf^.nodraw*ERRSET{eSYMB, eDUPE}=ERRSET{}) THEN
      IF lpf<>NIL THEN
        km:=distance(lpf^.vardat^.pos, v^.pos);
        IF (spikesens>0.0) & (llpf<>NIL) THEN
          d:=spikesens*distance(llpf^.vardat^.pos, v^.pos);
          IF (km>d) & (lastkm>d) THEN (*INCL(lpf^.nodraw, eSPIKE)*)
            lpf^.nodraw:=lpf^.nodraw-ERRSET{eDIST, eSPEED}+ERRSET{eSPIKE};
(*
            pf^.nodraw:=pf^.nodraw-ERRSET{eDIST, eSPEED};
*)
          END;
        END;

        IF maxhop>0.0 THEN
          IF eSPIKE IN lpf^.nodraw THEN lbad:=NIL ELSIF lbad<>NIL THEN bad:=lbad END;

          IF (NOT (eSPIKE IN lpf^.nodraw))  
          & (km>waylen) (* & (lastkm<=waylen)*)
          & (pf^.nodraw<=ERRSET{eSYMB, eDUPE, eSPIKE, eSPEED})
          THEN INCL(pf^.nodraw, eDIST); lbad:=pf END;

          IF (km<waylen) & (pf^.nodraw*ERRSET{eSYMB, eDUPE, eSPIKE, eSPEED, eDIST}=ERRSET{}) 
          THEN 
            waylen:=waylen+km*HOPPART;
            IF waylen>maxhop THEN waylen:=maxhop END;
          END;
        END;

        lastkm:=km;
      END; 
      llpf:=lpf;
      lpf:=pf;
    END;
    pf:=pf^.next;
  END;

  IF lbad<>NIL THEN bad:=lbad END;
  IF bad<>NIL THEN
    pf:=op^.frames;
    LOOP
      IF pf<>NIL THEN INCL(pf^.nodraw, eNODRAW) END;
      IF pf=bad THEN EXIT END;
      pf:=pf^.next;
    END;

    IF pf<>NIL THEN posinval(op^.lastpos) END;
    WHILE pf<>NIL DO                                                  (* maybe we have no pos now *)
      IF ((pf^.nodraw<=ERRSET{eDUPE, eDIST}) OR NOT posvalid(op^.lastpos))
      & posvalid(pf^.vardat^.pos) THEN op^.lastpos:=pf^.vardat^.pos END;
      pf:=pf^.next;
    END;

  END;

END joinchunk;

PROCEDURE makelogfn(VAR s:ARRAY OF CHAR);
VAR fn:FILENAME;
BEGIN
  confstr(fLOGWFN, fn);
  filepath(fn);
  IF fn[0]<>0C THEN Append(fn, DIRSEP) END;
  Append(fn, s);
  Assign(s, fn);
END makelogfn;


PROCEDURE inwindow(op:pOPHIST; rawbuf-:ARRAY OF CHAR);
VAR i,ii, j, matchlen: CARDINAL;
    in:BOOLEAN;
    pf:pFRAMEHIST;
    wc:ARRAY[0..99] OF CHAR;
    fn:FILENAME;
    pv:pVARDAT;
    doset:CARD8;
BEGIN
  in:=FALSE;
  tracenew.call[0]:=0C;
  doset:=0;
  IF op<>NIL THEN
    setmsgheard(op^.call);
    pf:=op^.frames;
    WHILE (pf<>NIL) & NOT in DO                             (* find waypoint inside screen *)
      pv:=pf^.vardat;
      IF posvalid(pv^.pos) THEN
        WITH pv^.pos DO
          IF (long>tracenew.winpos0.long) & (lat<tracenew.winpos0.lat)
          & (long<tracenew.winpos1.long) & (lat>tracenew.winpos1.lat) THEN in:=TRUE END;
        END; 
      END;
      pf:=pf^.next;
    END;   
    IF in THEN INC(tracenew.winevent) END;

--find user in watchlist

--  IF posvalid(op^.lastpos) THEN
      j:=0;
      matchlen:=0;
      LOOP
        confstrings(fWATCH, j, TRUE, wc);
        IF wc[0]=0C THEN EXIT END;                     (*  end of watchlist *)
        i:=0;
        ii:=0; 
        LOOP
          IF (i>HIGH(wc)) OR (ii>HIGH(op^.call))
          OR (wc[i]=0C) OR (op^.call[ii]=0C) THEN
            IF ((ii>HIGH(op^.call)) OR (op^.call[ii]=0C)) & ((wc[i]=0C) OR (wc[i]="*"))
            THEN
              IF i>=matchlen THEN
                tracenew.call:=op^.call;
                doset:=confflags(fWATCH, j);
                matchlen:=i;
              END; 

            END;
            EXIT

          ELSE
            IF wc[i]="*" THEN
              IF wc[i+1]<>0C THEN INC(i) END;
            ELSIF CAP(wc[i])<>CAP(op^.call[ii]) THEN EXIT

            ELSE INC(i) END;
          END;
          INC(ii);
        END;
        INC(j);
      END;
--  END;
    tracenew.beep:=ODD(doset);
    tracenew.follow:=ODD(doset DIV 2);

    IF ODD(doset DIV 4) THEN                               (* append to watchcall file *)
      Assign(fn, op^.call);
      alfanum(fn);                                         (* remove bad chars *)
(*
      confstr(fLOGWFN, fn);
      filepath(fn);
      IF fn[0]<>0C THEN Append(fn, DIRSEP) END;
      Append(fn, wc);
*)
      makelogfn(fn);
      IF NOT wrlog(rawbuf, realtime, fn, 0) THEN poplogerr(op^.call) END;
    END;

  END;
END inwindow;


PROCEDURE finddup(pf, frame:pFRAMEHIST):TIME;            (* return delay time if dupe found *)
VAR apos:POSITION;
    dupedelay, ret:TIME;
    speed      : CARDINAL;
    course     : CARDINAL;
    altitude   : INTEGER;
    dat        : DAT;
BEGIN
  apos:=frame^.vardat^.pos;
  ret:=0;
  IF (pf<>frame) & posvalid(apos) & (Decode(frame^.vardat^.raw, dat)>=0) THEN
    speed:=dat.speed;
    course:=dat.course;
    altitude:=dat.altitude;
    dupedelay:=frame^.time-lums.dupemaxtime;
    WHILE pf^.next<>frame DO
      WITH pf^.vardat^ DO
        IF (pf^.time>=dupedelay) & (frame^.time>pf^.time) & ((frame^.vardat=pf^.vardat)
        OR (apos.lat=pos.lat) & (apos.long=pos.long) & (Decode(raw, dat)>=0) & (speed=dat.speed)
        & (course=dat.course) & (altitude=dat.altitude)) THEN ret:=frame^.time-pf^.time
        ELSIF ret>0 THEN RETURN ret END;
      END;
      pf:=pf^.next;
    END;
  END;
  RETURN 0
END finddup;


PROCEDURE Checktrack(op:pOPHIST; lastf:pFRAMEHIST);
VAR frame:pFRAMEHIST;
    v:pVARDAT;
    apos:POSITION;
BEGIN
  IF lastf<>NIL THEN frame:=lastf^.next 
  ELSE 
    op^.margin0.long:=PI2*0.5;
    op^.margin0.lat:=-PI2*0.25;
    op^.margin1.long:=-PI2*0.5;
    op^.margin1.lat:=PI2*0.25;
    frame:=op^.frames;
    WHILE frame<>NIL DO frame^.vardat^.refcnt:=0; frame:=frame^.next END;
    frame:=op^.frames;
    WHILE frame<>NIL DO INC(frame^.vardat^.refcnt); frame:=frame^.next END;
    frame:=op^.frames;
  END;
  WHILE frame<>NIL DO
    v:=frame^.vardat;
    apos:=v^.pos;
    IF (*(v^.lastref=frame) &*) posvalid(apos) THEN
      WITH op^ DO
        IF apos.long<margin0.long THEN margin0.long:=apos.long END;
        IF apos.long>margin1.long THEN margin1.long:=apos.long END;
        IF apos.lat >margin0.lat  THEN margin0.lat :=apos.lat  END;
        IF apos.lat <margin1.lat  THEN margin1.lat :=apos.lat  END;
      END;

      IF (op^.margin0.long<>op^.margin1.long) OR (op^.margin0.lat<>op^.margin1.lat) THEN   (* moving station *)
(*
        dupef:=NIL;

        pf:=op^.frames;
        dupedelay:=frame^.time-lums.dupemaxtime; 
        WHILE pf<>frame DO
          IF pf^.time>=dupedelay THEN                  (* else ignore same pos if long ago *)
            WITH pf^.vardat^ DO        
              IF (apos.lat=pos.lat) & (apos.long=pos.long) THEN dupef:=pf END;
            END;
          END;
          pf:=pf^.next;
        END;

        IF (dupef<>NIL) & (dupef^.next<>frame) THEN INCL(frame^.nodraw, eDUPE) END;
*)
        IF finddup(op^.frames, frame)>0 THEN INCL(frame^.nodraw, eDUPE) END;
        IF maxspeed>0.0 THEN timespeed(lastf, apos, frame^.time, frame^.nodraw) END;
      END; 
    IF (frame^.nodraw<=ERRSET{eSYMB,eSPEED}) OR NOT posvalid(op^.lastpos) THEN op^.lastpos:=apos END;
--      IF (frame^.nodraw=ERRSET{}) OR NOT posvalid(op^.lastpos) THEN op^.lastpos:=apos END;
--        op^.lastpos:=apos;
    ELSE INCL(frame^.nodraw, eNOPOS) END;
    lastf:=frame;
    frame:=frame^.next;


  END;
  joinchunk(op);
(*
WrStr(op^.call); WrStr(op^.sym.tab);WrFixed(op^.lastpos.lat, 5,10);WrLn;
*)
END Checktrack;

PROCEDURE strcmp(a-,b-:ARRAY OF CHAR):BOOLEAN;     (* faster but needs 0 termination *)
VAR i:CARDINAL;
BEGIN
  i:=0;
  LOOP
    IF a[i]<>b[i] THEN RETURN FALSE ELSIF a[i]=0C THEN RETURN TRUE END;
    INC(i);
  END
END strcmp; 

PROCEDURE callfilt(v:CONFSET; str-:ARRAY OF CHAR; fullmatch:BOOLEAN):BOOLEAN;
VAR i,j:CARDINAL;
    s:ARRAY[0..30] OF CHAR;
BEGIN
  IF str[0]=0C THEN RETURN FALSE END;

  i:=0;
  LOOP
    confstrings(v, i, FALSE, s);
    IF s[0]=0C THEN RETURN FALSE END;

    s[HIGH(s)]:=0C; 
--  IF fullmatch THEN IF StrCmp(s, str) THEN RETURN TRUE END; 
    IF fullmatch THEN 
      j:=0;
      LOOP
        IF s[j]="*" THEN
          IF (s[j+1]=0C) OR (str[j]=0C) THEN RETURN TRUE END;

        ELSIF s[j]<>str[j] THEN EXIT

        ELSIF str[j]=0C THEN RETURN TRUE END;
   
        INC(j);
        IF j>HIGH(str) THEN EXIT END;
      END;
    ELSIF InStr(str, s)>=0 THEN RETURN TRUE END;                  (* comment filter *)

    INC(i);
  END;
END callfilt;

PROCEDURE isacall(s-:ARRAY OF CHAR):BOOLEAN;
VAR num, lit, p:CARDINAL;
    c:CHAR;
BEGIN
--  IF configon(fMUSTBECALL) THEN
    p:=0;
    num:=0;
    lit:=0;
    LOOP
      c:=s[p];
      IF (c>="0") & (c<="9") THEN INC(num) ELSIF (c>="A") & (c<="Z") THEN INC(lit) ELSE EXIT END;
 
      INC(p);
      IF p>5 THEN EXIT END;

    END;
    IF (lit<2) OR (num=0) OR (num>2) THEN RETURN FALSE END;

    IF s[p]="-" THEN
      INC(p);
      IF s[p]="1" THEN
        INC(p);
        IF (s[p]>="0") & (s[p]<="5") THEN INC(p) END;
      ELSIF (s[p]<"1") OR (s[p]>"9") THEN RETURN FALSE ELSE INC(p) END;

    END;
    RETURN (p>HIGH(s)) OR (s[p]=0C);

--  END;
--  RETURN TRUE
END isacall;



(*
PROCEDURE framestat(c-:MONCALL; isigate:BOOLEAN);
BEGIN
  IF iscall(c) THEN 
--    WrStr(c);
--    WrInt(ORD(isigate), 2);
  END;
END framestat;
*)

PROCEDURE inserthrt(dat-:DAT; VAR op:pOPHIST; errs:ERRSET);
VAR f, lastf:pFRAMEHIST;
    v:pVARDAT;
    i, ih, len:CARDINAL;
    stime:TIME;
    rb, s:ARRAY[0..50] OF CHAR;
BEGIN
  f:=op^.frames;
  lastf:=NIL;
  FOR ih:=0 TO dat.hrtlen-1 DO
    IF dat.hrtposes[ih].notinterpolated THEN       (* interpolating does vector drawer *)
      stime:=dat.hrtposes[ih].dtime;
      WHILE (f<>NIL) & (f^.time<stime) DO lastf:=f; f:=f^.next END;
      IF (f=NIL) OR (f^.time<>stime) THEN                      (* not a redundant same time frame *)
        ALLOCATE(f, SIZE(f^));  debugmem.req:=SIZE(f^); INC(debugmem.mon, debugmem.req);
        IF f=NIL THEN RETURN END;

        FILL(f, 0C, SIZE(f^));

        IF ABS(dat.hrtposes[ih].dalt)<FLOAT(MAX(INTEGER)-1) THEN 
          IntToStr(VAL(INTEGER, dat.hrtposes[ih].dalt), 0, s);
          rb:=">:$HR[a"; Append(rb, s); Append(rb, "]");
        ELSE rb[0]:=0C END;
        len:=SIZE(v^)-HIGH(v^.raw)+Length(rb);
        ALLOCATE(v, len); debugmem.req:=len; INC(debugmem.mon, len);
        IF v=NIL THEN RETURN END;

        FILL(v, 0C, len);
        WITH v^ DO
          pos.long:=dat.hrtposes[ih].dlong;
          pos.lat :=dat.hrtposes[ih].dlat;
          i:=0;
          REPEAT raw[i]:=rb[i]; INC(i) UNTIL rb[i]=0C;
        END;
        v^.lastref:=f;
        f^.vardat:=v;
        f^.time:=stime;
        f^.nodraw:=errs;
        IF lastf=NIL THEN
          f^.next:=op^.frames;
          op^.frames:=f;                                      (* new track *)
        ELSE
          f^.next:=lastf^.next;                               (* not nil if insert older frame *)
          lastf^.next:=f;                                     (* append waypoint *)
        END;
   
      END;
    END;
  END;
END inserthrt;


PROCEDURE settempspeed(op:pOPHIST; dat-:DAT);
VAR rv:REAL;
BEGIN
  IF dat.objectfrom[0]<>0C THEN INCL(op^.drawhints, ISOBJECT) END;
  EXCL(op^.drawhints, MIRRORSYM);

  IF dat.sym="_" THEN
    rv:=FtoC(dat.wx.temp);
    IF (rv>=MINTEMP) & (rv<=MAXTEMP) THEN
      op^.lasttempalt:=VAL(INT16, rv);
      op^.temptime:=systime;
      IF dat.course<=360 THEN op^.lastinftyp:=110+dat.course DIV 4;
      ELSE op^.lastinftyp:=100 END;                              (* wx but no course *)
      IF dat.speed<500 THEN
        op^.lastkmh:=VAL(INT16, FLOAT(dat.speed)*WKNOTS+0.5);
      ELSE op^.lastkmh:=0 END;
    ELSE op^.lastinftyp:=0 END;

  ELSIF dat.speed<30000 THEN
    op^.lastkmh:=VAL(INT16, FLOAT(dat.speed)*KNOTS+0.5);
    IF (dat.speed>0) & (dat.course>180) THEN INCL(op^.drawhints, MIRRORSYM) END;
    IF dat.course<=360 THEN op^.lastinftyp:=10+dat.course DIV 4
    ELSE op^.lastinftyp:=1 END;                                  (* drive speed but no course *)

  ELSIF op^.lastinftyp<100 THEN op^.lastinftyp:=0 END;           (* set no info if not wx *)

  IF op^.lastinftyp<100 THEN
    IF (dat.altitude>-10000) & (dat.altitude<65535-10000)
    THEN op^.lasttempalt:=dat.altitude+(10000-32768) ELSE op^.lasttempalt:=-32768 END;
  END;
END settempspeed;



PROCEDURE Stoframe(VAR optab:pOPHIST; rawbuf:ARRAY OF CHAR; stime:TIME; logmode:BOOLEAN; dat-:DAT):INTEGER;
CONST SAMETIME=27;                 (* max time diff for merged in frames *)

VAR op, opo:pOPHIST;
    frame, lastf:pFRAMEHIST;
    same:pVARDAT;
    igate:MONCALL;
    i, len:CARDINAL;
    hash, ch:CARD16;
BEGIN
  i:=0;
  hash:=0;
  REPEAT  
    ch:=ORD(rawbuf[i]);
    INC(hash, ch);
    INC(i);
  UNTIL ch=0;
  REPEAT DEC(i) UNTIL (i=0) OR (rawbuf[i]<>CR) & (rawbuf[i]<>LF) & (rawbuf[i]<>0C);  
  rawbuf[i+1]:=0C;                                                   (* remove trailing CR LF *)

--FOR len:=0 TO i DO WrInt(ORD(rawbuf[len]), 4) END; WrLn;

--  IF NOT logmode THEN
    IF (dat.igatep>0) & (dat.igatep<=HIGH(dat.viacalls)) 
    THEN igate:=dat.viacalls[dat.igatep] ELSE igate[0]:=0C END;
    IF callfilt(fOPFILT, dat.srccall, TRUE)
    OR callfilt(fIGATEFILT, igate, TRUE)
    OR callfilt(fOBJSRCFILT, dat.objectfrom, TRUE)
    OR callfilt(fDESTFILT, dat.dstcall, FALSE)
    OR callfilt(fSTRFILT, dat.comment, FALSE) THEN RETURN -1 END;

    IF configon(fMUSTBECALL) THEN
      IF (dat.type=OBJ) OR (dat.type=ITEM) THEN
        IF NOT isacall(dat.objectfrom) THEN RETURN -1 END;
      ELSIF NOT isacall(dat.srccall) THEN RETURN -1 END;
    END;
--  END;

--  IF NOT logmode & (dat.type=MSG) THEN getmessage END;

--  IF dat.hbitp<>0 THEN igate[0]:=0C END;

  opo:=NIL;
  op:=optab;
  WHILE (op<>NIL) & (dat.srccall<>op^.call) DO opo:=op; op:=op^.next END;
  IF op=NIL THEN                                                    (* new user *)
    ALLOCATE(op, SIZE(op^)); debugmem.req:=SIZE(op^); INC(debugmem.mon, debugmem.req);
    IF op=NIL THEN RETURN -2 END;

    FILL(op, 0C, SIZE(op^));
    op^.call:=dat.srccall;
    IF logmode OR (opo=NIL) THEN               (* store it at begin of list for quick find *) 
      op^.next:=optab;
      optab:=op;
    ELSE opo^.next:=op END;                    (* store it at end of list for draw latest on top *)
  ELSIF logmode & (opo<>NIL) THEN              (* move it to begin of list *)
    opo^.next:=op^.next;
    op^.next:=optab;
    optab:=op;
  END;

  IF dat.hrttime>0 THEN stime:=dat.hrttime END;

  IF op^.lasttime<=stime THEN                  (* new waypoint *) 
    settempspeed(op, dat);
(*
    IF dat.objectfrom[0]<>0C THEN INCL(op^.drawhints, ISOBJECT) END;
    EXCL(op^.drawhints, MIRRORSYM);

    IF dat.sym="_" THEN
      rv:=FtoC(dat.wx.temp);
      IF (rv>=MINTEMP) & (rv<=MAXTEMP) THEN
        op^.lasttempalt:=VAL(INT16, rv);
        op^.temptime:=systime;
        IF dat.course<=360 THEN op^.lastinftyp:=110+dat.course DIV 4;
        ELSE op^.lastinftyp:=100 END;                              (* wx but no course *)
        IF dat.speed<500 THEN
          op^.lastkmh:=VAL(INT16, FLOAT(dat.speed)*WKNOTS+0.5);
        ELSE op^.lastkmh:=0 END;
      ELSE op^.lastinftyp:=0 END;

    ELSIF dat.speed<30000 THEN
      op^.lastkmh:=VAL(INT16, FLOAT(dat.speed)*KNOTS+0.5);
      IF (dat.speed>0) & (dat.course>180) THEN INCL(op^.drawhints, MIRRORSYM) END;
      IF dat.course<=360 THEN op^.lastinftyp:=10+dat.course DIV 4
      ELSE op^.lastinftyp:=1 END;                                  (* drive speed but no course *)

    ELSIF op^.lastinftyp<100 THEN op^.lastinftyp:=0 END;           (* set no info if not wx *)

    IF op^.lastinftyp<100 THEN
      IF (dat.altitude>-10000) & (dat.altitude<65535-10000)
      THEN op^.lasttempalt:=dat.altitude+(10000-32768) ELSE op^.lasttempalt:=-32768 END;
    END;
*)
    op^.lasttime:=stime;
  END;

  frame:=op^.frames;
  lastf:=NIL;
  same:=NIL;

  IF logmode THEN                                              (* refcnt used as raw string hash *)
    WHILE (frame<>NIL) & ((frame^.vardat^.refcnt<>hash) 
    OR NOT strcmp(frame^.vardat^.raw, rawbuf)) DO lastf:=frame; frame:=frame^.next END;
  ELSE                                                         (* online data find without hash *) 
    WHILE (frame<>NIL) & NOT strcmp(frame^.vardat^.raw, rawbuf) 
    DO lastf:=frame; frame:=frame^.next END;      
  END; 

  IF frame<>NIL THEN                                           (* found same frame *) 
    same:=frame^.vardat;
    lastf:=same^.lastref;
    WHILE lastf^.next<>NIL DO lastf:=lastf^.next END;          (* find last node to append new *)
  END;


  IF (lastf<>NIL) & (lastf^.time>stime) THEN                   (* older frame to insert *)
    lastf:=NIL;
    frame:=op^.frames;
    WHILE (frame<>NIL) & (frame^.time<stime) DO lastf:=frame; frame:=frame^.next END;
    IF (frame<>NIL) & (frame^.time-stime<SAMETIME) THEN RETURN -2 END; (* not insert same frame *)

  END;

  ALLOCATE(frame, SIZE(frame^));  debugmem.req:=SIZE(frame^); INC(debugmem.mon, debugmem.req); 
  IF frame=NIL THEN RETURN -2 END;

  FILL(frame, 0C, SIZE(frame^));

  IF same=NIL THEN                                            (* found new data *)
    len:=SIZE(same^)-HIGH(same^.raw)+Length(rawbuf);
    ALLOCATE(same, len); debugmem.req:=len; INC(debugmem.mon, len);     
    IF same=NIL THEN RETURN -2 END;

    FILL(same, 0C, len);
    WITH same^ DO
      pos:=dat.pos;
--      altitude:=dat.altitude;
      IF (dat.hbitp=0) & (dat.igaterawp<=MAX(CARD8)) THEN     (* direct to igate *)
        igatepos:=dat.igaterawp;
        igatelen:=dat.igatelen;
      END;
      i:=0;
      REPEAT raw[i]:=rawbuf[i]; INC(i) UNTIL rawbuf[i]=0C;
      IF logmode THEN refcnt:=hash END;
    END;
  ELSIF NOT logmode THEN INC(same^.refcnt) END;
  IF (same^.lastref=NIL) OR (same^.lastref^.time<=stime) THEN same^.lastref:=frame END;
  frame^.vardat:=same;
  frame^.time:=stime;

  IF dat.typc IN CHSET{34C,35C,"!","#","$","%","'",")","*","/",";","=","@","_",140C} THEN
    IF (ORD(dat.symt) IN SET256{47,92,65..90,48..57}) & (dat.sym>" ") & (dat.sym<177C)
    THEN op^.sym.tab:=dat.symt; op^.sym.pic:=dat.sym ELSE INCL(frame^.nodraw, eSYMB) END;
    IF dat.objkill="1" THEN op^.sym.tab:=DELETSYM; op^.sym.pic:=0C END;
  END;
  IF lastf=NIL THEN 
    frame^.next:=op^.frames;
    op^.frames:=frame;                                      (* new track *)
  ELSE 
    frame^.next:=lastf^.next;                               (* not nil if insert older frame *)
    lastf^.next:=frame;                                     (* append waypoint *)
  END;

  IF dat.hrtlen>0 THEN inserthrt(dat, op, frame^.nodraw) END;

  IF NOT logmode THEN                                       (* read log check whole track at end *)
    Checktrack(op, lastf);
    inwindow(op, rawbuf);
  END;

--WrInt(dat.igatep, 10); WrInt(dat.hbitp, 5);  WrStrLn(rawbuf);
--IF (dat.igatep>0) & (dat.igatep<=HIGH(dat.viacalls))
--THEN framestat(dat.viacalls[dat.igatep], TRUE) END;
--FOR i:=1 TO dat.hbitp DO framestat(dat.viacalls[i], FALSE) END;
--WrLn;
  IF frame^.nodraw<=ERRSET{eDIST} THEN RETURN 0 ELSE RETURN -1 END;
END Stoframe;

(*
PROCEDURE chkptr(op:pOPHIST);                     (* check database pointer system *)
VAR
    frame, f:pFRAMEHIST;
    v:pVARDAT;
    c, cl:CARDINAL;
BEGIN
  WHILE op<>NIL DO
    frame:=op^.frames;
    WHILE frame<>NIL DO EXCL(frame^.nodraw, eNODRAW); frame:=frame^.next; END;
    frame:=op^.frames;

    IF frame=NIL THEN WrStrLn("op with no frames") END; 
    LOOP
      IF frame=NIL THEN EXIT END;

      IF (frame^.next<>NIL) & (frame^.time>frame^.next^.time) THEN WrStrLn("time decreases") END;

      IF NOT (eNODRAW IN frame^.nodraw) THEN 
        v:=frame^.vardat;
        f:=frame;
        c:=0;
        cl:=0;
        WHILE f<>NIL DO
          IF f^.vardat=v THEN 
            INC(c);
            IF eNODRAW IN f^.nodraw THEN WrStrLn("double used waypoint") END;  
            INCL(f^.nodraw, eNODRAW);
            IF v^.lastref=f THEN cl:=c END;
          END;
          f:=f^.next;
        END;
        IF cl<>c THEN WrStrLn("lastref not last") END;
        IF v^.refcnt<>c THEN WrStrLn("refcnt wrong") END;
      END;
      frame:=frame^.next;

    END;
    op:=op^.next;
  END;
END chkptr;
*)

PROCEDURE locked(op:pOPHIST):BOOLEAN;             (* prevent entries in click table from purge *)
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE i<click.entries DO 
    IF click.table[i].opf=op THEN RETURN TRUE END;
    INC(i);
  END;
  RETURN FALSE
END locked;



PROCEDURE freevardat(v:pVARDAT);
VAR  alen:CARDINAL;
BEGIN
  alen:=SIZE(v^)-HIGH(v^.raw)+Length(v^.raw);
  DEALLOCATE(v, alen); DEC(debugmem.mon, alen);
END freevardat;


PROCEDURE purge(VAR ops:pOPHIST; oldt, oldobj:TIME);
VAR op, lastop, opx:pOPHIST;
    frame:pFRAMEHIST;
    v:pVARDAT;
    old:TIME; 
BEGIN


--chkptr(ops);

(*
WrInt(ORD(lums.logmode), 1);
IF ops=ophist THEN WrStrLn("purge oph") ELSIF ops=ophist2 THEN WrStrLn("purge oph2") ELSE WrStrLn("purge error") END;
*)
  op:=ops;
  lastop:=NIL;
  WHILE op<>NIL DO

--WrStr("op:"); WrStr(op^.call); WrStr("         ");

    IF op^.sym.tab=DELETSYM THEN old:=MAX(TIME)
    ELSIF (ISOBJECT IN op^.drawhints) & (op^.lastinftyp<100)
    THEN old:=oldobj ELSE old:=oldt END;                   (* object but no wx obj for wx graphs *)

    LOOP
      frame:=op^.frames;
      IF frame=NIL THEN EXIT END;

--WrCard(systime-frame^.time, 6); IF frame^.next<>NIL THEN WrStr("+") END;

      IF (frame^.time>=old) OR locked(op) THEN EXIT END;  

      v:=frame^.vardat;
      IF v^.lastref=frame THEN freevardat(v) ELSE DEC(v^.refcnt) END;
      op^.frames:=frame^.next;

--WrStr("(purge)");

      DEC(debugmem.mon, SIZE(frame^)); DEALLOCATE(frame, SIZE(frame^));
    END;      

    IF (op^.frames=NIL) & NOT locked(op) THEN                (* empty op *)
      opx:=op;
      op:=op^.next;
      IF lastop=NIL THEN ops:=op ELSE lastop^.next:=op END; 

--WrStr(opx^.call); WrStrLn("(purgop) ");

      DEC(debugmem.mon, SIZE(opx^)); DEALLOCATE(opx, SIZE(opx^));
    ELSE
      lastop:=op;
      op:=op^.next;
    END;  

--WrLn;

  END;
END purge;

PROCEDURE delwaypoint(op:pOPHIST; VAR frame:pFRAMEHIST);
VAR f, lf, lastf:pFRAMEHIST;
    i, di, mi:INTEGER; 
    dat:DAT;
BEGIN
  IF (op=NIL) OR (frame=NIL) THEN RETURN END;

  i:=0;
  di:=0;
  mi:=0;
  lf:=NIL;
  f:=op^.frames;
  WHILE f<>NIL DO
    IF f^.next=frame THEN lf:=f; di:=mi END;        (* next frame is to delete *)
    IF f^.vardat=frame^.vardat THEN INC(i) END;     (* count references to delet frame data *)
    f^.vardat^.refcnt:=0;
    INC(mi);
    f:=f^.next;
  END;
  IF i=1 THEN freevardat(frame^.vardat) END;        (* the deleted was the only reference *)
  IF lf=NIL THEN op^.frames:=frame^.next ELSE lf^.next:=frame^.next END;
  DEC(debugmem.mon, SIZE(frame^)); DEALLOCATE(frame, SIZE(frame^));

  f:=op^.frames;
  WHILE f<>NIL DO 
    IF f^.vardat^.refcnt<MAX(CARD16) THEN INC(f^.vardat^.refcnt) END;
    f^.vardat^.lastref:=f;
    f^.nodraw:=ERRSET{};                                               (* mark errors new later *)
    f:=f^.next;
  END;

  Checktrack(op, NIL);

  i:=0;                                (* set new marker to the nearest from deleted with error *)
  mi:=MAX(INTEGER);
  frame:=NIL;
  lf:=NIL;
  lastf:=NIL;
  f:=op^.frames;
  WHILE f<>NIL DO
    IF (NOT lums.errorstep OR (f^.nodraw-ERRSET{eNOPOS}<>ERRSET{})) & (ABS(i-di)<mi)
    THEN mi:=ABS(i-di); frame:=f END; 
    IF i=di THEN lf:=f END;
    INC(i); 
    lastf:=f;
    f:=f^.next;
  END;
  IF frame=NIL THEN frame:=lf END;                    (* no error so set nearest without error *)

  IF (lastf<>NIL) & (Decode(lastf^.vardat^.raw, dat)>=0) THEN settempspeed(op, dat) END;
END delwaypoint;



PROCEDURE cmpfrom(a-:ARRAY OF CHAR; from:CARDINAL; b-:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (from<=HIGH(a)) & (b[i]<>0C) DO
    IF a[from]<>b[i] THEN RETURN FALSE END;
    INC(i);
    INC(from);
  END;
  RETURN TRUE
END cmpfrom;

(*
PROCEDURE AppQ(VAR h:ARRAY OF CHAR; q-:ARRAY OF CHAR; appcall:BOOLEAN);
BEGIN
  Append(h, ">"+TOCALL+",");
  Append(h, q);
  IF appcall THEN Append(h, servercall) END;
  Append(h, ":");
END AppQ;
*)

PROCEDURE AprsIs(VAR buf:ARRAY OF CHAR; tablen:CARDINAL; logcall-:ARRAY OF CHAR; 
                 udpchan:CARDINAL; valid:BOOLEAN; VAR tablechk:BOOLEAN):INTEGER;

VAR i, p, len, pins, pssid, psum0, psum1, ilen, ha, qpos:CARDINAL;
    hashl, hashh:SET8;
    qtext:ARRAY[0..31] OF CHAR;

  PROCEDURE callchk(withstar, iscall:BOOLEAN):BOOLEAN;
  VAR i,j,u,num,lit:CARDINAL;
      c:CHAR;
  BEGIN
    pssid:=0;
    u:=0;
    LOOP
      IF u>=tablen THEN EXIT END;
      j:=0;
      i:=p;
      WHILE ungate[u][j]=buf[i] DO
        INC(i);
        INC(j);
        IF ungate[u][j]=0C THEN tablechk:=TRUE; EXIT END;

      END;
      INC(u);
    END;

    IF iscall THEN                                                      (* we want a callsign *)
      num:=0;
      lit:=0;
      LOOP
        c:=buf[p];
        IF (c>="0") & (c<="9") THEN INC(num) ELSIF (c>="A") & (c<="Z") THEN INC(lit) ELSE EXIT END; 
        INC(p);
      END;
      IF (lit<2) OR (num=0) OR (num>2) THEN RETURN FALSE END;
      pssid:=p;
      IF buf[p]="-" THEN
        INC(p);
        IF buf[p]="1" THEN 
          INC(p);
          IF (buf[p]>="0") & (buf[p]<="5") THEN INC(p) END;
        ELSIF (buf[p]<"1") OR (buf[p]>"9") THEN RETURN FALSE ELSE INC(p) END;
      END;

    ELSIF (buf[p]="q") & (buf[p+1]="A") & (buf[p+2]>="A") THEN          (* qAx *)
      qpos:=p+2;
      INC(p, 3);

    ELSE                                                                (* we skip any text *)
      LOOP
        c:=buf[p];
        IF c="-" THEN pssid:=p END;
        IF (c<=" ") OR (c=">") OR (c="*") OR (c=",") OR (c=":") THEN EXIT END;
        INC(p);
      END;
    END;

    IF pssid=0 THEN pssid:=p END;
    IF withstar & (buf[p]="*") THEN INC(p) END;

    RETURN TRUE
  END callchk;

  PROCEDURE Iconstruct;
  VAR i,j,k:CARDINAL;
  BEGIN
    IF (p<=4) OR (buf[p-2]<>"I") THEN RETURN END;       (* ,CALL,I: *)
    i:=p-4;
    WHILE buf[i]<>"," DO                                (* hop back call *)  
      IF i=0 THEN RETURN END;
      DEC(i);
    END;
    k:=i;                                               (* "," before call *)
    INC(i);
    j:=0;
    WHILE (j<=HIGH(logcall)) & (logcall[j]<>0C) DO
      IF logcall[j]<>buf[i] THEN RETURN END;
      INC(i);
      INC(j);
    END;                                                (* logcall = call,I *)
    pins:=k;
    i:=p-1;
    p:=k+1;                                             (* payload *)
    LOOP
      buf[k]:=buf[i];
      IF (i>=HIGH(buf)) OR (buf[i]=0C) THEN EXIT END;
      INC(k);
      INC(i);
    END;                                                (* delete ,call,I *)
    qtext:=",qAR,"; Append(qtext, logcall);             (* insert ,qAR,call *)
(*
OE0AAA-9>T8SV40,WIDE1-1,DB0WGS,I:test
OE0AAA-9>T8SV40,WIDE1-1:test
OE0AAA-9>T8SV40,WIDE1-1,qAR,DB0WGS:test 
*)

  END Iconstruct;

BEGIN
  hashl:=SET8{};
  hashh:=SET8{};
  p:=0;
  pins:=0;
  pssid:=0;                                            (* for savety *)
  len:=0;
  WHILE (len<HIGH(buf)) & (buf[len]<>0C) & (buf[len]<>CR) DO INC(len) END;
  IF (len=0) OR (len+(SIZE(qtext)+3)>HIGH(buf)) THEN RETURN -2 END;
  qpos:=0;
  tablechk:=FALSE;
  LOOP
    psum0:=p;
    IF NOT callchk(FALSE, (udpchan<>0) OR callsrc) THEN RETURN -3 END; 
    IF buf[p]<>">" THEN RETURN -1 END;

    INC(p);
    IF NOT callchk(FALSE, FALSE) THEN RETURN -3 END;
    psum1:=pssid;
    WHILE buf[p]="," DO
      INC(p);
      IF NOT callchk(TRUE, FALSE) THEN RETURN -3 END;
    END;
    IF buf[p]<>":" THEN RETURN -1 END;
    IF pins=0 THEN pins:=p END;
    INC(p);
    IF buf[p]<>cTHIRDPARTY THEN EXIT END;
    INC(p);
  END;
  
  IF p>=len THEN RETURN -2 END; 
  qtext[0]:=0C;
  IF qpos>0 THEN                                                              (* qA *)
    IF CAP(buf[qpos])="Z" THEN RETURN -3                   
    ELSIF CAP(buf[qpos])="I" THEN qtext:=","; confappend(fMYCALL, qtext) END;  (* qAI *)
  ELSE
    IF udpchan<>0 THEN qtext:=",qAU,"; confappend(fMYCALL, qtext);
    ELSIF logcall[0]<>0C THEN
      IF cmpfrom(buf, 0, logcall) THEN qtext:=",qAC," ELSE qtext:=",qAS," END;
      confappend(fMYCALL, qtext);
      Iconstruct;
    END;
  END;
  IF buf[p]="?" THEN RETURN -4 END;
  FOR i:=psum0 TO psum1-1 DO HashCh(buf[i], hashl, hashh) END;
  WHILE (p<len) & (buf[p]<>15C) & (buf[p]<>12C) DO HashCh(buf[p], hashl, hashh); INC(p) END;
  ha:=(ORD(CAST(CHAR, hashl)) + ORD(CAST(CHAR, hashh))*256) MOD HASHSIZE;
  IF timehash[ha]+dupetime>realtime THEN RETURN -5 END;                       (* a duplicate *)

  IF (udpchan<>0) OR valid THEN timehash[ha]:=realtime END;

  IF (udpchan=0) & NOT valid THEN RETURN -1 END;
  buf[p]:=15C; INC(p);
  buf[p]:=12C; INC(p);
  buf[p]:=0C;  INC(p);

  ilen:=Length(qtext);
  IF ilen>0 THEN
    WHILE p>pins DO DEC(p); buf[p+ilen]:=buf[p] END;
    i:=0;

    WHILE i<ilen DO buf[p]:=qtext[i]; INC(p); INC(i) END;
  END;

  RETURN 0
END AprsIs;

PROCEDURE connstr(cp:pTCPSOCK; VAR s:ARRAY OF CHAR);
BEGIN
  WITH cp^ DO
    confstr(fMYCALL, s);
    Append(s, " connected to "); Append(s, ipnum); Append(s, ":"); Append(s, port);
  END;
END connstr;


PROCEDURE wrconnected(cp:pTCPSOCK);
VAR h:ARRAY[0..300] OF CHAR;
BEGIN
  connstr(cp, h);
  textautosize(0, 5, 6, 5, "b", h);
END wrconnected;


PROCEDURE tcpconnstat(VAR s:ARRAY OF CHAR);
VAR tcp:pTCPSOCK;
    h:ARRAY[0..99] OF CHAR;
BEGIN
  tcp:=tcpsocks;
  WHILE tcp<>NIL DO
    WITH tcp^ DO
      IF (connt>0) & (connt<realtime) THEN
        IF s[0]<>0C THEN Append(s, LF) END;
        Append(s, "TCP:"); Append(s, ipnum); Append(s, ":"); Append(s, port);
        Append(s, LF+"  Connecttime:"); TimeToStr(realtime-connt, h); Append(s, h);
        IF (lasttcprx<=realtime) & (realtime-lasttcprx<3600) THEN
          Append(s, LF+"  No rx since:"); TimeToStr(realtime-lasttcprx, h); Append(s, h);
        END;
        Append(s, LF+"  Rx Frames:"); IntToStr(rxframes, 1,h); Append(s, h);
        Append(s, LF+"  Rx Bytes:"); IntToStr(rxbytes, 1, h); Append(s, h);
        Append(s, LF+"  Tx Frames:"); IntToStr(txframes, 1, h); Append(s, h);
        Append(s, LF+"  Tx Bytes:"); IntToStr(txbytes, 1, h); Append(s, h);
      END;
      tcp:=next;
    END;
  END;
END tcpconnstat;

PROCEDURE udpconnstat(port:CARDINAL; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..50] OF CHAR;
    i:CARDINAL;
BEGIN
  IF port<=HIGH(udpsocks) THEN
    WITH udpsocks[port] DO
      IF starttime>0 THEN
        IF realtime<starttime THEN starttime:=realtime END;
        IF s[0]<>0C THEN Append(s, LF) END;
        Append(s, "Rf "); IntToStr(port+1, 1, h); Append(s, h);
        Append(s, ":");
        i:=1;
        LOOP
          conf2str(VAL(CONFSET, ORD(fUDP1)+port), i, h);
          IF h[0]=0C THEN EXIT END;

          IF i>1 THEN Append(s, " ") END;
          Append(s, h);
          INC(i);
        END; 

        Append(s, LF+"  ");
        ipv4tostr(ip, h);    Append(s, h); Append(s, ":");
        IntToStr(dport, 0, h);   Append(s, h);
        IF checkip THEN Append(s, "/") ELSE Append(s, ":") END;
        IntToStr(bindport, 0, h);Append(s, h);

        Append(s, LF+"  Uptime :"); TimeToStr(realtime-starttime, h); Append(s, h);
        IF (lastudprx>0) & (lastudprx<=realtime) THEN
          Append(s, LF+"  Last rx:"); TimeToStr(realtime-lastudprx, h); Append(s, h);
        END;
        IF (lastudptx>0) & (lastudptx<=realtime) THEN
          Append(s, LF+"  Last tx:"); TimeToStr(realtime-lastudptx, h); Append(s, h);
        END;
        Append(s, LF+"  Rx Frames:"); IntToStr(rxframes, 1,h); Append(s, h);
        Append(s, LF+"  Rx Bytes:"); IntToStr(rxbytes, 1, h); Append(s, h);
        Append(s, LF+"  Tx Frames:"); IntToStr(txframes, 1, h); Append(s, h);
        Append(s, LF+"  Tx Bytes:"); IntToStr(txbytes, 1, h); Append(s, h);
      END;
    END;
  END;
END udpconnstat;


PROCEDURE tcpclose(w:pTCPSOCK; fin:BOOLEAN);
VAR h:ARRAY[0..200] OF CHAR;
BEGIN
  WITH w^ DO
(*
    WHILE txbuf<>NIL DO
      pb:=txbuf;
      txbuf:=txbuf^.next;
(*
WrStrLn("deallocw");
*)
      DEC(debugmem.mon, SIZE(pb^)); DEALLOCATE(pb, SIZE(pb^));
      IF NOT fin & (txbuf<>NIL) THEN RETURN END;

    END;
*)
    IF CAST(INTEGER,fd)>=0 THEN CloseSock(fd) END;
    fd:=CAST(SOCKET,-1);

    lasttcprx:=0;
    h:="TCP Close ";
    Append(h, ipnum); Append(h, ":"); Append(h, port);
    textautosize(0, 5, 6, 4, "e", h);

  END;
END tcpclose;


PROCEDURE Watchbeacon(cp:pTCPSOCK);
VAR ok:BOOLEAN;
BEGIN
  ok:=Sendtcp(cp, "# watchbeacon"+CR+LF);
  cp^.watchtime:=realtime;
END Watchbeacon;



PROCEDURE appfilter(VAR s:ARRAY OF CHAR); (* build string "filter m/300" *)
VAR h:ARRAY[0..999] OF CHAR;
BEGIN
  confstr(fSERVERFILT, h);
  IF h[0]<>0C THEN Append(s, " filter "); Append(s, h) END;
END appfilter;


PROCEDURE updatefilters(cp:pTCPSOCK);
VAR ok:BOOLEAN;
    s:FRAMEBUF;
BEGIN
  s:="#"; appfilter(s); Append(s, CR+LF);
  ok:=Sendtcp(cp, s);

  s:="Sent to Server";
  appfilter(s);
  textautosize(0, 5, 6, 4, "b", s);

END updatefilters;



PROCEDURE tcpconn(VAR sockchain:pTCPSOCK; f:SOCKET):BOOLEAN;
VAR cp:pTCPSOCK;
    h:FRAMEBUF;
    res:INTEGER;
    ok:BOOLEAN;
    s:ARRAY[0..99] OF CHAR;
BEGIN

  IF CAST(INTEGER,f)<0 THEN RETURN FALSE END;
  ALLOCATE(cp, SIZE(cp^)); debugmem.req:=SIZE(cp^); INC(debugmem.mon, debugmem.req);
  IF cp=NIL THEN
    CloseSock(f);
    IF verb THEN WrStrLn("tcp conn out of memory") END;
    RETURN FALSE

  END;
  FILL(cp, 0C, SIZE(cp^));
  WITH cp^ DO
    fd:=f;
    res:=socknonblock(f);
--    txbuf:=NIL;
    watchtime:=realtime;
  END;
  cp^.next:=sockchain;
  sockchain:=cp;

  confstr(fMYCALL, s);
  IF s[0]<>0C THEN
    Assign(h, "user ");
    Append(h, s);
    confstr(fPW, s);
    IF (s[0]<>0C) (* & configon(fPW)*) THEN Append(h, " pass "); Append(h, s) END;
    Append(h, " vers ");
    Append(h, VERS);
    appfilter(h);
--    IF filter[0]<>0C THEN Append(h, " filter "); Append(h, filter) END;
    Append(h, ""+CR+LF);
    ok:=Sendtcp(cp, h);
  END;
  cp^.txframes:=0;
  cp^.txbytes:=0;
  RETURN TRUE
END tcpconn;


(*
PROCEDURE Gateconn(VAR cp:pTCPSOCK);
VAR fd:SOCKET;
    p, act, try, kill:pTCPSOCK;
    max:CARDINAL;
BEGIN
--WrStrLn(" gateconn");
(*
  IF cp<>NIL THEN
    IF (cp^.fd<>CAST(SOCKET,-1)) & NOT configon(fSERVERURL) THEN
      saybusy(kill^.fd, "");  
    END;
  ELSIF 
*)
  act:=NIL;
  try:=NIL;
  p:=cp;
  WHILE p<>NIL DO
    IF p^.connt>0 THEN                                            (* we have gate connect *)
      IF act<>NIL THEN                                            (* we have 2 connects *)
        IF act^.gatepri>p^.gatepri THEN (* stop second best *)
          kill:=act; 
          act:=p;
        ELSE kill:=p END;                                         (* stop second best *)
        saybusy(kill^.fd, "# remove double connect"+CR+LF)  
      ELSE act:=p END;
    ELSE try:=p END;                                              (* trying to connect *)
    p:=p^.next;
  END;
  IF (try=NIL) & Watchclock(connecttime, GATECONNDELAY) THEN                                                   (* no trials *)
    IF act=NIL THEN max:=HIGH(gateways) ELSE max:=act^.gatepri END; (* try only better *)
    IF (trygate>=max) OR (trygate>HIGH(gateways)) 
    OR (gateways[trygate].url[0]=0C) THEN trygate:=0 END;           (* loop thru table *) 

    IF trygate<max THEN
      WITH gateways[trygate] DO
        IF url[0]<>0C THEN
          fd:=connectto(url, port);
--WrInt(fd, 1);WrStrLn(" connfd");

          IF CAST(INTEGER,fd)>=0 THEN
            IF tcpconn(cp, fd, filterst) THEN
              Assign(cp^.ipnum, url);
              Assign(cp^.port, port);
              cp^.gatepri:=trygate;
--            Assign(h, servercall);
--            Append(h, " connected to "); Append(h, url); Append(h, ":"); Append(h, port);
--            xerrmsg(h);
            END;
          END; 
        END;
      END;
    END;
    INC(trygate);

  END;
END Gateconn;
*)

PROCEDURE urlport(s:ARRAY OF CHAR; VAR url, port:ARRAY OF CHAR);   (* url:port to url port *)
VAR i:INTEGER;
BEGIN
  Assign(url, s);
  i:=InStr(url, ":");
  IF i>0 THEN
    url[i]:=0C;
    Delstr(s, 0, i+1);
    Assign(port, s);
  ELSE port[0]:=0C END;  
END urlport;

PROCEDURE Gateconn(VAR cp:pTCPSOCK);

CONST DEFAULTPORT="14580";

VAR fd:SOCKET;
    s, ip, port:ARRAY[0..999] OF CHAR;
BEGIN
--WrInt(cycleservers, 5); WrStrLn(" gateconn");

  IF cp<>NIL THEN
    IF (CAST(INTEGER,cp^.fd)>=0) & NOT configon(fCONNECT) THEN
      saybusy(cp^.fd, "");
    END;

  ELSIF configon(fCONNECT) & Watchclock(connecttime, GATECONNDELAY) THEN

    LOOP
      confstrings(fSERVERURL, cycleservers, FALSE, s);
      IF (s[0]<>0C) OR (cycleservers=0) THEN EXIT END;

      cycleservers:=0;
    END; 

    IF s[0]<>0C THEN
      INC(cycleservers); 
      urlport(s, ip, port);
      IF port[0]=0C THEN port:=DEFAULTPORT END;
--WrInt(cycleservers, 5);WrStr(" <"); WrStr(ip);WrStr("><");WrStr(port);WrStrLn(">");
      fd:=connectto(ip, port);
      IF CAST(INTEGER,fd)>=0 THEN
        IF tcpconn(cp, fd) THEN
          Assign(cp^.ipnum, ip);
          Assign(cp^.port, port);
          cp^.beacont:=0;                                      (* send next beacon now *)
        END;
      END;
    ELSE xerrmsg("Net: No Online/Server URL configured") END;
  END;

END Gateconn;

PROCEDURE porttext(p:CARDINAL; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..30] OF CHAR;
BEGIN
  IntToStr(p+1, 1, h);
  Assign(s, "UDP "); Append(s, h);
END porttext;



PROCEDURE rfbeacons;
VAR nb, i  :CARDINAL;
    j      :INTEGER;
    bt,
    bn,
    bshift,
    shift  :TIME;
    s      :FRAMEBUF;
    h      :ARRAY[0..100] OF CHAR;
    say    :ARRAY[0..100] OF CHAR;
    port   :CHAR;
    dat    :DAT;
BEGIN
  nb:=0;
  shift:=beaconrandomstart;
  bshift:=conf2int(fRFBTSHIFT, 0, 0, 3600*24, 120);
  IF (rfbecondone=0) OR (rfbecondone>realtime) THEN rfbecondone:=realtime END;
  LOOP
    IF testbeaconbuf[0]<>0C THEN                                       (* manual sent beacon *)
      Assign(s, testbeaconbuf);
      testbeaconbuf[0]:=0C;
      say:="Sent: "; Append(say, s);
      IF getbeaconparm(s, bt, port) THEN bt:=1 ELSE bt:=0 END;
    ELSE 
      confstrings(fRBTEXT, nb, FALSE, s);
      IF s[0]=0C THEN EXIT END;
      IF NOT getbeaconparm(s, bt, port) THEN bt:=0 END;                (* valid time and port *)
      say[0]:=0C;
    END;

    IF bt>0 THEN                                                       (* valid time *)
      bn:=(realtime+shift) MOD bt;
--WrInt(realtime MOD 86400, 10); WrInt(realtime-rfbecondone, 4);  WrInt(bshift, 4); WrInt(shift, 4); WrInt(n, 4); WrStrLn(" b");
      IF bn<realtime-rfbecondone THEN
        beaconmacros(s, "", "", TRUE);
        IF s[0]<>0C THEN
          IF Decode(s, dat)>=0 THEN
            IF dat.symt<" " THEN h:="beacon warning: no symbol: "; Append(h, s); xerrmsg(h) END; 
            IF CAP(port)="N" THEN
              j:=InStr(s, ":");
              IF j>=0 THEN 
                Delstr(s, 0, j+1);                                     (* remove rf adress *)
                IF NOT SendNet(tcpsocks, s) THEN say:="beacon: Netport not connected" END;
              END; 

            ELSIF port>="1" THEN
              IF s[0]<>0C THEN
                i:=ORD(port)-ORD("1");
                IF (i<UDPSOCKS) & configon(VAL(CONFSET, ORD(fUDP1)+i)) THEN
                  IF NOT Sendudp(s, i) THEN
                    say:="beacon: Rfport ";
                    Append(say, CHR(i+ORD("1")));
                    Append(say, " not configured to send");
                  END;
                ELSE
                  say:="beacon: Rfport ";
                  Append(say, CHR(i+ORD("1")));
                  Append(say, " not enabled");
                END;
              END;
            END; 

            IF say[0]<>0C THEN textautosize(0, 0, 4, 2, "b", say) END;
          ELSE h:="rfbeacon not decodeable: "; Append(h, s); xerrmsg(h) END;
        END;
      END;
      INC(shift, bshift);            (* delay next beacon by shift time to before beacon *)
    END;
    INC(nb);
  END;
  rfbecondone:=realtime;
END rfbeacons;

PROCEDURE startserial(VAR pid:PROCESSHANDLE; cfg:CONFSET);
VAR s,h:ARRAY[0..1000] OF CHAR;
BEGIN
  IF configon(cfg) THEN
    IF NOT (pid.runs OR pid.started) THEN 
      confstr(cfg, s);
      IF s[0]<>0C THEN
        StartProg(s, pid);
        pid.started:=TRUE;
        IF pid.runs THEN textautosize(0, 0, 4, 3, "g", "Start Serial Interface");
        ELSE 
          h:="can not start "; Append(h, s); xerrmsg(h);
          configbool(cfg, FALSE);
          refresh:=TRUE;
        END;
      END;
    END;
  ELSE pid.started:=FALSE END;
END startserial;


PROCEDURE tcpjobs;
VAR acttcp  :pTCPSOCK;
    len, i  :INTEGER;
    ok      :BOOLEAN;
    s:ARRAY[0..999] OF CHAR;
BEGIN
  IF qwatchtime<>realtime THEN
    acttcp:=tcpsocks;
    WHILE acttcp<>NIL DO
      WITH acttcp^ DO
--        IF beacont<realtime THEN Timebeacon(acttcp) END;
        Timebeacon(acttcp);
        IF watchtime+WATCH<realtime THEN Watchbeacon(acttcp) END;
        IF configon(fALLOWGATE) THEN WatchTXQ(acttcp) END;
        IF isupdated(fSERVERFILT) THEN updatefilters(acttcp) END;
        acttcp:=next;
      END;
    END;
    qwatchtime:=realtime; 
    Gateconn(tcpsocks);
--  IF configon(fRFBTSHIFT) THEN rfbeacons END;
    rfbeacons;
  END;

--UDP
  FOR i:=0 TO HIGH(udpsocks) DO
    WITH udpsocks[i] DO
      IF configon(VAL(CONFSET, ORD(fUDP1)+VAL(CARDINAL,i)))
      & NOT isupdated(VAL(CONFSET, ORD(fUDP1)+VAL(CARDINAL,i))) THEN
        IF CAST(INTEGER,fd)<0 THEN
          ok:=FALSE;
          confstr(VAL(CONFSET, ORD(fUDP1)+VAL(CARDINAL,i)), s);
          IF s[0]<>0C THEN
            FILL(ADR(udpsocks[i]), 0C, SIZE(udpsocks[0]));
            fd:=CAST(SOCKET, -1);
            IF GetIp2(s, ip, dport, bindport, checkip)<0 THEN
              rawread:=TRUE;
              porttext(i, s); Append(s, " Config Error <IPNumber:TxPort:RxPort>");
              textautosize(0, 5, 6, 10, "e", s);
            ELSE
              fd:=openudp();
              rawread:=TRUE;
              porttext(i, s);
              IF (CAST(INTEGER,fd)<0) OR (bindudp(fd, bindport)<0) THEN
                Append(s, " Bindport Error, Illegal (Rx)Port or in Use");
                textautosize(0, 5, 6, 10, "e", s);
                CloseSock(fd);
                fd:=CAST(SOCKET, -1);
              ELSE
                Append(s, " Open");
                len:=socknonblock(fd);
                textautosize(0, 5, 6, 5, "b", s);
                ok:=TRUE;
              END;
            END;
          ELSE 
            porttext(i, s); Append(s, " Not Configured");
            textautosize(0, 5, 6, 10, "e", s);
          END;
          IF NOT ok THEN configbool(VAL(CONFSET, ORD(fUDP1)+VAL(CARDINAL,i)), FALSE) END;
        END;
        startserial(serialpid, fSERIALTASK);
        startserial(serialpid2, fSERIALTASK2);

      ELSIF CAST(INTEGER,fd)>=0 THEN
        CloseSock(fd);
        fd:=CAST(SOCKET, -1);
        starttime:=0;
        porttext(i, s); Append(s, " Close");
        textautosize(0, 5, 6, 4, "e", s);
      END;
    END; 
  END;

  sendmsg;

--WrInt(tickertime, 15); WrInt(realtime, 15); WrLn;
  IF tickertime+TICKEROFFTIME<realtime THEN Stopticker END;

END tcpjobs;


PROCEDURE beepprox(d, km:REAL);
BEGIN
  IF configon(fBEEPPROX) & (km<>0.0) & (d<km) THEN
    d:=1.0-d/km;
    d:=d*d;
    d:=d*d;
    beeplim(100,
         trunc((1.0-d)*FLOAT(conf2int(fBEEPPROX, 0, 20, 8000, 400))
                   +d *FLOAT(conf2int(fBEEPPROX, 2, 20, 8000, 400))),
         trunc((1.0-d)*FLOAT(conf2int(fBEEPPROX, 1, 0,  5000, 40))
                   +d *FLOAT(conf2int(fBEEPPROX, 3, 0,  5000, 1000))));
  END; 
END beepprox;


PROCEDURE approxywarn(pos:POSITION; call-:ARRAY OF CHAR);
CONST LOOKBACK=180;                                      (* last s look if nearest pos is last *)

VAR s:ARRAY[0..30] OF CHAR;
    h:ARRAY[0..100] OF CHAR;
    km, mind, mino, d:REAL;
    mypos:POSITION;
    op:pOPHIST;
    pf:pFRAMEHIST;
    fd:File;
BEGIN
  km:=conf2real(fAPPROXY, 0, 0.0, 30000.0, 0.0);
  IF km<>0.0 THEN
    IF getmypos(mypos) THEN
      d:=distance(pos, mypos);
      IF d<=km THEN                                          (* quick check if it is in radius *)
        op:=ophist;
        WHILE (op<>NIL) & (op^.call<>call) DO op:=op^.next END;
        IF op<>NIL THEN
          mino:=30000.0;
          mind:=30000.0;
          pf:=op^.frames;
          WHILE pf<>NIL DO
            IF (pf^.time+LOOKBACK>realtime) 
            & (pf^.nodraw*ERRSET{eDIST, eSPIKE, eDUPE, eSYMB, eNOPOS}=ERRSET{}) THEN
              d:=distance(pf^.vardat^.pos, mypos);

(*
FixToStr(distance(pf^.vardat^.pos, mypos), 4, s); WrStr(s); WrStr(" ");
FixToStr(distance(mypos, pf^.vardat^.pos), 4, s); WrStr(s); WrStr(" ");
postostr(pf^.vardat^.pos, s); WrStr(s); WrStr(" "); postostr(mypos, s); WrStrLn(s);
*)


              mino:=mind; 
              IF d<mind THEN mind:=d END;
            END;
            pf:=pf^.next;
          END;
          IF (mino<29000.0) & (mino<>d) & (mino>d) THEN
            beepprox(d, km);

            h:="approach ";
            FixToStr(d, 3, s); Append(h, s);
            Append(h, "km ");
            Append(h, call);
            textautosize(0, 5, 6, 120, "r", h);

            fd:=OpenWrite("proxwarn");
            IF FdValid(fd) THEN
              Assign(h, call);
              IntToStr(trunc(d*1000.0), 0, s); 
              Append(h, " p "); Append(h, s);         
              WrBin(fd, h, Length(h)); 
              Close(fd);
            END;
          END;
        END;
      END;
    END;
  END;
END approxywarn;


PROCEDURE IsBulletin(dat-:DAT):BOOLEAN;
BEGIN
  RETURN (dat.type=MSG) & (dat.msgto[0]="B") & (dat.msgto[1]="L") & (dat.msgto[2]="N");
END IsBulletin;


PROCEDURE digi(b-:FRAMEBUF; udpch:CARDINAL; outport:CARDINAL; directonly, appendrest:BOOLEAN;
               nomovetime:TIME; radius:CARDINAL; VAR words:ARRAY OF CHAR);
CONST DUPTIME=27;
      NN="n";
      BAD="x";
      VIA="v"; 

VAR dat:DAT;
    p, tp, len, ssid, n, n1,n2, viac, pn:CARDINAL;
    tb:FRAMEBUF;
    hashl, hashh:SET8;
    dt:TIME;
    norout:BOOLEAN;
    mypos:POSITION;
    mycall, s1, s2:ARRAY[0..30] OF CHAR; 

  PROCEDURE app(c:CHAR);
  BEGIN
    IF tp<HIGH(tb) THEN tb[tp]:=c; INC(tp); END;
    IF c="," THEN INC(viac) END; 
  END app;


  PROCEDURE via(typ:CHAR; from, to:CARDINAL):BOOLEAN;
  VAR i:CARDINAL;
      h:ARRAY[0..30] OF CHAR;      
  BEGIN
    IF from>=to THEN RETURN FALSE END;

    h[0]:=typ;
    i:=1;
    WHILE (i<HIGH(h)-2) & (from<to) DO h[i]:=b[from]; INC(from); INC(i) END;
    h[i]:=" ";
    h[i+1]:=0C;

    RETURN InStr(words, h)>=0
  END via;

  PROCEDURE num(i:CARDINAL; VAR n:CARDINAL):BOOLEAN;
  BEGIN
    IF (i<HIGH(b)) & (b[i]>="0") & (b[i]<="9") THEN n:=ORD(b[i])-ORD("0"); RETURN TRUE END;
    RETURN FALSE
  END num; 

  PROCEDURE scanpath(to:CARDINAL; store:BOOLEAN):BOOLEAN;
  VAR hp:CARDINAL;
  BEGIN 
    hp:=p;
    WHILE p<to DO                                   
      IF store THEN app(b[p]) END;
      IF (p+1>=to) OR (b[p]=",") THEN
        IF via(BAD, hp+1, p+ORD(p+1>=to)) THEN RETURN FALSE END;         (* bad word *)

        hp:=p;
      END;
      INC(p);
    END;
    RETURN TRUE
  END scanpath;


BEGIN
  IF nomovetime<DUPTIME THEN nomovetime:=DUPTIME END;

  IF udpch=0 THEN RETURN END;
  DEC(udpch);
  IF udpch>HIGH(udpsocks) THEN RETURN END;

  tp:=0;
  p:=0;
  len:=0;
  ssid:=0;
  viac:=0;
  confstr(fMYCALL, mycall);
  IF mycall[0]=0C THEN xerrmsg("Digi needs 'My Call'"); RETURN END;                                           (* no mycall *)

  norout:=InStr(words, " "+BAD+"-")>=0;                                 (* ssid routing off *)
  IF InStr(words, " "+BAD+"i")<0 THEN Append(words, " "+VIA); Append(words, mycall) END; (* if not diabled append mycall for via *)
  Append(words, " "+BAD); Append(words, mycall); Append(words, " ");    (* mycall as badword *)

  WHILE (len<HIGH(b)) & (b[len]<>0C) & (b[len]<>":") DO INC(len) END;   (* end of address part *)
  WHILE (p<len) & (b[p]<>">") DO app(b[p]); INC(p) END;                 (* end of src call *)
  IF via(BAD, 0, p) THEN RETURN END;                                    (* bad src call *)

  IF configon(fMUSTBECALL) THEN
    tb[tp]:=0C;
    IF NOT isacall(tb) THEN RETURN END;
  END;

  n:=p+1;
  WHILE (p<len) & (b[p]<>"-") & (b[p]<>",") DO app(b[p]); INC(p) END;   (* ssid or end of dst call *)
  IF via(BAD, n, p) THEN RETURN END;                                    (* bad dest call *)

  IF b[p]="-" THEN                                                      (* we have a ssid *)
    INC(p);
    IF num(p, n) THEN
      ssid:=n;
      INC(p);
      IF num(p, n) THEN
        ssid:=ssid*10 + n;
        INC(p);
      END;
    END;
  END;
  IF (ssid=0) OR (ssid>7) THEN norout:=TRUE END;
  IF NOT norout THEN DEC(ssid) END;                                     (* use ssid routing *)

  IF ssid>0 THEN                                                        (* write old or new ssid *)
    app("-");
    IF ssid>=10 THEN app("1") END;
    app(CHR(ssid MOD 10 + ORD("0")));
  END;

  n:=p;
  WHILE (n<len) & (b[n]<>"*") DO INC(n) END;                            (* find repeated flag *)
  IF n<len THEN
    IF directonly THEN RETURN END;                                      (* not direct heard *)

    IF NOT scanpath(n, TRUE) THEN RETURN END;                           (* append path till * and find badwords *)

    INC(p);
  END; 

  app(",");

  n:=0;
  WHILE (mycall[n]<>0C) DO app(mycall[n]); INC(n) END;                  (* append mycall *)
  app("*");

  IF p<len THEN                                                         (* look for via routing *)
    norout:=TRUE;
    IF b[p]="," THEN INC(p) END;
    n:=p;
    WHILE (p<len) & (b[p]<>",") DO INC(p) END;
    IF via(NN, n, p-3) & num(p-3, n1) & (n1>0) & (n1<=7) & (b[p-2]="-")
    & num(p-1, n2) & (n2>0) & (n2<=n1) THEN
      IF directonly & (n1<>n2) THEN RETURN END;                         (* not direct heard *)

      IF appendrest & (n2>1) THEN                                       (* append not n-0 *)
        app(",");
        pn:=n;
        WHILE pn+3<p DO app(b[pn]); INC(pn) END;                        (* append via word *)
        app(CHR(n1+ORD("0"))); app("-"); app(CHR(n2+(ORD("0")-1)));     (* append n-n *)
      END;
      norout:=FALSE;                                                    (* append rest path later*)

    ELSIF via(VIA, n, p) THEN norout:=FALSE END;                        (* append rest path later*)
  END;

  IF norout THEN RETURN END;                                            (* nothing to digipeat *)

  IF NOT scanpath(len, appendrest) THEN RETURN END;                     (* append rest path and find badwords *)

  IF viac>7 THEN RETURN END;                                            (* too much via *) 

  p:=len;
  WHILE (p<HIGH(b)) & (b[p]<>0C) DO app(b[p]); INC(p) END;  
  app(0C);

  IF Decode(tb, dat)<0 THEN RETURN END;

--radius

  IF (dat.type<>MSG) & (radius>0) THEN
    IF NOT getmypos(mypos) THEN xerrmsg("Digi with Radius needs MY Position"); RETURN END;

--IF posvalid(dat.pos) THEN WrFixed(distance(mypos, dat.pos), 1, 6); WrStrLn("=radius"); END;

    IF NOT posvalid(dat.pos) OR (distance(mypos, dat.pos)>FLOAT(radius)) THEN RETURN END;
  END;

-- dupe

  hashl:=SET8{};
  hashh:=SET8{};
  p:=0;
  n1:=0;
  n2:=0;
  LOOP
    WHILE (tb[p]<>0C) & (tb[p]<>":") DO INC(p) END;
    IF tb[p]<>":" THEN EXIT END;

    n1:=p;
    INC(p);
    IF tb[p]<>"}" THEN EXIT END;

    INC(p);
    n2:=p;
  END; 
  p:=n2;
  WHILE (p<n1) & (tb[p]<>">") DO HashCh(tb[p], hashl, hashh); INC(p) END;
  WHILE (p<n1) & (tb[p]<>"-") & (tb[p]<>",") DO HashCh(tb[p], hashl, hashh); INC(p) END;
  p:=n1;
  WHILE tb[p]<>0C DO HashCh(tb[p], hashl, hashh); INC(p) END;
  n:=(ORD(CAST(CHAR, hashl)) + ORD(CAST(CHAR, hashh))*256) MOD (HIGH(udpsocks[0].pdupetimes^)+1);

  IF (dat.type=MSG) & NOT IsBulletin(dat) THEN dt:=DUPTIME ELSE dt:=nomovetime END;  (* real messages fast dupetime *)
  
  
  IF (outport>0) & (outport-1<=HIGH(udpsocks)) THEN
    WITH udpsocks[outport-1] DO
      IF pdupetimes=NIL THEN
        ALLOCATE(pdupetimes, SIZE(pdupetimes^)); debugmem.req:=SIZE(pdupetimes^); INC(debugmem.mon, SIZE(pdupetimes^));
        IF pdupetimes=NIL THEN WrStrLn("duptime out of memory"); wrheap; RETURN END;
        FILL(pdupetimes, 0C, SIZE(pdupetimes^));
      END;
      IF pdupetimes^[n]+dt>realtime THEN (*WrInt(pdupetimes^[n]+dt-realtime, 5); WrStrLn("=age");*) RETURN END;
      pdupetimes^[n]:=realtime;
    END; 
  END;

  IF (outport=0) OR (outport-1>HIGH(udpsocks)) OR NOT Sendudp(tb, outport-1) THEN
    s1:="aprsdigi:can not send to port "; IntToStr(outport, 0, s2); Append(s1, s2); xerrmsg(s1);
  END;
--WrInt(udpch, 10); WrInt(dt, 10); WrInt(n, 10); WrStrLn("=h"); WrStrLn(tb);

END digi;

PROCEDURE digipeat(b-:FRAMEBUF; udpch:CARDINAL);
VAR 
    radius, outport, line:CARDINAL;
    nomovetime:TIME;
    appendrest, directonly:BOOLEAN;
    words:ARRAY[0..200] OF CHAR;
    word:ARRAY[0..10] OF CHAR;
    c:CHAR;

BEGIN
  line:=0;
  LOOP  
    confstrings(fDIGI, line, FALSE, words);
    IF words[0]=0C THEN EXIT END;

--words:="*42 890 300 TCPIP* WIDEn TRACEn RELAY ECHO GATE "; 
    c:=words[0];                                             (* input port *)
    IF (c="*") OR (c=CHR(udpch+ORD("0"))) THEN               (* our input port *)
      c:=words[1];                                           (* output port *)  
      IF c>="1" THEN outport:=ORD(c)-ORD("0") ELSE outport:=0 END;
      directonly:=TRUE;
      appendrest:=FALSE;
      CASE words[2] OF                                       (* direct/delpath *)
        "1":appendrest:=TRUE;
       |"2":directonly:=FALSE;
       |"3":directonly:=FALSE; appendrest:=TRUE; 
      ELSE END;
      Extractword(words, word);
      Extractword(words, word);
      IF StrToCard(word, nomovetime) THEN
        Extractword(words, word);
        IF StrToCard(word, radius)
        THEN digi(b, udpch, outport, directonly, appendrest, nomovetime, radius, words) END;
      END;
    END;
    INC(line);
  END;
END digipeat;


VAR 
    rfhered  : BOOLEAN;


PROCEDURE storedata(VAR mb:FRAMEBUF; cp:pTCPSOCK; udpch:CARDINAL; valid, local:BOOLEAN);
VAR res:INTEGER;
    fn:ARRAY[0..999] OF CHAR;
    s:ARRAY[0..20] OF CHAR;
    server:MONCALL;
    ok, tabchk:BOOLEAN;
    tp:pTCPSOCK;
    dat:DAT;
    dir:CHAR;
BEGIN
  IF lastpurge<>realtime THEN 
    IF lums.logmode THEN purge(ophist2, realtime-lums.purgetime, realtime-lums.purgetimeobj);
    ELSE purge(ophist, realtime-lums.purgetime, realtime-lums.purgetimeobj) END;
  END;

  IF cp<>NIL THEN server:=cp^.user.call ELSE server[0]:=0C END;

  IF local THEN res:=0                                             (* draw test bneacon *)
  ELSIF (rxidle>=3) & (lastlooped+IGATEMAXDELAY>=time()) THEN      (* not too long delayd data *)
    digipeat(mb, udpch);

    res:=AprsIs(mb, 6, server, udpch, valid, tabchk);

    IF (res>=0) & configon(fALLOWGATE) & NOT tabchk & (udpch>0) THEN
      confstr(fALLOWGATE, s);
      IF InStr(s, CHR(udpch+ORD("0")))>=0 THEN 
        IF NOT igatedelay THEN
          tp:=tcpsocks;
          WHILE tp<>NIL DO
            ok:=Sendtcp(tp, mb);
            tp:=tp^.next;
          END;
        ELSE WrStrLn("---discarded delayed gate-to-rf-frame") END;
      END;
    END;
  ELSIF verb THEN WrStrLn("---discarded delayed digpeat-frame") END;

  IF verb & (udpch>0) THEN WrInt(res, 3); WrStr(" udp "); WrStrLn(mb) END;
  IF (res>=0) & (Decode(mb, dat)>=0) THEN
    IF dat.type=MSG THEN 
      IF udpch>0 THEN getmessage(NIL, udpch, dat) ELSE getmessage(cp, 0, dat) END;
    END;

    IF lums.logmode THEN res:=Stoframe(ophist2, mb, realtime, FALSE, dat);
    ELSE res:=Stoframe(ophist, mb, realtime, FALSE, dat) END;

    IF NOT local THEN 
      IF configon(fLOGWFN) THEN 
        confstr(fLOGWFN, fn);
        IF NOT wrlog(mb, realtime, fn, res) THEN poplogerr(fn) END;
      END;

      IF posvalid(dat.pos) & configon(fAPPROXY) THEN approxywarn(dat.pos, dat.srccall) END;
    END;
  END;
  IF res<0 THEN dir:="-" ELSE dir:=">" END; 
  IF udpch>0 THEN wrmon(udpch, dir, mb) ELSE wrmon(0, dir, mb) END;
END storedata;

PROCEDURE drawbeacon(raw-:ARRAY OF CHAR);
VAR b:FRAMEBUF;
    port:CHAR;
    time:CARDINAL;
BEGIN
  Assign(b, raw);
  IF getbeaconparm(b, time, port) THEN
    beaconmacros(b, "", "", TRUE);
    storedata(b, NIL, 0, FALSE, TRUE);
  ELSE xerrmsg("decode error") END;
END drawbeacon;



PROCEDURE udpin(port:CARDINAL);
VAR mbuf : FRAMEBUF;
BEGIN
  WHILE getudp(port, mbuf) DO
    IF mbuf[0]<>0C THEN
      WITH udpsocks[port] DO
        lastudprx:=realtime;
        INC(rxframes);
        INC(rxbytes, Length(mbuf));
        IF starttime=0 THEN starttime:=realtime END;
      END;
      lastanyudprx:=realtime;
      storedata(mbuf, NIL, port+1, FALSE, FALSE);

    ELSIF verb THEN WrStrLn("axudp decode error") END;
  END; 
END udpin;


PROCEDURE tcpout(acttcp:pTCPSOCK):INTEGER;
VAR res, i:INTEGER;
BEGIN
  IF CAST(INTEGER,acttcp^.fd)>=0 THEN
    WITH acttcp^ DO
      res:=sendsock(fd, tbuf, tlen);
      IF res>0 THEN
        FOR i:=res TO tlen-1 DO tbuf[i-res]:=tbuf[i] END;
        DEC(tlen,res);
        IF connt=0 THEN
          connt:=realtime;
          wrconnected(acttcp);
        END;
        watchtime:=realtime;
--    ELSE tlen:=0;                        (* should not happen *)
      END;
    END;
  ELSE res:=-1 END;
  RETURN res
END tcpout;

PROCEDURE tcpin(acttcp:pTCPSOCK);
VAR res:INTEGER;
    mbuf    : FRAMEBUF;

BEGIN
  IF CAST(INTEGER,acttcp^.fd)>=0 THEN
    LOOP
      res:=Gettcp(acttcp^.fd, mbuf, acttcp^.rbuf, acttcp^.rpos);
--WrInt(res, 1);WrStrLn(" gettcp");
      IF res<0 THEN
--WrStrLn("closesock");
        CloseSock(acttcp^.fd);
        acttcp^.fd:=CAST(SOCKET,-1);
        EXIT
      END;
      IF res<=0 THEN EXIT END;

      INC(acttcp^.rxframes);
      INC(acttcp^.rxbytes, Length(mbuf));
      acttcp^.watchtime:=realtime;


--    WrMon(mbuf);

      storedata(mbuf, acttcp, 0, TRUE, FALSE);
      lasttcprx:=realtime;

    END;
  END;
END tcpin;

PROCEDURE initparms;
VAR i:CARDINAL;
BEGIN
  FILL(ADR(gateways), 0C, SIZE(gateways));
  FILL(ADR(udpsocks), 0C, SIZE(udpsocks));
  FOR i:=0 TO HIGH(udpsocks) DO udpsocks[i].fd:=CAST(SOCKET, -1) END;
  connecttime:=0;
  cycleservers:=0;
  logframename[0]:=0C;
  logframes:=6;  
  testbeaconbuf[0]:=0C;
--  servercall[0]:=0C; 
--  passwd[0]:=0C;
  rfhered:=FALSE;
  callsrc:=FALSE;
  igatedelay:=TRUE;
  rfbeacont:=0;
  qas:=0;
  qasc:=0;
  initxsize:=0;
  initysize:=0;
  initzoom:=0;
  finezoom:=1.0;
  posinval(mappos);
  spikesens:=2.0;
  maxhop:=100.0;
  maxspeed:=1000.0;
  nextbeep:=0;
  WITH lums DO
    map:=350;
    rfbri:=350;
    track:=1000;
    waypoint:=800;
    sym:=1000;
    obj:=1000;
    text:=750;
    nomov:=90; 
    maxdim:=3600;
    firstdim:=3600*23;
    purgetime:=3600*25;
    purgetimeobj:=3600*25;
    dupemaxtime:=3600*3;
    fps:=0;
--  mapmode:=REFLATER;
    mapname:="tiles";
    maplumcorr:=TILEBRIGHTNESS;    
    gamma:=2.2;
    centering:=40;
    movestep:=10;
    configfn:="aprsmap.cfg";
    wxcol:=0C;
  END;
  lastanyudprx:=0;
  lasttcprx:=0;
  mapdir:="osm";
  parms;
  ophist:=NIL;
  ophist2:=NIL;
  txmessages:=NIL;
  msgfifo:=NIL;
  msgmid:=0;
  realtime:=time(); 
  uptime:=realtime;
  trygate:=0;
  dupetime:=60;
  ungate[0]:="";
  ungate[1]:="NOGATE";
  ungate[2]:="RFONLY";
  ungate[3]:="TCPIP";
  ungate[4]:="TCPXX";
  ungate[5]:="q";
  ungate[6]:="";
  tcpsocks:=NIL;
  Stopticker;
  tickertime:=0;
  sentemptymsg:=FALSE;
  beaconrandomstart:=time() MOD 60;            (* set a beacon scheduler start second in minute *)
END initparms;

END aprsdecode.


