<*+M2EXTENSIONS *>
<*+STORAGE *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*-PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKDINDEX *>
<*-CHECKSET*>
<*CPU="PENTIUM"*>

<*NEW WITHSTDOUT*>
<*-WITHSTDOUT*>

IMPLEMENTATION MODULE aprstext; (* aprs tracks on osm map by oe5dxl *)

FROM SYSTEM IMPORT FILL, ADR, INT16;
FROM maptool IMPORT postoloc, getsrtm;

FROM aprsdecode IMPORT DAT, TYPES, WXNIL, Decode, lums, DEGSYM, IsBulletin,
     click, ERRSET, ERRFLAGS, LF, CR, MONCALL,
     pVARDAT, posinval, DRAWHINTS, pOPHIST, pFRAMEHIST, ophist, VARDAT,
     finddup, FRAMEHIST, CLICKTYPS, MSGREJ, realtime, trunc, DESTCALL;

FROM aprspos IMPORT POSITION, distance, azimuth, posvalid, KNOTS, WKNOTS,
                    FEET, ENCODEMICE, ENCODECOMP,
                    ENCODEGPSDAO, ENCODEMICEDAO;

FROM aprsstr IMPORT IntToStr, Append, Assign, DateToStr, FixToStr, Length,
                    TIME, StrCmp, Delstr, InStr, TimeToStr;

FROM osi IMPORT ln;
FROM useri IMPORT localtime, confstr, fRBTYP, fRBPOSTYP, fRBPORT, fRBSPEED,
                  fRBNAME, fMYPOS, fMYCALL, fRBALT, fRBDIR, fRBTIME, fRBPATH,
                  fRBPOS, fRBDEST, fRBCOMMENT, fRBSYMB, conf2int, confappend,
                  encerr, wrstrlist, wrstrmon;

CONST PI=3.14159265358979323844;

PROCEDURE strcp(from-:ARRAY OF CHAR; p, l:CARDINAL; VAR to:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (l>0) & (i<=HIGH(to)) DO to[i]:=from[p]; INC(i); INC(p); DEC(l) END;
  IF i<=HIGH(to) THEN to[i]:=0C END;
END strcp;

PROCEDURE DateLocToStr(time:TIME; VAR s:ARRAY OF CHAR);  (* append (+localtime) to time *)
CONST DAY=3600*24;
VAR lo:TIME;
    h:ARRAY[0..9] OF CHAR;
BEGIN
  lo:=localtime();
  IF time+DAY<realtime THEN DateToStr(time+lo, s) ELSE TimeToStr((time+lo) MOD DAY, s) END;
  IF lo<>0 THEN
    IntToStr(VAL(INTEGER, lo) DIV 3600,0,h);
    Append(s, "("); Append(s, h);Append(s, ")");
  END;
END DateLocToStr;

PROCEDURE FtoC(tempf:REAL):REAL;
BEGIN RETURN (tempf-32.0)/1.8 END FtoC;



PROCEDURE Errtxt(VAR s:ARRAY OF CHAR; pf, frame:pFRAMEHIST);
VAR h, hh:ARRAY[0..99] OF CHAR;
    l:CARDINAL;
    e:ERRSET;
BEGIN
  IF frame<>NIL THEN
    e:=frame^.nodraw;
    IF (frame^.vardat<>NIL) & (frame^.vardat^.lastref<>NIL)
    & NOT posvalid(frame^.vardat^.pos) THEN INCL(e, eNOPOS) END;
    h[0]:=0C;
    IF eDIST  IN e THEN Append(h, "DIST,") END;
    IF eSPIKE IN e THEN Append(h, "SPIKE,") END;
    IF eSYMB  IN e THEN Append(h, "SYMBOL,") END;
    IF eSPEED IN e THEN Append(h, "SPEED,") END;
    IF eNOPOS IN e THEN Append(h, "NOPOS,") END;
    IF eDUPE  IN e THEN
      Append(h, "DUPE,");
      IF pf<>NIL THEN IntToStr(finddup(pf,frame), 0, hh); Append(h, hh); Append(h, "s,") END;
    END;
    IF eNODRAW IN e THEN Append(h, "SEG,") END;
    l:=Length(h);
    IF l>0 THEN
      h[l-1]:=0C;
      Append(h, ']'+TEXTCOLEND);
      Append(s, TEXTCOLRED+'[');
      Append(s, h);
    END;
  END;
END Errtxt;



PROCEDURE Apphex(VAR s:ARRAY OF CHAR; h-:ARRAY OF CHAR);

  PROCEDURE Hex(d:CARDINAL):CHAR;
  BEGIN
    d:=d MOD 16;
    IF d>9 THEN INC(d, ORD("A")-10-ORD("0")) END;
    RETURN CHR(d+ORD("0"))
  END Hex;

VAR i, j:CARDINAL;
BEGIN
  i:=0;
  j:=Length(s);
  WHILE (i<=HIGH(h)) & (h[i]<>0C) & (j+10<HIGH(s)) DO
    IF h[i]<>CR THEN
      IF (h[i]<" ") OR (h[i]>=177C) THEN
        s[j]:=TEXTCOLBLU; INC(j);
        s[j]:="<"; INC(j);
        s[j]:=Hex(ORD(h[i]) DIV 16); INC(j);
        s[j]:=Hex(ORD(h[i])); INC(j);
        s[j]:=">"; INC(j);
        s[j]:=TEXTCOLEND;
      ELSE s[j]:=h[i] END;
      INC(j);
    END;
    INC(i);
  END;
  s[j]:=0C;
END Apphex;



PROCEDURE decode(VAR s:ARRAY OF CHAR; pf0, pf:pFRAMEHIST; oldvar:pVARDAT; odate:TIME;
                 decoded:BOOLEAN; VAR dat:DAT);

(*
  PROCEDURE radtostr(r:REAL; VAR s:ARRAY OF CHAR);
  BEGIN FixToStr(r*180.0/PI+0.000005, 6, s); END radtostr;
*)
  PROCEDURE rfdist(v:pVARDAT; VAR h:ARRAY OF CHAR);
  VAR digi:MONCALL;
      ig:pOPHIST; 
      s:ARRAY[0..31] OF CHAR;
  BEGIN
    WITH v^ DO
      IF (igatelen=0) OR NOT posvalid(pos) THEN RETURN END;

      strcp(raw, igatepos, igatelen, digi);
      ig:=ophist;
      WHILE (ig<>NIL) & (ig^.call<>digi) DO ig:=ig^.next END;
      IF (ig=NIL) OR NOT posvalid(ig^.lastpos) THEN RETURN END;

      Append(h, " Igate:"); Append(h, digi); Append(h, "(");
      FixToStr(distance(ig^.lastpos, pos), 4, s);
      Append(h, s); Append(h, "km)");

(*
FixToStr(distance(ig^.lastpos, pos), 4, s); WrStr(s); WrStr("|");
FixToStr(distance(pos, ig^.lastpos), 4, s); WrStr(s); WrStr(" ");
postostr(ig^.lastpos, s); WrStr(s); WrStr(" "); postostr(pos, s); WrStrLn(s);
*)


    END;
  END rfdist;

CONST TAB=LF+" ";

VAR h:ARRAY[0..511] OF CHAR;
    nl:BOOLEAN;
    ret:INTEGER;
    og:INTEGER;
    resol:REAL;
BEGIN
  IF pf^.time>0 THEN
    DateLocToStr(pf^.time, s);
    Append(s,":");
  ELSE s[0]:=0C END;
  ret:=Decode(pf^.vardat^.raw, dat);

  IF decoded THEN
    Apphex(s, dat.srccall);

    og:=MAX(INTEGER);
    IF NOT posvalid(dat.pos) THEN dat.pos:=pf^.vardat^.pos END;
    IF posvalid(dat.pos) THEN
      postostr(dat.pos, "3", h);
      Append(s," ");
      Append(s, h);
      Append(s, " (");
      postoloc(h, dat.pos);
      Append(s, h);
      Append(s, ") ");
      og:=getsrtm(dat.pos, resol);
    END;

    nl:=TRUE;
    IF (dat.symt>" ") & (dat.sym>" ") THEN
      Append(s, TAB);
      nl:=FALSE;
      Append(s, TEXTINSERTSYMBOL);
--      Append(s, "Sym:");
      Apphex(s, dat.symt);
      Apphex(s, dat.sym);
    END;

    IF dat.speed<MAX(CARDINAL) THEN
      IF nl THEN Append(s, TAB); nl:=FALSE ELSE Append(s, " ") END;
      IF dat.sym="_" THEN FixToStr(FLOAT(dat.speed)*WKNOTS, 2, h);
      ELSE FixToStr(FLOAT(dat.speed)*KNOTS, 0, h) END;
      Append(s, h);
      Append(s, "km/h");
      IF dat.course<360 THEN
        Append(s, " dir:");
        IntToStr(dat.course, 1, h);
        Append(s, h);
        Append(s, "deg");
      END;
    END;

    IF dat.altitude<MAX(INTEGER) THEN
      IF nl THEN Append(s, TAB); nl:=FALSE ELSE Append(s, " ") END;
      Append(s, "NN:");
      IntToStr(dat.altitude, 1, h);
      Append(s, h);
      Append(s, "m");
      IF og<MAX(INTEGER) THEN
        Append(s, " OG:");
        IntToStr(dat.altitude-og, 1, h);
        Append(s, h);
        Append(s, "m");
      END;
    END;
 
    rfdist(pf^.vardat, s);

    IF (oldvar<>NIL) & posvalid(oldvar^.pos) & posvalid(dat.pos) THEN
      IF nl THEN Append(s, TAB); nl:=FALSE ELSE Append(s, " ") END;
      Append(s, "moved:");
      FixToStr(distance(oldvar^.pos, dat.pos), 4, h);
      Append(s, h);
      Append(s, "km");
    END;

    IF (odate>0) & (pf^.time>=odate) THEN
      IF nl THEN Append(s, TAB); nl:=FALSE ELSE Append(s, " ") END;
      Append(s, "since ");
      IntToStr(pf^.time-odate, 1, h);
      Append(s, h);
      Append(s, "s");
    END;
    IF dat.type<>MSG THEN Errtxt(s, pf0, pf) END;

    nl:=TRUE;
    IF dat.sym="_" THEN
      IF dat.wx.gust<>WXNIL THEN
        Append(s, TAB); nl:=FALSE;
        Append(s, "Gust:");
        FixToStr(FLOAT(dat.wx.gust)*WKNOTS, 0, h);
        Append(s, h);
        Append(s, "km/h");
      END;
      IF dat.wx.temp<>WXNIL THEN
        IF nl THEN Append(s, TAB); nl:=FALSE END;
        Append(s, " Temp:");
        FixToStr(FtoC(dat.wx.temp) ,2, h);
        Append(s, h);
        Append(s, "C");
      END;

      IF dat.wx.hygro<>WXNIL THEN
        IF nl THEN Append(s, TAB); nl:=FALSE END;
        Append(s, " Hum:");
        IntToStr(VAL(INTEGER, dat.wx.hygro+0.5), 1, h);
        Append(s, h);
        Append(s, "%");  
      END;

      IF dat.wx.baro<>WXNIL THEN
        IF nl THEN Append(s, TAB); nl:=FALSE END;
        Append(s, " Baro:");
        FixToStr(dat.wx.baro*0.1, 2, h);
        Append(s, h);
        Append(s, "hPa");
      END;
      IF dat.wx.rain1<>WXNIL THEN
        IF nl THEN Append(s, TAB); nl:=FALSE END;
        Append(s, " Rain1h:");
        FixToStr(dat.wx.rain1*0.254, 2, h);
        Append(s, h);
        Append(s, "mm");
      END;
      IF dat.wx.rain24<>WXNIL THEN
        IF nl THEN Append(s, TAB); nl:=FALSE END;
        Append(s, " Rain24h:");
        FixToStr(dat.wx.rain24*0.254, 2, h);
        Append(s, h);
        Append(s, "mm");
      END;
      IF dat.wx.raintoday<>WXNIL THEN
        IF nl THEN Append(s, TAB); nl:=FALSE END;
        Append(s, " Rain00:");
        FixToStr(dat.wx.raintoday*0.254, 2, h);
        Append(s, h);
        Append(s, "mm");
      END;
      IF dat.wx.lum<>WXNIL THEN
        IF nl THEN Append(s, TAB) END;
        Append(s, " Luminosity:");
        FixToStr(dat.wx.lum, 0, h);
        Append(s, h);
        Append(s, "W");
      END;

    ELSIF dat.type=MSG THEN
      Append(s, TAB);
      Append(s, " Msg To:");
      Apphex(s, dat.msgto);
      IF dat.msgtext[0]<>0C THEN
        Append(s, " Text:[");
        Apphex(s, dat.msgtext);
        Append(s, "]");
      END;
      IF dat.acktext[0]<>0C THEN
        Append(s, " Ack:[");
        Apphex(s, dat.acktext);
        Append(s, "]");
      END;
      IF dat.ackrej=MSGREJ THEN Append(s, " Reject") END;

    ELSIF dat.type=OBJ THEN
      Append(s, TAB);
      IF dat.objkill="1" THEN Append(s, "Killed ") END;
      Append(s, "Object from:");
      Apphex(s, dat.objectfrom);

    ELSIF dat.type=ITEM THEN
      Append(s, TAB);
      IF dat.objkill="1" THEN Append(s, "Killed ") END;
      Append(s, "Item from:");
      Apphex(s, dat.objectfrom);
    END;

    IF (dat.type<>MSG) & (dat.comment[0]<>0C) THEN
      IF dat.type=TELE THEN Append(s, TAB+"Telemetry: [") ELSE Append(s, TAB+"Comment: [") END;
      Apphex(s, dat.comment);
      Append(s, "]");
    END;

    Append(s, TAB);
  END;

  Append(s, "[");
  Apphex(s, pf^.vardat^.raw);
  Append(s, "]");
  IF NOT decoded THEN Errtxt(s, pf0, pf) END;
END decode;

PROCEDURE setmark1(pos:POSITION; overwrite:BOOLEAN; alt:INTEGER; timestamp:TIME);
BEGIN
  IF overwrite OR NOT posvalid(click.markpos) OR (click.marktime<>0) THEN
    click.markpos:=pos;
    IF overwrite THEN click.marktime:=0 ELSE click.marktime:=realtime END;
    click.markalti:=alt;
    click.markpost:=timestamp; 
  END;

--WrFixed(pos.lat, 5, 10); WrFixed(pos.long, 5, 10);
--WrFixed(click.markpos.lat, 5, 10); WrFixed(click.markpos.long, 5, 10); WrStrLn(" mp");
END setmark1;


PROCEDURE setmarkalti(pf:pFRAMEHIST; op:pOPHIST; overwrite:BOOLEAN);
VAR dat:DAT;
    alt:INTEGER;
    pos:POSITION;
    t:TIME;
BEGIN
  posinval(pos);
  alt:=MAX(INTEGER);
  t:=realtime;
  IF (pf<>NIL) & (Decode(pf^.vardat^.raw, dat)=0) THEN
    IF dat.altitude>-10000 THEN alt:=dat.altitude END;
    pos:=dat.pos;
    t:=pf^.time;
  ELSIF (op<>NIL) & (op^.lastinftyp<100) THEN alt:=VAL(INTEGER, op^.lasttempalt)+(32768-10000)
  END;
  IF NOT posvalid(pos) & (op<>NIL) THEN pos:=op^.lastpos END;
  setmark1(pos, overwrite, alt, t);
END setmarkalti;


PROCEDURE optext(typ:CARDINAL; VAR last:BOOLEAN; VAR s:ARRAY OF CHAR);
VAR op:pOPHIST; 
    pf, pf1, pfe:pFRAMEHIST;
    cx, cn:CARDINAL;
    ss:ARRAY[0..999] OF CHAR;
    dat:DAT;
--    islast:BOOLEAN;
BEGIN
  op:=click.table[click.selected].opf;
  pf:=click.table[click.selected].pff0;
  IF (pf=NIL) & (op<>NIL) THEN pf:=op^.frames END;
  s[0]:=0C;
--  islast:=last;
  last:=FALSE;
  IF (op<>NIL) & (pf<>NIL) THEN

    IF typ=3 THEN
      setmarkalti(pf, op, FALSE);
--      click.marktime:=realtime;

    ELSIF typ=2 THEN                                              (* find last raw frame *)
      pf:=op^.frames;
      IF pf<>NIL THEN
        WHILE pf^.next<>NIL DO pf:=pf^.next END;
        click.table[click.selected].pff0:=pf;
--      IF islast THEN  
          setmarkalti(NIL, op, FALSE);    (* not use last frame for marker because marker should be at symbol position but sympol is on last ERROR-FREE position *)
--WrStrLn("mt2");
--      click.marktime:=realtime;
--      END;
      END;

    ELSIF typ=1 THEN                                              (* next frame *) 
      pf1:=pf;
      REPEAT
        IF pf^.next=NIL THEN pf:=op^.frames ELSE pf:=pf^.next END;
      UNTIL NOT lums.errorstep OR (pf1=pf) OR (pf^.nodraw-ERRSET{eNOPOS}<>ERRSET{});
--      IF pf^.next<>NIL THEN pf:=pf^.next ELSE pf:=op^.frames END;
      IF pf<>NIL THEN 
        click.table[click.selected].pff0:=pf;
        click.table[click.selected].pff:=pf;
        click.table[click.selected].typf:=tTRACK;                 (* set "track found" *)
        setmarkalti(pf, op, FALSE);
--        click.marktime:=realtime;
      END;

    ELSIF typ=0 THEN                                              (* back to last frame *)
      pf1:=pf;
      pfe:=pf;
      REPEAT
        IF NOT lums.errorstep OR (pfe^.nodraw-ERRSET{eNOPOS}<>ERRSET{}) THEN pf:=pfe END;
        IF pfe^.next=NIL THEN pfe:=op^.frames ELSE pfe:=pfe^.next END;
      UNTIL pfe=pf1;
(*
      pf:=op^.frames;
      IF pf=pf1 THEN pf1:=NIL END; 
      WHILE (pf<>NIL) & (pf^.next<>pf1) DO pf:=pf^.next END;
*)
      click.table[click.selected].pff0:=pf;
      click.table[click.selected].pff:=pf;
      click.table[click.selected].typf:=tTRACK;                   (* set "track found" *)
      setmarkalti(pf, op, FALSE);
--      click.marktime:=realtime; 
    END;

--    IF ((typ=1) OR (typ=0)) & lums.errorstep & (pf=pf1) THEN Assign(s, "no more errors found");
    IF lums.errorstep & (pf<>NIL) & (pf^.nodraw-ERRSET{eNOPOS}=ERRSET{}) THEN
      Assign(s, "Show errors mode: no (more) errors found");

    ELSIF pf<>NIL THEN
      cn:=0;
      cx:=0;
      pfe:=NIL;
      pf1:=op^.frames;
      WHILE pf1<>NIL DO
        INC(cn);
        IF pf1=pf THEN cx:=cn END;
        IF pf1^.next=pf THEN pfe:=pf1 END;
        pf1:=pf1^.next;
      END;
      IntToStr(cx, 0, s);  Append(s,"/");
      IntToStr(cn, 0, ss); Append(s, ss);
      Append(s, " ");
      IF pfe=NIL THEN decode(ss, op^.frames, pf, NIL, 0, TRUE, dat);
      ELSE decode(ss, op^.frames, pf, pfe^.vardat, pfe^.time, TRUE, dat) END;
      Append(s, ss); 
      last:=pf^.next=NIL;
    END;
  END;

END optext;

PROCEDURE oppo(opcall-:MONCALL):pOPHIST;              (* find pointer to call *)
VAR op:pOPHIST;
BEGIN
  IF opcall[0]=0C THEN RETURN NIL END;

  op:=ophist;
  WHILE (op<>NIL) & (op^.call<>opcall) DO op:=op^.next END;
  RETURN op
END oppo;


PROCEDURE listop(decoded:BOOLEAN);
VAR op:pOPHIST;
    pf:pFRAMEHIST;
    oldv:pVARDAT;
    oldt:TIME;
    s:ARRAY[0..999] OF CHAR;
    dat:DAT;
BEGIN
  op:=click.table[click.selected].opf;
  IF op<>NIL THEN
    pf:=op^.frames;
    oldv:=NIL;
    oldt:=0;
    WHILE pf<>NIL DO
      decode(s, op^.frames, pf, oldv, oldt, decoded, dat);
      IF posvalid(pf^.vardat^.pos) THEN oldv:=pf^.vardat END;
      oldt:=pf^.time;
      Append(s, LF);
      IF decoded THEN Append(s, LF) END; 
      wrstrlist(s, dat.srccall, pf^.vardat^.pos, pf^.time);
<* IF WITHSTDOUT THEN *>
      WrStr(s);
<* END *>
      pf:=pf^.next;
    END;
  END;
END listop;


PROCEDURE listin(r-:ARRAY OF CHAR; port, dir:CHAR; decoded:BOOLEAN);
VAR s, s1:ARRAY[0..999] OF CHAR;
    vard:VARDAT;
    pf:FRAMEHIST;
    i,j:CARDINAL;
    dat:DAT;
BEGIN
  FILL(ADR(vard), 0C, SIZE(vard));
  i:=0;
  j:=0;
  WHILE (i<HIGH(vard.raw)) & (i<=HIGH(r)) & (r[i]<>0C) DO
    IF (r[i]<>CR) & (r[i]<>LF) THEN j:=i END;
    vard.raw[i]:=r[i];
    INC(i);
  END;
  vard.raw[j+1]:=0C;
  FILL(ADR(pf), 0C, SIZE(pf));
  pf.vardat:=ADR(vard);
  decode(s, NIL, ADR(pf), NIL, 0, decoded, dat);
  IF decoded THEN s1[0]:=LF; s1[1]:=port; s1[2]:=0C;
  ELSE s1[0]:=port; s1[1]:=0C END;
  IF dir="<" THEN Append(s1, TEXTCOLRED+"<"+TEXTCOLEND) ELSE Append(s1, dir) END;
  Append(s1, s);
  wrstrmon(s1, dat.pos);
<* IF WITHSTDOUT THEN *>
  WrStr(s1);
<* END *>

END listin;


PROCEDURE listtyps(typ:CHAR; decod:BOOLEAN; oneop:ARRAY OF CHAR);
VAR op:pOPHIST;
    pf:pFRAMEHIST;
    s:ARRAY[0..999] OF CHAR;
    lastto, lasttext:ARRAY[0..100] OF CHAR;
    dat:DAT;
BEGIN
  op:=ophist;
  WHILE op<>NIL DO
    pf:=op^.frames;
    IF typ="N" THEN                                 (* no pos *)
      IF (pf<>NIL) & NOT posvalid(op^.lastpos) THEN
        WHILE pf^.next<>NIL DO pf:=pf^.next END;    (* show last frame *)
        decode(s, NIL, pf, NIL, 0, decod, dat);
        IF decod THEN Append(s, LF+LF) ELSE Append(s, LF) END;
        wrstrlist(s, dat.srccall, pf^.vardat^.pos, pf^.time);
<* IF WITHSTDOUT THEN *>
        WrStr(s);
<* END *>
      END;

    ELSIF typ="D" THEN                              (* moveing stations *)
      IF (pf<>NIL)
      & ((op^.margin0.lat>op^.margin1.lat) OR (op^.margin0.long<op^.margin1.long)) THEN
        WHILE pf^.next<>NIL DO pf:=pf^.next END;    (* show last frame *)
        decode(s, NIL, pf, NIL, 0, decod, dat);
        IF decod THEN Append(s, LF+LF) ELSE Append(s, LF) END;
        wrstrlist(s, dat.srccall, pf^.vardat^.pos, pf^.time);
<* IF WITHSTDOUT THEN *>
        WrStr(s);
<* END *>
      END;

    ELSIF typ="W" THEN 
      IF pf<>NIL THEN
        WHILE pf^.next<>NIL DO pf:=pf^.next END;    (* show last frame *)
        decode(s, NIL, pf, NIL, 0, decod, dat);

--        IF (dat.symt="/") & (dat.sym="_")
--        OR (op^.temptime+SHOWTEMPWIND>systime) & (op^.lastinftyp>=100)
--        & (op^.lasttempalt>=-99) & (op^.lasttempalt<=99) THEN

        IF (dat.symt="/") & (dat.sym="_") THEN
          IF decod THEN Append(s, LF+LF) ELSE Append(s, LF) END;
          wrstrlist(s, dat.srccall, pf^.vardat^.pos, pf^.time);
<* IF WITHSTDOUT THEN *>
          WrStr(s);
<* END *>
        END;
      END;

    ELSIF ((typ="M") OR (typ="B")) & ((oneop[0]=0C) OR (oneop=op^.call)) THEN (* bulletins messages *)
      lastto[0]:=0C;
      lasttext[0]:=0C;

      WHILE pf<>NIL DO
        IF (pf^.vardat^.lastref=pf) & (Decode(pf^.vardat^.raw, dat)>=0) THEN
          IF (typ="M") OR (typ="B") THEN
            IF (dat.type=MSG) & (dat.srccall<>dat.msgto) & (dat.msgtext[0]<>0C) THEN
              IF (typ="B")=IsBulletin(dat) THEN 
                IF NOT (StrCmp(lastto, dat.msgto) & StrCmp(lasttext, dat.msgtext)) THEN 
                  DateLocToStr(pf^.time, s); Append(s, " ");
                  Append(s, dat.srccall); Append(s, ">");
                  Append(s, dat.msgto); Append(s, ":[");
                  Apphex(s, dat.msgtext); Append(s, "]");
                  IF dat.acktext[0]<>0C THEN 
                    Apphex(s, " Ack[");Append(s, dat.acktext); Append(s, "]");
                  END;
                  Append(s, LF);
                  wrstrlist(s, dat.srccall, pf^.vardat^.pos, pf^.time);

<* IF WITHSTDOUT THEN *>
                  WrStr(s);
<* END *>
                  Assign(lastto, dat.msgto);
                  Assign(lasttext, dat.msgtext);
                END;
              END;
            END;
          END;  
        END;
        pf:=pf^.next;
      END;

    ELSIF typ="O" THEN
      IF pf<>NIL THEN
      
        WHILE pf^.next<>NIL DO pf:=pf^.next END;    (* show last frame *)
        decode(s, NIL, pf, NIL, 0, decod, dat);
        IF ((dat.type=OBJ) OR (dat.type=ITEM))
        & ((oneop[0]=0C) OR (oneop=dat.objectfrom)) THEN
          IF decod THEN 
            Append(s, LF+LF);
            wrstrlist(s, dat.srccall, pf^.vardat^.pos, pf^.time);
          ELSE
             Append(s, LF);
            wrstrlist(s, dat.objectfrom, pf^.vardat^.pos, pf^.time);
          END;
<* IF WITHSTDOUT THEN *>
          WrStr(s);
<* END *>
        END;
      END;

    END;

    op:=op^.next;
  END;
END listtyps;





PROCEDURE degtostr(d:REAL; lat:BOOLEAN; form:CHAR; VAR s:ARRAY OF CHAR);
CONST Z=ORD("0");
VAR n,i:CARDINAL;
BEGIN
  IF HIGH(s)<11 THEN s[0]:=0C; RETURN END;

  IF form="2" THEN i:=7 ELSIF form="3" THEN i:=8 ELSE i:=9 END;
  IF d<0.0 THEN
    d:=-d;
    IF lat THEN s[i]:="S" ELSE s[i+1]:="W" END;
  ELSIF lat THEN s[i]:="N" ELSE s[i+1]:="E" END;

  IF form="2" THEN                                          (* DDMM.MMNDDMM.MME *)
    n:=trunc(d*(6000*180/PI)+0.5);
    s[0]:=CHR(n DIV 600000 MOD 10+Z);
    i:=ORD(NOT lat);
    s[i]:=CHR(n DIV 60000 MOD 10+Z); INC(i);
    s[i]:=CHR(n DIV 6000 MOD 10+Z); INC(i);
    s[i]:=CHR(n DIV 1000 MOD 6+Z); INC(i);
    s[i]:=CHR(n DIV 100 MOD 10+Z); INC(i);
    s[i]:="."; INC(i);
    s[i]:=CHR(n DIV 10 MOD 10+Z); INC(i);
    s[i]:=CHR(n MOD 10+Z); INC(i);

  ELSIF form="3" THEN                                        (* DDMM.MMMNDDMM.MMME *)
    n:=trunc(d*(60000*180/PI)+0.5);
    s[0]:=CHR(n DIV 6000000 MOD 10+Z);
    i:=ORD(NOT lat);
    s[i]:=CHR(n DIV 600000 MOD 10+Z); INC(i);
    s[i]:=CHR(n DIV 60000 MOD 10+Z); INC(i);
    s[i]:=CHR(n DIV 10000 MOD 6+Z); INC(i);
    s[i]:=CHR(n DIV 1000 MOD 10+Z); INC(i);
    s[i]:="."; INC(i);
    s[i]:=CHR(n DIV 100 MOD 10+Z); INC(i);
    s[i]:=CHR(n DIV 10 MOD 10+Z); INC(i);
    s[i]:=CHR(n MOD 10+Z); INC(i);

  ELSE                                                       (* DDMMSS *)
    n:=trunc(d*(60*60*180/PI)+0.5);
    s[0]:=CHR(n DIV (60*6000) MOD 10+Z);
    i:=ORD(NOT lat);
    s[i]:=CHR(n DIV (60*600) MOD 10+Z); INC(i);
    s[i]:=CHR(n DIV (60*60) MOD 10+Z); INC(i);
    s[i]:=DEGSYM; INC(i);
    s[i]:=CHR(n DIV 600 MOD 6+Z); INC(i);
    s[i]:=CHR(n DIV 60 MOD 10+Z); INC(i);
    s[i]:="'"; INC(i);
    s[i]:=CHR(n DIV 10 MOD 6+Z); INC(i);
    s[i]:=CHR(n MOD 10+Z); INC(i);
    s[i]:='"'; INC(i);
  END;

  INC(i);
  s[i]:=0C;
END degtostr;

PROCEDURE postostr(pos:POSITION; form:CHAR; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..31] OF CHAR;
BEGIN
  degtostr(pos.lat, TRUE, form, s);
  Append(s,"/");
  degtostr(pos.long, FALSE, form, h);
  Append(s, h);
END postostr;


PROCEDURE measure(pos0, pos1:POSITION; VAR s:ARRAY OF CHAR; sum:BOOLEAN);
VAR h:ARRAY[0..31] OF CHAR;
BEGIN
  IF posvalid(pos0) & posvalid(pos1) THEN
    postostr(pos1, "3", s);
    Append(s," [");
    postoloc(h, pos1);
    Append(s, h);
    Append(s,"] ");
    FixToStr(distance(pos0, pos1), 4, h);
    Append(s, h); 
    Append(s, "km,");
    IntToStr(azimuth(pos0, pos1), 1, h);
    Append(s, h);
    Append(s, "deg to Marker");
    IF sum THEN
      IF click.waysum=0.0 THEN click.sumpos:=pos0 END;
      click.waysum:=click.waysum+distance(click.sumpos, pos1);
      click.sumpos:=pos1;  
      Append(s, " sum:"); 
      FixToStr(click.waysum, 4, h);
      Append(s, h);
      Append(s, "km");
    END;
  ELSE s[0]:=0C END;
END measure;

PROCEDURE degtopos(s:ARRAY OF CHAR; VAR pos:POSITION);       (* DDMM.MMNDDDMM.MME *) 
VAR err:BOOLEAN;
    d:CARDINAL;

  PROCEDURE c(ch:CHAR):CARDINAL;
  VAR n:CARDINAL;
  BEGIN
    IF ch>="0" THEN n:=ORD(ch)-ORD("0") ELSE n:=0; err:=TRUE END;  
    IF n>9 THEN err:=TRUE END;
    RETURN n;
  END c;

BEGIN
  err:=FALSE;
  d:=c(s[0])*60000 + c(s[1])*6000 + c(s[2])*1000 + c(s[3])*100 + c(s[5])*10 + c(s[6]);
  pos.lat:=FLOAT(d)*(PI/180.0/6000.0);
  IF pos.lat>=PI/2.0 THEN err:=TRUE END;
  IF CAP(s[7])="S" THEN pos.lat:=-pos.lat ELSIF CAP(s[7])<>"N" THEN err:=TRUE END;
  d:=c(s[9])*600000 + c(s[10])*60000 + c(s[11])*6000 + c(s[12])*1000 + c(s[13])*100
     + c(s[15])*10 + c(s[16]);
  pos.long:=FLOAT(d)*(PI/180.0/6000.0);
  IF pos.long>=PI THEN err:=TRUE END;
  IF CAP(s[17])="W" THEN pos.long:=-pos.long ELSIF CAP(s[17])<>"E" THEN err:=TRUE END;
  IF err THEN posinval(pos) END;
END degtopos;

PROCEDURE deghtopos(s:ARRAY OF CHAR; VAR pos:POSITION);     (* DDMM.MMMNDDMM.MMME *)
VAR err, e:BOOLEAN;
    d, i:CARDINAL;

  PROCEDURE c(mul:CARDINAL):BOOLEAN;
  VAR n:CARDINAL;
      ch:CHAR;
  BEGIN
    ch:=s[i];
    IF mul>0 THEN
      IF ch>="0" THEN n:=ORD(ch)-ORD("0") ELSE RETURN FALSE END;

      IF n>9 THEN RETURN FALSE END;

      INC(d, n*mul);
    ELSIF ch<>"." THEN RETURN FALSE END;

    INC(i); 
    RETURN TRUE;
  END c;

BEGIN
  err:=FALSE;
  d:=0;
  i:=0;
  e:=c(600000) & c(60000) & c(10000) & c(1000) & c(0) & c(100) & c(10) & c(1);
  pos.lat:=FLOAT(d)*(PI/180.0/60000.0);
  IF pos.lat>=PI/2.0 THEN err:=TRUE END;
  IF s[i]="S" THEN pos.lat:=-pos.lat ELSIF s[i]<>"N" THEN err:=TRUE END;
  INC(i, 2);
  d:=0;
  e:=c(6000000) & c(600000) & c(60000) & c(10000) & c(1000) & c(0) & c(100) & c(10) & c(1);
  pos.long:=FLOAT(d)*(PI/180.0/60000.0);
  IF pos.long>=PI THEN err:=TRUE END;
  IF s[i]="W" THEN pos.long:=-pos.long ELSIF s[i]<>"E" THEN err:=TRUE END;
  IF err THEN posinval(pos) END;
END deghtopos;



PROCEDURE num(n:INTEGER):CHAR;
BEGIN RETURN CHR(ABS(n) MOD 10 + ORD("0")) END num;

PROCEDURE dao91(x:CARDINAL):CARDINAL;                  (* 33 + radix91(xx/1.1) of dddmm.mmxx *)
BEGIN RETURN 33 + (x*20+11) DIV 22 END dao91;


PROCEDURE micedest(lat, long:INTEGER; VAR s:ARRAY OF CHAR);
VAR nb, nl:CARDINAL;
BEGIN
  nl:=ABS(long) DIV 6000;
  nb:=ABS(lat)  DIV 6000;
  s[0]:=CHR(80 + nb DIV 10);
  s[1]:=CHR(80 + nb MOD 10);
  nb:=VAL(CARDINAL, ABS(lat))-nb*6000;
  s[2]:=CHR(80 + nb DIV 1000);
  s[3]:=CHR(48 + 32*ORD(lat>=0) + nb DIV 100 MOD 10);
  s[4]:=CHR(48 + 32*ORD((nl<10) OR (nl>=100)) + nb DIV 10 MOD 10);
  s[5]:=CHR(48 + 32*ORD(long<0) + nb MOD 10);
  s[6]:=0C;
END micedest;

PROCEDURE micedata(lat, long:INTEGER; knots, dir:CARDINAL; alt:INTEGER;
                   sym:ARRAY OF CHAR; VAR s:ARRAY OF CHAR);
VAR nl, n:CARDINAL;
BEGIN
  IF dir>=360 THEN dir:=0 END;
  IF knots>799 THEN knots:=0 END;
  nl:=ABS(long) DIV 6000;
  IF nl<10 THEN s[0]:=CHR(nl+118);
  ELSIF nl>=100 THEN
    IF nl<110 THEN s[0]:=CHR(nl+8) ELSE s[0]:=CHR(nl-72) END;
  ELSE s[0]:=CHR(nl+28) END;
  nl:=VAL(CARDINAL, ABS(long))-nl*6000;                                (* long min*100 *)
  n:=nl DIV 100;
  IF n<10 THEN INC(n, 60) END;
  s[1]:=CHR(n+28);
  s[2]:=CHR(nl MOD 100+28);
  s[3]:=CHR(knots DIV 10 + 28);
  s[4]:=CHR(32 + knots MOD 10*10 + dir DIV 100);
  s[5]:=CHR(28 + dir MOD 100);
  s[6]:=sym[1];
  s[7]:=sym[0];
  IF alt>-10000 THEN
    n:=alt+10000;
    s[8]:=CHR(33 + n DIV (91*91) MOD 91);
    s[9]:=CHR(33 + n DIV 91 MOD 91);
    s[10]:=CHR(33 + n MOD 91);
    s[11]:="}";
    s[12]:=0C;
  ELSE s[8]:=0C END;
END micedata;

PROCEDURE alt2str(feet:INTEGER; VAR s:ARRAY OF CHAR);
BEGIN
  IF feet>-100000 THEN
    s[0]:="/";
    s[1]:="A";
    s[2]:="=";
    IF feet<0 THEN
      feet:=-feet;
      s[3]:="-";
    ELSE s[3]:=num(feet DIV 100000) END; (* /A=-nnnnn *)
    s[4]:=num(feet DIV 10000);
    s[5]:=num(feet DIV 1000);
    s[6]:=num(feet DIV 100);
    s[7]:=num(feet DIV 10);
    s[8]:=num(feet);
    s[9]:=0C;
  ELSE s[0]:=0C END;
END alt2str;

PROCEDURE speeddir2str(knots, dir:INTEGER; VAR s:ARRAY OF CHAR);
BEGIN
  IF (dir>=0) & (dir<360) THEN
    IF dir=0 THEN dir:=360 END;
    s[0]:=num(dir DIV 100);
    s[1]:=num(dir DIV 10);
    s[2]:=num(dir);
  ELSE s[0]:="."; s[1]:="."; s[2]:="." END;
  s[3]:="/";
  s[4]:=num(knots DIV 100);
  s[5]:=num(knots DIV 10);
  s[6]:=num(knots);
  s[7]:=0C;
END speeddir2str;


PROCEDURE compressdata(pos:POSITION; knots, dir:CARDINAL; feet:INTEGER;
                       sym:ARRAY OF CHAR; VAR s:ARRAY OF CHAR);
VAR n:INTEGER;
    h:ARRAY[0..200] OF CHAR;
BEGIN
  pos.lat :=pos.lat *(180/PI);
  pos.long:=pos.long*(180/PI);

  s[0]:=sym[0];

  IF pos.lat<90.0 THEN n:=trunc((90.0-pos.lat)*380926.0) ELSE n:=0 END;
  s[1]:=CHR(33+n DIV (91*91*91));
  s[2]:=CHR(33+n DIV (91*91) MOD 91);
  s[3]:=CHR(33+n DIV 91 MOD 91);
  s[4]:=CHR(33+n MOD 91);

  IF pos.long>-180.0 THEN n:=trunc((180.0+pos.long)*190463.0) ELSE n:=0 END;
  s[5]:=CHR(33+n DIV (91*91*91));
  s[6]:=CHR(33+n DIV (91*91) MOD 91);
  s[7]:=CHR(33+n DIV 91 MOD 91);
  s[8]:=CHR(33+n MOD 91);

  s[9]:=sym[1];

  IF knots>0 THEN
    IF dir>=360 THEN dir:=0 END;
    s[10]:=CHR(33+dir DIV 4);
    s[11]:=CHR(33+trunc(ln(FLOAT(knots+1))*12.9935872129));
    s[12]:=CHR(33+32+24+6);

  ELSIF feet>0 THEN
    n:=trunc(ln(FLOAT(feet))*500.5 + 0.5);
    IF n>=91*91 THEN n:=91*91-1 END;
    s[10]:=CHR(33+n DIV 91);
    s[11]:=CHR(33+n MOD 91);
    s[12]:=CHR(33+32+16+6);

  ELSE
    s[10]:=" ";
    s[11]:=" ";
    s[12]:=CHR(33+32+24+6);
  END;

  s[13]:=0C;
  IF (knots>0) & (feet>0) THEN
    alt2str(feet, h);
    Append(s, h);
  END;

END compressdata;

PROCEDURE deg2str(lat, long:INTEGER; VAR s:ARRAY OF CHAR); (* DDMM.MMNDDDMM.MME *)
CONST Z=ORD("0");
BEGIN
  IF lat<0 THEN
    lat:=-lat;
    s[7]:="S";
  ELSE s[7]:="N" END;
  IF long<0 THEN
    long:=-long;
    s[17]:="W";
  ELSE s[17]:="E" END;

  s[0]:=CHR(lat DIV 60000+Z);
  s[1]:=CHR(lat DIV 6000 MOD 10+Z);
  s[2]:=CHR(lat DIV 1000 MOD 6+Z);
  s[3]:=CHR(lat DIV 100 MOD 10+Z);
  s[4]:=".";
  s[5]:=CHR(lat DIV 10 MOD 10+Z);
  s[6]:=CHR(lat MOD 10+Z);

  s[9]:=CHR(long DIV 600000+Z);
  s[10]:=CHR(long DIV 60000 MOD 10+Z);
  s[11]:=CHR(long DIV 6000 MOD 10+Z);
  s[12]:=CHR(long DIV 1000 MOD 6+Z);
  s[13]:=CHR(long DIV 100 MOD 10+Z);
  s[14]:=".";
  s[15]:=CHR(long DIV 10 MOD 10+Z);
  s[16]:=CHR(long MOD 10+Z);
  s[18]:=0C;
END deg2str;

PROCEDURE encbeacon(VAR s:ARRAY OF CHAR; VAR len:CARDINAL);      (* assemble beacon string *)
CONST RAD=180/PI*600000;
VAR h:ARRAY[0..200] OF CHAR;
    symb:ARRAY[0..1] OF CHAR;
    typ, postyp:CHAR;
    bkn, dao, err:BOOLEAN;
    pos:POSITION;
    i:INTEGER;
    dir, knots, feet, alt, lat, long, latd, longd:INTEGER;
    datastart:CARDINAL;
BEGIN
  err:=FALSE;
  len:=16;                                                       (* ax.25 address + UI + PID *) 
  confstr(fRBTYP, s);
  typ:=CAP(s[0]);
  bkn:=(typ<>"O") & (typ<>"H") & (typ<>"P") & (typ<>"I") & (typ<>"J");
  confstr(fRBPOSTYP, postyp);
  confstr(fRBSYMB, symb);
  IF Length(symb)<>2 THEN encerr("no symbol"); err:=TRUE END;
  dao:=(postyp=ENCODEGPSDAO) OR (postyp=ENCODEMICEDAO);
  knots:=trunc(FLOAT(conf2int(fRBSPEED, 0, 0, MAX(INT16), 0))*(1.0/KNOTS)+0.5);
  dir  :=conf2int(fRBDIR, 0, 0, 360, 360);
  IF dir>360 THEN encerr("direction <=360") 
  ELSIF (knots=0) & (dir<>360) THEN encerr("direction needs speed>0") END;
  alt  :=conf2int(fRBALT, 0, -10000, 1000000, MIN(INT16));
  feet:=trunc(ABS(FLOAT(alt)/FEET+0.5));
  IF alt<0 THEN feet:=-feet END;

  confstr(fRBPORT, s); Append(s, ":");                           (* port *)
  IntToStr(conf2int(fRBTIME, 0, 0, MAX(INT16), 3600), 1, h);
  Append(s, h);                                                  (* repeat time *)
  Append(s, ":");
  IF bkn THEN
    confstr(fRBNAME, h);
    IF h[0]<=" " THEN encerr("no beacon call?") END;
    Append(s, h);
    confstr(fMYPOS, h);
    deghtopos(h, pos);
    IF NOT posvalid(pos) THEN confstr(fRBPOS, h) END; (* if not have net mypos *)
  ELSE 
    confstr(fMYCALL, h);
    IF h[0]<=" " THEN encerr("object/item needs a Config/Online/My Call") END;
    Append(s, h);
    confstr(fRBPOS, h);
  END;
  deghtopos(h, pos);
  IF NOT posvalid(pos) THEN encerr("position wrong"); err:=TRUE END;
  lat :=trunc(ABS(pos.lat) *RAD);
  long:=trunc(ABS(pos.long)*RAD);
  latd :=VAL(CARDINAL, lat ) MOD 100;
  longd:=VAL(CARDINAL, long) MOD 100;
  IF dao THEN  
    lat :=(lat -latd ) DIV 100;
    long:=(long-longd) DIV 100;
  ELSE  
--    lat :=(lat +50) DIV 100;
--    long:=(long+50) DIV 100;
    lat :=lat  DIV 100;
    long:=long DIV 100;
  END;
  IF pos.lat <0 THEN lat :=-lat  END;
  IF pos.long<0 THEN long:=-long END;

  Append(s, ">");
  IF CAP(postyp)=CAP(ENCODEMICE) THEN micedest(lat, long, h);
  ELSE
    confstr(fRBDEST, h);
    IF h[0]=0C THEN h:=DESTCALL END;
    i:=InStr(h, "-");
    IF i>0 THEN Delstr(h, i, SIZE(h)) END;                    (* delete ssid *)
  END;
  Append(s, h);
  confstr(fRBPATH, h);
  IF h[0]>" " THEN
    IF h[0]<>"-" THEN Append(s, ",") END;
    Append(s, h);                                             (* dest ssid + via path *)

    i:=0;
    WHILE s[i]<>0C DO
      IF s[i]="," THEN INC(len, 7) END;
      INC(i);
    END; 

  END;  
  Append(s, ":");                                             (* end of address *)  
  datastart:=Length(s);                                       (* rest of line for byte count *)

  IF NOT bkn THEN
    confstr(fRBNAME, h);
    IF h[0]<=" " THEN encerr("no object/item name?") END;
    Append(h, "         "); h[9]:=0C;    (* fix size *) 
    IF (typ="O") OR (typ="H") OR (typ="P") THEN
      Append(s, ";");                                         (* object *)   
      Append(s, h);
      IF typ="P" THEN Append(s, "_") ELSE Append(s, "*") END; (* delete or object *)
      IF typ="O" THEN Append(s, "\\Zz") ELSE Append(s, "\\Hh") END; (* time macro **)
    ELSE
      Append(s, ")");                                         (* item *)
      i:=3;
      WHILE h[i]>" " DO INC(i) END;
      h[i]:=0C;                                               (* item size 3..9 *)
      Append(s, h);
      IF typ="J" THEN Append(s, "_") ELSE Append(s, "!") END; (* delete or item*)
    END;
  ELSE
    IF CAP(postyp)=CAP(ENCODEMICE) THEN h:="`" ELSE h:="=" END;
    Append(s, h);                                             (* beacon protocol *)
  END;
  CASE CAP(postyp) OF
    CAP(ENCODEMICE): micedata(lat, long, knots, dir, alt, symb, h); Append(s, h);
   |CAP(ENCODECOMP):
      IF (feet<0) & (feet>-10000)
      THEN encerr("no negative altitude in compressed mode"); err:=TRUE END;
      compressdata(pos, knots, dir, feet, symb, h); Append(s, h);
  ELSE
    deg2str(lat, long, h);
    h[8]:=symb[0]; h[18]:=symb[1]; h[19]:=0C;                 (* symbol *)
    Append(s, h);
    IF knots>0 THEN                                           (* dir, speed *)
      speeddir2str(knots, dir, h);
      Append(s, h);
    END;
    IF alt>-10000 THEN
      alt2str(feet, h);
      Append(s, h);
    END;
  END;

  IF (CAP(postyp)<>CAP(ENCODECOMP)) & dao THEN                (* DAO *)
    h[0]:="!";
    h[1]:="w";
    h[2]:=CHR(dao91(latd));
    h[3]:=CHR(dao91(longd));
    h[4]:="!";
    h[5]:=0C;
    Append(s, h);
  END;
  confappend(fRBCOMMENT, s);
  INC(len, Length(s)-datastart);
  IF err THEN s[0]:=0C END; 
END encbeacon;


END aprstext.
