<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>

<*-PROCINLINE*>
<*+NOPTRALIAS*>
<*+GENHISTORY*>
<*CPU="PENTIUM"*>

<*+CHECKNIL *>
<*-DOREORDER*>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKSET*>
<*+COMMENT*>
<* IF __GEN_C__ THEN *>
<*+GENCTYPES*>
<* END *>

MODULE gps2aprs; (* read serial gps and make axudp aprs frames *)

FROM SYSTEM IMPORT ADR, CARD8, CARD16, SHIFT, CAST, FILL;



<* IF TARGET_FAMILY="WIN32" THEN *>
FROM Windows IMPORT CreateFile, GENERIC_READ, GENERIC_WRITE, Sleep,
                    FILE_SHARE_READ, OPEN_EXISTING, HANDLE, WriteFile, ReadFile,
                    DWORD, CloseHandle, FILE_ATTRIBUTE_NORMAL, COMMTIMEOUTS,
                    SetCommTimeouts, DCB, GetCommState, SetCommState, PARITY_TYPE, DCB_FLAG, DCB_FLAGS;
(*
FROM RealInOut IMPORT WriteReal;
*)
FROM osi IMPORT STDIO, NextArg;
<* ELSE *>
IMPORT udp;
FROM osi IMPORT OpenRW;
FROM mlib IMPORT usleep, termios, tcgetattr, tcsetattr,
                 CS8, CLOCAL, CREAD, TCSAFLUSH,
                 B1200, B2400, B4800, B9600, B19200, B38400,
                 B57600, B115200, B230400, B460800;
FROM Select IMPORT fdclr, fdsetr, issetr, selectr;
FROM Lib IMPORT NextArg;


<* END *>


(*
FROM osi IMPORT WrLn, WrStr, WrStrLn, WrFixed, OpenRW, OpenRead, RdBin, Close;
FROM Select IMPORT fdclr, fdsetr, issetr, selectr;
FROM mlib IMPORT usleep, termios, tcgetattr, tcsetattr,
                 CS8, CLOCAL, CREAD, TCSAFLUSH,
                 B1200, B2400, B4800, B9600, B19200, B38400,
                 B57600, B115200, B230400, B460800;
FROM Lib IMPORT NextArg;
FROM RealMath IMPORT ln;
FROM aprsstr IMPORT IPNUM, Append, mon2raw, Length, DateToStr, Assign;
FROM TimeConv IMPORT time;
*)

FROM TimeConv IMPORT time;
FROM osi IMPORT File, FdValid, WrLn, WrStr, WrStrLn, OpenRead, RdBin, Close,
                openudp, udpsend, WrFixed;
FROM RealMath IMPORT ln;
FROM aprsstr IMPORT IPNUM, Append, mon2raw, Length, DateToStr, Assign;


TYPE SET16=SET OF [0..15];
     SET8 =SET OF [0..7];


<* IF TARGET_FAMILY="WIN32" THEN *>
CONST DEFTTY="com1";
<* ELSE *>
CONST DEFTTY="/dev/ttyS0";
<* END *>


CONST CR=15C;
      LF=12C;
      KNOTS=1.851984;
      FEET=1.0/0.3048;
      DEFAULTPORT=9002;
      DEFAULTIP=7F000001H; (* 127.0.0.1 *)

VAR (*CRCL, CRCH: ARRAY[0..255] OF SET8;*)

    tbuf, ttynamee:ARRAY[0..1023] OF CHAR;
    mycall, via, comment:ARRAY[0..99] OF CHAR;
    symt, symb:CHAR;
    toport, baud:CARDINAL;
    ipnum:IPNUM; 
    udpsock:INTEGER;
    verb, anyip, usbrobust, junk, sumoff, withalti, withspeed, withdao, useaxudp:BOOLEAN;
    comptyp, micessid, btime0, btimedrive, drivekm, comintval, comcnt, btime, msgtyp:CARDINAL;
    lat, long, speed, course, alt:LONGREAL;
    posok, altok:BOOLEAN;
<* IF TARGET_FAMILY="WIN32" THEN *>
    tty:HANDLE;
    dlen:DWORD;
    void:BOOLEAN;
<* ELSE *>
    tty:INTEGER;
    saved: termios;
<* END *>


PROCEDURE Error(text:ARRAY OF CHAR);
BEGIN
  WrStr("aprstracker: "); WrStr(text); WrStrLn(" error abort");
  HALT
END Error;

PROCEDURE truncc(r:LONGREAL):CARDINAL;
BEGIN
  IF r<=0.0 THEN RETURN 0 ELSIF r>=MAX(INTEGER) THEN RETURN MAX(INTEGER) ELSE RETURN TRUNC(r) END;
END truncc;


PROCEDURE GetIp(h:ARRAY OF CHAR; VAR p:CARDINAL; VAR ip:CARDINAL; VAR port:CARDINAL):INTEGER;
VAR i, n:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  FOR i:=0 TO 4 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;

      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":") OR (n>255) THEN RETURN -1 END;

    ELSIF n>65535 THEN RETURN -1 END;

    port:=n;
    INC(p);
  END;
  RETURN 0
END GetIp;


<* IF TARGET_FAMILY="WIN32" THEN *>

--PROCEDURE WrFixed(x:REAL; place:INTEGER; witdh:CARDINAL);
--BEGIN WriteReal(x, place) END WrFixed;

PROCEDURE opentty;
VAR CommTimeouts: COMMTIMEOUTS;
    dcb:DCB;
BEGIN
--  tty:=CreateFile(ttyname,);
--  tty:=Create(ttyname);
  tty:=CreateFile(ttynamee, GENERIC_READ+GENERIC_WRITE, FILE_SHARE_READ, NIL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NIL);
  IF (verb OR NOT usbrobust) & (tty=NIL) THEN Error("com open error") END;

  IF tty<>NIL THEN
    IF GetCommState(tty, dcb) THEN
--    WrInt(dcb.BaudRate, 10); WrStrLn(" baud");
--    WrInt(dcb.ByteSize, 10); WrStrLn(" bits");
--    WrInt(CAST(CARDINAL, dcb.Flags), 10); WrStrLn(" flags");
      dcb.Parity:=NOPARITY;
      dcb.ByteSize:=8;
      dcb.BaudRate:=baud;
      dcb.Flags:=DCB_FLAGS{DCB_fBinary, DCB_fDtrControl_1, DCB_fRtsControl_1};
      void:=SetCommState(tty, dcb);
--    IF GetCommTimeouts (tty, CommTimeouts) THEN
      FILL(ADR(CommTimeouts), 0C, SIZE(CommTimeouts));
      CommTimeouts.ReadIntervalTimeout:=MAX(DWORD);
      void:=SetCommTimeouts(tty, CommTimeouts);
    ELSIF NOT usbrobust THEN Error("com config") ELSIF verb THEN WrStrLn("com config error") END;
  END;
END opentty;
<* ELSE *>


PROCEDURE SetComMode(fd:INTEGER; baud:CARDINAL);
VAR term : termios;
    res  : INTEGER;
    bd   : INTEGER;
BEGIN
  IF baud=1200 THEN bd:=B1200;
  ELSIF baud=2400 THEN bd:=B2400;
  ELSIF baud=4800 THEN bd:=B4800;
  ELSIF baud=9600 THEN bd:=B9600;
  ELSIF baud=19200 THEN bd:=B19200;
  ELSIF baud=38400 THEN bd:=B38400;
  ELSIF baud=57600 THEN bd:=B57600;
  ELSIF baud=115200 THEN bd:=B115200;
  ELSIF baud=230400 THEN bd:=B230400;
  ELSIF baud=460800 THEN bd:=B460800;
  ELSE Error("unknown baudrate") END;

  res:=tcgetattr(fd, saved);
  res:=tcgetattr (fd, term);
  WITH term DO
    c_lflag :=0;
    c_oflag :=0;
    c_iflag :=0;
(*  cfmakeraw(&termios);*)
    c_cflag :=CS8+CLOCAL+CREAD(*+CRTSCTS*)+bd;  (*0800018B2H*)
  END;
  res:=tcsetattr (fd, TCSAFLUSH, term);
END SetComMode;



PROCEDURE opentty;
BEGIN
  LOOP
    tty:=OpenRW(ttynamee);
    IF tty>=0 THEN
      SetComMode(tty, baud);
      EXIT
    ELSIF NOT usbrobust THEN Error("tty open") END;
    usleep(1000000);
  END;
END opentty;
<* END *>

PROCEDURE testtty(len:INTEGER; VAR err:BOOLEAN);
<* IF TARGET_FAMILY="WIN32" THEN *>
VAR dcb:DCB;
BEGIN
  IF NOT GetCommState(tty, dcb) THEN
    CloseHandle(tty);
    Sleep(1000);
    opentty;
    IF verb THEN WrStrLn("tty reopen") END;
    err:=TRUE;
  END;

<* ELSE *>
BEGIN
  IF len<=0 THEN
    Close(tty);
    usleep(1000000);
    opentty;
    err:=TRUE;
  END;
<* END *>
END testtty;



PROCEDURE GetNum(h-:ARRAY OF CHAR; eot:CHAR; VAR p,n:CARDINAL):BOOLEAN;
BEGIN
  n:=0;
  WHILE (h[p]>="0") & (h[p]<="9") DO
    n:=n*10+ORD(h[p])-ORD("0");
    INC(p);
  END;
  RETURN h[p]=eot
END GetNum;


PROCEDURE Parms;
VAR err:BOOLEAN;
    h:ARRAY[0..1023] OF CHAR;
    VAR i:CARDINAL;
BEGIN
  err:=FALSE;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN

      IF (h[1]="m") OR (h[1]="r") THEN 
        useaxudp:=(h[1]="r"); 
        NextArg(h);
        i:=0;
        IF GetIp(h, i, ipnum, toport)<0 THEN Error("-m or -r ip:port number") END;
--WrInt(ipnum, 15); WrStrLn("");
--        udpsock:=openudp();
--        IF udpsock<0 THEN Error("cannot open udp socket") END;

      ELSIF h[1]="a" THEN withalti:=FALSE

      ELSIF h[1]="u" THEN usbrobust:=FALSE

      ELSIF h[1]="k" THEN withspeed:=FALSE

      ELSIF h[1]="s" THEN sumoff:=TRUE

      ELSIF h[1]="D" THEN withdao:=TRUE;

      ELSIF h[1]="I" THEN NextArg(mycall);
        IF mycall[0]<"0" THEN Error("-I <mycall>") END;

      ELSIF h[1]="w" THEN NextArg(via);
        IF via[0]<=" " THEN Error("-m vias like RELAY,WIDE1-1") END;

      ELSIF h[1]="c" THEN
        NextArg(comment);
        IF Length(comment)>40 THEN Error("-c <comment>  (max 40 byte)") END;

      ELSIF h[1]="i" THEN 
        NextArg(h);
        IF (h[0]>" ") & (h[1]>" ") THEN
          symt:=h[0];
          symb:=h[1];
        ELSE Error("-i <icon> (house /-)") END;

      ELSIF h[1]="t" THEN
        NextArg(h);
        i:=0;
        WHILE (h[i]<>0C) & (h[i]<>":") & (i<HIGH(ttynamee)) DO ttynamee[i]:=h[i]; INC(i) END;
        ttynamee[i]:=0C;
        IF h[i]<>0C THEN 
          INC(i);
          IF NOT GetNum(h, 0C, i, baud) THEN Error("need ttydevice:baud") END;
        END; 

     ELSIF h[1]="b" THEN
        NextArg(h);
        i:=0;
        IF NOT GetNum(h, 0C, i, btimedrive)
        THEN Error("-b <s>") END;
 
     ELSIF h[1]="0" THEN
        NextArg(h);
        i:=0;
        IF NOT GetNum(h, 0C, i, btime0)
        THEN Error("-0 <s>") END;

     ELSIF h[1]="g" THEN
        NextArg(h);
        i:=0;
        IF NOT GetNum(h, 0C, i, drivekm)
        THEN Error("-g <km/h>") END;

     ELSIF h[1]="l" THEN
        NextArg(h);
        i:=0;
        IF NOT GetNum(h, 0C, i, comintval)
        THEN Error("-l <n>") END;

     ELSIF h[1]="f" THEN
        NextArg(h);
        i:=0;
        IF NOT GetNum(h, 0C, i, comptyp) OR (comptyp>2)
        THEN Error("-f <format> 0=uncomp, 1=comp, 2=mic-e") END;

      ELSIF h[1]="d" THEN
        NextArg(h);
        i:=0;
        IF NOT GetNum(h, 0C, i, micessid) OR (micessid>7)
        THEN Error("-d <ssid> 0..7") END;

      ELSIF h[1]="v" THEN verb:=TRUE;

      ELSIF h[1]="h" THEN
        WrLn;
        WrStrLn("Read serial GPS and make normal/compressed/mic-e Beacon as AXUDP or monitor");
        WrStrLn(" -0 <s>                            standing Beacon Time in Seconds (180)");
        WrStrLn(" -a                                altitude OFF");
        WrStrLn(" -b <s>                            driving Beacon Time in Seconds (15)");
        WrStrLn(" -c <commentstring>                APRS Comment (max 40 char)");
        WrStrLn("                                     insert time hhmmss: \\h");
        WrStrLn("                                     insert time ddhhmm: \\z");
        WrStrLn("                                     insert file       : \\:filename:");
        WrStrLn("                                     insert \\         : \\\");
        WrStrLn(" -d <x>                            Destination Call SSID 0..7");
        WrStrLn(" -D                                DAO Extension on for 20cm Resolution");
        WrStrLn(" -f <x>                            format 0=normal 1=compressed 2=mic-e (0)");
        WrStrLn(" -g <km/h>                         min. Speed for driving Beacon Time (4)");
        WrStrLn(" -h                                this");
        WrStrLn(" -I <mycall>                       Mycall with SSID like NOCALL-15");
        WrStrLn(' -i <icon>                         2 Icon chars "/-" (House), "/>" (Car)...(//)');
        WrStrLn(" -k                                Speed/Course OFF (not in mic-e)");
        WrStrLn(" -l <n>                            every n Beacons send one with Comment");
        WrStrLn(" -m <x.x.x.x:destport>             use Monitor UDP format");
        WrStrLn(" -r <x.x.x.x:destport>             use AXUDP (to Soundmodem)");
        WrStrLn(" -s                                GPS Checksum check OFF");

<* IF TARGET_FAMILY="WIN32" THEN *>
        WrStrLn(" -t <tty>:<baud>                   (com1:4800)");
<* ELSE *>
        WrStrLn(" -t <tty>:<baud>                   (/dev/ttyS0:4800)");
<* END *>
        WrStrLn(" -u                                not retry until open removable USB tty");
        WrStrLn(" -v                                verbous");
        WrStrLn(" -w <viapath>                      via Path like RELAY,WIDE1-1");
        WrLn;
        HALT

      ELSE err:=TRUE END;
(*
      h[0]:=0C;
*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF (comptyp=1) & withdao THEN Error("DAO Option not with compressed Format") END;
  IF err THEN WrStr(">"); WrStr(h); WrStrLn("< use -h"); HALT END;
END Parms;


(*
PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;


PROCEDURE UDPCRC(frame-:ARRAY OF CHAR; size:INTEGER):CARDINAL;
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-1 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  RETURN ORD(CAST(CHAR, l))+256*ORD(CAST(CHAR, h))
END UDPCRC;
*)

PROCEDURE sendudp(buf:ARRAY OF CHAR; len:INTEGER); 
VAR i:INTEGER;
--  crc:CARDINAL; 
BEGIN
(*
  IF withcrc THEN
    crc:=UDPCRC(buf, len);
    buf[len]:=CHR(crc MOD 256);
    buf[len+1]:=CHR(crc DIV 256);
    INC(len, 2);
  END;
  AppCRC(buf, len);
*)
  i:=udpsend(udpsock, buf, len, toport, ipnum);   
(*
FOR i:=0 TO upos-2 DO IO.WrHex(ORD(buf[i]), 3) END; IO.WrLn;
*)
END sendudp;



PROCEDURE skip(b-:ARRAY OF CHAR; VAR p:CARDINAL; len:CARDINAL);
BEGIN
  WHILE (p<len) & (b[p]<>",") DO INC(p) END;
  IF p<len THEN INC(p) END;
END skip;

PROCEDURE getnum(b-:ARRAY OF CHAR; VAR p:CARDINAL; len:CARDINAL; VAR n:CARDINAL):BOOLEAN;
BEGIN
--WrStr(b[p]);
  IF (p<len) & (b[p]>="0") & (b[p]<="9") THEN 
    n:=ORD(b[p]) - ORD("0");
    INC(p);
    RETURN TRUE
  END;
  n:=0;
  RETURN FALSE;
END getnum;

PROCEDURE beaconmacros(VAR s:ARRAY OF CHAR);
CONST MSYM="\";
      FILESYM=":";

VAR i:CARDINAL;
    len,j:INTEGER;
    ds,ns:ARRAY[0..255] OF CHAR;
    fn:ARRAY[0..1023] OF CHAR;
    f:File;
BEGIN
  i:=0;
  ns[0]:=0C;
  WHILE (i<HIGH(s)) & (s[i]<>0C) DO
    IF (s[i]=MSYM) & (s[i+1]=MSYM) THEN
      INC(i, 2);
      IF s[i]="z" THEN                          (* insert day, hour, min *)
        DateToStr(time(), ds);
        ds[0]:=ds[8]; ds[1]:=ds[9]; ds[2]:=ds[11]; ds[3]:=ds[12]; ds[4]:=ds[14]; ds[5]:=ds[15];
        ds[6]:=0C;
        Append(ns, ds);

      ELSIF s[i]="h" THEN                       (* insert hour, min, s *)
        DateToStr(time(), ds);
        ds[0]:=ds[11]; ds[1]:=ds[12]; ds[2]:=ds[14]; ds[3]:=ds[15]; ds[4]:=ds[17]; ds[5]:=ds[18];
        ds[6]:=0C;
        Append(ns, ds);

      ELSIF s[i]=FILESYM THEN                   (* insert or write file *)
        fn[0]:=0C;
        INC(i);
        WHILE (i<HIGH(s)) & (s[i]<>0C) & (s[i]<>FILESYM) DO
          Append(fn, s[i]);
          INC(i);
        END;
        f:=OpenRead(fn);
        IF FdValid(f) THEN
          len:=RdBin(f, ds, SIZE(ds)-1);
          Close(f);
          j:=0;
          WHILE (j<len) & (ds[j]<>CR) & (ds[j]<>LF) & (ds[j]<>0C) DO
            Append(ns, ds[j]);
            INC(j);
          END;

        ELSE
          Assign(s, "beacon macro file not readable "); Append(s, fn); 
          IF verb THEN WrStrLn(s) END;
          s[0]:=0C;
          RETURN

        END;

      ELSIF s[i]=MSYM THEN Append(ns, MSYM+MSYM);

      ELSE
        Assign(s, "bad beacon macro "); Append(s, ns); Append(s, "???");
        IF verb THEN WrStrLn(s) END;
        s[0]:=0C;
        RETURN
      END;
    ELSE Append(ns, s[i]) END;
    INC(i);
  END;
  Assign(s, ns);
END beaconmacros;




PROCEDURE decodeline(b-:ARRAY OF CHAR; len:CARDINAL);
VAR i, n :CARDINAL;
    div  :LONGREAL;
    sign :BOOLEAN;    
BEGIN 
  IF (b[0]="$") & (b[1]="G") (*& (b[2]="P")*) THEN
    IF (b[3]="R") & (b[4]="M") & (b[5]="C") THEN
(* $GPRMC,141333.593,A,9815.1000,N,01302.2000,E,0.00,00.00,140410,0,,A*7C *)
(* $GPRMC,112430.00,A,4812.41130,N,01305.61995,E,0.039,,200513,,,A*77 *)
    i:=7;
      skip(b, i, len);
      IF b[i]<>"A" THEN RETURN END;
      skip(b, i, len);
      IF getnum(b, i, len, n) THEN lat:=FLOAT(n*10) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n)/6.0 ELSE RETURN END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n)/60.0 ELSE RETURN END;
      IF b[i]="." THEN INC(i) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n)/600.0 ELSE RETURN END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n)/6000.0 ELSE RETURN END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n)/60000.0 END;
      IF getnum(b, i, len, n) THEN lat:=lat + FLOAT(n)/600000.0 END;
      skip(b, i, len);
      IF b[i]="S" THEN lat:=-lat ELSIF b[i]<>"N" THEN RETURN END;
      skip(b, i, len); 

      IF getnum(b, i, len, n) THEN long:=FLOAT(n*100) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n*10) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n)/6.0 ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n)/60.0 ELSE RETURN END;
      IF b[i]="." THEN INC(i) ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n)/600.0 ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n)/6000.0 ELSE RETURN END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n)/60000.0 END;
      IF getnum(b, i, len, n) THEN long:=long + FLOAT(n)/600000.0 END;
      skip(b, i, len);
      IF b[i]="W" THEN long:=-long ELSIF b[i]<>"E" THEN RETURN END;
      skip(b, i, len);

      speed:=0.0;
      WHILE getnum(b, i, len, n) DO speed:=speed*10.0 + FLOAT(n) END;
      IF b[i]="." THEN
        INC(i);
        div:=0.1;
        WHILE getnum(b, i, len, n) DO speed:=speed + FLOAT(n)*div; div:=div*0.1 END;
      END;
      speed:=speed*KNOTS;                                      (* knots to km/h *) 
      skip(b, i, len);

      course:=0.0;
      WHILE getnum(b, i, len, n) DO course:=course*10.0 + FLOAT(n) END;
      IF b[i]="." THEN
        INC(i);
        div:=0.1;
        WHILE getnum(b, i, len, n) DO course:=course + FLOAT(n)*div; div:=div*0.1 END;
      END;
      posok:=TRUE;

    ELSIF (b[3]="G") & (b[4]="G") & (b[5]="A") THEN
(* $GPGGA,152554,3938.5665,N,10346.2039,W,1,08,1.7,12382.7,M,-22.3,M,,*7B *)
(* $GPGGA,112435.00,4812.41112,N,01305.61998,E,1,08,1.04,398.3,M,44.9,M,,*59 *)
      i:=7; 
      skip(b, i, len);
      skip(b, i, len);
      skip(b, i, len);
      skip(b, i, len);
      skip(b, i, len);
      skip(b, i, len);
      skip(b, i, len);
      skip(b, i, len);

      alt:=0.0;
      IF b[i]="-" THEN sign:=TRUE; INC(i) ELSE sign:=FALSE END; 
      WHILE getnum(b, i, len, n) DO altok:=TRUE; alt:=alt*10.0 + FLOAT(n) END;
      IF b[i]="." THEN
        INC(i);
        div:=0.1;
        WHILE getnum(b, i, len, n) DO alt:=alt + FLOAT(n)*div; div:=div*0.1 END;
      END;
      IF sign THEN alt:=-alt END;
    END; 
  END;
END decodeline;


PROCEDURE checksum(b-:ARRAY OF CHAR; len:CARDINAL):BOOLEAN;

  PROCEDURE Hex(d:CARDINAL):CHAR;
  BEGIN
    d:=d MOD 16;
    IF d>9 THEN INC(d, ORD("A")-10-ORD("0")) END;
    RETURN CHR(d+ORD("0"))
  END Hex;

TYPE SET8=SET OF [0..7];

VAR i:CARDINAL;
    cs:SET8;
    ok:BOOLEAN;
BEGIN
  ok:=TRUE;
  i:=1;
  cs:=SET8{};
  WHILE (i<len) & (b[i]<>"*") DO
    cs:=cs/CAST(SET8, b[i]);
    INC(i);
  END;
  IF i+2>=len THEN ok:=FALSE END;

  IF ok THEN
    IF (b[i+1]<>Hex(CAST(CARDINAL, cs) DIV 16))
    OR (b[i+2]<>Hex(CAST(CARDINAL, cs) MOD 16)) THEN ok:=FALSE END;
  END;
  IF verb & NOT ok  THEN WrStrLn("GPS Checksum Error") END;
  RETURN ok
END checksum;


PROCEDURE showline(b-:ARRAY OF CHAR; len:CARDINAL);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE i<len DO
    WrStr(b[i]);
    INC(i);
  END;
  WrLn;
END showline;

PROCEDURE sendaprs(lat, long, alt, course, speed:LONGREAL;
                   comp:CARDINAL; withspd, withalt, dao, com:BOOLEAN; comm:ARRAY OF CHAR);

  PROCEDURE num(n:CARDINAL):CHAR;
  BEGIN RETURN CHR(n MOD 10 + ORD("0")) END num;

  PROCEDURE dao91(x:LONGREAL):CARDINAL;                  (* radix91(xx/1.1) of dddmm.mmxx *)
  VAR a:LONGREAL;
  BEGIN
    a:=ABS(x);
    RETURN (truncc((a-FLOAT(truncc(a)))*600000.0) MOD 100*20+11) DIV 22
  END dao91;


VAR b:ARRAY[0..200] OF CHAR;
    raw:ARRAY[0..360] OF CHAR;
    rp:INTEGER; 
    i,n, nl, micdest:CARDINAL;
    a:LONGREAL;
BEGIN
(* OE5FHM-9>APERXQ,RELAY,WIDE2-2:!4805.44N/01333.64E>325/016/A=001824 *)
  b:="";
  Append(b, mycall);
  micdest:=Length(b)+1;
  Append(b, ">APLT01");
  IF micessid>0 THEN Append(b, "-"); Append(b, CHR(micessid+ORD("0"))) END;
  IF via[0]<>0C THEN Append(b, ","); Append(b, via) END;
  IF comp=0 THEN                                               (* uncompressed *)
    Append(b, ":!");

    i:=Length(b);
    a:=ABS(lat);
    n:=truncc(a);
    b[i]:=num(n DIV 10); INC(i);
    b[i]:=num(n); INC(i);
    n:=truncc((a-FLOAT(n))*6000.0);
    b[i]:=num(n DIV 1000); INC(i);
    b[i]:=num(n DIV 100); INC(i);
    b[i]:="."; INC(i);
    b[i]:=num(n DIV 10); INC(i);
    b[i]:=num(n); INC(i);
    IF lat>=0.0 THEN b[i]:="N" ELSE b[i]:="S" END; INC(i);
    b[i]:=symt; INC(i);

    a:=ABS(long); 
    n:=truncc(a);
    b[i]:=num(n DIV 100); INC(i);
    b[i]:=num(n DIV 10); INC(i);
    b[i]:=num(n); INC(i);
    n:=truncc((a-FLOAT(n))*6000.0);
    b[i]:=num(n DIV 1000); INC(i);
    b[i]:=num(n DIV 100); INC(i);
    b[i]:="."; INC(i);
    b[i]:=num(n DIV 10); INC(i);
    b[i]:=num(n); INC(i);
    IF lat>=0.0 THEN b[i]:="E" ELSE b[i]:="W" END; INC(i);
    b[i]:=symb; INC(i);

    IF withspd THEN
      n:=truncc(course+1.5);
      b[i]:=num(n DIV 100); INC(i);
      b[i]:=num(n DIV 10); INC(i);
      b[i]:=num(n); INC(i);
      b[i]:="/"; INC(i);

      n:=truncc(speed*(1.0/KNOTS)+0.5);
      b[i]:=num(n DIV 100); INC(i);
      b[i]:=num(n DIV 10); INC(i);
      b[i]:=num(n); INC(i);
    END;

    IF withalt THEN
      b[i]:="/"; INC(i);
      b[i]:="A"; INC(i);
      b[i]:="="; INC(i);
      n:=truncc(ABS(alt*FEET+0.5));
      IF alt>=0.0 THEN b[i]:=num(n DIV 100000) ELSE b[i]:="-" END; INC(i);
      b[i]:=num(n DIV 10000); INC(i);
      b[i]:=num(n DIV 1000); INC(i);
      b[i]:=num(n DIV 100); INC(i);
      b[i]:=num(n DIV 10); INC(i);
      b[i]:=num(n); INC(i);
    END;

  ELSIF comp=1 THEN                                            (* compressed *)
    Append(b, ":!");
    i:=Length(b);
    b[i]:=symt; INC(i);

    IF lat<90.0 THEN n:=truncc((90.0-lat)*380926.0) ELSE n:=0 END;
    b[i]:=CHR(33+n DIV (91*91*91));     INC(i);
    b[i]:=CHR(33+n DIV (91*91) MOD 91); INC(i);
    b[i]:=CHR(33+n DIV 91 MOD 91);      INC(i);
    b[i]:=CHR(33+n MOD 91);             INC(i);

    IF long>-180.0 THEN n:=truncc((180.0+long)*190463.0) ELSE n:=0 END;
    b[i]:=CHR(33+n DIV (91*91*91));     INC(i);
    b[i]:=CHR(33+n DIV (91*91) MOD 91); INC(i);
    b[i]:=CHR(33+n DIV 91 MOD 91);      INC(i);
    b[i]:=CHR(33+n MOD 91);             INC(i);

    b[i]:=symb; INC(i);

    IF withspd THEN
      b[i]:=CHR(33+truncc(course) DIV 4);  INC(i);
      b[i]:=CHR(33+truncc(ln(speed*(1.0/KNOTS)+1.0)*12.9935872129));  INC(i);
      b[i]:=CHR(33+32+24+6);  INC(i);

    ELSIF withalt THEN
      IF alt*FEET>1.0 THEN n:=truncc(ln(alt*FEET)*500.5) ELSE n:=0 END;
      IF n>=91*91 THEN n:=91*91-1 END;
      b[i]:=CHR(33+n DIV 91);  INC(i);
      b[i]:=CHR(33+n MOD 91);  INC(i);
      b[i]:=CHR(33+32+16+6);   INC(i);

    ELSE
      b[i]:=" ";  INC(i);
      b[i]:=" ";  INC(i);
      b[i]:=CHR(33+32+24+6);  INC(i);
    END;

    IF withspeed & withalt THEN
      b[i]:="/"; INC(i);
      b[i]:="A"; INC(i);
      b[i]:="="; INC(i);
      n:=truncc(alt*FEET+0.5);
      IF alt>=0.0 THEN b[i]:=num(n DIV 10000) ELSE b[i]:="-" END; INC(i);
      b[i]:=num(n DIV 10000); INC(i);
      b[i]:=num(n DIV 1000); INC(i);
      b[i]:=num(n DIV 100); INC(i);
      b[i]:=num(n DIV 10); INC(i);
      b[i]:=num(n); INC(i);
    END;

  ELSIF comp=2 THEN                                            (* mic-e *)
    Append(b, ":"+140C);
    i:=micdest;

    nl:=truncc(ABS(long));
    n:=truncc(ABS(lat));
    b[i]:=CHR(80 + n DIV 10); INC(i);
    b[i]:=CHR(80 + n MOD 10); INC(i);
    n:=truncc((ABS(lat)-FLOAT(n))*6000.0);
    b[i]:=CHR(80 + n DIV 1000); INC(i);
    b[i]:=CHR(48 + 32*ORD(lat>=0.0) + n DIV 100 MOD 10); INC(i);
    b[i]:=CHR(48 + 32*ORD((nl<10) OR (nl>=100)) + n DIV 10 MOD 10); INC(i);
    b[i]:=CHR(48 + 32*ORD(long<0.0) + n MOD 10);

    i:=Length(b);
    IF nl<10 THEN b[i]:=CHR(nl+118);
    ELSIF nl>=100 THEN
      IF nl<110 THEN b[i]:=CHR(nl+8) ELSE b[i]:=CHR(nl-72) END;
    ELSE b[i]:=CHR(nl+28) END;
    INC(i);

    nl:=truncc((ABS(long)-FLOAT(nl))*6000.0);                (* long min*100 *)
    n:=nl DIV 100;
    IF n<10 THEN INC(n, 60) END;
    b[i]:=CHR(n+28);              INC(i);
    b[i]:=CHR(nl MOD 100+28);     INC(i);

    n:=truncc(speed*(1.0/KNOTS)+0.5);
    b[i]:=CHR(n DIV 10 + 28);     INC(i);
    nl:=truncc(course);
    b[i]:=CHR(32 + n MOD 10*10 + nl DIV 100);  INC(i);
    b[i]:=CHR(28 + nl MOD 100);                INC(i);

    b[i]:=symb; INC(i);
    b[i]:=symt; INC(i);
   
    IF withalt THEN
      IF alt>-10000.0 THEN n:=truncc(alt+10000.5) ELSE n:=0 END;
      b[i]:=CHR(33 + n DIV (91*91) MOD 91); INC(i);
      b[i]:=CHR(33 + n DIV 91 MOD 91);      INC(i);
      b[i]:=CHR(33 + n MOD 91);             INC(i);
      b[i]:="}";                            INC(i);
    END;

  END;

  IF dao THEN
    b[i]:="!"; INC(i);
    b[i]:="w"; INC(i);
    b[i]:=CHR(33 + dao91(lat)); INC(i);
    b[i]:=CHR(33 + dao91(long)); INC(i);
    b[i]:="!"; INC(i);
  END;

  b[i]:=0C;

  IF com THEN
    beaconmacros(comm);
    Append(b, comm);
  END;
--  Append(b, CR+LF);
 
  IF Length(mycall)>=3 THEN 
    IF useaxudp THEN 
      mon2raw(b, raw, rp);
      IF rp>0 THEN sendudp(raw, rp) END; 
    ELSE sendudp(b, Length(b)+1) END;
  END; 
  IF verb THEN

    WrFixed(lat, 6,10); WrFixed(long, 6,10);
    WrFixed(speed, 1,10); WrStr("km/h");
    WrFixed(course, 1,7); WrStr("deg");
    WrFixed(alt, 1,10); WrStrLn("m");

    WrStrLn(b);
  END;
END sendaprs;


VAR c:CHAR;
    len, rp:INTEGER;
    gpsp:CARDINAL;
    gpsb:ARRAY[0..99] OF CHAR;

BEGIN
<* IF TARGET_FAMILY="WIN32" THEN *>
    STDIO(TRUE);
<* END *>

  sumoff:=FALSE;
  anyip:=TRUE;
  junk:=TRUE;
  posok:=FALSE;
  altok:=FALSE;
  verb:=FALSE;
  usbrobust:=TRUE;
  baud:=4800;
<* IF TARGET_FAMILY="WIN32" THEN *>
  ttynamee:="com1";
<* ELSE *>
  ttynamee:="/dev/ttyS0";
<* END *>
  udpsock:=-1;
  gpsp:=0;
  mycall[0]:=0C;
  via[0]:=0C;
  comment[0]:=0C;
  symt:="/";
  symb:="/";
  comptyp:=0;  
  withalti:=TRUE;
  withspeed:=TRUE;
  withdao:=FALSE;
  micessid:=0;
  btime0:=3*60;
  btimedrive:=15;
  drivekm:=4;
  comintval:=5;
  comcnt:=0;
  btime:=0;
  msgtyp:=6;
  toport:=DEFAULTPORT;
  ipnum:=DEFAULTIP;
  useaxudp:=TRUE;
  Parms;
  IF Length(mycall)<3 THEN WrStrLn("no tx witout <mycall>") END; 
--Gencrctab;
  opentty;
  udpsock:=openudp();
  IF udpsock<0 THEN Error("cannot open udp socket") END;

  LOOP
<* IF TARGET_FAMILY="WIN32" THEN *>
    IF NOT ReadFile(tty, tbuf, SIZE(tbuf), dlen, NIL) THEN dlen:=0 END;
    len:=dlen;
    Sleep(250);
<* ELSE *>

    fdclr;
    fdsetr(tty);
--  fdsetr(udpsock);
    IF selectr(0, 0)>=0 THEN
      IF issetr(tty) THEN

        len:=RdBin(tty, tbuf, SIZE(tbuf));
<* END *>
        testtty(len, junk);

        
        IF NOT junk THEN 
          FOR rp:=0 TO len-1 DO 
            c:=tbuf[rp]; 
            IF (c=CR) OR (c=LF) THEN 
              IF gpsp>0 THEN          
                IF sumoff OR checksum(gpsb, gpsp) THEN 
                  decodeline(gpsb, gpsp);
                ELSE altok:=FALSE; posok:=FALSE; END;
                IF verb THEN showline(gpsb, gpsp) END;
                IF posok THEN 
                  INC(btime);
                  IF truncc(speed)>drivekm THEN 
                    IF btime>=btimedrive THEN btime:=0 END;
                  ELSIF btime>btime0 THEN btime:=0 END; 
                  IF btime=0 THEN
                    sendaprs(lat, long, alt, course, speed, comptyp, withspeed, withalti & altok, withdao, comcnt=0, comment);
                    INC(comcnt);
                    IF comcnt>=comintval THEN comcnt:=0 END;
                  END; 
                  altok:=FALSE; posok:=FALSE;
                END;
              END;
              gpsp:=0; 
            ELSIF (c>" ") & (gpsp<HIGH(gpsb)) THEN 
              gpsb[gpsp]:=c;
              INC(gpsp);     
            END;
          END;
        END;
        junk:=FALSE;

--    ELSIF issetr(udpsock) THEN
--      len:=getudp(udpsock, ubuf, ipnum, anyip);

<* IF TARGET_FAMILY="WIN32" THEN *>
<* ELSE *>
      END;
    END;
<* END *>
  END;

END gps2aprs.



