#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/io.h>
#include <linux/parport.h>
#include <linux/ppdev.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <errno.h>

 
int lptin(int adr)
{
  return inb(adr);
}

void lptout(int adr, int data)
{
  outb(data, adr);
}

int perm(int base)
{
  return ioperm(base,3,1);
}

char ppdevstat(int fdpar)
{
  unsigned char temp;
  ioctl(fdpar, PPRSTATUS, &temp);
  return temp;  
}

char ppdevrdata(int fdpar)
{
  unsigned char temp;
  ioctl(fdpar, PPRDATA, &temp);
  return temp;
}


void ppdevdata(int fdpar, char ch)
{
  ioctl(fdpar, PPWDATA, &ch);
}


void ppdevcontrol(int fdpar, char ch)
{
  ioctl(fdpar, PPWCONTROL, &ch);
}

void ppdevdatadir(int fdpar, int ch)
{
  ioctl(fdpar, PPDATADIR, &ch);
}



int ppclaim(int fdpar)
{
  return ioctl(fdpar, PPCLAIM);
}


/* gcc -O lpt.c -o lpt
fdpar: open /dev/parport0
The user has to have the previledges to have access to the ports for the program to run, so you have to be root to be able to ron this kind of programs without access problems. If you want to make a program which can be run by anybody then you have to first set the owner of the program to be root (for example do compilation when yhou are root), give the users rights to execute the program and then set the program to be always executed with owner (root) rights instead of the right of the user who runs it. You can set the programn to be run on owner rights by using following command: 
chmod +s lpt_test
*/
