<*+M2EXTENSIONS *>
<*+STORAGE *>
<*-GENFRAME*>
<*-DOREORDER*>
<*+NOPTRALIAS*>
<*CPU="PENTIUM"*>
<*+COMMENT*>
<* IF __GEN_C__ THEN *>
  <*+GENCTYPES*>
<* END *>

IMPLEMENTATION MODULE maptool; (* aprs tracks on osm map by oe5dxl *)

IMPORT pngread, pngwrite;
FROM jpgdec IMPORT readjpg;
FROM osi IMPORT WrStr, WrStrLn, WrInt, FdValid, InvalidFd, File, Exists, Erase,
                RdBin, OpenWrite, WrBin, Close, OpenRead, DIRSEP, Seek,
                sqrt, sin, arctan, tan, ln, cos, pi, exp
--<* IF TARGET_FAMILY="UNIX" THEN *>
,WrFixed
--<* END *>
;




FROM xosi IMPORT StartProg, CheckProg, sethand, pulling, CURSORTYP, Eventloop;
FROM TimeConv IMPORT time;
FROM SYSTEM IMPORT ADDRESS, FILL, ADR, INT16, INT8, CAST, MOVE, CARD8, CARD16, SHIFT, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM aprspos IMPORT POSITION, posvalid, distance, azimuth, EARTH, RAD;
FROM aprsdecode IMPORT initzoom, inittilex, inittiley, lums, finezoom, click,
     mappos, posinval, systime, verb, trunc, realtime, maploadpid, DEGSYM, COLTYP;

FROM aprsstr IMPORT IntToStr, FixToStr, Append, Length, TimeToStr,
                    TIME, cleanfilename, InStr, Assign;

FROM useri IMPORT confstr, configon, CONFSET, reloadmap, downloadprogress, debugmem,
                  wrheap, localtime, SP1, SP9, xerrmsg, refresh, conf2int,
                  textautosize, killmenuid;

FROM aprstext IMPORT postostr, DateLocToStr;

CONST 
      LF=12C; 
      MAXCOL=30000;
      SYMX=16;
      SYMY=16;
      SYMN=192;
      MAPGETFN="gettiles";                                        (* tiles request filename *)
      MAXFONTY=18;
      MINFONTY=7;
      DEFAULTFONTY=10;
      FONTFN="font.png";
      PNGEXT=".png";
      JPGEXT=".jpg";
      CHARS=MAXCHAR-32;

TYPE
     PIX8=RECORD r8, g8, b8:CARD8 END;
     SET8=SET OF [0..7];
     ROWS=ARRAY[0..TILESIZE-1] OF PIX8;
     pROWS=POINTER TO ROWS;
     SET16=SET OF [0..15];
     PNGBUF=ARRAY[0..TILESIZE-1] OF pROWS;
     pPNGBUF=POINTER TO PNGBUF;
     FN=ARRAY[0..1023] OF CHAR;
     SRTMCACHE=RECORD
       fd      :File;                               (* open ertm tile *)
       resol   :REAL;                               (* tile resolution m *)
       base    :POSITION;
       divx,
       divy    :REAL;
       xdeg,
       ydeg,
       xlast,
       ylast,
       xpix,
       ypix    :CARDINAL;
       alt     :INTEGER;                            (* last read altitude *)
       buf0,
       buf1    :CARDINAL;
       buf     :ARRAY[0..63] OF CHAR;
open, miss, hit:CARDINAL;
     END; 


VAR
    symbols:ARRAY[0..SYMX*SYMN-1] OF ARRAY[0..SYMY] OF PIX8;
    pngbuf :PNGBUF;
    font   :ARRAY[0..CHARS-1] OF RECORD
      char:ARRAY[0..MAXFONTY] OF ARRAY[0..7] OF CARD8;
      mask:ARRAY[0..MAXFONTY+2] OF SET16; 
      width:CARD8; 
    END;
    gammatab    :ARRAY[0..1023] OF CHAR;
    maploadstart:TIME;
    mapnamesbuf :ARRAY[0..4095] OF CHAR;                   (* tile name buffer *)
    mapnamesdone:CARD8;                                    (* tile names written to file *)
    lastmapreq  :TIME;                                     (* time of last map requested *)
    maploopcnt  :CARDINAL;                                 (* count same tile requests *)
    mapdelay    :TIME;                                     (* delay map load start on map moves *)
    srtmcache   :SRTMCACHE;


PROCEDURE sqr(x:REAL):REAL;
BEGIN RETURN x*x END sqr;


PROCEDURE makegammatab;
VAR c:CARDINAL;
CONST GAMMA=1.0/2.2;
BEGIN
  gammatab[0]:=0C;
  FOR c:=1 TO HIGH(gammatab) DO gammatab[c]:=CHR(trunc(exp(ln(FLOAT(c)/1024.0)*GAMMA)*255.5)) END;
END makegammatab;


PROCEDURE clr(img:pIMAGE);
VAR x:CARDINAL;
BEGIN
  FOR x:=0 TO HIGH(img^) DO
    FILL(ADR(img^[x]), 0C, SIZE(img^[0]));
  END;
END clr;

PROCEDURE vistime(t:TIME):BOOLEAN;
BEGIN RETURN systime<t+VAL(TIME, lums.maxdim+lums.firstdim) END vistime;


PROCEDURE limpos(VAR pos:POSITION);
BEGIN
  IF pos.long>pi THEN pos.long:=pi ELSIF pos.long<-pi THEN pos.long:=-pi END;
  IF pos.lat>MAXLAT THEN pos.lat:=MAXLAT ELSIF pos.lat<-MAXLAT THEN pos.lat:=-MAXLAT END;
END limpos;

PROCEDURE startmapdelay;
BEGIN
  mapdelay:=conf2int(fDELAYGETMAP, 0, 0, 60, 0);
  lastmapreq:=realtime;
  maploopcnt:=0;                                        (* operator moves map *)
END startmapdelay;


PROCEDURE findinfo(nx, ny:INTEGER);
VAR d:INTEGER;
    i:CARDINAL;
BEGIN
  WITH click DO
    d:=ABS(x-nx)+ABS(y-ny);
--IF (d<=5) & (ops<>NIL) THEN WrInt(d, 3);WrInt(entries, 3);WrStrLn(ops^.call); END;
    IF (d<=min) & (ops<>NIL) THEN     (* ops to ignore cc text *) 
      IF min>0 THEN entries:=0 ELSIF entries>HIGH(table) THEN entries:=HIGH(table) END;
      min:=d; 
      i:=0;
      WHILE (i<entries) & (table[i].opf<>ops) DO INC(i) END; 
      table[i].opf:=ops; 
      table[i].pff:=pf;
      table[i].pff0:=pf0;
      table[i].typf:=typ;
      IF i>=entries THEN INC(entries) END;
    END; 
  END; 
END findinfo;

PROCEDURE area(img:pIMAGE; x0,y0,x1,y1:INTEGER; col:COLTYP; add:BOOLEAN);
VAR xx,yy,h:INTEGER;
BEGIN
  IF x0>x1 THEN h:=x0; x0:=x1; x1:=h END;
  IF y0>y1 THEN h:=y0; y0:=y1; y1:=h END;
  IF x0<0 THEN x0:=0 END;
  IF x1<0 THEN x1:=0 END;
  IF y0<0 THEN y0:=0 END;
  IF y1<0 THEN y1:=0 END;
  IF x0>VAL(INTEGER,HIGH(img^)) THEN x0:=HIGH(img^) END;
  IF x1>VAL(INTEGER,HIGH(img^)) THEN x1:=HIGH(img^) END;
  IF y0>VAL(INTEGER,HIGH(img^[0])) THEN y0:=HIGH(img^[0]) END;
  IF y1>VAL(INTEGER,HIGH(img^[0])) THEN y1:=HIGH(img^[0]) END;
  FOR yy:=y0 TO y1 DO
    FOR xx:=x0 TO x1 DO
      WITH img^[xx][yy] DO
        IF add THEN
          INC(r, col.r);
          INC(g, col.g);
          INC(b, col.b);
        ELSE
          r:=col.r;
          g:=col.g;
          b:=col.b;
        END;
      END;
    END;
  END;
END area;

PROCEDURE realzoom(zi:INTEGER; zf:REAL):REAL;
BEGIN RETURN FLOAT(zi)+zf-1.0 END realzoom;

PROCEDURE expzoom(z:INTEGER):REAL;
BEGIN RETURN FLOAT(CAST(CARDINAL,SHIFT(BITSET{0}, z))) END expzoom;


PROCEDURE xytodeg(x, y:REAL; VAR pos:POSITION);
VAR zi:INTEGER;
    pixrad, zoom, ysf:REAL;
BEGIN
  zoom:=realzoom(initzoom, finezoom);
  ysf:=FLOAT(ysize);
  y:=ysf-y;
  IF y<0.0 THEN y:=0.0 ELSIF y>ysf THEN y:=ysf END;
  IF ABS(mappos.lat)>MAXLAT THEN posinval(pos); RETURN END;
  zi:=trunc(zoom);
  pixrad:=(pi*2.0)/((1.0+zoom-FLOAT(zi))*TILESIZE*expzoom(trunc(zoom)));
  pos.long:=mappos.long+pixrad*x;
  pos.lat :=2.0*arctan(exp(ln(tan(mappos.lat)+1.0/cos(mappos.lat))-pixrad*y))-pi*0.5;
  limpos(pos);
END xytodeg;

PROCEDURE shiftmap(x, y, ysize:INTEGER; zoom:REAL; VAR pos:POSITION);
VAR zi:INTEGER;
    pixrad:REAL;
BEGIN
  zi:=trunc(zoom);
  pixrad:=(1.0+zoom-FLOAT(zi))*TILESIZE*expzoom(trunc(zoom));
  pos.long:=pos.long-(pi*2.0)/pixrad*VAL(REAL,x);
  pos.lat :=2.0*arctan(exp(ln(tan(pos.lat)+1.0/cos(pos.lat))+(pi*2.0)/pixrad*VAL(REAL,ysize-y)))-pi*0.5;
  limpos(pos);
END shiftmap;

PROCEDURE center(xsize, ysize:INTEGER; zoom:REAL; centpos:POSITION; VAR pos:POSITION);
VAR zi:INTEGER;
    pixrad:REAL;
BEGIN
  zi:=trunc(zoom);
  pixrad:=(1.0+zoom-FLOAT(zi))*TILESIZE*expzoom(trunc(zoom));
  pos.long:=centpos.long-(pi*2.0)/pixrad*VAL(REAL,xsize DIV 2);
  pos.lat :=2.0*arctan(exp(ln(tan(centpos.lat)+1.0/cos(centpos.lat))+(pi*2.0)/pixrad*VAL(REAL,ysize DIV 2)))-pi*0.5;
  limpos(pos);
END center;



PROCEDURE mercator(lon, lat:REAL; zoom:INTEGER; VAR tilex, tiley:INTEGER; VAR x, y:REAL);
CONST TOL=0.0001;

VAR z:REAL;

BEGIN
  IF lat>MAXLAT THEN lat:=MAXLAT ELSIF lat<-MAXLAT THEN lat:=-MAXLAT END;
  IF lon>pi-TOL THEN lon:=pi-TOL ELSIF lon<-pi+TOL THEN lon:=-pi+TOL END;

  lat:=ln(tan(lat)+1.0/cos(lat));
  z:=expzoom(zoom);
  x:=(0.5+lon*(0.5/pi))*z;
  y:=(0.5-lat*(0.5/pi))*z; 
  tilex:=trunc(x);
  tiley:=trunc(y);
  x:=(x-FLOAT(tilex))*TILESIZE; 
  y:=(y-FLOAT(tiley))*TILESIZE;

EXCEPT
  WrStrLn("error in mercator");
  tilex:=0;
  tiley:=0;
  x:=0.0;
  y:=0.0; 

END mercator;

PROCEDURE mapxy(pos:POSITION; VAR x, y:REAL):INTEGER;
VAR tilex, tiley:INTEGER;
    xs, ys:REAL;
BEGIN
  IF posvalid(pos) THEN
    mercator(pos.long, pos.lat, initzoom, tilex, tiley, x, y);
    DEC(tilex, inittilex);
    DEC(tiley, inittiley);
    x:=(x+FLOAT(tilex*TILESIZE)-shiftx)*finezoom;
    y:=FLOAT(ysize)-(FLOAT(tiley*TILESIZE)+y-shifty)*finezoom;
--WrFixed(x, 5, 10); WrFixed(FLOAT(xsize), 5, 10); WrFixed(y, 5, 10); WrFixed(FLOAT(ysize), 5, 10); WrLn;
--doreorder error:    IF (x>=0.0) & (x<=FLOAT(xsize)) & (y>=0.0) & (y<=FLOAT(ysize)) THEN RETURN 0 END;
    xs:=FLOAT(xsize);
    ys:=FLOAT(ysize);
    IF (x>=0.0) & (x<=xs) & (y>=0.0) & (y<=ys) THEN RETURN 0 END;

  END;
  RETURN -1
END mapxy;

PROCEDURE pullmap(x, y:INTEGER; init:BOOLEAN);
VAR top:POSITION;
    i:CARDINAL;
BEGIN
  IF init THEN
    xytodeg(VAL(REAL,x), VAL(REAL,y), click.pullpos);
    sethand(cPULL4); pulling:=TRUE;
  ELSE
    FOR i:=0 TO 9 DO
      xytodeg(VAL(REAL,x), VAL(REAL,y), top);
      mappos.lat:=mappos.lat-(top.lat-click.pullpos.lat)*0.5;
      mappos.long:=mappos.long-(top.long-click.pullpos.long);
      limpos(mappos);
    END;
  END;
END pullmap;


PROCEDURE loctopos(VAR pos:POSITION; loc:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(loc) DO loc[i]:=CAP(loc[i]) END;
  IF ((HIGH(loc)=5) OR (loc[6]=0C))
  & (loc[0]>='A') & (loc[0]<='R')
  & (loc[1]>='A') & (loc[1]<='R')
  & (loc[2]>='0') & (loc[2]<='9')
  & (loc[3]>='0') & (loc[3]<='9')
  & (loc[4]>='A') & (loc[4]<='X')
  & (loc[5]>='A') & (loc[5]<='X') THEN
    pos.long:=(FLOAT(ORD(loc[0])-ORD('A'))*20.0
              +FLOAT(ORD(loc[2])-ORD('0'))*2.0
              +(FLOAT(ORD(loc[4])-ORD('A'))+0.5)/12.0 - 180.0)*(pi/180.0);
    pos.lat :=(FLOAT(ORD(loc[1])-ORD('A'))*10.0
              +FLOAT(ORD(loc[3])-ORD('0'))
              +(FLOAT(ORD(loc[5])-ORD('A'))+0.5)/24.0 - 90.0)*(pi/180.0);
  ELSE pos.lat:=0.0; pos.long:=0.0 END;
END loctopos;




PROCEDURE postoloc(VAR loc:ARRAY OF CHAR; pos:POSITION);
VAR lc,bc:CARDINAL;
    lr, br:REAL;
BEGIN
  limpos(pos);
  lr:=(pos.long*(180.0/pi)+180.0)*12.0;
  IF lr<0.0 THEN lr:=0.0 END;
  lc:=trunc(lr);
  br:=(pos.lat *(180.0/pi)+90.0 )*24.0;
  IF br<0.0 THEN br:=0.0 END;
  bc:=trunc(br);
  loc[0]:=CHR(ORD("A")+lc DIV (10*24));
  loc[1]:=CHR(ORD("A")+bc DIV (10*24));
  loc[2]:=CHR(ORD("0")+lc DIV 24 MOD 10);
  loc[3]:=CHR(ORD("0")+bc DIV 24 MOD 10);
  loc[4]:=CHR(ORD("A")+lc MOD 24);
  loc[5]:=CHR(ORD("A")+bc MOD 24);
  loc[6]:=0C;
END postoloc;


(*
PROCEDURE getsrtm13(pos:POSITION; typ:CHAR):INTEGER;
CONST SRTM3DIR="srtm3"; 
      SRTM3RES=1200;   
      SRTM1DIR="srtm1";
      SRTM1RES=3600;                                           (* pixel in srtm tile *)

VAR s:ARRAY[0..20] OF CHAR;
    path:FN;
    lati, longi, n, res:CARDINAL;
    latd, longd:REAL;
    h:INTEGER;
BEGIN
  limpos(pos);
  confstr(fOSMDIR, path);
  IF typ="3" THEN
    Append(path, DIRSEP+SRTM3DIR);
    res:=SRTM3RES;
  ELSE
    Append(path, DIRSEP+SRTM1DIR);
    res:=SRTM1RES;
  END;
  Append(path, DIRSEP);
  latd :=90.0 + pos.lat*(180.0/pi);
  longd:=180.0 + pos.long*(180.0/pi);
  lati:=trunc(latd);
  longi:=trunc(longd);
  IF lati<90 THEN s[0]:="S"; n:=90-lati ELSE s[0]:="N"; n:=lati-90 END;
  s[1]:=CHR(n DIV 10+ORD("0"));
  s[2]:=CHR(n MOD 10+ORD("0"));

  IF longi<180 THEN s[3]:="W"; n:=180-longi ELSE s[3]:="E"; n:=longi-180 END;
  s[4]:=CHR(n DIV 100+ORD("0"));
  s[5]:=CHR(n DIV 10 MOD 10+ORD("0"));
  s[6]:=CHR(n MOD 10+ORD("0"));
  s[7]:=".";
  s[8]:="h";
  s[9]:="g";
  s[10]:="t";
  s[11]:=0C;
  Append(path, s);
  IF NOT FdValid(srtmfd) OR NOT StrCmp(path, srtmfn) THEN
    IF FdValid(srtmfd) THEN Close(srtmfd) END;
    srtmfd:=OpenRead(path);
    srtmfn:=path;
  END;
  IF NOT FdValid(srtmfd) THEN
    IF verb THEN WrStr(path); WrStrLn(" not found"); END;
    RETURN MAX(INTEGER)

  END;

  latd:=latd-FLOAT(lati);
  longd:=longd-FLOAT(longi);
  latd :=(1.0-latd)*FLOAT(res);
  longd:=longd*FLOAT(res);
--WrInt(trunc(latd), 10); WrInt(trunc(longd), 10); WrStrLn("xy");

  n:=trunc(longd) + trunc(latd)*(res+1);
  Seek(srtmfd, n*2);
  IF RdBin(srtmfd, s, 2)=2 THEN
    h:=ORD(s[1]) + ORD(s[0])*256;
--WrInt(h, 10); WrStrLn("=hgt");
    IF h>=32768 THEN h:=h-65536 END;
    IF h<=-32767 THEN h:=MAX(INTEGER) END;
  ELSE h:=MAX(INTEGER) END;
--  Close(fd);
  RETURN h
END getsrtm13;


PROCEDURE getsrtm30(pos:POSITION):INTEGER;
CONST SRTM30DIR="srtm30";

VAR s:ARRAY[0..20] OF CHAR;
    path:ARRAY[0..1000] OF CHAR;
    lati, longi, n:CARDINAL;
    fd:File;
    latd, longd:REAL;
    h:INTEGER;
BEGIN
  limpos(pos);
  confstr(fOSMDIR, path);
  Append(path, DIRSEP+SRTM30DIR);
  Append(path, DIRSEP);
  latd :=90.0 + pos.lat*(180.0/pi);
  longd:=180.0 + pos.long*(180.0/pi);

  longi:=trunc(longd) DIV 40*40;
  IF longi<180 THEN s[0]:="W"; n:=180-longi ELSE s[0]:="E"; n:=longi-180 END;
  s[1]:=CHR(n DIV 100+ORD("0"));
  s[2]:=CHR(n DIV 10 MOD 10+ORD("0"));
  s[3]:=CHR(n MOD 10+ORD("0"));

  lati:=trunc(latd);
  IF lati>=130   THEN latd:=180.0-latd;  s[4]:="N"; s[5]:="9";
  ELSIF lati>=90 THEN latd:=130.0-latd;  s[4]:="N"; s[5]:="4";
  ELSIF lati>=60 THEN latd:= 90.0-latd;  s[4]:="S"; s[5]:="0";
  ELSE                latd:= 40.0-latd;  s[4]:="S"; s[5]:="4" END;
  s[6]:="0"; 
  s[7]:=".";
  s[8]:="D";
  s[9]:="E";
  s[10]:="M";
  s[11]:=0C;
  Append(path, s);
  fd:=OpenRead(path);
  IF NOT FdValid(fd) THEN
    IF verb THEN WrStr(path); WrStrLn(" not found"); END;
    RETURN MAX(INTEGER)

  END;

  longd:=longd-FLOAT(longi);
  longd:=longd*120.0;
--WrInt(trunc(longd), 10); WrInt(trunc(latd), 10); WrStrLn("xy");

  n:=trunc(longd) + trunc(latd*120.0)*4800;
--WrInt(n, 15); WrStrLn(" n");
  Seek(fd, n*2);
  IF RdBin(fd, s, 2)=2 THEN
    h:=ORD(s[1]) + ORD(s[0])*256;
--WrInt(h, 10); WrStrLn("=hgt");
    IF h>=32768 THEN h:=h-65536 END;
    IF h<=-32767 THEN h:=MAX(INTEGER) END;
  ELSE h:=MAX(INTEGER) END;
  Close(fd);
  RETURN h
END getsrtm30;


PROCEDURE getsrtm(pos:POSITION; VAR resolution:REAL):INTEGER;
VAR nn:INTEGER;
BEGIN
  nn:=getsrtm13(pos, "1");
  resolution:=30.0;
  IF nn=MAX(INTEGER) THEN nn:=getsrtm13(pos,"3"); resolution:=90.0 END;
  IF nn=MAX(INTEGER) THEN nn:=getsrtm30(pos); resolution:=900.0 END;
  RETURN nn
END getsrtm;
*)

PROCEDURE opensrtm(pos:POSITION; typ:CARD8);
CONST SRTM3DIR="srtm3";
      SRTM1DIR="srtm1";
      SRTM30DIR="srtm30";

VAR s:ARRAY[0..20] OF CHAR;
    path:FN;
    n, xi, res:CARDINAL;
    latd, longd:REAL;
BEGIN
  latd :=90.0 + pos.lat*(180.0/pi);
  longd:=180.0 + pos.long*(180.0/pi);

  WITH srtmcache DO
    limpos(pos);
    confstr(fOSMDIR, path);
    resol:=0.0;
    IF typ=3 THEN
      Append(path, DIRSEP+SRTM3DIR+DIRSEP);
      res:=1200;
      resol:=90.0;
    ELSIF typ=1 THEN
      Append(path, DIRSEP+SRTM1DIR+DIRSEP);
      res:=3600;
      resol:=30.0;
    END;
    ydeg:=trunc(latd);
    xdeg:=trunc(longd);
    IF resol<>0.0 THEN 
      IF ydeg<90 THEN s[0]:="S"; n:=90-ydeg ELSE s[0]:="N"; n:=ydeg-90 END;
      s[1]:=CHR(n DIV 10+ORD("0"));
      s[2]:=CHR(n MOD 10+ORD("0"));
      IF xdeg<180 THEN s[3]:="W"; n:=180-xdeg ELSE s[3]:="E"; n:=xdeg-180 END;
      s[4]:=CHR(n DIV 100+ORD("0"));
      s[5]:=CHR(n DIV 10 MOD 10+ORD("0"));
      s[6]:=CHR(n MOD 10+ORD("0"));
      s[7]:=".";
      s[8]:="h";
      s[9]:="g";
      s[10]:="t";
      base.lat:=FLOAT(ydeg+1);
      base.long:=FLOAT(xdeg);
      divx:=FLOAT(res);
      divy:=divx;
      xpix:=res+1;
      ypix:=xpix;

    ELSE
      resol:=900.0;
      Append(path, DIRSEP+SRTM30DIR+DIRSEP);
      xi:=xdeg DIV 40*40;
      IF xi<180 THEN s[0]:="W"; n:=180-xi ELSE s[0]:="E"; n:=xi-180 END;
      s[1]:=CHR(n DIV 100+ORD("0"));
      s[2]:=CHR(n DIV 10 MOD 10+ORD("0"));
      s[3]:=CHR(n MOD 10+ORD("0"));

      IF ydeg>=130   THEN base.lat:=180.0; ypix:=6000; s[4]:="N"; s[5]:="9";
      ELSIF ydeg>=90 THEN base.lat:=130.0; ypix:=4800; s[4]:="N"; s[5]:="4";
      ELSIF ydeg>=50 THEN base.lat:= 90.0; ypix:=4800; s[4]:="S"; s[5]:="0";
      ELSE                base.lat:= 50.0; ypix:=6000; s[4]:="S"; s[5]:="4" END;
      s[6]:="0";
      s[7]:=".";
      s[8]:="D";
      s[9]:="E";
      s[10]:="M";
      base.long:=FLOAT(xi);
      divx:=120.0;
      divy:=divx;
      xpix:=4800;

    END;

    s[11]:=0C;
    Append(path, s);
    fd:=OpenRead(path);
    buf1:=0;
    buf0:=0;
INC(open)
  END;
END opensrtm;


PROCEDURE findsrtm(pos:POSITION);
BEGIN
  limpos(pos);
  IF srtmcache.fd=InvalidFd THEN
    opensrtm(pos, 1);
    IF srtmcache.fd=InvalidFd THEN
      opensrtm(pos, 3);
      IF srtmcache.fd=InvalidFd THEN opensrtm(pos, 30) END;
    END;
  END;
END findsrtm;

PROCEDURE readsrtm(pos:POSITION):BOOLEAN;
VAR x, y, i:CARDINAL;
--    s:ARRAY[0..1] OF CHAR;
BEGIN
  pos.lat :=90.0 + pos.lat*(180.0/pi);
  pos.long:=180.0 + pos.long*(180.0/pi);

  WITH srtmcache DO
    IF (xdeg=trunc(pos.long)) & (ydeg=trunc(pos.lat)) THEN   (* we are in same degree else check if finer resolution exists *)
      pos.lat :=base.lat-pos.lat;
      pos.long:=pos.long-base.long;
      IF (pos.lat>=0.0) & (pos.long>=0.0) THEN
        x:=trunc(pos.long*divx);
        y:=trunc(pos.lat*divy);
        IF (x<xpix) & (y<ypix) THEN
          IF (y<>ylast) OR (x<buf0) OR (x>=buf1) THEN
INC(miss);          
            i:=SIZE(buf) DIV 4;
            IF x<i THEN buf0:=0 ELSE buf0:=x-i END;
            buf1:=buf0+SIZE(buf) DIV 2;
            IF buf1>xpix THEN buf1:=xpix; buf0:=buf1-SIZE(buf) DIV 2 END;
            IF xpix-x<i THEN i:=xpix-x END; 

            Seek(fd, (buf0 + y*xpix)*2);
            IF RdBin(fd, buf, SIZE(buf))<>SIZE(buf) THEN
              buf0:=0;
              buf1:=0;
              alt:=MAX(INTEGER);
              RETURN TRUE

            END;


          ELSE INC(hit) END;

          i:=(x-buf0)*2;
          alt:=ORD(buf[i+1]) + ORD(buf[i])*256;
          IF alt>=32768 THEN alt:=alt-65536 END;
          IF alt<=-32767 THEN alt:=MAX(INTEGER) END;
          xlast:=x;
          ylast:=y;
          RETURN TRUE

        END;


(*
        IF (x=xlast) & (y=ylast) THEN INC(hit); RETURN TRUE END;

        IF (x<xpix) & (y<ypix) THEN
INC(miss);
          xlast:=x;
          ylast:=y;
          Seek(fd, (x + y*xpix)*2);
          IF RdBin(fd, s, 2)=2 THEN
            alt:=ORD(s[1]) + ORD(s[0])*256;
            IF alt>=32768 THEN alt:=alt-65536 END;
            IF alt<=-32767 THEN alt:=MAX(INTEGER) END;
          ELSE alt:=MAX(INTEGER) END;
          RETURN TRUE

        END;
*)
      END;
    END;
  END;
  RETURN FALSE
END readsrtm;


PROCEDURE closesrtmfile;
BEGIN IF srtmcache.fd<>InvalidFd THEN Close(srtmcache.fd); srtmcache.fd:=InvalidFd END; END closesrtmfile;


PROCEDURE getsrtm(pos-:POSITION; VAR resolution:REAL):INTEGER;
VAR nn:INTEGER; 
BEGIN
  nn:=MAX(INTEGER);
  IF srtmcache.fd=InvalidFd THEN findsrtm(pos) END;
  IF srtmcache.fd<>InvalidFd THEN
    IF readsrtm(pos) THEN nn:=srtmcache.alt;
    ELSE
      closesrtmfile;
      findsrtm(pos);     
      IF (srtmcache.fd<>InvalidFd) & readsrtm(pos) THEN nn:=srtmcache.alt END;
    END;
  END;
  resolution:=srtmcache.resol;
  RETURN nn
END getsrtm;




(*
PROCEDURE wgs84(lat, long, heig:REAL; VAR x,y,z:REAL);       (* wgs84 ecef *)
CONST
      A=6378137;
--      B=6356752;
--      F=(A-B)/A;
--      E=2*F-F*F;
      E=0.081819190842522;

VAR n,sl,h:REAL;
BEGIN
  sl:=sin(lat);
  n:=A/sqrt(1.0-E*E*sl*sl);
  h:=heig+n;
  z:=(n*(1.0-E*E)+heig)*sl;
  y:=h*sin(long)*cos(lat);
  x:=h*cos(long)*cos(lat);
END wgs84;
*)

PROCEDURE wgs84s(lat, long, nn:REAL; VAR x,y,z:REAL);   (* km *)
CONST
VAR h:REAL;
BEGIN
  h:=nn+EARTH;
  z:=h*sin(lat);
  y:=h*sin(long)*cos(lat);
  x:=h*cos(long)*cos(lat);
END wgs84s;

PROCEDURE wgs84r(x,y,z:REAL; VAR lat, long, heig:REAL);   (* km *)
VAR h:REAL;
BEGIN
  h:=x*x + y*y;
  IF ABS(x)>ABS(y) THEN
    long:=arctan(y/x);
    IF x<0.0 THEN
      IF y>0.0 THEN long:=pi+long ELSE long:=long-pi END;
    END;
  ELSE
    long:=pi*0.5-arctan(x/y);
    IF y<0.0 THEN long:=long-pi END;
  END;
  lat:=arctan(z/sqrt(h));
  heig:=sqrt(h + z*z) - EARTH;
END wgs84r;




PROCEDURE fresnel(a, b, lambda:REAL):REAL;
BEGIN IF lambda=0.0 THEN RETURN 0.0 ELSE RETURN sqrt(lambda*a*b/(a+b)) END; END fresnel;

PROCEDURE frescol(a:REAL; VAR r,g,b:CARD16);
CONST M=700;
BEGIN
  b:=M;
  r:=0;
  g:=100;
  IF a<=0.001 THEN r:=M; g:=0; b:=0;
  ELSIF a<0.999 THEN
    b:=0;
    IF a<0.5 THEN r:=M; g:=trunc(a*(M*2.0));
    ELSE g:=M; r:=trunc((1.0-a)*(M*2.0)) END;
  END;
END frescol;

PROCEDURE geoprofile(image:pIMAGE; pos0, pos1:POSITION; lambda:REAL;
                     ant1nn:BOOLEAN; ant1, ant2:INTEGER; VAR dist, dbi, a1, a2:REAL):INTEGER;

CONST SCALEHLINES=0.1;                                (* size of headroom lines to rf path size *)
      DOTSTEP=2;
      MAXDIST=1000000;
      HERR=-20000.0;

TYPE pHTAB=POINTER TO HTAB;
     HTAB=RECORD
            next:pHTAB;
            tx,ty,alt:REAL;
          END;

VAR nn, fs, fstep:INTEGER;
    x0,y0,z0, x1,y1,z1, dx,dy,dz, h, d, x,y, fres, maxfres, xo,yo, kf, nv, odist,
    fressum, fresmin, fullsum, dh, h0, h1, hmid, resol, a, wdif, xsh, ysh, xproj, yproj:REAL;
    pos, posf:POSITION;
    blue, green, red:CARD16;
    phtab, pht:pHTAB;
BEGIN
srtmcache.open:=0;
srtmcache.miss:=0;
srtmcache.hit:=0;

  dbi:=0.0;
  dist:=0.0;
  IF ant1nn THEN nn:=0;  (* ant1 is given in NN not over ground (m) *) 
  ELSE
    nn:=getsrtm(pos0, resol);
    IF nn=MAX(INTEGER) THEN closesrtmfile; RETURN -1 END;

  END;
  a1:=VAL(REAL, nn+ant1);
  wgs84s(pos0.lat, pos0.long, a1*0.001, x0,y0,z0);
  nn:=getsrtm(pos1, resol);
  IF nn=MAX(INTEGER) THEN closesrtmfile; RETURN -1 END;

  a2:=VAL(REAL, nn+ant2);
  wgs84s(pos1.lat, pos1.long, a2*0.001, x1,y1,z1);
  x1:=x1-x0;
  y1:=y1-y0;
  z1:=z1-z0;
  dist:=sqrt(x1*x1 + y1*y1 + z1*z1)*1000.0;
  IF dist<1.0 THEN closesrtmfile; RETURN -3 END;
  IF dist>MAXDIST THEN closesrtmfile; RETURN -2 END;

  IF lambda<>0.0 THEN dbi:=32.2+8.68588963806503655305*ln(dist*0.3/lambda) END;

  odist:=0.7071/dist;                                      (* step 1/sqrt(2) of map resolution *)
  d:=0.0;  
  maxfres:=fresnel(dist*0.5, dist*0.5, lambda);
  IF maxfres=0.0 THEN maxfres:=1.0 END;
  xo:=0.0;
  yo:=0.0;
  fresmin:=1.0;

  nv:=FLOAT(azimuth(pos0, pos1))*(pi/180.0);

  phtab:=NIL;
  REPEAT

    fres:=fresnel(dist*d, dist*(1.0-d), lambda);
    dx:=x0 + x1*d;
    dy:=y0 + y1*d;
    dz:=z0 + z1*d;
    wgs84r(dx,dy,dz, pos.lat, pos.long, hmid);
    IF mapxy(pos, x, y)>=0 THEN
      hmid:=hmid*1000.0;
      fressum:=0.0;
      fullsum:=0.0;
      fstep:=trunc(fres*0.5/resol);
      FOR fs:=-fstep TO fstep DO
        kf:=VAL(REAL, fs)*resol/20000000.0*pi;
        posf.lat:=pos.lat + kf*sin(nv);
        posf.long:=pos.long - kf*cos(nv);
        dh:=sqr(fres*0.5) - sqr(VAL(REAL, fs)*resol);
        nn:=getsrtm(posf, resol);
        IF nn=MAX(INTEGER) THEN h:=HERR ELSE h:=VAL(REAL, nn) END; (* m over ground *)
        IF dh>0.0 THEN
          dh:=sqrt(dh);
          h0:=hmid - dh;
          h1:=hmid + dh;
--WrFixed(dh, 3, 10); WrFixed(h0, 3, 10); WrFixed(h1, 3, 10); WrStrLn(" dh");

          fullsum:=fullsum + (h1-h0);

--WrFixed(h, 3, 10); WrFixed(h0, 3, 10); WrStrLn(" hh0");

          IF h>h0 THEN h0:=h END;
          IF h1>h0 THEN fressum:=fressum + (h1-h0) END; 
        ELSE
          fullsum:=1.0;
          IF h<hmid THEN fressum:=1.0 END;                
        END;
      END;

      IF fullsum>0.0 THEN
        fressum:=fressum/fullsum;
        IF fressum<fresmin THEN fresmin:=fressum END;
--WrFixed(fullsum, 3, 10); WrFixed(fressum, 3, 10); WrStrLn(" ff");
        IF sqr(xo-x)+sqr(yo-y)>DOTSTEP*DOTSTEP THEN
          IF h=HERR THEN waypoint(image, x, y, 1.5, 500, 500, 500);    (* have no srtm *)
          ELSE
            frescol(fresmin, red, green, blue); 
            waypoint(image, x, y, 1.25+1.25*fres/maxfres, red, green, blue);

            ALLOCATE(pht, SIZE(pht^));           (* store headroom values for scaling later *)
            IF pht<>NIL THEN
              pht^.next:=phtab; phtab:=pht;
              pht^.alt:=hmid-FLOAT(nn);          (* meters over (or under) ground *)
              pht^.tx:=x; pht^.ty:=y;            (* pixel on screen *)
            END;
(*
            IF hdif<0.0 THEN red:=100; green:=0; blue:=0;           (* no sight *)
            ELSE red:=0; green:=30; blue:=100 END;                  (* sight *)
            IF yproj<0.0 THEN hdif:=-hdif END;
            xsh:=x+hdif*xproj;                                      (* rotate to normalvector *)
            ysh:=y-hdif*yproj;                                      (* rotate to normalvector *)
            vector(image, x,y,xsh,ysh, red,green,blue, 256, 0.0);
            waypoint(image, xsh, ysh, 1.5, red*3, green*3, blue*3);
*)
          END;
          xo:=x;
          yo:=y;
          fresmin:=1.0;
        END;

      END;
    END;

    d:=d+resol*odist;
  UNTIL d>1.0;

  IF phtab<>NIL THEN
    pht:=phtab;
    a:=1.0;
    LOOP                                                 (* find maximum for scaling *)
      IF ABS(pht^.alt)>a THEN a:=ABS(pht^.alt) END;
      IF pht^.next=NIL THEN EXIT END;
      pht:=pht^.next;  
    END;

    d:=sqrt(1.0 + sqr(phtab^.tx-pht^.tx) + sqr(phtab^.ty-pht^.ty));    (* rftrack pixels on screen *)

    wdif:=sqr((pos0.long-pos1.long)*cos(pos0.lat)) + sqr(pos0.lat-pos1.lat); 
    IF wdif<>0.0 THEN
      wdif:=sqrt(wdif);                                                 (* dist pos0-pos1 *) 
      wdif:=wdif*a/(d*SCALEHLINES);
      xproj:=(pos0.lat-pos1.lat)/wdif;                                  (* 90 deg rotatationsvector *)
      yproj:=(pos0.long-pos1.long)*cos(pos0.lat)/wdif;                  (* for headroom lines to track *) 
    ELSE xproj:=0.0; yproj:=0.0 END;
    WHILE phtab<>NIL DO
      a:=phtab^.alt;
      IF a<0.0 THEN red:=80; green:=0; blue:=0;                       (* no sight *)
      ELSE red:=0; green:=30; blue:=100 END;                          (* sight *)
      IF yproj<0.0 THEN a:=-a END;                                    (* no sight always upside *)
      xsh:=phtab^.tx+a*xproj;                                         (* rotate to normalvector *)
      ysh:=phtab^.ty-a*yproj;                                         (* rotate to normalvector *)
      vector(image, phtab^.tx, phtab^.ty, xsh, ysh, red,green,blue, 256, 0.0); (* headroom line *)
      waypoint(image, xsh, ysh, 1.5, red*3, green*3, blue*3);         (* thicken end of headroom line *)
      pht:=phtab;
      phtab:=phtab^.next;
      DEALLOCATE(pht, SIZE(pht^));
    END;
  END;
  closesrtmfile;
--WrInt(srtmcache.open, 10); WrInt(srtmcache.miss, 10); WrInt(srtmcache.hit, 10); WrStrLn("=o.m.h");
 
  RETURN 0;

END geoprofile;



PROCEDURE Radiorange(image:pIMAGE; txpos:POSITION; ant1, ant2:INTEGER;
                     smooth:CARDINAL; colnr:CARDINAL; VAR abort:BOOLEAN);

  VAR bri:CARD16;

  PROCEDURE setcol(VAR p:PIX);
  BEGIN
    IF colnr=0 THEN 
      IF bri>p.r THEN p.r:=bri END;
    ELSIF bri>p.g THEN p.g:=bri END;
  END setcol;


CONST DARKJUMP=0.5;    (* shadow deepness to step relation *)
      INCSPEED=1.15;   (* enlarge light beam search step size going away from tx *) 
      STARTFINE=0.25;  (* start step size as part of srtm resolution at tx pos *)
      FRAMESTEP=1.8;   (* pixel step along corner of image *)
      RAYSTEP=1.8;     (* pixel step along radiaton ray *)
      FULLUM=1000.0;   (* full bright in image *)

VAR xp, yp, frame, far:CARDINAL;
    nn, void:INTEGER;
    x0,y0,z0, x1,y1,z1, dx,dy,dz, px, py, pz, h, hs, d, x,y, ox,oy, xtx,ytx,
    st, minst, xi, yi, dist, odist, resol, resoltx, a, atx, arx, rais, lum, osmooth:REAL;
    pos:POSITION;

    rt, startt:TIME;
    ss,ss1:ARRAY[0..100] OF CHAR; 
BEGIN
srtmcache.open:=0;
srtmcache.miss:=0;
srtmcache.hit:=0;

  startt:=time();

  nn:=getsrtm(txpos, resoltx);   (* altitude of tx an map resolution in m here *)

  IF nn=MAX(INTEGER) THEN closesrtmfile; RETURN END;
  IF smooth>0 THEN osmooth:=FULLUM/FLOAT(smooth) ELSE osmooth:=FULLUM END;

  atx:=VAL(REAL, nn+ant1);
  wgs84s(txpos.lat, txpos.long, atx*0.001, x0,y0,z0);

  arx:=VAL(REAL, ant2);
  xi:=0.0;
  yi:=0.0;
  nn:=mapxy(txpos, xtx, ytx);
  frame:=0;
  LOOP
    xytodeg(xi, yi, pos);
    IF (frame=0) & (ytx>0.0) OR (frame=2) & (ytx<FLOAT(ysize))
    OR (frame=1) & (xtx>0.0) OR (frame=3) & (xtx<FLOAT(xsize)) THEN

      wgs84s(pos.lat, pos.long, atx*0.001, x1,y1,z1);
      dx:=x1-x0;
      dy:=y1-y0;
      dz:=z1-z0;

      dist:=sqrt(dx*dx + dy*dy + dz*dz)*1000.0;              (* sight line length in m *)
      IF dist>1.0 THEN

        odist:=1.0/dist;
        minst:=resoltx*odist*STARTFINE;                      (* fine start steps at tx pos *)
        st:=minst;

        d:=0.0;
        rais:=-1000000000.0;
        far:=10;                                             (* use more steps to measure size *)
        ox:=0.0;
        oy:=0.0;
        LOOP
          d:=d+st;
          IF d>1.0 THEN EXIT END;

          px:=x0 + dx*d;
          py:=y0 + dy*d;
          pz:=z0 + dz*d;
          wgs84r(px,py,pz, pos.lat, pos.long, a);
          a:=a*1000.0;

          nn:=getsrtm(pos, resol);
          IF nn=MAX(INTEGER) THEN EXIT END;                  (* no altitude so say shadow *)

          h:=VAL(REAL, nn)-a;                                (* m ground over searchpath *)
          hs:=rais*d;                                        (* h sight line m over searchpath *)  
          IF h+arx>hs THEN                                   (* rx antenna in sight *)
            IF mapxy(pos, x, y)>=0 THEN
              xp:=TRUNC(x);
              yp:=TRUNC(y);
              IF (xp<HIGH(image^)) & (yp<HIGH(image^[0])) THEN
(*
                setcol(image^[xp  ][yp  ], color);
                setcol(image^[xp+1][yp  ], color);
                setcol(image^[xp  ][yp+1], color);
                setcol(image^[xp+1][yp+1], color);
*)

                lum:=(h+arx-hs)*osmooth;
                IF lum>FULLUM THEN lum:=FULLUM END;

                IF (xp>0) & (yp>0) THEN
(*
colh.r:=TRUNC(FLOAT(color.r)*lum);
colh.g:=TRUNC(FLOAT(color.g)*lum);
colh.b:=TRUNC(FLOAT(color.b)*lum);

                  setcol(image^[xp  ][yp  ]);
                  setcol(image^[xp+1][yp  ]);
                  setcol(image^[xp  ][yp+1]);
                  setcol(image^[xp-1][yp  ]);
                  setcol(image^[xp  ][yp-1]);
lum:=lum*0.5;
colh.r:=TRUNC(FLOAT(color.r)*lum);
colh.g:=TRUNC(FLOAT(color.g)*lum);
colh.b:=TRUNC(FLOAT(color.b)*lum);

                  setcol(image^[xp+1][yp+1]);
                  setcol(image^[xp-1][yp+1]);
                  setcol(image^[xp+1][yp-1]);
                  setcol(image^[xp-1][yp+1]);
*)
                  bri:=TRUNC(lum);
                  setcol(image^[xp  ][yp  ]);
                  setcol(image^[xp+1][yp  ]);
                  setcol(image^[xp  ][yp+1]);
                  setcol(image^[xp-1][yp  ]);
                  setcol(image^[xp  ][yp-1]);
                  bri:=bri DIV 2;
                  setcol(image^[xp+1][yp+1]);
                  setcol(image^[xp-1][yp+1]);
                  setcol(image^[xp+1][yp-1]);
                  setcol(image^[xp-1][yp+1]);
                END;


              END;
            END;

          ELSIF far>0 THEN void:=mapxy(pos, x, y) END;

          IF far>0 THEN                                      (* increase step size *)
            IF ABS(x-ox)+ABS(y-oy)<RAYSTEP THEN st:=st*INCSPEED
            ELSE
              IF st>minst THEN st:=st*(1.0/INCSPEED) END;
              DEC(far);
            END;
            ox:=x;
            oy:=y;
          END;
 
          IF h>hs THEN rais:=h/d;                             (* this point has light on ground *)
          ELSE d:=d+(hs-h)*DARKJUMP*odist END;                (* no light so jump farer *)

        END;
      END; 
    END;                                                      (* go along next side of image *)

    CASE frame OF
      0:
        xi:=xi+(1.0+ABS((VAL(REAL,xi)-xtx)/(VAL(REAL,yi)-ytx)))*FRAMESTEP;
        IF xi>=FLOAT(HIGH(image^)) THEN xi:=0.0; INC(frame) END;
     |1:
        yi:=yi + (1.0+ABS((VAL(REAL,yi)-ytx)/(VAL(REAL,xi)-xtx)))*FRAMESTEP;
        IF yi>=FLOAT(HIGH(image^[0])) THEN yi:=FLOAT(HIGH(image^[0])); INC(frame) END;
     |2:
        xi:=xi + (1.0+ABS((VAL(REAL,xi)-xtx)/(VAL(REAL,yi)-ytx)))*FRAMESTEP;
        IF xi>=FLOAT(HIGH(image^)) THEN xi:=FLOAT(HIGH(image^)); INC(frame) END;
    ELSE 
        IF yi>0.0 THEN yi:=yi-(1.0+ABS((VAL(REAL,yi)-ytx)/(VAL(REAL,xi)-xtx)))*FRAMESTEP ELSE EXIT END;
    END;

    rt:=time();
    IF rt<>realtime THEN
      realtime:=rt;
      IF startt+4<rt THEN
        click.cmd:=0C;
        refresh:=TRUE;
        ss:="radiorange";
        IF colnr<>0 THEN Append(ss, " 2") END;
        IntToStr(frame*25, 3, ss1); Append(ss, ss1); Append(ss, "% ESC to abort");
        textautosize(0, 0, 5, 0, "g", ss);

        pos:=mappos;
        Eventloop(1);
--      IF (click.cmd=<>0C) OR (pos.lat<>mappos.lat) OR (pos.long<>mappos.long)(*OR refresh*) THEN abort:=TRUE; EXIT END;
        IF NOT click.withradio THEN abort:=TRUE; EXIT END;
      END;

    END;

  END;    
  killmenuid(5);
  closesrtmfile;
--WrInt(stat1, 10);WrInt(stat2, 10);WrInt(stat3, 10); WrInt(stat4, 10); WrStrLn(" maps whites jumps");
--WrInt(srtmcache.open, 10); WrInt(srtmcache.miss, 10); WrInt(srtmcache.hit, 10); WrStrLn("=o.m.h");

END Radiorange;


PROCEDURE xytoloc(x, y:INTEGER; VAR s:ARRAY OF CHAR); (* lat/long + locator of pointer pixel *)
VAR mpos:POSITION;
    h:ARRAY[0..100] OF CHAR;
    nn:INTEGER;
    resol:REAL;
BEGIN
  xytodeg(VAL(REAL,x), VAL(REAL,y), mpos);
  postostr(mpos, "3", s); Append(s, " ");
  postostr(mpos, "1", h); Append(s, h);  Append(s, " ");
  FixToStr(mpos.lat/RAD, 6, h); Append(s, h);  Append(s, " ");
  FixToStr(mpos.long/RAD, 6, h); Append(s, h);  Append(s, " ");

  postoloc(h, mpos); Append(s, h);
  nn:=getsrtm(mpos, resol); 

  IF nn<MAX(INTEGER) THEN
    IntToStr(nn, 0, h);
    Append(s, " ");
    Append(s, h);
    Append(s, "m");
  END;

  IF (*(click.marktime=0) &*) posvalid(click.markpos) THEN
    FixToStr(distance(click.markpos, mpos), 4, h);
    Append(s, " ");
    Append(s, h);
    Append(s, "km ");
    IntToStr(azimuth(click.markpos, mpos), 0, h);
    Append(s, h);
    Append(s, DEGSYM);
  END;

END xytoloc;



PROCEDURE Colset(VAR c:COLTYP; w:CHAR);
BEGIN
  c.r:=256;
  c.g:=256;
  c.b:=256;
  IF    w="Y" THEN c.b:=0
  ELSIF w="R" THEN c.b:=0; c.g:=0;
  ELSIF w="G" THEN c.r:=0; c.b:=0;
  ELSIF w="B" THEN c.r:=0; c.g:=60;
  ELSIF w="O" THEN c.b:=0; c.g:=150;
  ELSIF w="0" THEN c.r:=255; c.g:=40; c.b:=10;
  ELSIF w="1" THEN c.r:=240; c.g:=120; c.b:=10;
  ELSIF w="2" THEN c.r:=240; c.g:=190; c.b:=10;
  ELSIF w="3" THEN c.r:=240; c.g:=240; c.b:=10;
  ELSIF w="4" THEN c.r:=110; c.g:=240; c.b:=10;
  ELSIF w="5" THEN c.r:=10; c.g:=240; c.b:=210;
  ELSIF w="6" THEN c.r:=10; c.g:=190; c.b:=240;
  ELSIF w="7" THEN c.r:=10; c.g:=90; c.b:=240;
  ELSIF w="8" THEN c.r:=140; c.g:=10; c.b:=240;
  ELSIF w="9" THEN c.r:=240; c.g:=10; c.b:=220;
  END;
END Colset; 

PROCEDURE addcol(VAR pixel:PIX; rr,gg,bb,f:INTEGER);
VAR fh:INTEGER;
BEGIN
  WITH pixel DO
    fh:=r+rr*f DIV 256;
    IF fh<0 THEN fh:=0 ELSIF fh>MAXCOL THEN fh:=MAXCOL END;
    r:=fh;
    fh:=g+gg*f DIV 256;           
    IF fh<0 THEN fh:=0 ELSIF fh>MAXCOL THEN fh:=MAXCOL END;
    g:=fh;
    fh:=b+bb*f DIV 256;           
    IF fh<0 THEN fh:=0 ELSIF fh>MAXCOL THEN fh:=MAXCOL END;
    b:=fh;
  END;
END addcol;


PROCEDURE waypoint(image:pIMAGE; x,y,r:REAL; rr,gg,bb:INTEGER);
VAR xi, yi, tx, ty, ri:INTEGER;
    fx, fy, mx, my, h:REAL;
BEGIN
  IF (x>r) & (x<FLOAT(HIGH(image^)+1)-r) & (y>r) & (y<FLOAT(HIGH(image^[0])+1)-r) THEN
    ri:=trunc(r)+1;
    tx:=trunc(x);
    fx:=x-FLOAT(tx);
    ty:=trunc(y);
    fy:=y-FLOAT(ty);

    FOR yi:=-ri TO ri DO
      FOR xi:=-ri TO ri DO
        mx:=FLOAT(xi)-fx;
        my:=FLOAT(yi)-fy;
        h:=mx*mx+my*my;
        IF h>0.0 THEN h:=sqrt(h) END;
        h:=r-h;
        IF h>0.0 THEN
          IF h>1.0 THEN h:=1.0 END;
          addcol(image^[tx+xi][ty+yi],rr,gg,bb,trunc(h*256.0));
        END;
      END;
    END;
  END;
END waypoint;



PROCEDURE vector(image:pIMAGE; x0,y0,x1,y1:REAL; rr,gg,bb:INTEGER; width:CARDINAL; glow:REAL);
CONST K=65536;
      KF=256;
VAR h, r, w1, w2, ro:REAL;
    xi, yi, yie, ya, yb, n, n0, e0, de0, e1, iw2, f1:CARDINAL;
    k, frr, fbb, fgg:INTEGER;
    flip, mirror, mirr:BOOLEAN;
BEGIN
(*scissoring*)
  mirr:=y0>y1;
  IF x0>x1 THEN h:=x1; x1:=x0; x0:=h; h:=y1; y1:=y0; y0:=h; mirror:=TRUE ELSE mirror:=FALSE END;

  IF (x0>=FLOAT(HIGH(image^)-1)) OR (x1<=0) THEN RETURN END;                 (* hor out *)

  IF x0<=0 THEN y0:=y0 + (y1-y0)*x0/(x0-x1); x0:=1.0  END;
  IF x1>=FLOAT(HIGH(image^)-1) 
  THEN 
    y1:=y0 + (y1-y0)*(FLOAT(HIGH(image^)-1)-x0)/(x1-x0);
    x1:=FLOAT(HIGH(image^)-1);
  END;

  IF y0<=0.0 THEN
    IF y1<=0.0 THEN RETURN END;                                       (* bottom out *)

    x0:=x0 + (x1-x0)*y0/(y0-y1);
    y0:=1.0;
  ELSIF y0>=FLOAT(HIGH(image^[0])-1) THEN
    IF y1>=FLOAT(HIGH(image^[0])-1) THEN RETURN END;                            (* top out *)

    x0:=x0 + (x1-x0)*(FLOAT(HIGH(image^[0])-1)-y0)/(y1-y0);
    y0:=FLOAT(HIGH(image^[0])-1);
  END;
  IF y1<=0.0 THEN
    x1:=x1 + (x1-x0)*y1/(y0-y1);
    y1:=1.0;
  ELSIF y1>=FLOAT(HIGH(image^[0])-1) THEN
    x1:=x0 + (x1-x0)*(FLOAT(HIGH(image^[0])-1)-y0)/(y1-y0);
    y1:=FLOAT(HIGH(image^[0])-1);
  END;
(*scissoring*)

  IF x0<2.0 THEN x0:=2.0 END;
  IF x0>FLOAT(HIGH(image^)-1) THEN x0:=FLOAT(HIGH(image^)-1) END;
  IF y0<2.0 THEN y0:=2.0 END;
  IF y0>FLOAT(HIGH(image^[0])-1) THEN y0:=FLOAT(HIGH(image^[0])-1) END;
  IF x1<2.0 THEN x1:=2.0 END;
  IF x1>FLOAT(HIGH(image^)-1) THEN x1:=FLOAT(HIGH(image^)-1) END;
  IF y1<2.0 THEN y1:=2.0 END;
  IF y1>FLOAT(HIGH(image^[0])-1) THEN y1:=FLOAT(HIGH(image^[0])-1) END;

  w1:=FLOAT(width)/512.0;
  IF x1-x0<ABS(y1-y0) THEN h:=x0; x0:=y0; y0:=h; h:=x1; x1:=y1; y1:=h; flip:=TRUE ELSE flip:=FALSE END;
  IF x0>x1 THEN h:=y1; y1:=y0; y0:=h; h:=x1; x1:=x0; x0:=h; mirror:=NOT mirror END;
  IF x1=x0 THEN RETURN END;

  h:=(y1-y0)/(x1-x0);
  ro:=sqrt(1.0+h*h);
  w2:=w1*ro;
  iw2:=trunc(w2*K);
  r:=w1*sin(arctan(h));
  xi:=trunc(x0-ABS(r));
  w1:=(y0-h*ABS(r)-w2-0.5)*K;
  IF w1<0.0 THEN ya:=0 ELSE ya:=trunc(w1) END;
(*
  ya:=TRUNC((y0-h*ABS(r)-w2-0.5)*K);
*)
  e0:=iw2*2;
  yb:=ya+e0;
  IF ABS(r)>0.1 THEN de0:=trunc(FLOAT(e0)/(ABS(r)*2.0)) ELSE de0:=e0 END;
  k:=VAL(INTEGER, h*K);
  n:=trunc(x1-FLOAT(xi)+ABS(r) );
  mirr:=y0>y1;

  IF click.dryrun THEN ya:=(ya+yb) DIV 2 END;
  glow:=glow/ro;
  e1:=0;
  n0:=n;

  WHILE n>0 DO
    IF click.dryrun THEN
      yi:=ya DIV K;
      IF flip THEN findinfo(yi-1, xi); findinfo(yi, xi); findinfo(yi+1, xi);
      ELSE findinfo(xi, yi-1);findinfo(xi, yi); findinfo(xi, yi+1); END;
    ELSE 
      IF mirror THEN h:=FLOAT(n) ELSE h:=FLOAT(n0-n) END;
      IF h<glow THEN 
        h:=h/glow; 
        frr:=trunc(FLOAT(rr)*(1.125-h)* 6.0 ); 
        fgg:=trunc(FLOAT(gg)*h);
        fbb:=trunc(FLOAT(bb)*h);
      ELSE
        frr:=rr;
        fbb:=bb;
        fgg:=gg;
      END;


      IF mirr THEN
        IF e0>de0 THEN
          yie:=yb-e0;
          DEC(e0, de0);
        ELSE yie:=yb END;

        IF n<=trunc(ABS(r)*2.0) THEN INC(ya, de0) END;
        yi:=ya;
      ELSE
        IF e0>de0 THEN
          yi:=ya+e0;
          DEC(e0, de0);
        ELSE yi:=ya END;

        IF n<=trunc(ABS(r)*2.0) THEN DEC(yb, de0) END;
        yie:=yb;
      END; 

      f1:=256-yi MOD K DIV 256;
      yi:=yi DIV K*K; 
      REPEAT
        IF flip THEN addcol(image^[yi DIV K][xi], frr,fgg,fbb, f1)
        ELSE addcol(image^[xi][yi DIV K], frr,fgg,fbb, f1) END;
        INC(yi, K);
        f1:=256;
      UNTIL yi>=yie;
      f1:=(K+yie-yi) MOD K DIV 256;
      IF flip THEN addcol(image^[yi DIV K][xi], frr,fgg,fbb, f1)
      ELSE addcol(image^[xi][yi DIV K], frr,fgg,fbb, f1) END;
--      INC(yb, k);
        yb:=VAL(INTEGER, yb)+k;
    END;
--    INC(ya, k);
      ya:=VAL(INTEGER, ya)+k;
    INC(xi);
    DEC(n); 
  END;

EXCEPT
  RETURN
END vector;

PROCEDURE setmark(image:pIMAGE; pos:POSITION; hard:BOOLEAN);
VAR i:INTEGER;
    x, y:REAL;
    col:COLTYP;
BEGIN
  IF posvalid(pos) & (mapxy(pos, x, y)>=0) THEN
    col.r:=0; col.g:=1000; col.b:=1000;
    IF hard THEN col.r:=1000; col.b:=0 END;
    FOR i:=-6 TO 6 DO
      waypoint(image, x+FLOAT(i*3), y, 1.3, col.r,col.g,col.b);
      waypoint(image, x, y+FLOAT(i*3), 1.3, col.r,col.g,col.b);
    END;
  END;
END setmark;


PROCEDURE drawchar(img:pIMAGE; ch:CHAR; x0r,y0r:REAL; VAR inc:INTEGER;
                   bri, contrast:CARDINAL; col:COLTYP; dryrun:BOOLEAN);
CONST ALPHA=255;
      WHITE=1023;
VAR x, y, x0, y0, xx, yy, fine:INTEGER;
    fx, fy, c, cf, cn:CARDINAL;
    dimmlev:REAL;

  PROCEDURE dim(x, y:INTEGER);
  VAR lum:REAL;
  BEGIN
    IF (x<0) OR (x>=VAL(INTEGER,HIGH(img^))) OR (y<0) OR (y>=VAL(INTEGER,HIGH(img^[0]))) THEN RETURN END;

    WITH img^[x][y] DO 
      lum:=FLOAT(VAL(CARDINAL,r)*87 + VAL(CARDINAL,g)*140 + VAL(CARDINAL,b)*28);
      IF lum>dimmlev THEN
        lum:=dimmlev/lum; 
        r:=trunc(FLOAT(r)*lum);   
        g:=trunc(FLOAT(g)*lum);
        b:=trunc(FLOAT(b)*lum);
      END;
    END;
  END dim;

BEGIN
  IF (ch>=" ") & (x0r>=0.0) & (y0r>=0.0) THEN
    cn:=ORD(ch)-ORD(" ");
    IF cn>HIGH(font) THEN cn:=0 END;

    dimmlev:=256*80.0;
    IF contrast=1 THEN dimmlev:=FLOAT(VAL(CARDINAL, col.r*87 + col.g*140 + col.b*28)*bri)*0.002 END;
    x0:=trunc(x0r);
    y0:=trunc(y0r);
    fx:=trunc((x0r-FLOAT(x0))*256.0);
    fy:=trunc((y0r-FLOAT(y0))*256.0);
    fine:=ORD((fx<>0) OR (fy<>0));

    WITH font[cn] DO
      IF (contrast>0) & NOT dryrun THEN 
        FOR y:=0 TO VAL(INTEGER, lums.fontysize-1) DO
          FOR x:=0 TO 15 DO
(*
            IF hicontrast & (mask[y]<>SET16{}) OR (x IN mask[y]) THEN dim(x0+x, y0+y) END;
*)
            IF x IN mask[y] THEN dim(x0+x+fine, y0+y) END;
          END;
        END; 
      END;
      FOR y:=0 TO VAL(INTEGER, lums.fontysize-3) DO
        yy:=y0 + y + 1;
        FOR x:=0 TO HIGH(font[0].char[0]) DO
          xx:=x0 + x + 1;
          c:=char[y][x]*bri DIV 256;
          IF (c>0) & (xx>=0) & (xx+1<VAL(INTEGER,HIGH(img^)))
          & (yy>=0) & (yy+1<VAL(INTEGER,HIGH(img^[0]))) THEN
            IF dryrun THEN findinfo(xx, yy);
            ELSE
              cf:=c*(256-fx)*(256-fy) DIV 65536;
              WITH img^[xx][yy] DO
                INC(r, cf*col.r DIV 256);
                INC(g, cf*col.g DIV 256);
                INC(b, cf*col.b DIV 256);
                IF ODD(g+col.g) THEN DEC(g) END;                     (* even is invert enable *)
              END;
              IF fine<>0 THEN                                        (* save cpu *) 
                cf:=c*(fx)*(256-fy) DIV 65536;
                WITH img^[xx+1][yy] DO
                  INC(r, cf*col.r DIV 256);
                  INC(g, cf*col.g DIV 256);
                  INC(b, cf*col.b DIV 256);
                END;
                cf:=c*(256-fx)*(fy) DIV 65536;
                WITH img^[xx][yy+1] DO
                  INC(r, cf*col.r DIV 256);
                  INC(g, cf*col.g DIV 256);
                  INC(b, cf*col.b DIV 256);
                END;
                cf:=c*(fx)*(fy) DIV 65536;
                WITH img^[xx+1][yy+1] DO
                  INC(r, cf*col.r DIV 256);
                  INC(g, cf*col.g DIV 256);
                  INC(b, cf*col.b DIV 256);
                END;
              END;
            END;
          END;
        END;
      END;
      inc:=width+1;
    END;
  END;
END drawchar;

PROCEDURE charwidth(ch:CHAR):CARDINAL;
VAR cn:CARDINAL;
BEGIN
  IF ch>=" " THEN
    cn:=ORD(ch)-ORD(" ");
    IF cn>HIGH(font) THEN cn:=0 END;
    RETURN font[cn].width+1
  END;
  RETURN 0
END charwidth;


PROCEDURE drawsym(image:pIMAGE; tab,sym:CHAR; mirror:BOOLEAN; x0r,y0r:REAL; bri:CARDINAL);
CONST ALPHA=220;
      WHITELEV=250;

VAR x, y, x0, y0, xi, sx:INTEGER;
    br1a, br0a, br1b, br0b, br1c, br0c, br1d, br0d, b:CARDINAL;
    col:COLTYP;
    fx, fy:CARDINAL;
    
BEGIN
  IF bri=0 THEN RETURN END;

  sx:=VAL(INTEGER, sym)-VAL(INTEGER," ");
  IF (sx<=0) OR (sx>=96) OR (x0r<-SYMX) 
  OR (y0r<-SYMY) OR (x0r>FLOAT(HIGH(image^)+SYMX)) OR (y0r>FLOAT(HIGH(image^[0])+SYMY)) THEN RETURN END;

  IF tab<>"/" THEN INC(sx, 96) END;
  sx:=sx*SYMX;
  IF bri>255 THEN bri:=255 END;

  x0:=VAL(INTEGER,x0r);
  y0:=VAL(INTEGER,y0r);
  IF x0<0 THEN fx:=0 ELSE fx:=trunc((x0r-FLOAT(x0))*256.0) END;
  IF y0<0 THEN fy:=0 ELSE fy:=trunc((y0r-FLOAT(y0))*256.0) END;
  DEC(x0, SYMX DIV 2);
  DEC(y0, SYMY DIV 2);

  b:=bri*(256-fx)*(256-fy) DIV 65536;
  br1a:=256-b;
  br0a:=b*(WHITELEV*WHITELEVEL) DIV 65536;
 
  IF (fx<>0) OR (fy<>0) THEN                                    (* save cpu *)
    b:=bri*(fx)*(256-fy) DIV 65536;
    br1b:=256-b;
    br0b:=b*(WHITELEV*WHITELEVEL) DIV 65536;

    b:=bri*(256-fx)*(fy) DIV 65536;
    br1c:=256-b;
    br0c:=b*(WHITELEV*WHITELEVEL) DIV 65536;

    b:=bri*(fx)*(fy) DIV 65536;
    br1d:=256-b;
    br0d:=b*(WHITELEV*WHITELEVEL) DIV 65536;
  END;

  FOR y:=0 TO SYMY-1 DO
    FOR x:=0 TO SYMX-1 DO
      IF (x0+x>=0) & (y0+y>=0) & (x+x0+1<VAL(INTEGER,HIGH(image^)))
      & (y+y0+1<VAL(INTEGER,HIGH(image^[0]))) THEN
        IF mirror THEN xi:=SYMY-1-x+sx ELSE xi:=x+sx END;
        WITH symbols[xi][y] DO
          IF (r8<ALPHA) OR (g8<ALPHA) OR (b8<ALPHA) THEN
            IF click.dryrun THEN findinfo(x+x0, y+y0);
            ELSE
              WITH image^[x+x0][y+y0] DO
                r:=(r*br1a + r8*br0a) DIV 256;
                g:=(g*br1a + g8*br0a) DIV 256;
                b:=(b*br1a + b8*br0a) DIV 256;
              END;
              IF (fx<>0) OR (fy<>0) THEN                        (* save cpu *)
                WITH image^[x+x0+1][y+y0] DO
                  r:=(r*br1b + r8*br0b) DIV 256;
                  g:=(g*br1b + g8*br0b) DIV 256;
                  b:=(b*br1b + b8*br0b) DIV 256;
                END;
                WITH image^[x+x0][y+y0+1] DO
                  r:=(r*br1c + r8*br0c) DIV 256;
                  g:=(g*br1c + g8*br0c) DIV 256;
                  b:=(b*br1c + b8*br0c) DIV 256;
                END;
                WITH image^[x+x0+1][y+y0+1] DO
                  r:=(r*br1d + r8*br0d) DIV 256;
                  g:=(g*br1d + g8*br0d) DIV 256;
                  b:=(b*br1d + b8*br0d) DIV 256;
                END;
              END;
            END;
          END;
        END;
      END;
    END;
  END;
  IF (tab>="0") & (tab<="9") OR (tab>="A") & (tab<="Z") THEN
    Colset(col, "W");
    drawchar(image, tab, x0r-(FLOAT((SYMX) DIV 2)-4),y0r-(FLOAT((SYMY) DIV 2)-(SYMY-FLOAT(lums.fontysize))*0.5+0.5), sx, bri*2, 1, col, click.dryrun);
  END;
END drawsym;


PROCEDURE OptTextPlace(img:pIMAGE; s:ARRAY OF CHAR; VAR xt, yt:INTEGER);
CONST HY=MAXFONTY;
      MARGIN=2;

VAR i, cn:CARDINAL;
    wid, x, y, yh, cont, lr, lg, lb, min, (*max,*) ymin, n, fonty:INTEGER;
    ct:ARRAY[0..HY*3-1] OF INTEGER;

BEGIN
  fonty:=lums.fontysize-3;
  IF (xt<0) OR (xt>=VAL(INTEGER,HIGH(img^))) OR (yt<-fonty)
  OR (yt>=VAL(INTEGER,HIGH(img^[0]))+fonty) THEN RETURN END;
  i:=0;
  wid:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) DO
    IF s[i]>=" " THEN
      cn:=ORD(s[i])-ORD(" ");
      IF cn>HIGH(font) THEN cn:=0 END;
      INC(wid, font[cn].width);
    END;
    INC(i);
  END;

  min:=MAX(INTEGER);
(*
  max:=0;
*)
  n:=0;
  FOR y:=0 TO 3*fonty-1 DO
    yh:=yt+y-fonty;
--  IF (yh>=MARGIN) & (yh<VAL(INTEGER,HIGH(img^[0])+1-lums.fontysize)-MARGIN) THEN (* never place text outside drawable *)
    IF (yh>=MARGIN) & (yh<VAL(INTEGER,HIGH(img^[0])+1)-MARGIN) THEN (* never place text outside drawable *)
      cont:=0;
      lr:=0; lg:=0; lb:=0; 
      FOR x:=xt TO xt+wid-1 DO
        IF x<VAL(INTEGER,HIGH(img^)-1) THEN
          WITH img^[x][yh] DO
            INC(cont, ABS(r-lr)+ABS(g-lg)+ABS(b-lb));
            lr:=r; lg:=g; lb:=b;
          END;
        END;
      END;
    ELSE cont:=wid*32768 END;  

    
    IF (y<fonty) OR (y>=fonty*2) THEN cont:=cont*400 DIV 256 END;

    ct[y]:=cont; 
    INC(n, cont);
    IF y>=fonty THEN
      DEC(n, ct[y-fonty]);
      IF n<min THEN min:=n; ymin:=y END;
(*
      IF n>max THEN max:=n END;
*)
    END;
  END;

  INC(yt, ymin-fonty*2);
END OptTextPlace;


PROCEDURE drawstr(image:pIMAGE; s-:ARRAY OF CHAR; xr, yr:REAL; bri, contrast:CARDINAL;
                  col:COLTYP; VAR pos:INT8; slide:CARDINAL; fixpos,dryrun:BOOLEAN);
VAR i:CARDINAL;
    dy, inc, x, y:INTEGER;
BEGIN
  IF bri=0 THEN RETURN END;

  IF slide>0 THEN
    IF fixpos THEN yr:=yr+VAL(REAL, pos);
    ELSE
      y:=VAL(INTEGER, yr);
      x:=VAL(INTEGER, xr);
      dy:=y;
      OptTextPlace(image, s, x, y);
      y:=y DIV 2*2 + 1;                   (* not odd lines for better 420 color conversion *)
      pos:=y-dy;
      xr:=VAL(REAL, x);
      yr:=VAL(REAL, y); 
    END;
  END;
  i:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) DO
    drawchar(image, s[i], xr,yr, inc, bri, contrast, col, dryrun);
    xr:=xr+FLOAT(inc);
    INC(i);
  END;
END drawstr;

PROCEDURE drawstri(image:pIMAGE; s-:ARRAY OF CHAR; xr, yr:INTEGER; bri, contrast:CARDINAL;
                   col:COLTYP; proportional,dryrun:BOOLEAN);
VAR i:CARDINAL;
    inc:INTEGER;
    c:CHAR; 
BEGIN
  i:=0;
  LOOP
    IF i>HIGH(s) THEN EXIT END;

    c:=s[i];
    IF c=0C THEN EXIT END;

    IF (c>=SP1) & (c<=SP9) THEN INC(xr, ORD(c)-(ORD(SP1)-1))          (* microspaces *)  
    ELSE
      drawchar(image, s[i], FLOAT(xr), FLOAT(yr), inc, bri, contrast, col, dryrun);
      IF proportional THEN INC(xr,inc) ELSE INC(xr, CHARWIDTH) END;
    END;  
    INC(i);
  END;
END drawstri;


PROCEDURE drawarrow(image:pIMAGE; x0, y0, len, ang:REAL; wind, bri:CARDINAL; col:COLTYP);
CONST L=7;
      WS=20;    (* wind fethers per kmh *) 
      LW=8;
      WW=4;
      A=0.12;
      W=-1.25;
VAR r,g,b, wi:INTEGER;
    x1, y1, s, c, l, s1, c1:REAL;
BEGIN
--WrInt(wind, 10);WrStrLn("=w");
  s:=sin(ang);
  c:=cos(ang);
  r:=bri*col.r DIV 256;
  g:=bri*col.g DIV 256;
  b:=bri*col.b DIV 256;
  IF wind=0 THEN
    vector(image, x0, y0, x0-(len-5.0)*s, y0+(len-5.0)*c, r,g,b, 400, 0.0);
    x1:=x0-len*s;
    y1:=y0+len*c;
    l:=len-L;
    vector(image, x1, y1, x0-l*sin(ang+A), y0+l*cos(ang+A), r,g,b, 200, 0.0);
    vector(image, x1, y1, x0-l*sin(ang-A), y0+l*cos(ang-A), r,g,b, 200, 0.0);
  ELSE
    len:=len+FLOAT(WW*wind DIV WS);
    vector(image, x0, y0, x0-len*s, y0+len*c, r,g,b, 250, 0.0);
    s1:=sin(ang+W);
    c1:=cos(ang+W);
    wi:=wind;
    IF wi<WS THEN wi:=WS END;
    REPEAT
      x1:=x0-len*s (*-s1*);
      y1:=y0+len*c (*+c1*);
      l:=FLOAT(LW);
      IF wi<WS THEN l:=LW*VAL(REAL,wi)/WS END; 
      vector(image, x1, y1, x1-l*s1, y1+l*c1, r,g,b, 250, 0.0);
      DEC(wi, WS);
      len:=len-WW;
    UNTIL wi<=0; 


  END;
END drawarrow;


PROCEDURE cc(img:pIMAGE; from, to:TIME);
VAR col:COLTYP;
    s,h:ARRAY[0..1023] OF CHAR;
    pos:INT8;
BEGIN
  click.ops:=NIL;
  IF lums.map>0 THEN s:="Maps:(c)www.openstreetmap.org" ELSE s:="" END;
  IF (HIGH(img^)>=399) OR (lums.map=0) THEN
    Append(s, " Date:");
    DateLocToStr(from, h); Append(s,h);
    IF to<>0 THEN
      Append(s, "-");
      TimeToStr((to+localtime()) MOD 86400, h); Append(s,h);
    END;
  END;
  Colset(col, "G");
  Append(s, " Zoom:"); FixToStr(FLOAT(initzoom)-0.995+finezoom, 3, h); Append(s,h);
  drawstr(img, s, 5.0, FLOAT(HIGH(img^[0])-lums.fontysize-25), 300, 0, col, pos, 3, FALSE, click.dryrun);
END cc;


PROCEDURE ruler(img:pIMAGE);

CONST RULERY=10;
      RULERX0=20;
      RULERX1=300;

VAR lpos, rpos:POSITION;
    h:ARRAY[0..100] OF CHAR;
    r, d, e:REAL;
    m, w:CARDINAL;
    pos:INT8;
    col:COLTYP;
BEGIN
  IF (RULERX1>xsize) OR (initzoom<6) THEN RETURN END;

  xytodeg(VAL(REAL,RULERX0), VAL(REAL,RULERY), lpos);
  xytodeg(VAL(REAL,RULERX1), VAL(REAL,RULERY), rpos);
  d:=1000.0*distance(lpos, rpos);
  IF d=0.0 THEN RETURN END;

  r:=d;
  m:=1;
  WHILE r>=10.0 DO r:=r*0.1; m:=m*10 END;
  e:=r;
  IF r>=5.0 THEN r:=5.0 ELSIF r>=2.0 THEN r:=2.0 ELSE r:=1.0 END;
  e:=r/e*FLOAT(RULERX1-RULERX0);
  vector(img, FLOAT(RULERX0), FLOAT(RULERY), FLOAT(RULERX0)+e, FLOAT(RULERY), 0,120,100, 200, 0.0);
  vector(img, FLOAT(RULERX0), FLOAT(RULERY)-3, FLOAT(RULERX0), FLOAT(RULERY+3), 0,120,100, 200, 0.0);
  vector(img, FLOAT(RULERX0)+e, FLOAT(RULERY)-3, FLOAT(RULERX0)+e, FLOAT(RULERY+3), 0,120,100, 200, 0.0);
  m:=m*trunc(r);
  w:=m;
  IF w>=1000 THEN w:=w DIV 1000 END;
  IntToStr(w, 1, h);
  IF m>=1000 THEN Append(h, "km") ELSE Append(h, "m") END;
  Colset(col, "G");
  drawstr(img, h, FLOAT(RULERX0)+e*0.5-15.0, FLOAT(RULERY), 250, 0, col, pos, 0, TRUE, click.dryrun);
END ruler;


PROCEDURE shine(image:pIMAGE; lum:INTEGER);
CONST VIS=80.0;
      PEAK=1000.0;

VAR x,y,max:INTEGER;
    f,c,rr,gg,bb:CARDINAL;
    done:BOOLEAN;
    ex:REAL; 

  PROCEDURE smoo(x:INTEGER):INTEGER;
  BEGIN IF x<=0 THEN RETURN x ELSE RETURN trunc(exp(ln(FLOAT(x)/VIS)*ex)*VIS) END; END smoo;

--BEGIN RETURN trunc(FLOAT(x)/FLOAT(max)*5000.0) END smoo;
 
BEGIN
  max:=trunc(VIS)+1;
  FOR y:=0 TO VAL(INTEGER,HIGH(image^[0])) DO
    FOR x:=0 TO VAL(INTEGER,HIGH(image^)) DO 
      WITH image^[x][y] DO IF g>max THEN max:=g END; END;
    END;
  END;
  ex:=ln(PEAK/VIS)/ln(FLOAT(max)/VIS);
  IF ex>1.5 THEN ex:=1.5 END;

--WrInt(max, 10);WrFixed(ex, 3,10);WrLn;

  FOR y:=0 TO VAL(INTEGER,HIGH(image^[0])) DO
    FOR x:=0 TO VAL(INTEGER,HIGH(image^)) DO
      WITH image^[x][y] DO
        r:=smoo(r);
        g:=smoo(g);
        b:=smoo(b);
      END;
    END;
  END;

  REPEAT
    done:=TRUE;
    FOR y:=2 TO VAL(INTEGER,HIGH(image^[0])-2) DO
      FOR x:=2 TO VAL(INTEGER,HIGH(image^)-2) DO
        WITH image^[x][y] DO
          c:=r DIV 2;
          IF g>c THEN c:=g END;
          IF b>c THEN c:=b END;
          IF c>=256 THEN
            rr:=0;
            gg:=0;
            bb:=0;
            f:=65535 DIV c;
            c:=r*f DIV 256;
            IF r>c THEN rr:=(r-c) DIV 10 END;
            r:=c;
            c:=g*f DIV 256;
            IF g>c THEN gg:=(g-c) DIV 12 END;
            g:=c;
            c:=b*f DIV 256;
            IF b>c THEN bb:=(b-c) DIV 12 END;
            b:=c;
            WITH image^[x-1][y-1] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x-1][y  ] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x-1][y+1] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x+1][y-1] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x+1][y  ] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x+1][y+1] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x  ][y+1] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x  ][y-1] DO INC(r, rr); INC(g, gg); INC(b, bb) END;
            WITH image^[x-2][y  ] DO INC(r, rr DIV 2); INC(g, gg DIV 2 ); INC(b, bb DIV 2) END;           
            WITH image^[x+2][y  ] DO INC(r, rr DIV 2); INC(g, gg DIV 2 ); INC(b, bb DIV 2) END;           
            WITH image^[x  ][y-2] DO INC(r, rr DIV 2); INC(g, gg DIV 2 ); INC(b, bb DIV 2) END;           
            WITH image^[x  ][y+2] DO INC(r, rr DIV 2); INC(g, gg DIV 2 ); INC(b, bb DIV 2) END;           

            done:=FALSE;
          END;
        END;
      END;
    END;
  UNTIL done;

  FOR y:=0 TO VAL(INTEGER,HIGH(image^[0])) DO
    FOR x:=0 TO VAL(INTEGER,HIGH(image^)) DO
      WITH image^[x][y] DO
        r:=r*lum DIV 512;
        g:=g*lum DIV 512;
        b:=b*lum DIV 512;
      END;
    END;
  END;
END shine;

PROCEDURE makebw(p:pIMAGE);
VAR x,y,w:CARDINAL;
BEGIN
  FOR y:=0 TO HIGH(p^[0]) DO
    FOR x:=0 TO HIGH(p^) DO 
      WITH p^[x][y] DO
        w:=(VAL(CARDINAL,r)*340 + VAL(CARDINAL,g)*550 + VAL(CARDINAL,b)*110) DIV 1000;
        r:=w;
        g:=w;
        b:=w; 
      END;
    END; 
  END;
END makebw;



(*
PROCEDURE lim(n:CARDINAL):CARD16;
BEGIN IF n>MAX(CARD16) THEN RETURN MAX(CARD16) ELSE RETURN n END; END lim;
*)


PROCEDURE addpix(VAR s, a:PIX);
BEGIN
(*
   h:=s.r + a.r; IF h>MAX(CARD16) THEN s.r:=MAX(CARD16) ELSE s.r:=h END;
   h:=s.g + a.g; IF h>MAX(CARD16) THEN s.g:=MAX(CARD16) ELSE s.g:=h END;
   h:=s.b + a.b; IF h>MAX(CARD16) THEN s.b:=MAX(CARD16) ELSE s.b:=h END;
*)
   INC(s.r, a.r);
   INC(s.g, a.g);
   INC(s.b, a.b);
END addpix;


PROCEDURE addmap(image, map:pIMAGE);
VAR x,y:INTEGER;
BEGIN
  FOR x:=0 TO VAL(INTEGER,HIGH(image^)) DO
    FOR y:=0 TO VAL(INTEGER,HIGH(image^[0])) DO 
      addpix(image^[x][y], map^[x][y]);
(*
      image^[x+xsize*y].r:=lim(map^[x+xsize*y].r + image^[x+xsize*y].r);
      image^[x+xsize*y].g:=lim(map^[x+xsize*y].g + image^[x+xsize*y].g);
      image^[x+xsize*y].b:=lim(map^[x+xsize*y].b + image^[x+xsize*y].b);
*)
    END;
  END;
END addmap;

(*
PROCEDURE openppm(fn:ARRAY OF CHAR; verb:BOOLEAN):File;
VAR fd:File;
    line:INTEGER;
    ch, cho:CHAR;
BEGIN
  cleanfilename(fn);
  fd:=OpenRead(fn);
  IF NOT FdValid(fd) THEN 
    IF verb THEN WrStr(fn); WrStrLn(" not found"); END;
    RETURN InvalidFd;
  END;
 
  line:=0;
  cho:=0C;
  LOOP
    IF RdBin(fd, ch, 1)<>1 THEN 
      WrStr(fn); WrStrLn(" read error"); Close(fd); RETURN InvalidFd
    END;
    IF ch=LF THEN INC(line) END; 
    IF line=3 THEN EXIT END;
    IF (ch="#") & (cho=LF) THEN DEC(line) END;
    cho:=ch;
  END;
  RETURN fd
END openppm; 
*)


PROCEDURE mapname(x, y, zoom:INTEGER; VAR fn, reqn:ARRAY OF CHAR);
VAR hh:ARRAY[0..20] OF CHAR;
    path:ARRAY[0..1000] OF CHAR;
BEGIN
    fn[0]:=0C;
    confstr(fOSMDIR, path);
    Append(fn, path);
    Append(fn, DIRSEP);
    Append(fn, lums.mapname);  
    Append(fn, DIRSEP);
--WrInt(zoom,6);WrInt(x,6);WrInt(y,6);WrStrLn(" zoom x y");
    IntToStr(zoom, 1, hh);
    Append(fn, hh);
    Append(fn, DIRSEP);
--    Append(fn, hh);

    reqn[0]:=0C;
    Append(reqn, lums.mapname);
    Append(reqn," ");
    Append(reqn, hh);
    Append(reqn," ");
(*
    IntToStr(x, 1, hh);

    Append(fn,"-");
    Append(fn, hh);
    Append(fn,"-");
*)
     IntToStr(x, 1, hh);
     Append(fn, hh);
     Append(fn, DIRSEP);

    Append(reqn, hh);
    Append(reqn," ");

    IntToStr(y, 1, hh);  
    Append(fn, hh);
--    Append(fn,".png");
    Append(reqn,hh);
    Append(reqn, LF);
END mapname;


PROCEDURE squaredelay(c:CARDINAL):CARDINAL;
VAR n:CARDINAL;
BEGIN
  n:=1;
  WHILE c>0 DO INC(n,n); DEC(c) END;
  RETURN n-1;
END squaredelay;


PROCEDURE decodetile(fn-:ARRAY OF CHAR; ppngbuf:pPNGBUF; maxx, maxy, maxxbyte:INTEGER):BOOLEAN;
VAR s:ARRAY[0..99] OF CHAR;
BEGIN
  Assign(s, fn); Append(s, PNGEXT);
  IF ppngbuf<>NIL THEN
    IF (pngread.readpng(s, ppngbuf^, maxx, maxy, maxxbyte)>=0)               (* normal png in .png *)
    OR (readjpg(s, ppngbuf^, maxx, maxy, maxxbyte)>=0) THEN RETURN TRUE END; (* jpg hided in .png *)
  ELSIF Exists(s) THEN RETURN TRUE END;

  Assign(s, fn); Append(s, JPGEXT);
  IF ppngbuf<>NIL THEN RETURN readjpg(s, ppngbuf^, maxx, maxy, maxxbyte)>=0 END; (* jpg in .jpg *)

  RETURN Exists(s)
END decodetile;

(*
PROCEDURE existsimg(fn-:ARRAY OF CHAR):BOOLEAN;
VAR s:ARRAY[0..99] OF CHAR;
BEGIN
  Assign(s, fn); Append(s, PNGEXT);
  IF Exists(s) THEN RETURN TRUE END;
  Assign(s, fn); Append(s, JPGEXT);
  RETURN Exists(s)
END existsimg;
*)

PROCEDURE reqmap(wfn:ARRAY OF CHAR; byop:BOOLEAN);  (* append filename of missing tiles to file, 0C is flush *)

CONST MAPLOADPROGSTARTDELAY=10;
      MINSPACE=80;

VAR s,h:ARRAY[0..999] OF CHAR;
    fd:File;
    lb:CARDINAL;
BEGIN
--WrStr(">");WrStr(wfn);
  IF NOT byop THEN mapdelay:=0 END;
  IF mapnamesdone=1 THEN                                (* filled buffer written *)
    mapnamesdone:=0;
    IF NOT Exists(MAPGETFN) THEN                        (* a maploader is at work *)
      IF byop & (wfn[0]<>0C) & (InStr(mapnamesbuf, wfn)>=0) THEN mapnamesdone:=2 ELSE maploopcnt:=0 END;
    END;
    mapnamesbuf[0]:=0C;
  END;

  IF (maploopcnt<5) OR (mapnamesbuf[0]=0C) THEN Append(mapnamesbuf, wfn) END; (* store 1 line if looping *)
  lb:=Length(mapnamesbuf);
  IF (lb>0) & ((wfn[0]=0C) OR (lb+MINSPACE>=SIZE(mapnamesbuf))) THEN  (* namebuffer full or flush *)

--WrInt(maploopcnt, 10); WrInt(mapdelay, 10); WrInt(realtime-lastmapreq, 10); WrInt(realtime, 15); WrInt(lastmapreq, 15); WrStrLn(" delay");  
    IF lastmapreq + mapdelay + squaredelay(maploopcnt)<=realtime THEN

      IF mapnamesdone=2 THEN                                           (* looping mapload *)
        IF maploopcnt>=4 THEN textautosize(0, 0, 5, 10, "e", "get no map from downloader") END;
        IF maploopcnt<8 THEN INC(maploopcnt) END;
      END; 

      fd:=OpenWrite(MAPGETFN);
      IF FdValid(fd) THEN
        WrBin(fd, mapnamesbuf, lb);
        Close(fd);
        IF verb THEN WrStr("try:");WrInt(maploopcnt, 1); WrStrLn(" written gettiles:"); WrStr(mapnamesbuf) END;
        lastmapreq:=realtime;
        mapdelay:=0; 

        IF maploadstart+MAPLOADPROGSTARTDELAY<realtime THEN   (* delay for new start *)
--WrStrLn("cp");
          IF maploadpid.runs THEN CheckProg(maploadpid) END;
          IF NOT maploadpid.runs THEN                         (* start map load task *) 
--WrStrLn("ps");
            confstr(fGETMAPS, s);                                      (* maploader program name *)
            IF s[0]<>0C THEN
              confstr(fOSMDIR, h);
              IF h[0]<>0C THEN Append(s, ' -r "'); Append(s, h) ; Append(s, '"') END;  (* add -r rootdir *)
              StartProg(s, maploadpid);
              IF maploadpid.runs THEN 
                maploadstart:=realtime;
                textautosize(0, 0, 4, 3, "g", "Start Mapdownload");
              ELSE h:="can not start "; Append(h, s); xerrmsg(h); refresh:=TRUE END; 
            END;
          END;
        ELSIF maploadstart>realtime THEN maploadstart:=0 END;      (* if clock jumped back *)

      ELSE WrStrLn("cannot write "+MAPGETFN) END;
    ELSIF lastmapreq>realtime THEN lastmapreq:=realtime END;       (* systime gone backward *)
    mapnamesdone:=1;
  END;
END reqmap;


PROCEDURE loadmap(map:pIMAGE; tx,ty,zoom:INTEGER; fzoom, shftx, shfty:REAL;
                  VAR done, blown:BOOLEAN; blow, dryrun:BOOLEAN);
  PROCEDURE zoommap;
  VAR x, y, y0, rr, gg, bb, mul, mum, yi, yim:INTEGER;
      r:REAL;
      tr:CARDINAL;
  BEGIN
    y0:=VAL(INTEGER,HIGH(map^[0])+1)-VAL(INTEGER, FLOAT(HIGH(map^[0])+1)/fzoom);
    FOR x:=HIGH(map^) TO 0 BY -1 DO
      r:=FLOAT(x)/fzoom;
      tr:=trunc(r);
      mul:=VAL(INTEGER, 256.0*(r-FLOAT(tr)));
      mum:=256-mul;
      FOR y:=HIGH(map^[0]) TO y0 BY -1 DO
        WITH map^[tr+1][y] DO
          rr:=r*mul;
          gg:=g*mul;
          bb:=b*mul;
        END;
        WITH map^[tr][y] DO
          INC(rr, r*mum);
          INC(gg, g*mum);
          INC(bb, b*mum);
        END;
        WITH map^[x][y] DO r:=rr DIV 256; g:=gg DIV 256; b:=bb DIV 256 END;
      END;
    END;
    FOR y:=0 TO VAL(INTEGER,HIGH(map^[0])) DO
      r:=FLOAT(VAL(INTEGER,HIGH(map^[0]))-y)/fzoom;
--      yi:=VAL(INTEGER,HIGH(map^[0]))-VAL(INTEGER, r); 
--      tr:=TRUNC(r);
      tr:=trunc(r);
      yi:=HIGH(map^[0])-tr;
      mul:=VAL(INTEGER, 256.0*(r-FLOAT(tr)));
      mum:=256-mul;
      IF yi>0 THEN yim:=yi-1 ELSE yim:=0 END;
      FOR x:=0 TO VAL(INTEGER,HIGH(map^)) DO
        WITH map^[x][yim] DO
          rr:=r*mul;
          gg:=g*mul;
          bb:=b*mul;
        END;
        WITH map^[x][yi] DO
          INC(rr, r*mum);
          INC(gg, g*mum);
          INC(bb, b*mum);
        END;
        WITH map^[x][y] DO r:=rr DIV 256; g:=gg DIV 256; b:=bb DIV 256 END;
      END;
    END;
  END zoommap;


  PROCEDURE loadtile(h-, wfn-:ARRAY OF CHAR; dx,dy:INTEGER; doubx, douby:CARDINAL):BOOLEAN;
  VAR x,y, xx, yy, ix, iy:INTEGER;  
      maxx, maxy, maxxbyte:INTEGER;

    PROCEDURE col(c:INTEGER):CARD16;
    BEGIN

      INC(c, lums.maplumcorr);
      IF c<0 THEN c:=0 END;
      RETURN VAL(CARDINAL, c)*VAL(CARDINAL, lums.map) DIV 256; 

(*
      RETURN (c)*VAL(CARDINAL,lums.map) DIV 256;
*)
    END col;

  BEGIN
    IF dryrun THEN
      IF decodetile(h, NIL, 0, 0, 0) THEN RETURN TRUE ELSE done:=FALSE; RETURN FALSE END;
    END;
    IF map=NIL THEN RETURN FALSE END;

    maxx:=TILESIZE;
    maxy:=TILESIZE;
    maxxbyte:=maxx*3;
    IF verb THEN WrStr("open>");WrStr(h);WrStrLn("<") END;
--    IF (pngread.readpng(h, pngbuf, maxx, maxy, maxxbyte)<0) OR reloadmap THEN
    IF NOT decodetile(h, ADR(pngbuf), maxx, maxy, maxxbyte) OR reloadmap THEN  
      IF wfn<>"" THEN 
        IF configon(fGETMAPS) OR mappack.run OR reloadmap THEN reqmap(wfn, NOT reloadmap) END;
        done:=FALSE;
      END; 
      FOR y:=dy TO dy+TILESIZE-1 DO
        FOR x:=dx TO dx+TILESIZE-1 DO 
          IF (x>=0) & (x<VAL(INTEGER,HIGH(map^)+1)) & (y>=0) & (y<VAL(INTEGER,HIGH(map^[0])+1)) THEN
            WITH map^[x][y] DO r:=0; g:=0; b:=0; END;
          END;
        END;
      END;
      RETURN FALSE;

    END;

    IF doubx>0 THEN                                       (* use half zoom tile and double size *) 
      IF douby=1 THEN yy:=0; y:=TILESIZE-1; iy:=-1 ELSE yy:=TILESIZE DIV 2; y:=0; iy:=1 END;
      REPEAT
        IF doubx=1 THEN xx:=0; x:=TILESIZE-1; ix:=-1 ELSE xx:=TILESIZE DIV 2; x:=0; ix:=1 END; 
        REPEAT 
          pngbuf[y]^[x]:=pngbuf[yy+y DIV 2]^[xx+x DIV 2];
--        pngbuf[y]^[x].r8:=255;
          INC(x, ix);
        UNTIL (x<0) OR (x>TILESIZE-1);
        INC(y, iy);
      UNTIL (y<0) OR (y>TILESIZE-1);
    END;

    FOR y:=0 TO TILESIZE-1 DO
      yy:=TILESIZE-1-y+dy;
      FOR x:=0 TO TILESIZE-1 DO
        xx:=x+dx;
        IF (xx>=0) & (xx<VAL(INTEGER,HIGH(map^)+1)) & (yy>=0) & (yy<VAL(INTEGER,HIGH(map^[0])+1)) THEN
          WITH map^[xx][yy] DO
--          IF add THEN
--            INC(r, col(pngbuf[y]^[x].r8));
--            INC(g, col(pngbuf[y]^[x].g8));
--            INC(b, col(pngbuf[y]^[x].b8));
--          ELSE
              r:=col(pngbuf[y]^[x].r8);
              g:=col(pngbuf[y]^[x].g8);
              b:=col(pngbuf[y]^[x].b8);
--          END;
          END;
        END;
      END;
    END;
    RETURN TRUE
  END loadtile;

VAR x, y, maxtil, dx, dy, xh, yh:INTEGER;
    fnn, wfn:ARRAY[0..4095] OF CHAR;
    ok:BOOLEAN;
BEGIN
  done:=TRUE;
  blown:=FALSE;
--  FILL(map, 0C, SIZE(PIX)*xsize*ysize);

  maxtil:=trunc(expzoom(zoom))-1;
  yh:=VAL(INTEGER, FLOAT(HIGH(map^[0]))/fzoom+shfty) DIV TILESIZE;
  xh:=VAL(INTEGER, FLOAT(HIGH(map^))/fzoom+shftx) DIV TILESIZE;
--  IF ((tx+1>=maxtil) OR (ty+1>=maxtil)) & NOT dryrun THEN clr(map) END;
--  FOR y:=0 TO VAL(INTEGER, FLOAT(HIGH(map^[0]))/fzoom+shfty) DIV TILESIZE DO
--    FOR x:=0 TO VAL(INTEGER, FLOAT(HIGH(map^))/fzoom+shftx) DIV TILESIZE DO

  IF ((tx+xh>maxtil) OR (ty+yh>maxtil)) & NOT dryrun THEN clr(map) END;
  FOR y:=0 TO yh DO
    FOR x:=0 TO xh DO
      IF (tx+x<=maxtil) & (ty+y<=maxtil) THEN
        mapname(tx+x, ty+y, zoom, fnn, wfn);
        dx:=x*TILESIZE-VAL(INTEGER,shftx);
        dy:=VAL(INTEGER,HIGH(map^[0])+1)-TILESIZE-y*TILESIZE+VAL(INTEGER,shfty);
        IF NOT loadtile(fnn, wfn, dx, dy, 0, 0) & (zoom>4) & NOT dryrun & blow THEN
          mapname((tx+x) DIV 2, (ty+y) DIV 2, zoom-1, fnn, wfn);
          ok:=loadtile(fnn, "", dx, dy, (tx+x) MOD 2+1, (ty+y) MOD 2+1);
          IF ok THEN blown:=TRUE END;                       (* we have inserted a blown up tile *)
        END;
      END;
    END;
  END;
  IF NOT dryrun THEN
    IF fzoom>1.0 THEN zoommap END;
    IF mapnamesbuf[0]<>0C THEN 
      reqmap("", NOT reloadmap);                              (* flush buffer *)
    ELSE Erase(MAPGETFN, ok) END;                             (* forget whipe over requests *)
  END; 
  reloadmap:=FALSE;
END loadmap;


PROCEDURE IsMapLoaded():BOOLEAN;
BEGIN RETURN NOT maploadpid.runs OR NOT Exists(MAPGETFN) END IsMapLoaded;



PROCEDURE MapPackageJob(dryrun:BOOLEAN);

  PROCEDURE inc(VAR x, y, z:INTEGER):BOOLEAN;
  VAR tx0, tx1, ty0, ty1:INTEGER;

    PROCEDURE margin;
    VAR maxtil:INTEGER;
        px, py:REAL;
    BEGIN
      WITH mappack DO
        mercator(leftup.long, leftup.lat, z, tx0, ty0, px, py);
        mercator(rightdown.long, rightdown.lat, z, tx1, ty1, px, py);
        maxtil:=trunc(expzoom(z))-1;
        IF tx0>maxtil THEN tx0:=maxtil END;
        IF tx1>maxtil THEN tx1:=maxtil END;
        IF ty0>maxtil THEN ty0:=maxtil END;
        IF ty1>maxtil THEN ty1:=maxtil END;
      END;
    END margin;
    
  BEGIN
    IF z=0 THEN
      z:=1;
      margin;
      x:=tx0;
      y:=ty0;
    ELSE
      margin;
      INC(x);
      IF x>tx1 THEN
        x:=tx0;
        INC(y);
        IF y>ty1 THEN
          INC(z);
          IF z>mappack.tozoom THEN RETURN FALSE END;

          margin;
          x:=tx0;
          y:=ty0;
        END;
      END;
    END;
    RETURN TRUE
  END inc;

  PROCEDURE checktile(fn:ARRAY OF CHAR):BOOLEAN;
  VAR maxx, maxy, maxxbyte:INTEGER;
  BEGIN
    maxx:=TILESIZE;
    maxy:=TILESIZE;
    maxxbyte:=maxx*3;
--    RETURN pngread.readpng(fn, pngbuf, maxx, maxy, maxxbyte)>=0
    RETURN decodetile(fn, ADR(pngbuf), maxx, maxy, maxxbyte)
  END checktile;



CONST MAXREQ=10;
      MAXRETRYS=10;
      MAXLOOKUP=500000;
VAR x, y, z:INTEGER;
    fn, rfn:ARRAY[0..4095] OF CHAR;
    rcnt:CARDINAL;

BEGIN
  WITH mappack DO
    
    IF dryrun THEN
      REPEAT
        IF zoom>0 THEN                                           (* zoom 0 is init *)
          mapname(tx, ty, zoom, fn, rfn);
          IF NOT decodetile(fn, NIL, 0, 0, 0) THEN 
            INC(needcnt);
            IF needcnt>MAXLOOKUP THEN overflow:=TRUE END;        (* to long calculation time *)
          END;
          INC(mapscnt);
        END;
      UNTIL NOT inc(tx, ty, zoom) OR overflow;
      RETURN

    ELSIF NOT run THEN RETURN END;

    IF delay+1<retrys*retrys THEN INC(delay); RETURN END;        (* increasing delay *)

    delay:=0;

    IF IsMapLoaded() THEN                                        (* check what have *)
--WrStrLn("gettiles deleted");
      LOOP
        IF zoom>0 THEN                                           (* zoom 0 is init *)
          mapname(tx, ty, zoom, fn, rfn);
          IF NOT checktile(fn) THEN
            IF retrys<MAXRETRYS THEN EXIT END;

            INC(givups);
          END;
          INC(donecnt); 
          retrys:=0;
        END; 
        IF NOT inc(tx, ty, zoom) THEN 
          run:=FALSE;
          downloadprogress;                                      (* say end of job *)
          RETURN

        END;                                                     (* all done *)
      END;
      downloadprogress;
      rcnt:=0;
      x:=tx;
      y:=ty;
      z:=zoom;
      REPEAT
        mapname(x, y, z, fn, rfn);
        IF NOT checktile(fn) THEN
          reqmap(rfn, FALSE);
          INC(rcnt);
        END;
      UNTIL NOT inc(x, y, z) OR (rcnt>=MAXREQ);                  (* last map *)
      reqmap("", FALSE);                                         (* flush request buffer *) 
      IF retrys>0 THEN INC(retrysum) END;
      INC(retrys);
    END;
  END;

END MapPackageJob;


PROCEDURE StartMapPackage(lu, rd:POSITION; tillzoom:INTEGER; dryrun:BOOLEAN);
BEGIN
  
  FILL(ADR(mappack), 0C, SIZE(mappack));
  WITH mappack DO
    leftup:=lu;
    rightdown:=rd;
    tozoom:=tillzoom;
    run:=NOT dryrun;
  END;
  IF dryrun THEN MapPackageJob(TRUE) END;

END StartMapPackage;







PROCEDURE loadsym(h:ARRAY OF CHAR);

TYPE ROWS=ARRAY[0..SYMX*SYMN-1] OF PIX8;
     pROWS=POINTER TO ROWS;

VAR x, y:CARDINAL;
    rows:ARRAY[0..SYMY-1] OF pROWS;
    maxx, maxy, maxxbyte, res:INTEGER;
    bu:ARRAY[0..SYMY-1] OF ARRAY[0..SYMX*SYMN*3-1] OF CHAR;

BEGIN
  FOR y:=0 TO HIGH(rows) DO rows[y]:=ADR(bu[y][0]) END;
  maxx:=SYMX*SYMN;
  maxy:=SYMY;
  maxxbyte:=maxx*3;
  res:=pngread.readpng(h, rows, maxx, maxy, maxxbyte);
  IF res<0 THEN WrInt(res, 1); WrStrLn(" symbol file read error"); RETURN END;

  FILL(ADR(symbols), 0C, SIZE(symbols));
  FOR y:=0 TO SYMY-1 DO
    FOR x:=0 TO SYMX*SYMN-1 DO 
      WITH symbols[x][SYMY-1-y] DO
        r8:=rows[y]^[x].r8;
        g8:=rows[y]^[x].g8;
        b8:=rows[y]^[x].b8;
      END;
    END;
  END;
END loadsym;


PROCEDURE sinc(x:REAL; w:CARDINAL):REAL;          (* sin(x)/x with hann windown *)
VAR win:REAL; 
BEGIN
  IF ABS(x)<0.001 THEN RETURN 1.0 END;
  win:=3.1415926535*x/FLOAT(w);
  x:=x*3.1415926535;
  RETURN sin(x)/x*sin(win)/win
END sinc;


PROCEDURE loadfont;
CONST MAXY=24;                          (* font image max y size *)
      MAXX=600;                         (* font image max x size *)  
      CHARX=6;                          (* chars x size pixel *)
      MINWIDTH=3;
      GARBAGE=500;                      (* sum of pixels outside y font image *)     
      FIRLEN=3;

TYPE ROWS=ARRAY[0..MAXX-1] OF CHAR;
     pROWS=POINTER TO ROWS;

VAR c, x, y, xshift, y0, y1, fonty, i, higth:CARDINAL;
    m:SET16;
    maxx, maxy, maxxbyte, res:INTEGER; 
    rows:ARRAY[0..MAXY-1] OF pROWS; 
    bu:ARRAY[0..MAXY-1] OF ARRAY [0..MAXX-1] OF CHAR;
    xhist:ARRAY[0..CHARX-1] OF CARDINAL;
    yhist:ARRAY[0..MAXY-1] OF CARDINAL;
    fir:ARRAY[0..MAXY+FIRLEN*2] OF REAL;
    sum, yr:REAL;
    nin:CARDINAL;
    fn:ARRAY[0..1024] OF CHAR;
BEGIN
  higth:=conf2int(fFONTSIZE, 0, MINFONTY, MAXFONTY, DEFAULTFONTY);
  FILL(ADR(font), 0C, SIZE(font));

  FOR y:=0 TO HIGH(rows) DO rows[y]:=ADR(bu[y][0]) END;
  maxx:=MAXX;
  maxy:=MAXY;
  maxxbyte:=maxx;
  fn:=FONTFN;
  res:=pngread.readpng(fn, rows, maxx, maxy, maxxbyte);

  IF (res<0) OR (maxx<1) OR (maxx>MAXX) OR (maxy<1) OR (maxy>MAXY)
  THEN 
    WrInt(res, 1);
    WrStrLn(" fontfile read error");
    lums.fontysize:=higth+3;
    RETURN
  END;


  FOR x:=0 TO CHARX-1 DO xhist[x]:=0 END;
  FOR y:=0 TO MAXY-1 DO yhist[y]:=0 END;
  FOR x:=0 TO VAL(CARDINAL, maxx-1) DO     (* make column histogram to find char position in font file *)
    FOR y:=0 TO VAL(CARDINAL, maxy-1) DO 
      INC(xhist[x MOD CHARX], ORD(rows[y]^[x]));
      INC(yhist[y], ORD(rows[y]^[x]));
    END;
  END;
  c:=MAX(CARDINAL);
  FOR x:=0 TO CHARX-1 DO 
    IF xhist[x]<c THEN c:=xhist[x]; xshift:=x END;          (* find space between chars *)
  END;
  y0:=0;
  y1:=0;
  FOR y:=0 TO MAXY-1 DO                                     (* find y position and size *)
    IF yhist[y]>GARBAGE THEN
      IF y0=0 THEN y0:=y END;
      y1:=y;
    END;
  END;
  IF y1<y0+4 THEN WrStrLn(" font too small error"); RETURN END;
(*
  fonty:=y1-y0+3;
  IF fonty>MAXFONTY THEN
    WrStrLn(" font too high");
    fonty:=MAXFONTY; 
  END;
*)
  nin:=y1-y0+1;
--WrInt(y0, 10); WrInt(y1, 10); WrLn;

  fonty:=higth+3;
  FOR y:=0 TO HIGH(fir) DO fir[y]:=0.0 END;
  FOR x:=0 TO CHARS*CHARX-1 DO
    FOR y:=0 TO nin-1 DO fir[y+FIRLEN]:=FLOAT(ORD(rows[y0+y]^[x+xshift])) END;

--FOR y:=0 TO HIGH(fir) DO WrInt(trunc(fir[y]), 8); END; WrLn;

    FOR y:=0 TO higth-1 DO
      IF higth<>nin THEN
        yr:=FLOAT(y*nin)/FLOAT(higth);
        sum:=0.0;
        FOR i:=1 TO FIRLEN*2 DO
          sum:=sum + sinc(FLOAT(i)-FIRLEN-(yr-FLOAT(trunc(yr))), FIRLEN)*FLOAT(fir[i+trunc(yr)]);
        END;
      ELSE sum:=fir[y+FIRLEN] END;
      IF sum<=0.0 THEN c:=0 ELSIF sum>255.9 THEN c:=255 ELSE c:=trunc(sum) END;
      font[x DIV CHARX].char[fonty-y-3][x MOD 6]:=c;
    END;
  END;

(*
  FOR y:=0 TO fonty-3 DO
    FOR x:=0 TO CHARS*CHARX-1 DO
      WITH font[x DIV CHARX] DO char[fonty-y-3][x MOD 6]:=ORD(rows[y0+y]^[x+xshift]) END;
    END; 
  END;
*)

  lums.fontysize:=fonty;

  FOR c:=0 TO HIGH(font) DO
    WITH font[c] DO
      width:=MINWIDTH;
      FOR y:=0 TO fonty-3 DO
        FOR x:=0 TO 7 DO
          IF char[y][x]>=128 THEN
            IF c<>0 THEN
              m:=SHIFT(SET16{0..4}, VAL(INTEGER,x)-1)*SET16{1..7};
              mask[y]:=mask[y]+m;
              IF y+1<=HIGH(mask) THEN mask[y+1]:=mask[y+1]+m END;
              IF y+2<=HIGH(mask) THEN mask[y+2]:=mask[y+2]+m END;
            END;
            IF x>width THEN width:=x END;
          END;
        END;
      END;
    END;
  END; 
END loadfont;

PROCEDURE saveppm(fn:ARRAY OF CHAR; image:pIMAGE; xsize, ysize:INTEGER):INTEGER;

CONST BMPHLEN=54;

VAR fd:File;
    h:ARRAY[0..255] OF CHAR; 
    x, y:INTEGER;
    b:ARRAY[0..32767] OF CHAR;
    len:CARDINAL;
    pngimg:pngwrite.PNGPIXMAP;
    ret:INTEGER;

  PROCEDURE numh(n, pos, size:CARDINAL);
  VAR i:CARDINAL;
  BEGIN
    FOR i:=0 TO size-1 DO
      h[pos+i]:=CHR(n MOD 256);
      n:=n DIV 256;
    END;
  END numh;   

  PROCEDURE wr(c:CARD16);
  BEGIN
    IF c<=HIGH(gammatab) THEN b[len]:=gammatab[c] ELSE b[len]:=377C END;
    INC(len);
    IF len>HIGH(b) THEN WrBin(fd, b, len); len:=0 END;
  END wr; 

  PROCEDURE pngc(c:CARD16):CARD8;
  BEGIN IF c<=HIGH(gammatab) THEN RETURN ORD(gammatab[c]) ELSE RETURN 255 END END pngc;

BEGIN
  cleanfilename(fn);
  fd:=OpenWrite(fn);
  IF NOT FdValid(fd) THEN
    WrStr(fn); WrStrLn(" not writeable");
    RETURN -1
  END;

  len:=Length(fn);                                               (* check fn if ppm or bmp *)
  IF (len>=4) & (fn[len-4]=".") & (CAP(fn[len-3])="B") 
  & (CAP(fn[len-2])="M") & (CAP(fn[len-1])="P") THEN             (* make BMP *) 
    FILL(ADR(h), 0C, SIZE(h));
    h[0]:="B";
    h[1]:="M";
    numh(((xsize*3+4) DIV 4*4)*ysize+BMPHLEN, 2, 4);             (* file len pad lines to x4 byte *)
    numh(54, 10, 4);                                             (* headerlen *)
    numh(40, 14, 4);                                             (* DWORD   biSize *)
    numh(xsize, 18, 4);                                          (* LONG    biWidth *)
    numh(ysize, 22, 4);                                          (* LONG    biHeight *)
    numh(1, 26, 2);                                              (* WORD    biPlanes *)
    numh(24, 28, 2);                                             (* WORD    biBitCount *)
    numh(0, 30, 4);                                              (* DWORD   biCompression *)
    WrBin(fd, h, BMPHLEN); 
    len:=0;
    FOR y:=0 TO ysize-1 DO
      FOR x:=0 TO xsize-1 DO
        WITH image^[x][y] DO wr(b); wr(g); wr(r) END;
      END;
      WHILE len MOD 4<>0 DO wr(0) END;                           (* pad to modulo 4 *)
    END;
    IF len>0 THEN WrBin(fd, b, len) END;
    Close(fd);
    ret:=0;

  ELSIF (len>=4) & (fn[len-4]=".") & (CAP(fn[len-3])="P")
  & (CAP(fn[len-2])="N") & (CAP(fn[len-1])="G") THEN             (* make PNG *)

    ret:=-1;
    Close(fd);
    ALLOCATE(pngimg.image, xsize*ysize*3);
    IF pngimg.image<>NIL THEN
      FOR y:=0 TO ysize-1 DO
        FOR x:=0 TO xsize-1 DO
          WITH image^[x][ysize-1-y] DO
            WITH pngimg.image^[x+y*xsize] DO red:=pngc(r); green:=pngc(g); blue:=pngc(b) END;
          END;
        END;
      END;
      pngimg.width:=xsize;
      pngimg.height:=ysize;
      ret:=pngwrite.writepng(fn, pngimg);
      DEALLOCATE(pngimg.image, xsize*ysize*3);
    ELSE WrStrLn("png write out of memory") END;

  ELSE                                                           (* ppm header *)
    h:="P6"+LF; WrBin(fd, h, Length(h));
    IntToStr(xsize, 1, h); WrBin(fd, h, Length(h));
    h:=" "; WrBin(fd, h, Length(h));
    IntToStr(ysize, 1, h); WrBin(fd, h, Length(h));
    h:=LF+"255"+LF; WrBin(fd, h, Length(h));
    len:=0;
    FOR y:=ysize-1 TO 0 BY -1 DO
      FOR x:=0 TO xsize-1 DO
        WITH image^[x][y] DO wr(r); wr(g); wr(b) END;
      END;
    END;
    IF len>0 THEN WrBin(fd, b, len) END;
    Close(fd);
    ret:=0;
  END;

  RETURN ret
END saveppm;


PROCEDURE allocimage(VAR image:pIMAGE; x, y:INTEGER);
BEGIN
--WrInt(x, 6); WrInt(y, 6); WrStrLn(" allocimage");
  IF image<>NIL THEN DEC(debugmem.screens, SIZE(image^)); DISPOSE(image); END;
  NEW(image, x, y); debugmem.req:=TSIZE(PIX)*x*y; INC(debugmem.screens, debugmem.req);
  IF image=NIL THEN WrStrLn("image out of memory"); wrheap; HALT END;
  IF verb THEN wrheap END;
END allocimage;

PROCEDURE allocpngbuf;
VAR i:CARDINAL; 
BEGIN
  FOR i:=0 TO HIGH(pngbuf) DO 
    NEW(pngbuf[i]); debugmem.req:=SIZE(pngbuf[0]); INC(debugmem.screens, debugmem.req);
    IF pngbuf[i]=NIL THEN WrStrLn("pngbuf out of memory"); wrheap; HALT END;
  END;
END allocpngbuf;



BEGIN
  maploadpid.runs:=FALSE;
  maploadstart:=0;
  loadsym("symbols.png");
--  loadfont;
  makegammatab;
  allocpngbuf;  
  mapnamesbuf[0]:=0C;
  mapnamesdone:=0;
  maploopcnt:=0;
  lastmapreq:=0;
  mapdelay:=0;
  srtmcache.fd:=InvalidFd;
END maptool.


(*
waypoints size
# text antialias
# symbol overlay
# symbol antialiasing
text colour
radiation area speed
# gamma faster
*)