IMPLEMENTATION MODULE Str;

PROCEDURE Caps(VAR s: ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(s) DO
    IF s[i]=0C THEN RETURN END;
    s[i]:=CAP(s[i]);
  END;
END Caps;

PROCEDURE Length(CONST s: ARRAY OF CHAR) : CARDINAL;
VAR i:CARDINAL;
BEGIN
  FOR i:=0 TO HIGH(s) DO
    IF s[i]=0C THEN RETURN i END;
  END;
  RETURN SIZE(s);
END Length;

PROCEDURE Copy(VAR r: ARRAY OF CHAR; CONST s: ARRAY OF CHAR);
VAR i,l:CARDINAL;
BEGIN
  l:=HIGH(r);
  IF HIGH(s)<l THEN l:=HIGH(s) END;
  FOR i:=0 TO l DO
    r[i]:=s[i];
    IF s[i]=0C THEN RETURN END;
  END;
  IF l<HIGH(r) THEN r[l+1]:=0C END;
END Copy;

PROCEDURE Append(VAR r: ARRAY OF CHAR; CONST s: ARRAY OF CHAR);
VAR i,j,l,m:CARDINAL;
BEGIN
  l:=Length(r);
  m:=l+SIZE(s);
  IF m>SIZE(r) THEN m:=SIZE(r) END;
  j:=0;
  FOR i:=l TO m-1 DO
    r[i]:=s[j];
    IF r[i]=0C THEN RETURN END;
    INC(j);
  END;
  IF m<SIZE(r) THEN r[m]:=0C END;
END Append;

PROCEDURE Insert(VAR r: ARRAY OF CHAR; CONST s: ARRAY OF CHAR; p:CARDINAL);
VAR i,l:CARDINAL;
BEGIN
  l:=Length(s);
  IF HIGH(r)>p+l THEN
    FOR i:=HIGH(r)-l TO p BY -1 DO r[i+l]:=r[i] END;
    FOR i:=0 TO l-1 DO r[p]:=s[i]; INC(p) END;
  END;
END Insert;

PROCEDURE Delete(VAR s: ARRAY OF CHAR; from,len: CARDINAL);
BEGIN
  IF len#0 THEN
    IF from<=HIGH(s) THEN
      WHILE from+len<=HIGH(s) DO
        s[from]:=s[from+len];
        IF s[from]=0C THEN RETURN END;
        INC(from);
      END;
      s[from]:=0C;
    END;
  END;
END Delete;

PROCEDURE Compare(CONST s1,s2: ARRAY OF CHAR) : INTEGER;
VAR i,l,l1,l2:CARDINAL;
BEGIN
  l1:=Length(s1);
  l2:=Length(s2);
  IF l2<l1 THEN l:=l2 ELSE l:=l1 END;
  FOR i:=0 TO l-1 DO
    IF s1[i]#s2[i] THEN
      IF s1[i]<s2[i] THEN RETURN -1 ELSE RETURN 1 END;
    END;
  END;
  IF l1=l2 THEN RETURN 0
  ELSIF l1<l2 THEN RETURN -1 ELSE RETURN 1 END;
END Compare;

PROCEDURE ToLeft(VAR s:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(s)) AND (s[i]=" ") DO INC(i) END;
  Delete(s,0,i);
END ToLeft;

PROCEDURE ExtractWord(VAR w,s:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  w[0]:=0C;
  ToLeft(s);
  i:=0;
  WHILE (s[i]#0C) & (s[i]#" ") DO
    IF i<=HIGH(w) THEN w[i]:=s[i] END;
    INC(i);
  END;
  Delete(s,0,i);
  IF i<=HIGH(w) THEN w[i]:=0C END;
END ExtractWord;

PROCEDURE StrToCard(CONST s: ARRAY OF CHAR; VAR x:LONGCARD) : BOOLEAN;
VAR i:CARDINAL;
    ok:BOOLEAN;
BEGIN
  x:=0;
  ok:=FALSE;
  FOR i:=0 TO HIGH(s) DO
    IF (s[i]>="0") & (s[i]<="9") THEN x:=x*10+(ORD(s[i])-ORD("0")); ok:=TRUE
    ELSE RETURN ok & (s[i]=0C) END;
  END;
  RETURN ok;
END StrToCard;

PROCEDURE StrToBased(CONST s:ARRAY OF CHAR; Base:CARDINAL; VAR x:LONGINT):BOOLEAN;
VAR i:CARDINAL;
    sign,ok:BOOLEAN;
BEGIN
  x:=0;
  ok:=FALSE;
  sign:=s[0]="-";
  i:=ORD(sign);
  LOOP
    IF i>HIGH(s) THEN EXIT END;
    IF s[i]<"0" THEN ok:=ok & (s[i]=0C); EXIT END;
    IF (s[i]<="9") & ((ORD(s[i])-48)<Base) THEN
      x:=x*LONGINT(Base)+((ORD(s[i])-ORD("0"))); ok:=TRUE
    ELSIF (s[i]>="A") & ((ORD(s[i])-55)<Base) THEN
      x:=x*LONGINT(Base)+(ORD(s[i])-55);
      ok:=TRUE;
    ELSE ok:=FALSE; EXIT END;
    INC(i);
  END;
  IF sign THEN x:=-x END;
  RETURN ok;
END StrToBased;



  PROCEDURE AppCh(VAR s:ARRAY OF CHAR; VAR p:CARDINAL; ch:CHAR);
  BEGIN
    IF p<SIZE(s) THEN s[p]:=ch; INC(p) END;
  END AppCh;

  PROCEDURE Max(a,b:INTEGER):INTEGER;
  BEGIN
    IF a>=b THEN RETURN a ELSE RETURN b END;
  END Max;

  PROCEDURE Exp10(i:INTEGER):REAL;
  VAR x, b:REAL;
      k:INTEGER;
  BEGIN
    IF i>0 THEN b:=10.0 ELSE b:=0.1 END;
    x:=1.0;
    FOR k:=1 TO ABS(i) DO x:=x*b END;
    RETURN x;
  END Exp10;

  PROCEDURE Convert(VAR s:ARRAY OF CHAR; VAR p:CARDINAL;
                    num:LONGCARD; len:CARDINAL; ch:CHAR; neg:BOOLEAN);
  VAR digit:ARRAY[1..11] OF CHAR;
      i, cnt:CARDINAL;
  BEGIN
    cnt:=0;
    REPEAT
      INC(cnt);
      digit[cnt]:=CHR(num MOD 10+ORD('0'));
      num:=num DIV 10;
    UNTIL num=0;
    IF neg THEN INC(cnt); digit[cnt]:='-' END;
    FOR i:=len TO cnt+1 BY -1 DO AppCh(s,p,ch) END;
    FOR i:=cnt TO 1 BY -1 DO AppCh(s,p,digit[i]) END;
  END Convert;

PROCEDURE RealToStr(VAR s:ARRAY OF CHAR; x:REAL; decimals:INTEGER; f:CARDINAL);
VAR exp:INTEGER;
    before, behind, minimal, i, p:CARDINAL;
    y:LONGCARD;
    delta,delta1,delta10:REAL;
    sign, exponential:BOOLEAN;
BEGIN
  p:=0;
  sign:=x<0.0;
  x:=ABS(x);
  IF (decimals<0) OR (x>1.0E8) THEN
    exponential:=TRUE;
    decimals:=ABS(decimals);
    minimal:=7;
  ELSE
    exponential:=FALSE;
    minimal:=3;
  END;
  f:=Max(f,minimal);
  behind:=-Max(-decimals, minimal-f);
  before:=f-behind-minimal+2;
  delta:=0.05*Exp10(-INTEGER(behind));
  delta1:=1.0-delta;
  delta10:=delta1*10.0;
  exp:=0;
  IF exponential AND (x<>0.0) THEN
    WHILE x< delta1 DO x:=x*10.0; DEC(exp) END;
    WHILE x>=delta10 DO x:=x*0.1; INC(exp) END;
  END;
  x:=x+delta;
  y:=TRUNC(x);
  Convert(s,p,y,before,' ',sign);
  x:=x-FLOAT(y);
  AppCh(s,p,".");
  WHILE behind>0 DO
    i:=-Max(-INTEGER(behind),-9);
    x:=x*Exp10(i);
    y:=TRUNC(x);
    Convert(s,p,y,i,'0',FALSE);
    x:=x-FLOAT(y);
    DEC(behind,i);
  END;
  IF exponential THEN
    AppCh(s,p,"E");
    IF exp>=0 THEN AppCh(s,p,'+') ELSE AppCh(s,p,'-') END;
    Convert(s,p,LONGCARD(ABS(exp)),2,'0',FALSE);
  END;
  IF p<SIZE(s) THEN s[p]:=0C END;
END RealToStr;

PROCEDURE EngToStr(VAR s:ARRAY OF CHAR; x:REAL; digits, f:CARDINAL);
VAR exp:INTEGER;
    i,p:CARDINAL;
    y:LONGCARD;
    delta,delta1,delta10:REAL;
    sign:BOOLEAN;
BEGIN
  p:=0;
  INC(digits,3);
  IF digits>8 THEN digits:=8 END;
  sign:=x<0.0;
  x:=ABS(x);
  i:=5+digits+ORD(sign);
  IF f<i THEN f:=i END;
  delta:=0.0005*Exp10(-INTEGER(digits-3));
  delta1:=1.0-delta;
  delta10:=delta1*10.0;
  exp:=0;
  IF x<>0.0 THEN
    WHILE x< delta1 DO x:=x*10.0; DEC(exp) END;
    WHILE x>=delta10 DO x:=x*0.1; INC(exp) END;
  END;
  x:=x+delta;
  i:=CARDINAL(exp+999) MOD 3;
  DEC(exp,INTEGER(i));
  IF i=2 THEN x:=x*100.0 ELSIF i=1 THEN x:=x*10.0 END;
  y:=TRUNC(x);
  DEC(digits,i+1);
  Convert(s,p,y,f-digits-5,' ',sign);
  x:=x-FLOAT(y);
  AppCh(s,p,'.');
  IF digits>0 THEN Convert(s,p,TRUNC(x*Exp10(digits)),digits,'0',FALSE) END;
  AppCh(s,p,'E');
  IF exp>=0 THEN AppCh(s,p,'+') ELSE AppCh(s,p,'-') END;
  Convert(s,p,LONGCARD(ABS(exp)),2,'0',FALSE);
  IF p<SIZE(s) THEN s[p]:=0C END;
END EngToStr;


PROCEDURE StrToReal(CONST s: ARRAY OF CHAR; VAR r:REAL): BOOLEAN;
VAR d:REAL;
    neg,ok:BOOLEAN;
    e,i,p:CARDINAL;
BEGIN
  ok:=FALSE;
  p:=0;
  r:=0.0;
  IF s[0]="-" THEN neg:=TRUE; INC(p) ELSIF s[0]="+" THEN neg:=FALSE; INC(p)
  ELSE neg:=FALSE END;
  WHILE (p<SIZE(s)) AND (s[p]>="0") AND (s[p]<="9") DO
    r:=r*10.0+FLOAT(ORD(s[p])-ORD("0"));
    INC(p);
    ok:=TRUE;
  END;
  IF (p<SIZE(s)) AND (s[p]=".") THEN
    INC(p);
    d:=1.0;
    WHILE (p<SIZE(s)) AND (s[p]>="0") AND (s[p]<="9") DO
      d:=d/10.0;
      r:=r+d*FLOAT(ORD(s[p])-ORD("0"));
      INC(p);
      ok:=TRUE;
    END;
    IF neg THEN r:=-r END;
    IF (p<SIZE(s)) AND (s[p]="E") THEN
      ok:=FALSE;
      INC(p);
      IF p<SIZE(s) THEN
        IF s[p]="-" THEN neg:=TRUE; INC(p);
        ELSIF s[p]="+" THEN neg:=FALSE; INC(p);
        ELSE neg:=FALSE END;
        e:=0;
        WHILE (p<SIZE(s)) AND (s[p]>="0") AND (s[p]<="9") AND (e<38) DO
          e:=e*10+ORD(s[p])-ORD("0");
          INC(p);
        END;
        d:=1.0;
        FOR i:=1 TO e DO d:=d*10.0 END;
        IF neg THEN r:=r/d ELSE r:=r*d END;
      END;
    END;
  ELSIF neg THEN r:=-r END;
  RETURN ok AND ((p=SIZE(s)) OR (s[p]=0C))
END StrToReal;

PROCEDURE CardToStr(x,f:CARDINAL; VAR s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
BEGIN
  s[HIGH(s)]:=0C;
  i:=HIGH(s);
  REPEAT
    DEC(i);
    s[i]:=CHR(x MOD 10+ORD("0"));
    x:=x DIV 10;
  UNTIL (x=0) OR (i=0);
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;
  WHILE i>f DO
    DEC(i);
    s[i]:=" ";
  END;
  IF i>0 THEN
    j:=0;
    WHILE i<=HIGH(s) DO
      s[j]:=s[i];
      INC(j);
      INC(i);
    END;
  END;
END CardToStr;

PROCEDURE IntToStr(x:INTEGER; f:CARDINAL; VAR s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
    neg:BOOLEAN;
BEGIN
  s[HIGH(s)]:=0C;
  i:=HIGH(s);
  IF x<0 THEN x:=-x; neg:=TRUE ELSE neg:=FALSE END;
  REPEAT
    DEC(i);
    s[i]:=CHR(x MOD 10+ORD("0"));
    x:=CARDINAL(x) DIV 10;
  UNTIL (x=0) OR (i=0);
  IF neg & (i>0) THEN DEC(i); s[i]:="-" END;
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;
  WHILE i>f DO
    DEC(i);
    s[i]:=" ";
  END;
  IF i>0 THEN
    j:=0;
    WHILE i<=HIGH(s) DO
      s[j]:=s[i];
      INC(j);
      INC(i);
    END;
  END;
END IntToStr;

PROCEDURE LongCardToStr(x:LONGCARD; f:CARDINAL; VAR s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
BEGIN
  s[HIGH(s)]:=0C;
  i:=HIGH(s);
  REPEAT
    DEC(i);
    s[i]:=CHR(x MOD 10+ORD("0"));
    x:=x DIV 10;
  UNTIL (x=0) OR (i=0);
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;
  WHILE i>f DO
    DEC(i);
    s[i]:=" ";
  END;
  IF i>0 THEN
    j:=0;
    WHILE i<=HIGH(s) DO
      s[j]:=s[i];
      INC(j);
      INC(i);
    END;
  END;
END LongCardToStr;

PROCEDURE LongIntToStr(x:LONGINT; f:CARDINAL; VAR s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
    neg:BOOLEAN;
BEGIN
  s[HIGH(s)]:=0C;
  i:=HIGH(s);
  IF x<0 THEN x:=-x; neg:=TRUE ELSE neg:=FALSE END;
  REPEAT
    DEC(i);
    s[i]:=CHR(x MOD 10+ORD("0"));
    x:=LONGCARD(x) DIV 10;
  UNTIL (x=0) OR (i=0);
  IF neg & (i>0) THEN DEC(i); s[i]:="-" END;
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;
  WHILE i>f DO
    DEC(i);
    s[i]:=" ";
  END;
  IF i>0 THEN
    j:=0;
    WHILE i<=HIGH(s) DO
      s[j]:=s[i];
      INC(j);
      INC(i);
    END;
  END;
END LongIntToStr;

PROCEDURE LongBasedToStr(x:LONGCARD; base:CARDINAL; f:INTEGER; VAR s:ARRAY OF CHAR);
VAR i,j:CARDINAL;
    fill:CHAR;
BEGIN
  IF f<0 THEN fill:="0"; f:=-f ELSE fill:=" " END;
  IF base<2 THEN base:=2 END;
  s[HIGH(s)]:=0C;
  i:=HIGH(s);
  REPEAT
    DEC(i);
    s[i]:=CHR(x MOD LONGCARD(base)+ORD("0"));
    IF s[i]>"9" THEN INC(s[i],7) END;
    x:=x DIV VAL(LONGCARD,base);
  UNTIL (x=0) OR (i=0);
  IF f<HIGH(s) THEN f:=HIGH(s)-f ELSE f:=1 END;
  WHILE i>CARDINAL(f) DO
    DEC(i);
    s[i]:=fill;
  END;
  IF i>0 THEN
    j:=0;
    WHILE i<=HIGH(s) DO
      s[j]:=s[i];
      INC(j);
      INC(i);
    END;
  END;
END LongBasedToStr;

END Str.
