<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*-PROCINLINE*>
<*+NOPTRALIAS*>
<*-DOREORDER *>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKDINDEX*>
<*-CHECKSET*>
<*CPU="PENTIUM"*>
<*+COMMENT*>
<* IF __GEN_C__ THEN *>
  <*+GENCTYPES*>
<* END *>

MODULE udpbox; (* axudp in/out ui/aprs stream splitter, filter, digipeater by OE5DXL *)

IMPORT udp;
FROM osi IMPORT WrLn, WrStr, WrStrLn, WrInt, WrHex;
(*FROM FdSet IMPORT FdSet, FD_ZERO, FD_SET, FD_ISSET, TimeVal;*)
FROM Select IMPORT fdclr, fdsetr, selectr, issetr;
(*FROM mlib IMPORT select*)
FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8;
FROM Storage IMPORT ALLOCATE;
FROM Lib IMPORT NextArg;
FROM TimeConv IMPORT time; 
FROM osi IMPORT OpenRead, OpenWrite, OpenAppend, Close, WrBin, RdBin, File, Erase;
FROM aprspos IMPORT GetPos, distance, POSITION, RAD, posvalid;
FROM aprsstr IMPORT TIME ,Assign, Append, Length, StrToFix,
     StrCmp, DateToStr, CtrlHex, Hash, HashCh, AppCRC, SET8, Call2Str, raw2mon, mon2raw;

CONST CALLLEN=7;
      HASHSIZE=16384;

      NOTFIRSTDIGI=3;
      NOUPLINKCHECK=4;
      SENDTRACE=5;
      SENDWIDE=6;
      DOWNPATHDIGICALL=7;
      DOWNPATHRELAY=8;
      DOWNPATHALL=9;
      NOVIADIGICALL=10;
      NOVIARELAY=11;
      NOVIATRACE=12;
      NOVIAWIDEN=13;
      NOCALLBEFOREWIDE=14;
      SSIDTOWIDE=15;
      NULLSSID=16;
      KILLWIDE=17;
      VIAGATE=18;
      RELAYECHO=19;

TYPE  UDPPORT=CARDINAL;
      IPNUM=CARDINAL;
      PATHSET=SET OF [0..31];
      SET256=SET OF [0..255];
      RAWCALL=ARRAY[0..CALLLEN-1] OF CHAR; 
      MONCALL=ARRAY[0..8] OF CHAR;
      FILENAME=ARRAY[0..1023] OF CHAR;

      pDIGIPARMS=POINTER TO DIGIPARMS;
      DIGIPARMS=RECORD
                  digicall              : RAWCALL;
                  pathcheck             : PATHSET;
                  duptime, messagetime  : TIME;
                  timehash              : ARRAY[0..HASHSIZE-1] OF TIME;
                END;

      BEACON=RECORD
               bintervall,
               piggytime : TIME;                  (* time send beacons earlier if sending some else *)
               piggyback : BOOLEAN;               (* sent something so append beacon immediately *)
               bfile     : FILENAME;
               btime     : TIME;
               bline     : CARDINAL;
             END;


      pCALLS=POINTER TO CALLS;
      CALLS=RECORD
              next      : pCALLS;
              call      : RAWCALL;
            END;

      pOUTPORT=POINTER TO OUTPORT;
      OUTPORT=RECORD
                next       : pOUTPORT;
                toip       : IPNUM;   
                toport     : UDPPORT;
                filtercalls: pCALLS;
                echo, rawwrite, crlfwrite, passnoUI, passwix: BOOLEAN;
                aprspass   : SET256;
                digiparm   : pDIGIPARMS;
                beacon     : BEACON;
                mypos      : POSITION;
                maxkm      : INTEGER;
              END;
      
      pINSOCK=POINTER TO INSOCK;
      INSOCK=RECORD
               next       : pINSOCK;
               fd         : INTEGER;
               rawread    : BOOLEAN;
               rflinkname : MONCALL;
               fromip     : IPNUM;
               bindport   : UDPPORT;
               outchain   : pOUTPORT;
             END; 

      pMSGHASH=POINTER TO MSGHASH; 
      MSGHASH=RECORD
                next    : pMSGHASH;
                usercall: MONCALL;
                msgfile : FILENAME;
                wpos    : CARDINAL;
                hash:ARRAY[0..15] OF RECORD
                  sums, ackcnt:CARDINAL;
                  acktime: TIME;
                  source : pINSOCK;
                  froms  : MONCALL;
                  acks   : ARRAY[0..5] OF CHAR;
                END;
              END;  


CONST MAXLEN=256+7*10+10+2;
      MINLEN=7*2+1+2;
      BLANKH=CHR(ORD(" ")*2);
      HBIT=128;
      ACKMSG="ack";
      POLYNOM=BITSET{3,10,15};
      cFILTPASS="p";
      cFILTDEL="d";
      DEFAULTMESSAGETIME=28;                      (* block seconds user message frames *)
      DEFAULTDUPTIME=29*60;                       (* block seconds invariant payload frames *)
      CR=015C;
      LF=012C;
      SENDACKS=4;
      OLDMSG=600;                                 (* s long kill dupe user message *)
      TOCALL="APNL01";
      DEFAULTACK="WIDE2-2";
      cUSERMSG=":";

VAR
(*
 CRCL, CRCH            : ARRAY[0..255] OF SET8;
*)
    show                  : BOOLEAN;
    insocks               : pINSOCK;
    showip                : IPNUM;
    showport              : UDPPORT;
    msgusers              : pMSGHASH; 
    ackpath               : ARRAY[0..63] OF CHAR;

PROCEDURE Err(text-:ARRAY OF CHAR);
BEGIN
  WrStr("udpbox: "); WrStr(text); WrStrLn(" error abort");
  HALT
END Err;

(*
PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;
*)


(*
PROCEDURE AppCRC(VAR frame:ARRAY OF CHAR; size:INTEGER);
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-1 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  frame[size  ]:=CAST(CHAR, l);
  frame[size+1]:=CAST(CHAR, h);
END AppCRC;
*)

(*
PROCEDURE Hash(frame-:ARRAY OF CHAR; start, end:INTEGER):CARDINAL;
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
    c:CHAR;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=start TO end-1 DO
    c:=frame[i];
    IF c<>" " THEN
      b:=CAST(CARD8, CAST(SET8, c) / l);
      l:=CRCL[b] / h;
      h:=CRCH[b];
    END;
  END;
  RETURN (ORD(CAST(CHAR, l)) + ORD(CAST(CHAR, h))*256) MOD HASHSIZE;
END Hash;
*)

(*
PROCEDURE Call2Str(r-:ARRAY OF CHAR; VAR t:ARRAY OF CHAR; pos:CARDINAL; VAR len:CARDINAL):BOOLEAN;
VAR i,e,ssid:CARDINAL;
    c:CHAR;
BEGIN
  e:=pos;
  FOR i:=pos TO pos+5 DO 
    IF r[i]<>100C THEN e:=i END;
  END; 
  FOR i:=pos TO e DO 
    c:=CHR(ASH(ORD(r[i]), -1));
    IF c<=" " THEN t[len]:=0C; len:=0; RETURN FALSE END;
    t[len]:=c;
    INC(len);
  END;
  ssid:=ASH(ORD(r[pos+6]), -1) MOD 16;
  IF ssid>0 THEN 
    t[len]:="-"; INC(len); 
    IF ssid>9 THEN t[len]:="1"; INC(len); END;
    t[len]:=CHR(ssid MOD 10 + ORD("0")); INC(len);
  END;
  RETURN TRUE
END Call2Str;
*)

PROCEDURE Stomsg(user:pMSGHASH; from-, to-, msg-, ack-:ARRAY OF CHAR; fromsock:pINSOCK);
VAR i, h : CARDINAL;
    t    : TIME;
    f    : File;
    mb   : ARRAY[0..255] OF CHAR;
BEGIN
  WITH user^ DO
    i:=0;
    WHILE (i<=HIGH(msg)) & (msg[i]<>0C) DO INC(i) END;
    t:=time();
    h:=Hash(msg, 0, i) MOD HASHSIZE;
    i:=0;
    WHILE (i<=HIGH(hash)) & NOT ((h=hash[i].sums) & (hash[i].acktime+OLDMSG>=t) 
    & StrCmp(ack, hash[i].acks) & StrCmp(from, hash[i].froms)) DO INC(i) END;
    IF i>HIGH(hash) THEN                                                        (* new msg*)

      DateToStr(t,mb);
      Append(mb, " from ");
      Append(mb, from);
      Append(mb, " to ");
      Append(mb, to);
      Append(mb, " <");
      Append(mb, msg);
      Append(mb, "> (");
      Append(mb, ack);
      Append(mb, ")");

IF show THEN  WrStr(" <"); WrStr(mb); WrStr("> "); END;

      Append(mb, 12C);

      IF msgfile[0]<>0C THEN
        f:=OpenAppend(msgfile);
        IF f<0 THEN f:=OpenWrite(msgfile) END;
        IF f>=0 THEN
          WrBin(f, mb, Length(mb));
          Close(f);
        END; 
      END;

      WITH hash[wpos] DO
        sums:=h;
        Assign(acks, ack);
        Assign(froms, from);
        IF ack[0]>" " THEN 
          ackcnt:=SENDACKS;
          acktime:=0;
        END;
        source:=fromsock;
      END;
      INC(wpos);
      IF wpos>HIGH(hash) THEN wpos:=0 END;    
    ELSE                                                                              (* old msg *)
      hash[i].ackcnt:=SENDACKS;
    END;
  END;
END Stomsg;

PROCEDURE Usermsg(b-:ARRAY OF CHAR; len,p:INTEGER; fromsock:pINSOCK; passself:BOOLEAN):BOOLEAN;
CONST THIRDPARTY="}";
      HEADEREND=":";
      FROMEND=">";
      USERACK="{";

VAR pf:INTEGER;
    j:CARDINAL; 
    user:pMSGHASH;
    from, to:ARRAY[0..8] OF CHAR;
    ack:ARRAY[0..5] OF CHAR;
    msg:ARRAY[0..68] OF CHAR;
    ok:BOOLEAN; 
BEGIN
  pf:=0;                                                              (* from whom *)
  WHILE b[p]=THIRDPARTY DO                                            (* remove third party header *)
    pf:=p+1;
    WHILE (p<len) & (b[p]<>HEADEREND) DO INC(p) END;
    INC(p);
  END;

  IF (p+10<len) & (b[p]=cUSERMSG) & (b[p+10]=cUSERMSG) THEN           (* user message *)
    INC(p); 

    j:=0;                                                             (* message from *)
    IF pf=0 THEN ok:=Call2Str(b, from, 7, j);
    ELSE
      WHILE (pf<len) & (j<=HIGH(from)) & (b[pf]<>FROMEND) DO
        from[j]:=b[pf];
        INC(pf);
        INC(j);
      END;
    END;
    WHILE j<=HIGH(from) DO from[j]:=" "; INC(j) END;

    ok:=FALSE;
    FOR j:=0 TO HIGH(to) DO                                           (* message to *)
      to[j]:=b[p+VAL(INTEGER,j)];
      IF to[j]<>from[j] THEN ok:=TRUE END;
    END;

    IF NOT ok THEN                                                    (* msk from to same call *)
IF show THEN WrStr(" msg to it self ") END;
      RETURN NOT passself

    END;
--WrStr("<"); WrStr(from); WrStr(">"); WrStr("<"); WrStr(to); WrStrLn(">");


    user:=msgusers;
    WHILE user<>NIL DO
      j:=0;
      WHILE (j<=HIGH(to)) & (user^.usercall[j]=to[j]) DO INC(j) END; 
      IF j=9 THEN 
(*
        j:=0;
        IF pf=0 THEN
          IF Call2Str(b, from, 7, j) THEN END;
        ELSE 
          WHILE (pf<len) & (j<=HIGH(from)) & (b[pf]<>FROMEND) DO from[j]:=b[pf]; INC(pf); INC(j); END;
        END;
        WHILE j<=HIGH(from) DO from[j]:=" "; INC(j) END; 

        FOR j:=0 TO 8 DO to[j]:=b[p]; INC(p) END;
*)
        INC(p,10); 

        j:=0;
        WHILE (p<len) & (j<HIGH(msg)) & (b[p]<>USERACK) DO msg[j]:=b[p]; INC(j); INC(p) END;
        msg[j]:=0C;
        
        j:=0;
        LOOP
          IF ACKMSG[j]<=" " THEN RETURN FALSE END;   (* "ack" in text field is not for delete *)
          IF ACKMSG[j]<>msg[j] THEN EXIT END;
          INC(j);
        END;

        INC(p);

        j:=0;
        WHILE (p<len) & (j<HIGH(ack)) DO ack[j]:=b[p]; INC(j); INC(p) END;
        ack[j]:=0C;

        Stomsg(user, from, to, msg, ack, fromsock);
        RETURN TRUE
      END;
      user:=user^.next;
    END; 
  END;
  RETURN FALSE
END Usermsg;


PROCEDURE CallFilt(calls:pCALLS; s-:ARRAY OF CHAR; len:INTEGER):BOOLEAN;
VAR i, j:INTEGER;
    c:pCALLS;
    b:CHAR;
    ok:BOOLEAN; 

CONST  WILDH=CHR(ORD("*")*2);
BEGIN
  i:=0;
  REPEAT
    c:=calls;
    WHILE c<>NIL DO  
      j:=0;
      LOOP
        IF (c^.call[j]<>WILDH) & (c^.call[j]<>s[i+j]) THEN EXIT END;
        INC(j);
        IF j>=CALLLEN-1 THEN 
          IF (c^.call[j]<>0C) 
          & (CAST(SET8, c^.call[j])*SET8{1..4}<>CAST(SET8, s[i+j])*SET8{1..4}) THEN EXIT END;
          RETURN TRUE
        END;
      END; 
      c:=c^.next;
    END;
    INC(i, CALLLEN);
  UNTIL (i>=len) OR ODD(ORD(s[i-1]));
  
  INC(i,2);
  IF s[i]="}" THEN
    INC(i);
    LOOP
      IF i>=len THEN EXIT END;
      c:=calls;
      WHILE c<>NIL DO
        j:=0;
        ok:=TRUE;
        LOOP
          b:=s[i+j];
          IF (i+j>=len) OR (b="*") OR (b=",") OR (b=">") OR (b=":") OR (b="-") THEN EXIT END;
          IF (j>=CALLLEN-1) OR (c^.call[j]<>WILDH) & (b<>CHR(ASH(ORD(c^.call[j]),-1))) THEN
            ok:=FALSE;
          END;
          INC(j);
        END;
        IF ok & ((j>=CALLLEN-1) OR (c^.call[j]=BLANKH)) THEN RETURN TRUE END;
        c:=c^.next;
      END;
      WHILE (i<len) & (s[i]<>",") & (s[i]<>">") & (s[i]<>":") DO INC(i) END;
      IF s[i]=":" THEN
        INC(i);
        IF s[i]<>"}" THEN EXIT END;
      END;    
      INC(i);
    END;
  END;

  RETURN FALSE;
END CallFilt;


PROCEDURE DistFilt(mypos:POSITION; b:ARRAY OF CHAR; payload, len:CARDINAL):INTEGER;
VAR i, speed, course,
    commentpos       :CARDINAL;
    alt              :INTEGER; 
    sym, symt, postyp:CHAR;
    pos              :POSITION;
BEGIN
  FOR i:=CALLLEN-1 TO 0 BY -1 DO b[i+1]:=CAST(CHAR, SHIFT(CAST(SET8,b[i]), -1)) END;
  b[len]:=0C;
  GetPos(pos, speed, course, alt, sym, symt, b, 1, payload, commentpos, postyp);
  IF posvalid(pos) THEN
    RETURN TRUNC(distance(mypos,pos))
  ELSE RETURN -1 END;
END DistFilt;  


PROCEDURE Filter(b-:ARRAY OF CHAR; len:INTEGER; parm:pOUTPORT; fromsock:pINSOCK):BOOLEAN;
VAR i:INTEGER;
    km:INTEGER;
BEGIN
  DEC(len,2);                                                      (* crc *)  
  i:=13;
  WHILE (i<len) & NOT ODD(ORD(b[i])) DO INC(i, 7) END;
  INC(i,3); 
  IF (i>len) OR (CAST(SET8, b[i-2])-SET8{4}<>SET8{0,1}) THEN 

IF show THEN WrStr(" not UI ") END;

  RETURN parm^.passnoUI END; (* not UI frame *)                                                               (* first payload byte *)
(* is UI frame *)
  IF Usermsg(b, len, i, fromsock, parm^.passwix) THEN RETURN FALSE END;  
  IF (parm^.filtercalls<>NIL) & CallFilt(parm^.filtercalls, b, len) THEN 
IF show THEN WrStr(" callfilter match") END;
    RETURN FALSE
  END; 

  IF NOT (ORD(b[i]) IN parm^.aprspass) THEN 
IF show THEN WrStr(" message type filter") END;
    RETURN FALSE
  END;

  IF (parm^.maxkm>0) & ((b[i]<>cUSERMSG) OR (b[i+10]<>cUSERMSG)) THEN  (* dist filter on and no user message *) 
    km:=DistFilt(parm^.mypos, b, i, len);
    IF km<0 THEN
IF show THEN WrStr(" no pos") END;
      RETURN FALSE
    END; 
IF show THEN WrStr(" "); WrInt(km,1); WrStr("km"); END;
    IF km>=parm^.maxkm THEN
IF show THEN WrStr(" too far") END;
      RETURN FALSE
    END;  
  END;

  RETURN TRUE;
END Filter;



PROCEDURE getudp(fd:INTEGER; VAR buf:ARRAY OF CHAR; fromip:IPNUM; addcrc:BOOLEAN):INTEGER;
VAR fromport:UDPPORT;
    ip:IPNUM;
    crc1, crc2:CHAR;
    len:INTEGER;
BEGIN
  len:=udp.udpreceive(fd, buf, SIZE(buf), fromport, ip);
  IF (len>2) & (len<CAST(INTEGER, SIZE(buf))) & ((fromip=0) OR (fromip=ip)) THEN
    showip:=ip;
    showport:=fromport;
    IF NOT addcrc THEN RETURN len END;

    crc1:=buf[len-2];
    crc2:=buf[len-1];
    AppCRC(buf, len-2);
    IF (crc1=buf[len-2]) & (crc2=buf[len-1]) THEN RETURN len 
    ELSIF show THEN 
      WrStr(" raw crc error "); 
(*
      IO.WrHex(ORD(crc1)+ORD(crc2)*256, 1);
      IO.WrStr("<>");
      IO.WrHex(ORD(buf[len-2])+ORD(buf[len-1])*256, 1);
      IO.WrStr("  ");
*)
    END; 

  END;
  RETURN -1
END getudp; 

(*
PROCEDURE mon2raw(VAR mon, raw:ARRAY OF CHAR; VAR p:INTEGER);
CONST CTRL=CHR(3);
      PID=CHR(0F0H);
      cTO=">"; 
      cVIA=",";
      cLASTCALL=":";
      cSSID="-";
      cREPEATED="*";
      MAXVIAS=8;
      MAXSSID=15;
      SSIDBASE=16*3;
      CALLFILL=" ";
      
VAR i,n,r:CARDINAL;
    

PROCEDURE call(sep1, sep2, sep3:CHAR; sbase:CARDINAL):BOOLEAN;
VAR l,s:CARDINAL; 
BEGIN
  l:=0;
  WHILE (mon[i]<>0C) & (mon[i]<>sep1) & (mon[i]<>sep2) & (mon[i]<>sep3) & (mon[i]<>cSSID) DO
    s:=ORD(mon[i])*2 MOD 256;
    IF s<=ORD(" ")*2 THEN RETURN FALSE END;
    raw[p]:=CHR(s);
    INC(p);
    INC(i);
    INC(l);
    IF l>=CALLLEN THEN RETURN FALSE END;
  END;
  WHILE l<CALLLEN-1 DO
    raw[p]:=CHR(ORD(CALLFILL)*2);
    INC(p);
    INC(l);
  END;
  s:=0;
  IF mon[i]=cSSID THEN
    INC(i);
    WHILE (mon[i]>="0") & (mon[i]<="9") DO s:=s*10 + ORD(mon[i])-ORD("0"); INC(i) END;
    IF s>MAXSSID THEN RETURN FALSE END;    
  END;
  raw[p]:=CHR((s+sbase)*2);
  INC(p);
  RETURN TRUE
END call;

BEGIN
  p:=CALLLEN;
  i:=0;
  IF NOT call(cTO, 0C, 0C, SSIDBASE) THEN p:=0; RETURN END;            (* from call *)

  p:=0;
  IF mon[i]<>cTO THEN RETURN END;                                      (* ">" *)

  INC(i);
  IF NOT call(cLASTCALL, cVIA, 0C, SSIDBASE+64) THEN p:=0; RETURN END; (* dest call bit 7 for UI v2 command *)

  p:=CALLLEN*2;
  n:=0;
  WHILE mon[i]=cVIA DO
    INC(i);
    IF NOT call(cLASTCALL, cVIA, cREPEATED, SSIDBASE) THEN p:=0; RETURN END; 

    INC(n);
    IF n>MAXVIAS THEN p:=0; RETURN END;

    IF mon[i]=cREPEATED THEN                                           (* "*" has repeatet sign *)
      INC(i);
      FOR r:=p TO CALLLEN*3 BY -CALLLEN DO raw[r-1]:=CHR(ORD(raw[r-1])+HBIT) END; (* set "has repeated" flags *)
    END;
  END;
  IF (p=0) OR (mon[i]<>cLASTCALL) THEN p:=0; RETURN END;               (* ":" start of info sign *)

  raw[p-1]:=CHR(ORD(raw[p-1]) + 1);                                    (* end address field mark *)
  raw[p]:=CTRL;
  INC(p);
  raw[p]:=PID;
  INC(p);
  INC(i);
  WHILE (mon[i]<>0C) & (i<=HIGH(mon)) DO                               (* copy info part *)
    IF p>=VAL(INTEGER, HIGH(raw))-2 THEN p:=0; RETURN END;             (* spare 2 bytes for crc *)

    raw[p]:=mon[i];
    INC(p);
    INC(i);
  END;
  AppCRC(raw,p); 
  INC(p, 2);
END mon2raw;
*)

(*
PROCEDURE raw2mon(VAR raw, mon:ARRAY OF CHAR; len:INTEGER; VAR p:CARDINAL);
VAR i:INTEGER;
BEGIN
  p:=0;
  mon[p]:=0C;
  i:=0;
  WHILE NOT ODD(ORD(raw[i])) DO 
    INC(i);
    IF i>len THEN RETURN END;                         (* no address end mark found *)
  END;
  IF i MOD 7 <> 6 THEN RETURN END;                    (* address end not modulo 7 error *)

  IF NOT Call2Str(raw,mon,7,p) THEN RETURN END; 
  mon[p]:=">"; INC(p);
  IF NOT Call2Str(raw,mon,0,p) THEN RETURN END;

  i:=14;
  WHILE (i+6<len) & NOT ODD(ORD(raw[i-1])) DO
    mon[p]:=","; INC(p);
    IF NOT Call2Str(raw,mon,i,p) THEN RETURN END;

    IF (ORD(raw[i+6])>=128) & (ODD(ORD(raw[i+6])) OR (ORD(raw[i+13])<128)) 
    THEN mon[p]:="*"; INC(p); END;
    INC(i,7);
  END;  
  INC(i,2);  (* ctrl, pid *)

  mon[p]:=":"; INC(p);

  WHILE (i<len) & (p<HIGH(mon)-1) DO 
    IF raw[i]<>0C THEN mon[p]:=raw[i]; INC(p); END; 
    INC(i);
  END;
(*
  mon[p]:=15C; INC(p);
  mon[p]:=12C; INC(p);
*)
  mon[p]:=0C; INC(p);

  mon[p]:=0C;

END raw2mon;
*)


PROCEDURE checkhamnet(VAR b:ARRAY OF CHAR; VAR len:INTEGER; rflinkname-:ARRAY OF CHAR; VAR hamup:RAWCALL);
VAR i, j:INTEGER;
    s:CARDINAL;
BEGIN
  IF rflinkname[0]=0C THEN RETURN END;

  hamup[0]:=0C;
  i:=0;
  WHILE b[i]<>">" DO                                                (* skip fromcall *) 
    INC(i); 
    IF i>=len THEN len:=0; RETURN END;
  END;
  INC(i);

  j:=0;
  WHILE (j<=VAL(INTEGER, HIGH(rflinkname))) & (rflinkname[j]<>0C) DO   (* compare rflink name *) 
    IF b[i]<>rflinkname[j] THEN 
      len:=0;
      RETURN
    END;
    INC(i);
    INC(j);  
  END;

  IF b[i]="," THEN
    INC(i);
    j:=0;
    WHILE (i<len) & (b[i]<>"-") & (b[i]<>",") & (b[i]<>":") DO        (* make rawcall of rflink uplink *)
      s:=ORD(b[i])*2 MOD 256;
      IF s<=ORD(" ")*2 THEN len:=0; RETURN END;
      hamup[j]:=CHR(s);
      INC(i);
      INC(j);
      IF j>=CALLLEN THEN len:=0; RETURN END;
    END;
    WHILE j<CALLLEN-1 DO
      hamup[j]:=CHR(ORD(" ")*2);
      INC(j);
    END;
    s:=0;
    IF b[i]="-" THEN
      INC(i);
      WHILE (b[i]>="0") & (b[i]<="9") DO s:=s*10 + ORD(b[i])-ORD("0"); INC(i) END;
      IF s>15 THEN len:=0; RETURN END;
    END;
    hamup[j]:=CHR((s+48+64)*2);                                       (* set H bit *)
  END;

  IF (b[i]<>",") & (b[i]<>":") THEN len:=0; RETURN END;
  
  WHILE b[i]<>"}" DO                                                (* find end of rflink head *)
    INC(i);
    IF i>=len THEN len:=0; RETURN END;
  END;
  INC(i);
  DEC(len, i);                                                    (* payload len *)
  FOR j:=0 TO len DO b[j]:=b[i]; INC(i) END;                        (* remove rflink head *)

(* DIGICALL>HAMNAME,UPLINKCALL,.... :}payload *)
END checkhamnet;


(*
PROCEDURE MakeDupeTime(s-:ARRAY OF CHAR; p:INTEGER; parm:pDIGIPARMS):TIME;
VAR le,nu:CARDINAL;
    i:INTEGER; 
BEGIN
  le:=0;
  nu:=0;
  FOR i:=p+3 TO p+5 DO 
    IF (s[i]>="A") & (s[i]<="Z") THEN INC(le) END;
    IF (s[i]>="0") & (s[i]<="9") THEN INC(nu) END;
  END;
  IF (s[p+2]=cUSERMSG) & (le>0) & (nu>0) & (le+nu=3) THEN        (* looks like a user message *)
    RETURN parm^.messagetime
  END;
  RETURN parm^.duptime
END MakeDupeTime;
*)

PROCEDURE IsCall(raw-:ARRAY OF CHAR; pos:CARDINAL; div:CARDINAL):BOOLEAN;
VAR le, nu, i:CARDINAL;
    c:CHAR; 
BEGIN
  le:=0;
  nu:=0;
  FOR i:=pos TO pos+2 DO
    c:=CHR(ORD(raw[i]) DIV div);
    IF (c>="A") & (c<="Z") THEN INC(le) END;
    IF (c>="0") & (c<="9") THEN INC(nu) END;
  END;
  RETURN (le>0) & (nu>0) & (le+nu=3);                            (* looks like a call *)
END IsCall;


PROCEDURE Dup(raw-:ARRAY OF CHAR; pathlen, rawlen:CARDINAL; VAR sum:CARDINAL):BOOLEAN;
VAR len, i:CARDINAL;
    hashl, hashh  :SET8;
    h:ARRAY[0..255] OF CHAR;
    ok:BOOLEAN;
(*
  PROCEDURE hash(c:CHAR);
  VAR b:CARD8;
  BEGIN
(*
IO.WrStr("<");IO.WrChar(c);IO.WrStr(">");
*)
    IF c<>" " THEN
      b:=CAST(CARD8, CAST(SET8, c) / hashl);
      hashl:=CRCL[b] / hashh;
      hashh:=CRCH[b];
    END;
  END hash;
*)
BEGIN
  hashl:=SET8{};
  hashh:=SET8{};
  INC(pathlen, 2);                                                 (* skip frametyp pid *)
  IF raw[pathlen]<>"}" THEN
    len:=0;
    ok:=Call2Str(raw, h, CALLLEN, len);
    i:=0;
    WHILE i<len DO HashCh(h[i], hashl, hashh); INC(i) END;
    len:=0;
    ok:=Call2Str(raw, h, 0, len);
    i:=0;
    WHILE (i<len) & (h[i]<>"-") DO HashCh(h[i], hashl, hashh); INC(i) END;
  ELSE
    i:=pathlen+1;
    LOOP
      INC(pathlen);
      IF pathlen>=rawlen THEN EXIT END;
      IF raw[pathlen-1]=":" THEN
        IF raw[pathlen]="}" THEN i:=pathlen+1 ELSE EXIT END;
      END;  
    END;
    WHILE (i<pathlen-1) & (raw[i]<>">") DO HashCh(raw[i], hashl, hashh); INC(i) END;
    INC(i);
    WHILE (i<pathlen-1) & (raw[i]<>"-") & (raw[i]<>",") DO HashCh(raw[i], hashl, hashh); INC(i) END;
  END;

  i:=pathlen;
  WHILE (i<rawlen) & (raw[i]<>CR) & (raw[i]<>LF) DO HashCh(raw[i], hashl, hashh); INC(i) END;
  sum:=(ORD(CAST(CHAR, hashl)) + ORD(CAST(CHAR, hashh))*256) MOD HASHSIZE;

  IF raw[pathlen]<>cUSERMSG THEN RETURN FALSE END;
  RETURN IsCall(raw, pathlen+1, 1)                               (* if call it is user msg *)
END Dup;


PROCEDURE Cmp(s-:ARRAY OF CHAR; start:CARDINAL; word-:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE word[i]<>0C DO
    IF word[i]<>CHR(ORD(s[start]) DIV 2) THEN RETURN FALSE END;
    INC(i);
    INC(start);
  END;
  RETURN TRUE
END Cmp;


PROCEDURE ChkNN(ssid:CARDINAL; c:CHAR):BOOLEAN;
BEGIN 
  c:=CHR(ORD(c) DIV 2);
  RETURN (c=" ") & (ssid=0) OR (c>="1") & (c<="7") & (c>=CHR(ORD("0")+ssid))
END ChkNN;

PROCEDURE NeqN(ssid:CARDINAL; c:CHAR; pos:INTEGER):BOOLEAN;
BEGIN RETURN (pos<=CALLLEN*2) & ((ssid+ORD("0")=ORD(c) DIV 2) OR (ssid=0) & (c=BLANKH)) END NeqN;


PROCEDURE setSSID(VAR c:CHAR; ssid:CARDINAL);
BEGIN c:=CAST(CHAR, CAST(SET8,c)-SET8{1..4}+CAST(SET8,ssid*2)) END setSSID;

PROCEDURE getSSID(c:CHAR):CARDINAL;
BEGIN RETURN ORD(c) DIV 2 MOD 16 END getSSID;

PROCEDURE killwide(VAR startpath:INTEGER; downpath:INTEGER; VAR s:ARRAY OF CHAR);
VAR i,j:INTEGER;
BEGIN
  FOR i:=startpath TO downpath-1 BY CALLLEN DO
    IF (s[i]=CHR(ORD("W")*2)) & (s[i+1]=CHR(ORD("I")*2))  
    & (s[i+2]=CHR(ORD("D")*2)) & (s[i+3]=CHR(ORD("E")*2)) THEN
      FOR j:=i-1 TO startpath BY -1 DO s[j+CALLLEN]:=s[j] END;
      INC(startpath, CALLLEN);
    END;
  END;
END killwide;




PROCEDURE Digi(VAR raw, send:ARRAY OF CHAR; inlen:INTEGER; VAR outlen:INTEGER; hamup-:RAWCALL;
               parm:pDIGIPARMS; duponly:BOOLEAN);
VAR i, j, pathlen, startpath, actdigi, downpath, goodpath:INTEGER;
    ssid, hash, ssidroute:CARDINAL;
    t,tt:TIME;
    ok, nodigicall, noloop:BOOLEAN;
BEGIN
  IF parm^.digicall[0]<=BLANKH THEN duponly:=TRUE END;
  outlen:=0;
  DEC(inlen, 2);                                              (* crc bytes *)

  pathlen:=CALLLEN*2-1;
  WHILE (pathlen<inlen) & NOT ODD(ORD(raw[pathlen])) DO INC(pathlen,CALLLEN) END; (* find end of path *)
  INC(pathlen);

  ok:=FALSE;
  downpath:=0;
  IF NOT duponly THEN
    actdigi:=CALLLEN*2;
    noloop:=TRUE;
    IF NOTFIRSTDIGI IN parm^.pathcheck THEN                   (* need not be first repeater *)
      WHILE (actdigi<pathlen) & (raw[actdigi+(CALLLEN-1)]>=CHR(128)) DO 

(* test if own digicall in path *)
        ok:=FALSE;
        FOR i:=0 TO CALLLEN-2 DO
          IF raw[i+actdigi]<>parm^.digicall[i] THEN ok:=TRUE END;
        END;
        IF getSSID(raw[actdigi+CALLLEN-1])<>getSSID(parm^.digicall[CALLLEN-1]) THEN ok:=TRUE END;
        IF NOT ok THEN noloop:=FALSE END;

        INC(actdigi,CALLLEN);
      END;
    END;

    IF noloop THEN                                            (* not looping thru own digi *)
      startpath:=actdigi+CALLLEN;
      nodigicall:=FALSE;
      IF DOWNPATHALL IN parm^.pathcheck THEN downpath:=pathlen END;

(* test for ssid routing*)

      ssid:=CAST(INTEGER, parm^.pathcheck*PATHSET{0..2});     (* limit ssid routing hopps *)
      ssidroute:=getSSID(raw[CALLLEN-1]);                     (* destination call ssid *)

      goodpath:=CALLLEN*2;
      WHILE (goodpath<pathlen) & (raw[goodpath+6]>=CHR(128)) 
      & IsCall(raw, goodpath, 2) DO INC(goodpath, CALLLEN) END; (* repeated via callsigns *)

      IF (ssidroute>0) & (ssid>0) & (goodpath=pathlen) & (pathlen<CALLLEN*7)
      & ((NOTFIRSTDIGI IN parm^.pathcheck) OR (goodpath=CALLLEN*2)) THEN
        ok:=TRUE;
        IF ssidroute>7 THEN ssidroute:=1 END;                 (* we can no directional routing *)
        IF ssidroute>ssid THEN ssidroute:=ssid END;           (* limit dest ssid to WIDEn-n *) 

        IF (ssidroute=1) OR NOT (SSIDTOWIDE IN parm^.pathcheck) THEN (* use decrement dest ssid routing *) 
          setSSID(raw[CALLLEN-1], ssidroute-1);               (* chain by dec dest ssid *)
          ssidroute:=0;
        ELSE                                                  (* expand to digicall + wideN-N *)
          DEC(ssidroute);
          setSSID(raw[CALLLEN-1], 0);                         (* switch to via routing *)
        END;          
        downpath:=0;                                          (* delete rest of path *)

IF show THEN 
  WrStr(" via ssid routing ");
END;

      ELSE
        ssidroute:=0;
        IF goodpath<=CALLLEN*2 THEN goodpath:=0 END;          (* may be missing uplink call *)
        IF NOUPLINKCHECK IN parm^.pathcheck THEN goodpath:=actdigi END;
        ok:=(pathlen>actdigi) & (raw[actdigi+(CALLLEN-1)]<CHR(128));  (* there are via calls & is not digipeated *)
        IF ok THEN
          ssid:=getSSID(raw[actdigi+(CALLLEN-1)]);
          IF NOVIADIGICALL IN parm^.pathcheck THEN ok:=FALSE
          ELSE 
            FOR i:=0 TO CALLLEN-2 DO 
              IF raw[i+actdigi]<>parm^.digicall[i] THEN ok:=FALSE END;
            END;
            IF ssid<>getSSID(parm^.digicall[CALLLEN-1]) THEN ok:=FALSE END;
          END;
          IF ok THEN
            IF DOWNPATHDIGICALL IN parm^.pathcheck THEN downpath:=pathlen END;

IF show THEN WrStr(" via digicall "); END;

          ELSE
            IF NOT (NOVIARELAY IN parm^.pathcheck) THEN
              ok:=Cmp(raw, actdigi, "RELAY ");
              IF NOT ok & (RELAYECHO IN parm^.pathcheck) THEN ok:=Cmp(raw, actdigi, "ECHO  ") END;
              IF ok THEN
                IF DOWNPATHRELAY IN parm^.pathcheck THEN downpath:=pathlen END;

IF show THEN WrStr(" via RELAY "); END;

              END;
            END;  
          END;

          IF NOT ok THEN
            IF VIAGATE IN parm^.pathcheck THEN
              ok:=Cmp(raw, actdigi, "GATE  ");
              IF ok THEN
                IF DOWNPATHRELAY IN parm^.pathcheck THEN downpath:=pathlen END;

IF show THEN WrStr(" via GATE "); END;

              END;
            END;
          END;

          IF NOT ok THEN 
            IF NOT (NOVIATRACE IN parm^.pathcheck) 
            & Cmp(raw, actdigi, "TRACE")
            & ChkNN(ssid, raw[actdigi+(CALLLEN-2)])
            & ((goodpath=actdigi) OR NeqN(ssid, raw[actdigi+(CALLLEN-2)], actdigi)) THEN
              ok:=TRUE;
              IF (ssid>ORD(NOT (NULLSSID IN parm^.pathcheck))) & (SENDTRACE IN parm^.pathcheck) THEN
                setSSID(raw[actdigi+(CALLLEN-1)], ssid-1);          (* dec(N) of WIDEn-N *)
                startpath:=actdigi;
              END;
              IF NOT (DOWNPATHALL IN parm^.pathcheck) THEN downpath:=actdigi+CALLLEN END;
            END;

IF show & ok THEN WrStr(" via TRACEn-n "); END;

          END;

          IF NOT ok THEN
            IF NOT (NOVIAWIDEN IN parm^.pathcheck) 
            & Cmp(raw, actdigi, "WIDE") & (raw[actdigi+(CALLLEN-2)]=BLANKH)
            & ChkNN(ssid, raw[actdigi+(CALLLEN-3)])
            & ((goodpath=actdigi) OR NeqN(ssid, raw[actdigi+(CALLLEN-3)], actdigi)) THEN
              ok:=TRUE;
              IF (raw[actdigi+(CALLLEN-3)]<>BLANKH) & (SENDWIDE IN parm^.pathcheck) THEN
                IF (NOCALLBEFOREWIDE IN parm^.pathcheck)
                OR (goodpath<>actdigi) & NOT NeqN(ssid, raw[actdigi+(CALLLEN-3)], actdigi) THEN nodigicall:=TRUE END;   (* maybe repeatet before *)

                IF ssid>ORD(NOT (NULLSSID IN parm^.pathcheck)) THEN
                  setSSID(raw[actdigi+(CALLLEN-1)], ssid-1);
                  startpath:=actdigi; 
                ELSIF nodigicall THEN raw[actdigi+(CALLLEN-1)]:=CHR(ORD("0")*2+HBIT); (* WIDE* *) 
                END;
                IF nodigicall THEN startpath:=actdigi END;
              END;
              IF NOT (DOWNPATHALL IN parm^.pathcheck) THEN downpath:=actdigi+CALLLEN END;
            END;

IF show & ok THEN WrStr(" via WIDEn-n " ); END;

          END;

IF show & NOT ok THEN WrStr(" no source path " ); END;

        ELSIF show THEN WrStr(" already digipeated " ) END;
      END;
    ELSIF show THEN WrStr(" we have already digipeated " ) END; 
  END;

  IF duponly OR ok THEN
(*
IO.WrLn; IO.WrStr("<<<");IO.WrHex(ORD(raw[pathlen+2]),1);IO.WrStr(">>> ");
*)
    tt:=parm^.duptime;
    IF Dup(raw, pathlen, inlen, hash) THEN tt:=parm^.messagetime END;
    t:=time();                                                          (* time in s *)
    IF parm^.timehash[hash]+tt<=t THEN                                  (* not a duplicate *)
      parm^.timehash[hash]:=t;

      IF duponly THEN                                                   (* dupfilter only *)
        outlen:=inlen+2;
        FOR i:=0 TO outlen-1 DO send[i]:=raw[i] END;

      ELSE                                                              (* digipeater *)
        i:=0;
        WHILE i<actdigi DO send[i]:=CAST(CHAR, CAST(SET8,raw[i])*SET8{1..7}); INC(i) END; (* copy from-to and clear address end bit *)

        IF NOT nodigicall THEN

          IF hamup[0]<>0C THEN
            FOR j:=0 TO CALLLEN-1 DO send[i]:=hamup[j]; INC(i) END;    (* append uplink via digicall *)
          END;

          FOR j:=0 TO CALLLEN-1 DO send[i]:=parm^.digicall[j]; INC(i) END;    (* append new via digicall *)
        END;
        IF ssidroute>0 THEN
          send[i]:=CHR(ORD("W")*2); INC(i);
          send[i]:=CHR(ORD("I")*2); INC(i);
          send[i]:=CHR(ORD("D")*2); INC(i);
          send[i]:=CHR(ORD("E")*2); INC(i);
          send[i]:=CHR((ORD("0")+ssidroute)*2); INC(i);
          send[i]:=CHR(ORD(" ")*2); INC(i);
          send[i]:=CHR((ORD("0")+ssidroute)*2); INC(i);               (* no H bit set *)
        END;

        IF KILLWIDE IN parm^.pathcheck THEN killwide(startpath, downpath, raw) END;
        j:=startpath;                                                   (* append rest of path *)
        WHILE (j<downpath) & (i<CALLLEN*10) DO send[i]:=raw[j]; INC(i); INC(j) END; 
        send[i-1]:=CAST(CHAR, CAST(SET8, send[i-1])+SET8{0});           (* set address end bit *)

        FOR j:=pathlen TO inlen-1 DO send[i]:=raw[j]; INC(i); END;      (* append data field no crc *)
        AppCRC(send,i);
        outlen:=i+2;
      END;

    ELSIF show THEN WrStr(" "); WrInt(t-parm^.timehash[hash],1); WrStr("s since same payload "); 
    END;

  END;
END Digi;




PROCEDURE GetIp(h:ARRAY OF CHAR; VAR p:CARDINAL; VAR ip:IPNUM; VAR port:UDPPORT):INTEGER;
VAR i, n:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  FOR i:=0 TO 4 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;

      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":") OR (n>255) THEN RETURN -1 END;

    ELSIF n>65535 THEN RETURN -1 END;

    port:=n;
    INC(p);
  END;  
  RETURN 0
END GetIp;


PROCEDURE GetSec(h:ARRAY OF CHAR; VAR p, n:CARDINAL):INTEGER;
VAR ok:BOOLEAN;
BEGIN
  h[HIGH(h)]:=0C;
  n:=0;
  ok:=FALSE;
  WHILE (h[p]>="0") & (h[p]<="9") DO
    ok:=TRUE;
    n:=n*10+ORD(h[p])-ORD("0");
    INC(p);
  END;
  IF NOT ok THEN RETURN -1 END;
(*
IO.WrCard(n,10); IO.WrLn;
*)
  RETURN 0
END GetSec;




PROCEDURE MakeRawCall(VAR c:RAWCALL; s:ARRAY OF CHAR; j:CARDINAL);
VAR i, n:CARDINAL;
BEGIN
  i:=0;
  WHILE i<CALLLEN-1 DO
    IF (s[j]<>0C) & (s[j]<>",") & (s[j]<>"-") THEN c[i]:=CHR(ORD(s[j])*2); INC(j);
    ELSE c[i]:=BLANKH END; 
    INC(i);
  END;
  n:=0;
  IF s[j]="-" THEN
    INC(j);
    WHILE (s[j]>="0") & (s[j]<="9") DO n:=n*10 + ORD(s[j])-ORD("0"); INC(j) END;
  END;
  IF n>15 THEN Err("wrong SSID") END;
  IF s[j]="*" THEN c[CALLLEN-1]:=0C ELSE c[CALLLEN-1]:=CHR(n*2+(96+HBIT)) END;   (* set H bit *)
END MakeRawCall;


PROCEDURE Ackpath(h-:ARRAY OF CHAR);
BEGIN
  Assign(ackpath, ">");
  Append(ackpath, TOCALL);
  IF h[0]<>0C THEN
    Append(ackpath, ",");
    Append(ackpath, h);
  END;
  Append(ackpath, "::");
END Ackpath;

PROCEDURE getfix(VAR x:REAL; s-:ARRAY OF CHAR; VAR p:CARDINAL):BOOLEAN;
VAR i:CARDINAL;
    h:ARRAY[0..255] OF CHAR;
BEGIN
  i:=0;
  WHILE (s[p]>" ") & (s[p]<>"/") & (i<HIGH(h)) DO h[i]:=s[p]; INC(i); INC(p) END;
  h[i]:=0C;
  IF StrToFix(x, h) THEN RETURN TRUE END;
  RETURN FALSE
END getfix;


PROCEDURE parms;
VAR h                : ARRAY[0..4095] OF CHAR;
    err, actecho,
    actpasswix,
    actpassui        : BOOLEAN;
    lasth            : CHAR;
    actsock          : pINSOCK;
    outsock, onext   : pOUTPORT;
    actpass          : SET256;
    actdigi          : pDIGIPARMS; 
    i, n, nold       : CARDINAL;
    actbeacon        : BEACON;
    user             : pMSGHASH; 
    actcall, callnext: pCALLS;
    actkm            : REAL;
    actpos           : POSITION;  
BEGIN

  msgusers:=NIL;
  actsock:=NIL;
  actcall:=NIL;
  err:=FALSE;
  show:=FALSE;
  Ackpath(DEFAULTACK);
  actkm:=0.0;
  actpassui:=FALSE;
  actpasswix:=FALSE;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN
      lasth:=h[1];
      IF lasth="a" THEN
        NextArg(h);
        IF h[0]="-" THEN h[0]:=0C END; 
        Ackpath(h);

      ELSIF (lasth="R") OR (lasth="M") OR (lasth="L") THEN
        NextArg(h);
        actecho:=FALSE;
        actpass:=SET256{0..255};
        actdigi:=NIL;
        actcall:=NIL;
        actkm:=0.0; 
        actpassui:=FALSE;
        actpasswix:=FALSE;
        actbeacon.bintervall:=0;
        actbeacon.piggytime:=0;
        actbeacon.piggyback:=FALSE;
        ALLOCATE(actsock, SIZE(actsock^));
        IF actsock=NIL THEN Err("out of memory") END;
        WITH actsock^ DO
          IF GetIp(h, i, fromip, bindport)<0 THEN Err("cannot open udp socket") END;
          fd:=udp.openudp();
          rawread:=lasth="R";
          rflinkname[0]:=0C;
          IF lasth="L" THEN 
            n:=0;
            IF h[i-1]=":" THEN
              LOOP
                IF i>=HIGH(h) THEN EXIT END;
                IF h[i]=0C THEN EXIT END;
                rflinkname[n]:=h[i];
                INC(i);
                INC(n);
              END;
            END;
            IF n=0 THEN Err("-L ip:port:name") END;
          END;
          outchain:=NIL;
          IF (fd>=0) & (udp.bindudp(fd, bindport)<0) THEN Err("cannot bind inport") END;
          next:=NIL;
        END;
        IF insocks<>NIL THEN actsock^.next:=insocks END;
        insocks:=actsock;

      ELSIF lasth="f" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -f") END;
        actpass:=SET256{};
        IF (h[0]<>cFILTDEL) & (h[0]<>cFILTPASS) THEN Err("-f (p)ass or (d)elete needed") END;
        i:=1;
        n:=0;
        nold:=256;
        LOOP
          IF i>=HIGH(h) THEN EXIT END;
          IF (h[i]>="0") & (h[i]<="9") THEN n:=n*10 + ORD(h[i]) - ORD("0");
          ELSE
            LOOP 
              IF (n>0) & (n<256) THEN INCL(actpass, n) END;
              IF n<=nold THEN EXIT END;
              DEC(n);
            END;
            nold:=256; 
            IF h[i]="-" THEN nold:=n ELSIF h[i]<>"," THEN EXIT END;
            n:=0;
          END;  
          INC(i);
        END;
        IF h[0]=cFILTDEL THEN actpass:=-actpass END;  

      ELSIF lasth="k" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -k") END;
        i:=0;
        IF NOT getfix(actpos.lat, h, i) THEN Err("latitude in deg") END;
        INC(i); 
        IF (h[i-1]<>"/") OR NOT getfix(actpos.long, h, i) THEN Err("longitude in deg") END;
        INC(i);
        IF (h[i-1]<>"/") OR NOT getfix(actkm, h, i) OR (actkm>=FLOAT(MAX(INTEGER))) THEN 
          Err("distance in km");
        END;

      ELSIF lasth="b" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -b") END;
        WITH actbeacon DO
          i:=0;
          IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN 
            bintervall:=n;
            btime:=bintervall+time();
            bline:=0;
            INC(i);
            FOR n:=0 TO HIGH(bfile) DO IF i<=HIGH(h) THEN bfile[n]:=h[i]; INC(i) END; END;
          ELSE Err("beacon format is time:file") END;
        END;

      ELSIF lasth="d" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -d") END;

        ALLOCATE(actdigi, SIZE(actdigi^));
        IF actdigi=NIL THEN Err("out of memory") END;
        WITH actdigi^ DO
          MakeRawCall(digicall, h, 0);
          IF (digicall[0]=0C) OR (digicall[CALLLEN-1]=0C) THEN Err("wrong digi callsign") END;
          FOR i:=0 TO HIGH(timehash) DO timehash[i]:=0 END;
          duptime:=DEFAULTDUPTIME;
          messagetime:=DEFAULTMESSAGETIME;
          pathcheck:=PATHSET{};
        END;

      ELSIF lasth="e" THEN actecho:=TRUE

      ELSIF (lasth="r") OR (lasth="m")  OR (lasth="c") THEN
        IF actsock=NIL THEN Err("need input -M or -R before -r or -m or -c") END;
        NextArg(h);

        ALLOCATE(outsock, SIZE(outsock^));
        IF outsock=NIL THEN Err("out of memory") END;
        WITH outsock^ DO
          IF GetIp(h, i, toip, toport)<0 THEN Err("wrong udp:port") END;
          aprspass:=actpass;
          echo:=actecho; 
          digiparm:=actdigi;
          rawwrite:=lasth="r";
          crlfwrite:=lasth="c";
          beacon:=actbeacon;
          actbeacon.bintervall:=0;
          passnoUI:=actpassui;
          passwix:=actpasswix;
          next:=NIL;
          filtercalls:=actcall;
          mypos.lat :=actpos.lat*RAD;
          mypos.long:=actpos.long*RAD;
          maxkm:=TRUNC(actkm);
        END;
        actdigi:=NIL;
        actpassui:=FALSE;
        actpasswix:=FALSE;
        onext:=actsock^.outchain;
        IF onext=NIL THEN actsock^.outchain:=outsock;
        ELSE 
          WHILE onext^.next<>NIL DO onext:=onext^.next END;
          onext^.next:=outsock;
        END;

      ELSIF lasth="h" THEN
        WrLn;
        WrStrLn(" -a <paths>     user message ack path eg. WIDE2-2 or - for no path");
        WrStrLn(" -b <s>:<file>  enable beacon every s(econds) path and text from <file>");
        WrStrLn("                cycles thru lines in file, empty lines = no tx (size max 8kb)");
        WrStrLn("                \\z ddhhmm, \\h hhmmss, \\:filename: insert file, \\\ is \\");
        WrStrLn("                \\rm delete beacon file");
        WrStrLn("                file may be modified any time eg. by telemetry program");
        WrStrLn(" -c <ip>:<port> send text monitor udp frame with cr lf");
        WrStrLn(" -d <call>      digipeater enable (and dupe filter) call");
        WrStrLn(" -d -           dupe filter without data modification");
        WrStrLn(" -e             echo last (filtert) output");
        WrStrLn(" -f <filterparm>  'p<x>,<x>...' pass UI frames with first char (-f p58,110)");
        WrStrLn("                  'd<x>,<x>...' pass UI frames with not first char (-f d32,65-79)");
        WrStrLn(" -h             this");
        WrStrLn(" -k <deg>/<deg>/<km> distance filter, center/radius -k 48.2/13.5/100");
        WrStrLn("                -k 0/0/20000 remove all (not user msg) with no position data");
        WrStrLn(" -L <ip>:<port>:<netname>   read monitor rflink header with netname");
        WrStrLn(" -M <ip>:<port> read text monitor udp frame");
        WrStrLn(" -m <ip>:<port> send text monitor udp frame 0 terminated");
        WrStrLn(" -p <n>,<...>   -p 7,8 igate friendly digi relaying all direct heared");
        WrStrLn("                -p 5,6,7,8,9 first hop digi, -p 3,4 (noisy) last hop digi");
        WrStrLn("                -p 0,1,3,4,5,6,7,8,9,14,16 original, noisy, path loosing ...");
        WrStrLn("                0..2 limit ssid-routing to (bit0 + 2*bit1 + 4*bit2)");
        WrStrLn("                dest-3: dest-2,digicall*, dest-3,call*: dest-2,call,digicall*");
        WrStrLn("                3 allow repeatet before (mostly with wrong path trace)");
        WrStrLn("                4 no uplink check for 'looks like direct heared'");
        WrStrLn("                  (noisy, wrong path trace possible)");
        WrStrLn("                5 resend TRACEn-(N-1), 6 resend WIDEn-(N-1)");
        WrStrLn("                  so frames may be relayed again by loss of downlink trace");
        WrStrLn("                7,8,9 append remaining digi path after via digicall, RELAY/GATE, WIDE");
        WrStrLn("                  so frames may be relayed again by loss of downlink trace");
        WrStrLn("                10, 11, 12, 13 switch off via digicall, RELAY, TRACE, WIDE");
        WrStrLn("                14 insert not digicall on direct heared before WIDEn-N,");
        WrStrLn("                   as others do, your digi is hidden, and path is shown wrong");
        WrStrLn("                15 convert destination ssid routing to WIDEn-n");
        WrStrLn("                16 send n-0 without repeated flag");
        WrStrLn("                17 remove all WIDE from downlink path");
        WrStrLn("                18 enable via GATE (use as gate: disable via all other)");
        WrStrLn("                19 allow ECHO as alias to RELAY");
        WrStrLn(" -P <s>         piggyback time sending beacon earlier if sent anything now");
        WrStrLn(" -R <ip>:<port> read raw axudp frame, 0 ip read from all (-R 0.0.0.0:2000)");
        WrStrLn(" -r <ip>:<port> send raw axudp frame");
        WrStrLn(" -s             pass not-UI-frames too (all PR-Frames, SABM, RR..) (raw mode only)");
        WrStrLn(" -S             pass messages to itself");
        WrStrLn(" -t <s>,<s>     dupe filter time in seconds (all types , user messages)");
        WrStrLn("                -t 1740,28 29min not same beacon, 28s for retrying user message)");
        WrStrLn(" -u <call>:<file> global option, receive & ack usermessages to call store in file");
        WrStrLn("                repeat -u for more Calls to same or different File");
        WrStrLn(" -v             show frames and analytics on stdout");
        WrStrLn(" -x <call>{,<call>} delete frames with call in a address field, -x TCPIP,UID***-*");
        WrStrLn("udpbox -v -M 0.0.0.0:9200 -d MYCALL-10 -p 0,1,7 -t 1800,28 -r 192.168.1.24:9400");
        WrLn;

        HALT

      ELSIF lasth="s" THEN actpassui:=TRUE;

      ELSIF lasth="S" THEN actpasswix:=TRUE;

      ELSIF lasth="t" THEN
        IF actdigi=NIL THEN Err("need -d before -t") END;
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN 
          actdigi^.duptime:=n;
          INC(i);
          IF (h[i-1]=",") & (GetSec(h,i,n)>=0) THEN actdigi^.messagetime:=n END; 
        END;

      ELSIF lasth="P" THEN
        IF actsock=NIL THEN Err("need input -M or -R before -P") END;
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN actbeacon.piggytime:=n END;

      ELSIF lasth="p" THEN
        IF actdigi=NIL THEN Err("need -d before -p") END;
        NextArg(h);
        i:=0;
        WHILE GetSec(h,i,n)>=0 DO 
          IF n<31 THEN INCL(actdigi^.pathcheck, n) END;
          IF h[i]="," THEN INC(i) END;
        END;

      ELSIF lasth="u" THEN
        NextArg(h);
        ALLOCATE(user, SIZE(user^));
        IF user=NIL THEN Err("out of memory") END;
        WITH user^ DO
          wpos:=0;
          msgfile[0]:=0C;
          FOR i:=0 TO HIGH(hash) DO hash[i].ackcnt:=0 END;
          i:=0;
          n:=0;
          WHILE (n<=HIGH(usercall)) & (h[i]<>0C) & (h[i]<>":") DO 
            usercall[n]:=h[i]; INC(n); INC(i);
          END;
          WHILE n<=HIGH(usercall) DO usercall[n]:=" "; INC(n) END;
          IF h[i]<>0C THEN
            INC(i);
            n:=0;
            WHILE (n<=HIGH(msgfile)) & (h[i]<>0C) DO msgfile[n]:=h[i]; INC(n); INC(i) END;
          END;
          next:=NIL;
        END;
        IF msgusers<>NIL THEN user^.next:=msgusers END;  
        msgusers:=user;

      ELSIF lasth="v" THEN
        show:=TRUE;
 
      ELSIF lasth="x" THEN
        NextArg(h);
        IF actsock=NIL THEN Err("need input -M or -R before -x") END;

        i:=0;
        LOOP
          ALLOCATE(callnext, SIZE(callnext^));
          IF callnext=NIL THEN Err("out of memory") END;
          MakeRawCall(callnext^.call, h, i);
          callnext^.next:=actcall;
          actcall:=callnext;
          WHILE h[i]<>"," DO
            IF (i>=HIGH(h)) OR (h[i]<=" ") THEN EXIT END;
            INC(i);        
          END;
          INC(i);
        END;

      ELSE err:=TRUE END;
(*
      h[0]:=0C;
*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN WrStr(">"); WrStr(h); WrStrLn("< use -h"); HALT END;

END parms;

PROCEDURE showpip(ip:IPNUM; port:UDPPORT);
BEGIN
  WrInt(ip DIV 1000000H,1); WrStr(".");
  WrInt(ip DIV 10000H MOD 100H ,1); WrStr(".");
  WrInt(ip DIV 100H MOD 100H ,1); WrStr(".");
  WrInt(ip MOD 100H ,1); WrStr(":");
  WrInt(port, 1);
END showpip;

(*
PROCEDURE showstr(s-:ARRAY OF CHAR);

  PROCEDURE Hex(b:SET8):CHAR;
  VAR d:CARDINAL;
  BEGIN
    d:=CAST(CARDINAL, b*SET8{0..3});
    IF d>9 THEN INC(d, ORD("A")-10-ORD("0")) END;
    RETURN CHR(d+ORD("0"))  
  END Hex;

VAR i,j:CARDINAL;
    h:ARRAY[0..1023] OF CHAR; 
BEGIN
  i:=0;
  j:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) & (j<HIGH(h)-5) DO
    IF s[i]<" " THEN 
      h[j]:="<"; INC(j);
      h[j]:=Hex(SHIFT(CAST(SET8, s[i]), -4)); INC(j);
      h[j]:=Hex(CAST(SET8, s[i])); INC(j);
      h[j]:=">";
    ELSE h[j]:=s[i] END;
    INC(i);
    INC(j);
  END;
  h[j]:=0C;
  WrStrLn(h); 
END showstr;
*)

PROCEDURE cpraw(VAR in, out:ARRAY OF CHAR; VAR len:INTEGER);
VAR i,n,e:INTEGER;
    c:CHAR;
    h:BOOLEAN;

  PROCEDURE showhex(s-:ARRAY OF CHAR);
  VAR i:INTEGER;
  BEGIN
IF show THEN
 WrLn;
 WrStrLn(s);
 FOR i:=0 TO len-1 DO WrHex(ORD(in[i]),3) END;
 WrLn;
 FOR i:=0 TO e-1 DO
   n:=ORD(in[i]) DIV 2;
   IF n<ORD(" ") THEN WrStr("<"); WrHex(ORD(n),1); WrStr(">")
   ELSE WrStr(CHR(n)) END;
   IF i MOD 7=6 THEN WrStr(",") END;
 END;
 WrLn;
END;

  END showhex;

BEGIN
  e:=0;
  FOR i:=0 TO len-1 DO
    c:=in[i];
    out[i]:=c;
    IF (e=0) & ODD(ORD(c)) THEN e:=i+1 END;
  END;

  IF (VAL(CARDINAL,e) MOD CALLLEN<>0) OR (e<CALLLEN*2) OR (e>CALLLEN*10) THEN
    showhex(" bad raw format, no address end found");
    len:=0;
  ELSE 
    h:=TRUE;
    FOR i:=CALLLEN*3-1 TO e-1 BY CALLLEN DO
      IF ORD(in[i])>=128 THEN
        IF NOT h THEN
          showhex(" bad H bit in raw frame"); 
          len:=0;
        END; 
        h:=TRUE;
      ELSE h:=FALSE END;
    END;
  END;
END cpraw;


PROCEDURE beaconmacros(VAR s:ARRAY OF CHAR; VAR del:BOOLEAN);
CONST MSYM="\";
VAR i:CARDINAL;
    len,j:INTEGER;  
    ds,ns:ARRAY[0..255] OF CHAR;
    fn:ARRAY[0..1023] OF CHAR;
    f:File;
BEGIN
  del:=FALSE;
  i:=0;
  ns[0]:=0C;
  WHILE (i<HIGH(s)) & (s[i]<>0C) DO
    IF (s[i]=MSYM) & (s[i+1]=MSYM) THEN
      INC(i, 2);
      IF s[i]="z" THEN                       (* insert day, hour, min *)
        DateToStr(time(), ds);
        ds[0]:=ds[8]; ds[1]:=ds[9]; ds[2]:=ds[11]; ds[3]:=ds[12]; ds[4]:=ds[14]; ds[5]:=ds[15];
        ds[6]:=0C;
        Append(ns, ds); 
      ELSIF s[i]="h" THEN                    (* insert hour, min, s *)
        DateToStr(time(), ds);
        ds[0]:=ds[11]; ds[1]:=ds[12]; ds[2]:=ds[14]; ds[3]:=ds[15]; ds[4]:=ds[17]; ds[5]:=ds[18];
        ds[6]:=0C;
        Append(ns, ds); 
      ELSIF s[i]=":" THEN                    (* insert file *)
        fn[0]:=0C;
        INC(i);
        WHILE (i<HIGH(s)) & (s[i]<>0C) & (s[i]<>":") DO Append(fn, s[i]); INC(i) END;
        f:=OpenRead(fn);
        IF f>=0 THEN
          len:=RdBin(f, ds, SIZE(ds)-1);
          Close(f);
          j:=0;
          WHILE (j<len) & (ds[j]<>CR) & (ds[j]<>LF) & (ds[j]<>0C) DO 
            Append(ns, ds[j]); 
            INC(j);
          END;
        ELSE
          IF show THEN WrLn; WrStrLn("beacon macro file not readable "); END;
          s[0]:=0C;
          RETURN

        END; 
      ELSIF (s[i]="r") & (s[i+1]="m") THEN   (* delete beacon file *)
        s[0]:=0C;
        del:=TRUE;
        RETURN

      ELSIF s[i]="\" THEN Append(ns, "\\");
      ELSE
        IF show THEN WrLn; WrStrLn("bad beacon macro "); END;
        s[0]:=0C;
        RETURN

      END; 
    ELSE Append(ns, s[i]) END;
    INC(i);
  END;
  Assign(s, ns);
END beaconmacros;


PROCEDURE beacon(insock:pINSOCK; VAR buf:ARRAY OF CHAR; VAR len:INTEGER; VAR outsock:pOUTPORT);
VAR i, bol, eol, lc:INTEGER;
    f   :File;
    fb  :ARRAY[0..32767] OF CHAR;
    t   :TIME;
    del,
    ok:BOOLEAN;
BEGIN
  len:=0;
  outsock:=insock^.outchain;
  LOOP
    IF outsock=NIL THEN len:=0; EXIT END;
    WITH outsock^.beacon DO
      t:=time();
      IF piggyback THEN INC(t, piggytime) END;
      piggyback:=FALSE;
      IF (bintervall>0) & (bfile[0]<>0C) & (btime<=t) THEN
        INC(btime, bintervall);
        IF btime<=t THEN btime:=t+bintervall END;
        f:=OpenRead(bfile);
        IF f>=0 THEN
          len:=RdBin(f, fb, SIZE(fb)-1);
          Close(f);
    

          WHILE (len>0) & (fb[len-1]<=" ") DO DEC(len) END;      (* remove junk from eof *)
          IF (len>0) & (len<HIGH(fb)) THEN fb[len]:=LF; INC(len) END; 


          REPEAT
            lc:=bline;
            eol:=0;
            LOOP
              bol:=eol;
              WHILE (eol<len) & (fb[eol]<>LF) DO INC(eol) END;
              IF eol>=len THEN bol:=eol; IF bline<>0 THEN lc:=1; bline:=0 END; EXIT END;
              IF fb[bol]<>"#" THEN
                IF lc=0 THEN INC(bline); EXIT END;
                DEC(lc);
              END;
              INC(eol);
            END;
          UNTIL lc=0;

          i:=0;
          WHILE bol<eol DO fb[i]:=fb[bol]; INC(i); INC(bol) END;
          fb[i]:=0C;
(*
IF show THEN WrStrLn(fb) END;
*)        

          len:=0;
          IF i>0 THEN 
            beaconmacros(fb, del);
            IF del THEN Erase(bfile, ok) ELSE mon2raw(fb, buf, len) END;

IF show & (len=0) THEN WrLn; 
IF del THEN WrStrLn("delete beacon file "); ELSE WrStrLn("bad beacon format "); END;
END;

          END;
          EXIT

        ELSIF show THEN WrStrLn("beacon file not found") END;
      END;
      outsock:=outsock^.next;
    END; 
  END;
END beacon;

PROCEDURE sendack(VAR buf:ARRAY OF CHAR; VAR len:INTEGER; fromsock:pINSOCK);
CONST ACKTIME=30;

VAR m:INTEGER;
    i,j:CARDINAL;
    user:pMSGHASH;
    fb:ARRAY[0..255] OF CHAR;
    t:TIME;
BEGIN
  user:=msgusers;
  t:=time();
  WHILE user<>NIL DO
    len:=0;
    WITH user^ DO
      FOR m:=0 TO HIGH(hash) DO
        WITH hash[m] DO
          IF (ackcnt>0) & (acktime<t) & (fromsock=source) THEN
            DEC(ackcnt);
            acktime:=t+ACKTIME; 

            j:=0;
            i:=0;
            WHILE (i<=HIGH(usercall)) & (usercall[i]>" ") DO 
              fb[j]:=usercall[i];
              INC(j);
              INC(i);
            END;

            i:=0;
            WHILE ackpath[i]>" " DO fb[j]:=ackpath[i]; INC(j); INC(i); END;

            FOR i:=0 TO 8 DO fb[j]:=froms[i]; INC(j); END;
            fb[j]:=":";
            INC(j); 

            i:=0;
            WHILE ACKMSG[i]>" " DO fb[j]:=ACKMSG[i]; INC(j); INC(i); END;
(*
IO.WrLn; IO.WrStr("    <"); IO.WrStr(hash[m].acks); IO.WrStrLn(">");
*)
            i:=0;
            WHILE acks[i]>" " DO fb[j]:=acks[i]; INC(j); INC(i); END;

            fb[j]:=0C;
(*
IO.WrLn; IO.WrStr("    <"); IO.WrStr(fb); IO.WrStrLn(">");
*)
            mon2raw(fb, buf, len);
IF show & (len=0) THEN WrStr(fb); WrStrLn(" message ack path wrong") END;


            RETURN
          END;
        END;
      END;
      user:=next;
    END;
  END;
END sendack;

VAR 
    ibuf, rawbuf, rawout, workraw : ARRAY[0..MAXLEN-1] OF CHAR;
    mbuf                  : ARRAY[0..511] OF CHAR;
    inlen, outlen, res    : INTEGER;
    monlen                : CARDINAL;
    actsock               : pINSOCK;
    outsock, isbeacon     : pOUTPORT;
    nobeacon,
    piggy                 : BOOLEAN;
    hamup                 : RAWCALL;

BEGIN
  insocks:=NIL;
(*
  Gencrctab;
*)
  parms;


(*
  FD_ZERO(inset);
  maxsock:=0;
  actsock:=insocks;
  WHILE actsock<>NIL DO
    WITH actsock^ DO  
      IF fd>=0 THEN 
        FD_SET(fd, inset);
        IF fd>maxsock THEN maxsock:=fd END; 
      END;
      actsock:=next;
    END;
  END;
*)

  LOOP
(*
    rset:=inset;
    tv.tv_usec:=0;
    tv.tv_sec:=1;
    IF select(maxsock+1, ADR(rset), NIL, NIL, ADR(tv))>=0 THEN
*)
    fdclr;
    actsock:=insocks;
    WHILE actsock<>NIL DO
      WITH actsock^ DO
        IF fd>=0 THEN fdsetr(fd) END;
        actsock:=next;
      END;
    END;
    IF selectr(1, 0)>=0 THEN

      actsock:=insocks;
      WHILE actsock<>NIL DO  
        
        REPEAT
          piggy:=FALSE;

          inlen:=0; 
          IF (actsock^.fd>=0) & issetr(actsock^.fd) THEN
            inlen:=getudp(actsock^.fd, ibuf, actsock^.fromip, actsock^.rawread);
          END;
          hamup[0]:=0C;
          IF inlen>0 THEN
            nobeacon:=TRUE;
            IF actsock^.rawread THEN cpraw(ibuf, rawbuf, inlen);
            ELSE
              IF inlen<=HIGH(ibuf) THEN ibuf[inlen]:=0C END;
              checkhamnet(ibuf, inlen, actsock^.rflinkname, hamup);
              IF inlen>0 THEN
                mon2raw(ibuf, rawbuf, inlen);
                IF show & (inlen=0) THEN WrStrLn("bad mon format "); END;
              ELSIF show THEN WrStrLn("no rflink head match"); END;
            END;
            isbeacon:=NIL;
          ELSE
            nobeacon:=FALSE;
            beacon(actsock, rawbuf, inlen, isbeacon);
            IF isbeacon=NIL THEN sendack(rawbuf, inlen, actsock) END;
          END; 
 
          IF inlen>=2 THEN
            IF show THEN
              raw2mon(rawbuf, mbuf, inlen-2, monlen);
              WrLn;
              showpip(showip, showport);
              WrStr("("); WrInt(inlen,1); WrStr(")"); 
              WrStr(":");
              IF monlen<=0 THEN WrStr("<raw to mon error>") END; 
              CtrlHex(mbuf);
              WrStrLn(mbuf);
            END;

            outsock:=actsock^.outchain;
            outlen:=0;
            WHILE outsock<>NIL DO
              IF show THEN WrStr(" tx: "); showpip(outsock^.toip, outsock^.toport); END;
              workraw:=rawbuf;
              IF ((isbeacon=NIL) OR (isbeacon=outsock) OR outsock^.echo) 
              & Filter(workraw, inlen, outsock, actsock) THEN

                IF outsock^.digiparm<>NIL THEN 
                  Digi(workraw, rawout, inlen, outlen, hamup, outsock^.digiparm, NOT nobeacon);
                  IF show & (outlen>0) THEN WrStr(" digi"); END;
                ELSIF NOT outsock^.echo THEN
                  rawout:=workraw;
                  outlen:=inlen;
                END;                                                 (* else use last filtert *)

                IF outlen>0 THEN
                  outsock^.beacon.piggyback:=TRUE;
                  piggy:=TRUE;
                  IF outsock^.rawwrite THEN
                    res:=udp.udpsend(actsock^.fd, rawout, outlen, outsock^.toport, outsock^.toip);
                    IF show THEN WrStrLn(" raw") END;
                  ELSE
                    raw2mon(rawout, mbuf, outlen-2, monlen);
                    IF monlen>0 THEN
                      IF outsock^.crlfwrite THEN 
                        mbuf[monlen-1]:=CR; mbuf[monlen]:=LF; INC(monlen);
                      END; 
                      res:=udp.udpsend(actsock^.fd, mbuf, monlen, outsock^.toport, outsock^.toip);
                      IF show THEN WrStrLn(" mon") END;
                    ELSIF show THEN WrStrLn(" monerr") END;
                  END;
                ELSIF show THEN WrStrLn(" no tx") END;
              ELSIF show THEN WrStrLn(" deleted") END;
              outsock:=outsock^.next;
            END;
          END;
        UNTIL NOT piggy;   
        actsock:=actsock^.next;
      END;
    END;
  END;
END udpbox.


(*

      -->-----------------         -->--------
      !                  !         !         !
----- !   -----   -----  !   ----- !   ----- !         -----    -----  -----
!-R ! !   !-d !   !-r !  !   !-d ! !   !-r ! ! -----   !-d !    !-r !  !-R ! 
!-M !--->-!-f !->-!-m !  -->-!-f !--->-!-m ! --!-e !->-!-f !-->-!-m !  !-M !-> ...
-----     !-p !   !-c !      !-p !     !-c !   -----   !-p !    !-c !  -----
          !-x !   -----      !-x !     -----           !-x !    -----
          !-b !              !-b !                     !-b !
          -----              -----                     -----
receive   filter1 send       filter2   send            filter3  send

*)