<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*+NOPTRALIAS*>
<*-CHECKNIL *>
<*-CHECKINDEX*>
<*-CHECKDINDEX *>
<*-CHECKSET*>
<*CPU="PENTIUM"*>
<* IF __GEN_C__ THEN *>
  <*+GENCTYPES*>
  <*+COMMENT*>
  <*-GENDEBUG*>
  <*-LINENO*>
  <*-GENHISTORY*>
  <*-DOREORDER *>
  <*-PROCINLINE*>
<* ELSE *>
  <*-GENDEBUG*>
  <*-LINENO*>
  <*-GENHISTORY*>
  <*-DOREORDER *>
  <*-PROCINLINE*>
<* END *>

<*NEW MSG*>
<*+MSG*>

MODULE udpgate4; (* axudp / tcpip  aprs-is gateway and message repeater by OE5DXL *)

IMPORT udp, tcp, FileSys;
FROM osi IMPORT WrLn, WrStr, WrStrLn, WrInt, WrHex, NextArg,
                OpenRead, OpenAppend, OpenWrite, Close,
                WrBin, RdBin, Size, Seek, Exists;

FROM Select IMPORT selectrw, fdclr, fdsetr, fdsetw, issetr, issetw;
FROM SYSTEM IMPORT CAST, SHIFT, ADR, CARD8, CARD16, FILL;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM TimeConv IMPORT time; 
FROM aprspos IMPORT POSITION, RAD, posvalid, distance, GetPos, GetSym, KNOTS;
FROM aprsstr IMPORT TIME, Assign, Append, Length, IntToStr, FixToStr, StrToFix,
     StrCmp, InStr, TimeToStr, DateToStr, CtrlHex, IPNUM, UDPPORT, SET8, HashCh,
     AppCRC, mon2raw, raw2mon, GetIp2, CardToStr;
(*
FROM stat IMPORT fstat, stat_t;
*)

CONST CALLLEN=7;
      HASHSIZE=65536;

<* IF __GEN_C__ THEN *>
      VERS="udpgate(c) 0.53";
<* ELSE *>
      VERS="udpgate 0.53";
<* END *>

      TOCALL="APNL51";
      HTTPTIMEOUT=60;
      APRSLISTENSOCKS=4;                             (* max same time tcp connects *)
      WWWLISTENSOCKS=16;                             (* max same time www tcp connects *)
      UDPSHOWTIME=600;                               (* show udp in html *)
      GATECONNDELAY=30;
      MAXINTERNALDELAY=5;                            (* max seconds between udp ports read to not discard data *)

TYPE  
      MONCALL=ARRAY[0..9] OF CHAR;
      FILENAME=ARRAY[0..1023] OF CHAR;
      FRAMEBUF=ARRAY[0..511] OF CHAR;
(*
      FRAMEBUF=ARRAY[0..256+3+11*10] OF CHAR;
*)

      BEACON=RECORD
               bintervall: TIME;
               bfile     : FILENAME;
               btime     : TIME;
             END;


      POSCALL=RECORD
                call:MONCALL;
                typ:CHAR;
                pos:POSITION;
              END;   
       

      FILTERS=RECORD
                typ       :CHAR;
                base,
                edge      :POSITION;
                radius    :REAL;
                viacalls  :ARRAY[0..7] OF MONCALL;
                notvia    :BOOLEAN;
                entrycalls:ARRAY[0..7] OF MONCALL;
                notentry  :BOOLEAN;
              END;
 
      WWWB=ARRAY[0..1400] OF CHAR;

      pWWWBUF=POINTER TO WWWBUF;
      WWWBUF=RECORD
              buf  :WWWB;
              tlen :INTEGER;
              push :BOOLEAN;
              next :pWWWBUF;
            END;

      QWatch=RECORD
               lasttb  :CARDINAL;
               qsize   :INTEGER;
               lastqb  :INTEGER;
               txbyte  :ARRAY[0..59] OF INTEGER;
             END;

      pTCPSOCK=POINTER TO TCPSOCK;
      TCPSOCK=RECORD
               next    : pTCPSOCK;
               fd      : INTEGER;
               beacont, 
               connt   : TIME;
               slowlink,
               valid   : BOOLEAN; 
               service : CHAR;
               gatepri : CARDINAL;    
               ipnum   : ARRAY[0..63] OF CHAR;
               port    : ARRAY[0..5] OF CHAR;
               user    : POSCALL;
               vers    : ARRAY[0..20] OF CHAR; 
               wwwst   : CARDINAL;
               reload  : CARDINAL;
               sortby  : ARRAY[0..1] OF CHAR;
               qwatch  : QWatch;
               txframes,
               txbytes,
               txbytesh, 
               rxframes,
               rxbytes,
               rxbytesh: CARDINAL;
               filters : FILTERS;
               rpos, 
               tlen    : INTEGER;
               rbuf, 
               tbuf    : FRAMEBUF; 
               get     : ARRAY[0..255] OF CHAR;
               txbuf   : pWWWBUF;
             END;

     pUDPSOCK=POINTER TO UDPSOCK;
     UDPSOCK=RECORD
               next       : pUDPSOCK;
               fd         : INTEGER;
               rawread,
               checkip    : BOOLEAN;
               ip         : IPNUM;
               bindport,
               dport      : UDPPORT;
               lasttxtime : TIME;                          (* for net to rf bit/s limit *)
               laststat   : CARDINAL;
               torfradius : REAL;                          (* radius 0 no gateing *)
               maxbytes,                                   (* byte/s tx *)  
               lasttxbytes,                                (* for tx byte/s limit *)
               txframes,
               txbytes    : CARDINAL;
               portname   : ARRAY[0..9] OF CHAR;
               stat:ARRAY[0..15] OF RECORD
                 uip                : IPNUM;
                 uport              : UDPPORT;
                 rxframes, rxbytes  : CARDINAL;
                 utime, dtime       : TIME;
               END;
             END;


     GATEFILT=(gUNGATE, gRFONLY, gNOGATE, gTCPIP, gTCPXX, gQ);
     GFILTSET=SET OF GATEFILT; 

<*IF MSG THEN*>
CONST MAXHEARD=500;
      cUSERMSG=":";
      cTHIRDPARTY="}";
      ICONDIR="icon";
      CALLINKFN="calllink.txt";          (* build an URL for a klicked mh call *)
      MHSTEPS=48;
      tCELSIUS="C";
      tSPEED="S";
      UNACKRET=1;
      MSGLEN=67;

TYPE
     MSGTEXT=ARRAY[0..MSGLEN] OF CHAR;
     ACKTEXT=ARRAY[0..4] OF CHAR;
     REPLYACK=ARRAY[0..1] OF CHAR;
     SOURCE=(OBSOLET, NET, INDIR, DIR);

     pMESSAGE=POINTER TO MESSAGE;
     MESSAGE=RECORD
               next    :pMESSAGE;
               chkt,
               txtime,
               gentime :TIME;
               txport,
               msg2rf,
               msg2net,
               ack2rf,
               ack2net,
               retryc  :CARDINAL;
               acksrc,
               src     :SOURCE;
               reject,
               acked,
               ackackt,
               queryrep:BOOLEAN;
               from,
               to      :MONCALL;
               ack     :ACKTEXT;
               replyack:REPLYACK; 
               text    :MSGTEXT;          (* no text is ack *)
             END;

     pHEARD=POINTER TO HEARD;
     HEARD=RECORD
       next    :pHEARD;
       fromrx  :CARDINAL;
       time    :TIME;
       call    :MONCALL;
       cntt    :TIME;
       position:POSITION; 
       sym,symt:CHAR; 
       cnt     :ARRAY[0..MHSTEPS] OF CARD16;
       head    :ARRAY[0..40] OF CHAR;
       datatyp :CHAR;
       data    :REAL;
       sortval :LONGREAL;                (* sort value inserted depending on sort by *)
       ungate  :BOOLEAN;                 (* flag set by user to not igate this direct heard *)  
     END;

VAR msgsendtime:TIME;

<*END*>



CONST 
      POLYNOM=BITSET{3,10,15};
      CRCINIT=BITSET{0..15};
      CRCRESULT=BITSET(40715);
      CR=015C;
      LF=012C;
      cUSERMESSAGE=":";
      cISGATEWAY="G";
      cISSERVER="S";
      cISWWW="W";

VAR 
    verb, callsrc         : BOOLEAN;
    tcpsocks              : pTCPSOCK;
    showip1               : IPNUM;
    showport1             : UDPPORT;
    systime, keeptime     : TIME;

    ungates               : ARRAY[MIN(GATEFILT)..MAX(GATEFILT)] OF ARRAY[0..10]OF CHAR;
    timehash              : ARRAY[0..HASHSIZE-1] OF TIME;
    udpdonetime,
    dupetime, uptime      : TIME;
    rawlogname,
    netbeaconfn,
    logframename          : FILENAME;
    lastdnstime,
    gateconndelay,
    netbeaconintervall    : TIME;
    vcourse, vspeed,
    compos,
    qas, qasc, 
    maxusers,httpcount    : CARDINAL;
    vsym, vsymt           : CHAR;
    valt,
    wwwsizelimit,
    logframes             : INTEGER;
    showid, servercall    : MONCALL;
    home                  : POSITION;                         (* own position *)
    passwd                : ARRAY[0..5] OF CHAR;
    serverrangefilter,
    actfilter             : ARRAY[0..255] OF CHAR;
    wwwdir                : ARRAY[0..1023] OF CHAR;
    tcpbindport, 
    wwwbindport           : ARRAY[0..5] OF CHAR;
    nettorfpath           : ARRAY[0..80] OF CHAR;
    udpsocks              : pUDPSOCK; 
    trygate               : CARDINAL;
    qmaxtime              : INTEGER;
    gateways              : ARRAY[0..20] OF RECORD
                              url:ARRAY[0..255] OF CHAR;
                              port:ARRAY[0..5] OF CHAR;
                              resolvtime,
                              connecttime:TIME;
                              filterst:ARRAY[0..255] OF CHAR;
                            END;  

<*IF MSG THEN*>
  rfdestcall,
  netdestcall,
  viacall    :MONCALL;
  netmhin,
  netmhout,
  msghttpcount,
  mhhttpcount,
  maxmsg,
  maxatonce  :CARDINAL;
  lastrfsent,
  purgeunack,
  purgemsg,
  purgeacked,
  purgeunacksent,
  rfquiet,
  heardtimevia,
  heardtimew,
  heardtime  :TIME;
  messages   :pMESSAGE;
  heardvia,
  hearddir   :pHEARD;
  sendnetmsg :BOOLEAN;
  netmh      :ARRAY[0..99] OF MONCALL;
  mhfilelines:CARDINAL;
  mhfilename :FILENAME;
<*END*>

PROCEDURE Rename(fname,newname: ARRAY OF CHAR);
VAR ok:BOOLEAN;
BEGIN
  FileSys.Rename(fname, newname, ok);
END Rename;


PROCEDURE Err(text-:ARRAY OF CHAR);
BEGIN
  WrStr("udpgate: "); WrStr(text); WrStrLn(" error abort");
  HALT
END Err;

PROCEDURE Max(a,b:CARDINAL):CARDINAL;
BEGIN IF a>b THEN RETURN a ELSE RETURN b END; END Max;


PROCEDURE skipblank(s-:ARRAY OF CHAR; VAR p:CARDINAL);
BEGIN WHILE (p<HIGH(s)) & (s[p]=" ") DO INC(p) END; END skipblank;

PROCEDURE FiltToStr(f:FILTERS; VAR s:ARRAY OF CHAR);

  PROCEDURE app(x:REAL; rad:BOOLEAN);
  VAR h:ARRAY[0..29] OF CHAR;
  BEGIN
    Append(s,"/");
    IF rad THEN FixToStr(x/RAD,5,h) ELSE FixToStr(x,0,h) END;
    Append(s,h);
  END app;

  PROCEDURE wrcalls(tab-:ARRAY OF MONCALL; not:BOOLEAN; sym:CHAR);
  VAR j:CARDINAL;
  BEGIN
    IF tab[0][0]<>0C THEN
      IF s[0]<>0C THEN Append(s," ") END;
      IF not THEN Append(s,"-") END;
      Append(s,sym);
      j:=0;
      WHILE tab[j][0]<>0C DO
        Append(s,"/");
        Append(s, tab[j]);
        INC(j);
      END;
    END;
  END wrcalls;


BEGIN
  s[0]:=0C;
  WITH f DO
    IF typ="a" THEN  
      Assign(s, "a");
      app(base.lat, TRUE);
      app(base.long, TRUE);
      app(edge.lat, TRUE);
      app(edge.long, TRUE);
    ELSIF typ="r" THEN
      Assign(s, "r");
      app(base.lat, TRUE);
      app(base.long, TRUE);
      app(radius, FALSE);
    ELSIF typ="m" THEN
      Assign(s, "m");
      app(radius, FALSE);
    END;

    wrcalls(viacalls, notvia, "d");
    wrcalls(entrycalls, notentry, "e");

  END;
END FiltToStr;


PROCEDURE Watchclock(VAR t:TIME; intervall:TIME):BOOLEAN;
VAR tn:TIME;
BEGIN
  IF (intervall>0) OR (t=0) THEN    (* send once *)
    tn:=systime;
    IF t<=tn THEN
      INC(t, intervall);
      IF t<=tn THEN t:=tn+intervall END;
      RETURN TRUE
    END;
  END;
  RETURN FALSE
END Watchclock; 


PROCEDURE call2pass(c-:ARRAY OF CHAR):CARDINAL;
CONST ROOT=CAST(BITSET, 073E2H);
VAR i:CARDINAL;
    s:BITSET;
BEGIN
  s:=ROOT;
  i:=0;
  WHILE (i<=HIGH(c)) & (c[i]<>0C) & (c[i]<>"-") DO 
    s:=s/SHIFT(CAST(BITSET, ORD(CAP(c[i]))),VAL(INTEGER,NOT ODD(i))*8); 
    INC(i);
  END;
  RETURN CAST(CARDINAL, s*BITSET{0..14})
END call2pass;


PROCEDURE GetSec(h:ARRAY OF CHAR; VAR p, n:CARDINAL):INTEGER;
VAR ok:BOOLEAN;
BEGIN
  h[HIGH(h)]:=0C;
  n:=0;
  ok:=FALSE;
  WHILE (h[p]>="0") & (h[p]<="9") DO
    ok:=TRUE;
    n:=n*10+ORD(h[p])-ORD("0");
    INC(p);
  END;
  IF NOT ok THEN RETURN -1 END;
(*
IO.WrCard(n,10); IO.WrLn;
*)
  RETURN 0
END GetSec;

PROCEDURE callok(h-:ARRAY OF CHAR):BOOLEAN;
VAR i,num,lit:CARDINAL;
    c:CHAR;
BEGIN
  num:=0;
  lit:=0;
  i:=0;
  LOOP
    c:=h[i];
    IF (c>="0") & (c<="9") THEN INC(num) ELSIF (c>="A") & (c<="Z") THEN INC(lit) ELSE EXIT END;
    INC(i);
  END;
  IF (lit<2) OR (num=0) OR (num>2) THEN RETURN FALSE END;
  IF h[i]="-" THEN
    INC(i);
    IF h[i]="1" THEN
      INC(i);
      IF (h[i]>="0") & (h[i]<="5") THEN INC(i) END;
    ELSIF (h[i]<"1") OR (h[i]>"9") THEN RETURN FALSE ELSE INC(i) END;
  END;
  RETURN h[i]=0C
END callok;


PROCEDURE parms;
VAR h          : ARRAY[0..4095] OF CHAR;
    err        : BOOLEAN;
    lasth      : CHAR;
    i, n       : CARDINAL;
    gatecnt    : CARDINAL;
    fd, len    : INTEGER;
    usock, ush : pUDPSOCK;
    ii         : INTEGER; 
BEGIN
  err:=FALSE;
  verb:=FALSE;
  gatecnt:=0;
  keeptime:=0; (*600*)                          (* default keep connected to gateway time *)
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN
      lasth:=h[1];

      IF (lasth="R") OR (lasth="M") THEN
        NextArg(h);
        ALLOCATE(usock, SIZE(usock^));
        IF usock=NIL THEN Err("out of memory") END;

        FILL(usock, 0C, SIZE(usock^));
        WITH usock^ DO
          IF GetIp2(h, ip, dport, bindport, checkip)<0 THEN Err("-R or -M need ip:port:port") END;
          fd:=udp.openudp();
          rawread:=lasth="R";
          IF (fd<0) OR (udp.bindudp(fd, bindport)<0) THEN Err("-R or -M cannot bind udpport") END;

          len:=udp.socknonblock(fd);

          ii:=InStr(h, "+");
          IF ii>0 THEN 
            i:=ii+1;
            IF (GetSec(h,i,n)>=0) THEN 
              maxbytes:=n;
              INC(i);
              IF (h[i-1]=":") & (GetSec(h,i,n)>=0) THEN torfradius:=FLOAT(n) END;
            END;
          END;

          ii:=InStr(h, "#");                   (* get port name *)
          IF ii>0 THEN
            INC(ii);
            i:=0;
            WHILE (i<=HIGH(portname)) & (ii<=HIGH(h)) & (h[ii]<>0C) DO
              portname[i]:=h[ii];
              INC(i);
              INC(ii);
            END;
          END;

          next:=NIL;
        END;
        IF udpsocks=NIL THEN udpsocks:=usock;
        ELSE 
          ush:=udpsocks; 
          WHILE ush^.next<>NIL DO ush:=ush^.next END; 
          ush^.next:=usock;
        END; 

      ELSIF lasth="c" THEN callsrc:=TRUE;

      ELSIF (lasth="s") OR (lasth="S") THEN
        NextArg(h);
        Assign(servercall, h);
        IF (servercall[0]=0C) OR (servercall[0]="-") OR ((lasth="s") & NOT callok(h)) 
        THEN Err("-s call-ssid") END;

      ELSIF lasth="p" THEN
        NextArg(h);
        IF (h[0]>="0") & (h[0]<="9") THEN
          i:=0;  
          WHILE (i<=HIGH(passwd)) & (h[i]>=" ") DO passwd[i]:=h[i]; INC(i) END;
        ELSE
          fd:=OpenRead(h);
          IF fd<0 THEN Err("-p passcode or passwordfile") END;
          len:=RdBin(fd, passwd, SIZE(passwd)-1);
          IF len>=0 THEN passwd[len]:=0C ELSE Err("-p error with password file") END;
          Close(fd);
        END;
        passwd[HIGH(passwd)]:=0C;
        i:=0; 
        WHILE (passwd[i]>="0") & (passwd[i]<="9") DO INC(i) END;
        IF (i=0) OR (passwd[i]<>0C) THEN Err("-p invalid passcode") END;

      ELSIF lasth="m" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN maxusers:=n ELSE Err("-m number") END;

      ELSIF lasth="D" THEN
        NextArg(h);
        Assign(wwwdir, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-D directory") END;

      ELSIF lasth="d" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN dupetime:=n ELSE Err("-d number") END;
        IF dupetime<27 THEN WrStrLn("-d do not set dupefilter less 27s!") END;

      ELSIF lasth="e" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN 
          IF n=0 THEN n:=1 END;
          gateconndelay:=n;
        ELSE Err("-e seconds") END;

<*IF MSG THEN*>
      ELSIF lasth="H" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN heardtimew:=n*60 ELSE Err("-H minutes") END;

      ELSIF lasth="I" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN heardtimevia:=n*60 ELSE Err("-I minutes") END;
<*END*>

<*IF MSG THEN*>
      ELSIF lasth="L" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN maxmsg:=n ELSE Err("-L number") END;
<*END*>

      ELSIF lasth="l" THEN
        NextArg(h);
        i:=0;
        IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN
          logframes:=n;
          INC(i);
          FOR n:=0 TO HIGH(logframename) DO 
            IF i<=HIGH(h) THEN 
              logframename[n]:=h[i];
              INC(i);
            END;
          END;
          IF logframename[0]<=" " THEN Err("-l loglevel:filename") END;
        ELSE Err("log format is level:file") END;

      ELSIF lasth="r" THEN
        NextArg(rawlogname);
        IF rawlogname[0]<=" " THEN Err("-r rawlogfilename") END;

      ELSIF lasth="F" THEN
        NextArg(h);
        i:=0;
        IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN
          mhfilelines:=n;
          INC(i);
          FOR n:=0 TO HIGH(mhfilename) DO
            IF i<=HIGH(h) THEN
              mhfilename[n]:=h[i];
              INC(i);
            END;
          END;
          IF mhfilename[0]<=" " THEN Err("-F MHfilename") END;
        ELSE Err("MH File lines:file") END;

      ELSIF lasth="n" THEN
        NextArg(h);
        i:=0;
        IF (GetSec(h,i,n)>=0) & (h[i]=":") THEN
          netbeaconintervall:=n*60;
          INC(i);
          FOR n:=0 TO HIGH(netbeaconfn) DO 
            IF i<=HIGH(h) THEN 
              netbeaconfn[n]:=h[i];
              INC(i);
            END;
          END;
          IF netbeaconfn[0]<=" " THEN Err("-n netbeacon filename") END;
        ELSE Err("-n netbeacon format is minutes:file") END;

      ELSIF lasth="N" THEN sendnetmsg:=FALSE;

      ELSIF lasth="t" THEN
        NextArg(h);
        Assign(tcpbindport, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-t port") END;

      ELSIF lasth="w" THEN
        NextArg(h);
        Assign(wwwbindport, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-w port") END;

      ELSIF lasth="f" THEN
        NextArg(h);
        Assign(serverrangefilter, h);
        IF (h[0]=0C) OR (h[0]="-") THEN Err("-f rangefilter") END;
        FOR i:=0 TO Length(serverrangefilter) DO
          IF serverrangefilter[i]="," THEN serverrangefilter[i]:=" " END;
        END;  

      ELSIF lasth="g" THEN                     (* "url port" or "url:port" or "url:port#filter" *) 
        NextArg(h);
        IF h[0]=0C THEN Err("-g url port") END;
        IF gatecnt>HIGH(gateways) THEN Err("-g gateway table full") END;

        h[HIGH(h)]:=0C;
        IF h[0]="[" THEN
          ii:=1;
          WHILE (h[ii]<>0C) & (h[ii]<>"]") DO INC(ii) END;
          IF (h[ii]<>"]") OR (h[ii+1]<>":") THEN Err("-g [url]:port") END;

          h[ii]:=0C;
          i:=1;
          WHILE i<=HIGH(h) DO h[i-1]:=h[i]; INC(i) END;
          
        ELSE ii:=InStr(h, ":") END;
        IF ii>=0 THEN h[ii]:=0C END;
        Assign(gateways[gatecnt].url, h);
        IF ii>0 THEN                           (* port number *)
          INC(ii);
          i:=0;
          WHILE ii<=HIGH(h) DO h[i]:=h[ii]; INC(i); INC(ii) END;
        ELSE NextArg(h) END;

        h[HIGH(h)]:=0C;
        ii:=InStr(h, "#");
        IF ii>=0 THEN h[ii]:=0C END;
        IF h[0]=0C THEN Err("-g url:port") END;
        Assign(gateways[gatecnt].port, h);

        IF ii>0 THEN                           (* we have a filter string *)    
          INC(ii);
          i:=0;
          WHILE ii<=HIGH(h) DO 
            IF h[ii]="," THEN h[ii]:=" " END;
            h[i]:=h[ii];
            INC(i);
            INC(ii);
          END;
          Assign(gateways[gatecnt].filterst, h);
        END;

        INC(gatecnt);

      ELSIF lasth="h" THEN
        WrStrLn(" -c             delete frames with no valid source call in APRS-IS stream");
        WrStrLn(" -D <path>      www server root directory (-D /usr/www/)");
        WrStrLn(" -d <time>      dupe filter time in seconds, not below 27s! (default 60s)");
        WrStrLn(" -e <time>      wait before (re)connect to (next) gateway in seconds, (30s)");
<*IF MSG THEN*>
        WrStrLn(" -F <lines>:<file> write direct heard file (call,sym,port,s,cnt,km,data,path)");
<*END*>
        WrStrLn(" -f <filters>   backstream filter text sent to out connected server -f m/50");
        WrStrLn("                if blanks dont pass parameter settings use , (-f m/30,-d/CW)");
        WrStrLn(" -g <url>:<port>[#<filters>] connect to APRS-IS gateway, repeat -g for a list");
        WrStrLn("                with favorites first and all urls will be tried to connect");
        WrStrLn("                if the active connect is not the first in list, urls");
        WrStrLn("                before will be polled and if gets connected, data transfer");
        WrStrLn("                is switched to this link and the old gets disconnected");
        WrStrLn("                if no filter setting, global -f filter is used");
        WrStrLn("                -g www.db0anf.de:14580#m/50 -g 127.0.0.1:3000");
        WrStrLn("                ipv6 if enabled by kernel -g [::1]:14580#m/200");
        WrStrLn(" -h             this");
<*IF MSG THEN*>
        WrStrLn(" -H <time>      direct heard keep time minutes (Min) (-H 1440)");
        WrStrLn(" -I <time>      indirect heard keep time minutes (Min) (-I 30)");
        WrStrLn(" -j <time>      maximum time to (re)send messages (s) (-j 43200)");
<*END*>
        WrStrLn(" -k <time>      0 always connect to gateway else connect on demand and hold (0)");
        WrStrLn("                (seconds) after last User gone or valid UDP Data arrived");
<*IF MSG THEN*>
        WrStrLn(" -L <number>    max messages stored else delete oldest (-L 1000)");
        WrStrLn("                -L 0 and -x set and net-to-rf enabled all msg to heard gatet");
<*END*>
        WrStrLn(" -l <level>:<file> logfile -l 6:/tmp/log.txt");
        WrStrLn("                level: 1 logins, 2 +sent frames, 6 +fitered frames, 7 +dups");
        WrStrLn(" -M <ip>:<dport>/<lport>[+<byte/s>[:<radius>]][#<portname>]");
        WrStrLn("                udp rf port (monitor frame format) for local (t)rx");
        WrStrLn("                <dport>:<lport> read from any ip, dport=0 no tx");
        WrStrLn("                +byte/s enable inet to rf for services like WLNK, WHO-IS");
        WrStrLn("                :radius enable all inet to rf gate (from km around digi)");
        WrStrLn("                messages to NOT direct heard users are gated at any radius >0");
        WrStrLn("                #portname max 10 char like '144800'");
        WrStrLn("                repeat -M for each radio port with a tx or different portname");
        WrStrLn(" -m <maxconnects> max inbound connects -m 20 (default 50)");
        WrStrLn(" -N             send no stored messages to net except query answers");
        WrStrLn(" -n <min>:<file> netbeacon minutes:filename -n 10:netbeacon.txt");
        WrStrLn("                \\z ddhhmm, \\h hhmmss, \\:filename: insert file, \\\ is \\");
        WrStrLn("                beacon file like: !8959.00N/17959.00E&igate mars");
        WrStrLn("                beacon file used by udpgate itself to find out own position");
<*IF MSG THEN*>
        WrStrLn(" -P <time[:time]> purge unacked (:acked) messages after seconds (-P 86400:300)");
<*END*>
        WrStrLn(" -p <password>  login passwort for aprs-is servers -p 12345");
        WrStrLn("                to hide password in commandline use file mode -p pass.txt");
        WrStrLn(" -Q <n>         send netbeacon with qAS if qAI dont pass some servers");
        WrStrLn("                0=never, 1=always else every n beacons send 1 with qAI");
<*IF MSG THEN*>
        WrStrLn(" -q <time>      quiet time after rf tx seconds (-q 10)");
<*END*>
        WrStrLn(" -r <filename>  write a dated 1 day logfile with date+time+data lines");
        WrStrLn(" -R             same as -M but axudp format");
        WrStrLn(" -s <call>      server call of this server -s MYCALL-10 (-S no callcheck)");
        WrStrLn(" -T <seconds>   kill link to server if unack tcp bytes are longer in tx queue");
        WrStrLn("                avoids delayed trackpoints (default 15s, off 0, max 60)");
        WrStrLn(" -t <localport> local igate tcp port for in connects -t 14580");
<*IF MSG THEN*>
        WrStrLn(" -U <time[:time]> purge unsent(:sent) unack messages after seconds (-P 900:60)");
<*END*>
        WrStrLn(" -v             show frames and analytics on stdout");
        WrStrLn(" -V             Via Path for net to rf frames");
        WrStrLn(" -W <filesize>  limit www server file size in 1024byte, (-W 1000)");
        WrStrLn(" -w <port>      port of www server -w 14501");
<*IF MSG THEN*>
        WrStrLn(" -x <call>      via <call> send messages to rf (-x OE0AAA-10) tx off: -x -");
        WrStrLn("                default is server call");
<*END*>
        WrStrLn("udpgate -v -R 127.0.0.1:9200:9201 -s MYCALL-10 -l 7:aprs.log -n 10:beacon.txt -t 14580 -g www.server.org:14580#m/30 -p 12345");

        HALT
(*
      ELSIF lasth="u" THEN
        NextArg(h);
        IF GetIp(h, rfgateip, rfgateport)<0 THEN Err("-u wrong ip:port") END;
*)       
<*IF MSG THEN*>

      ELSIF lasth="j" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN msgsendtime:=n ELSE Err("-j seconds") END;

      ELSIF lasth="P" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN purgemsg:=n ELSE Err("-P seconds") END;
        IF h[i]=":" THEN
          INC(i);
          IF GetSec(h,i,n)>=0 THEN purgeacked:=n ELSE Err("-P seconds:seconds") END;
        END;

      ELSIF lasth="U" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN purgeunack:=n ELSE Err("-U seconds") END;
        IF h[i]=":" THEN
          INC(i);
          IF GetSec(h,i,n)>=0 THEN purgeunacksent:=n ELSE Err("-U seconds:seconds") END;
        END;
<*END*>

      ELSIF lasth="Q" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN qas:=n ELSE Err("-Q number") END;

<*IF MSG THEN*>
      ELSIF lasth="q" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN rfquiet:=n ELSE Err("-q seconds") END;
<*END*>

      ELSIF lasth="v" THEN
        verb:=TRUE;

      ELSIF lasth="V" THEN
        NextArg(h);
        Assign(nettorfpath, h);
        IF (h[0]=0C) OR (h[0]="-") & (h[1]<>0C) THEN Err("-V net to rf via path") END;

      ELSIF lasth="k" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN keeptime:=n ELSE Err("-k seconds") END;

      ELSIF lasth="T" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN qmaxtime:=n ELSE Err("-T seconds") END;
        IF qmaxtime>HIGH(tcpsocks^.qwatch.txbyte) THEN qmaxtime:=HIGH(tcpsocks^.qwatch.txbyte) END;

<*IF MSG THEN*>
      ELSIF lasth="x" THEN
        NextArg(h);
        Assign(viacall, h);
        IF (h[0]=0C) OR (h[0]="-") & (h[1]<>0C) THEN Err("-x call") END;
<*END*>

      ELSIF lasth="W" THEN
        NextArg(h);
        i:=0;
        IF GetSec(h,i,n)>=0 THEN wwwsizelimit:=n*1024 ELSE Err("-W kbytes") END;

      ELSE err:=TRUE END;
      (*h[0]:=0C;*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN Append(h, " ? use -h"); Err(h) END;
  IF servercall[0]=0C THEN WrLn; WrStrLn("udpgate: NO SERVERCALL ?"); WrLn; END;
  IF (wwwbindport[0]<>0C) & (wwwdir=0C) 
  THEN WrLn; WrStrLn("udpgate: -w www-port but no -D icon-dir-path ?"); WrLn; END;
END parms;

PROCEDURE porttosock(p:CARDINAL):pUDPSOCK;
VAR s:pUDPSOCK;
BEGIN
  IF p=0 THEN RETURN NIL 
  ELSE
    s:=udpsocks;
    WHILE (s<>NIL) & (p>1) DO s:=s^.next; DEC(p) END;
  END;
  RETURN s
END porttosock;

(*
PROCEDURE udpstat(usock:pUDPSOCK; len:INTEGER; fromport:UDPPORT; ipn:IPNUM);
VAR i, oldi : INTEGER;
    oldt    : TIME;
    
BEGIN
  i:=0;
  oldt:=systime;
  oldi:=0;
  LOOP
    IF (usock^.stat[i].uip=ipn) & (usock^.stat[i].uport=fromport) THEN
      oldi:=i;
      i:=HIGH(usock^.stat);
    END;
    IF i>=HIGH(usock^.stat) THEN
      WITH usock^.stat[oldi] DO
        uport:=fromport;
        uip:=ipn;        
        IF ((dtime+utime) DIV 2>systime)             (* allow clock back step till 1/2 uptime *) 
        OR (utime+UDPSHOWTIME<systime) THEN          (* reset statistic *)
          dtime:=systime;
          rxframes:=0;
          rxbytes:=0;
(*
          IF usock^.lasttxtime+UDPSHOWTIME<systime THEN          (* reset tx statistic *)

          usock^.txframes:=0;
          usock^.txbytes:=0;
*)
        END;
        IF len>0 THEN INC(rxframes) END;
        INC(rxbytes, len);
        utime:=systime;
        usock^.laststat:=oldi;
      END;
      EXIT
    END;

    IF usock^.stat[i].utime<oldt THEN
      oldt:=usock^.stat[i].utime;
      oldi:=i;
    END;
 
    INC(i);
  END;
END udpstat; 
*)


PROCEDURE Sendudp(s-:FRAMEBUF; totx:CARDINAL; unlimit:BOOLEAN);
VAR len:INTEGER;
    raw:FRAMEBUF;
    us:pUDPSOCK;
BEGIN
  us:=porttosock(totx);                                         (* send to which udp modem *)
  IF (us<>NIL) & (unlimit OR ((systime-us^.lasttxtime)*us^.maxbytes>us^.lasttxbytes)) THEN
    IF us^.rawread THEN mon2raw(s, raw, len) ELSE len:=Length(s)+1; raw:=s END;
    IF len>1 THEN 
      WITH us^ DO
--        udpstat(us, 0, dport, ip);
        lasttxbytes:=len;
        lasttxtime:=systime;
        INC(txframes);
        INC(txbytes, len);
      END;

      len:=udp.udpsend(us^.fd, raw, len, us^.dport, us^.ip);
    ELSIF verb THEN WrStrLn("wrong inet to rf frame format") END;
  END; 
END Sendudp;


PROCEDURE getudp(usock:pUDPSOCK; VAR buf:FRAMEBUF):BOOLEAN;
VAR fromport     : UDPPORT;
    ipn          : IPNUM;
    crc1, crc2   : CHAR;
--    len, i       : INTEGER;
    len, i, oldi : INTEGER;
    mlen         : CARDINAL;
    mbuf         : FRAMEBUF; 
    oldt         : TIME;
    
BEGIN
  len:=udp.udpreceive(usock^.fd, buf, SIZE(buf), fromport, ipn);
  IF (len>2) & (len<CAST(INTEGER, SIZE(buf))) & (NOT usock^.checkip OR (usock^.ip=ipn)) THEN
    buf[len]:=0C;
    IF usock^.rawread THEN
      crc1:=buf[len-2];
      crc2:=buf[len-1];
      AppCRC(buf, len-2);
      IF (crc1<>buf[len-2]) OR (crc2<>buf[len-1]) THEN 
        IF verb THEN WrStrLn(" axudp crc error") END; 
        buf[0]:=0C;
      ELSE  
        raw2mon(buf, mbuf, len-2, mlen);
        IF (mbuf[0]=0C) & verb THEN 
          WrStrLn(" axudp frame decode error");

 FOR i:=0 TO len-3 DO WrHex(ORD(buf[i]),3) END;
 WrLn;
 i:=0;
 LOOP
   IF i>=len-3 THEN EXIT END;
   IF ORD(buf[i]) DIV 2<ORD(" ") THEN WrStr("<") ; WrHex(ORD(buf[i]) DIV 2,1); WrStr(">");
   ELSE WrStr(CHR(ORD(buf[i]) DIV 2)) END;
   IF ODD(ORD(buf[i])) THEN EXIT END;
   IF i MOD 7=6 THEN WrStr(",") END;
   INC(i);
 END;
 WrLn;

        END;
        buf:=mbuf;
      END; 
      len:=Length(buf);                  (* for statistic *)
    END;

---    udpstat(usock, len, fromport, ipn);

(* statistic *)
    i:=0;
    oldt:=systime;
    oldi:=0;
    LOOP
      IF (usock^.stat[i].uip=ipn) & (usock^.stat[i].uport=fromport) THEN
        oldi:=i;
        i:=HIGH(usock^.stat);
      END;
      IF i>=HIGH(usock^.stat) THEN
        WITH usock^.stat[oldi] DO
          uport:=fromport;
          uip:=ipn;        
          IF ((dtime+utime) DIV 2>systime)             (* allow clock back step till 1/2 uptime *) 
          OR (utime+UDPSHOWTIME<systime) THEN          (* reset statistic *)
            dtime:=systime;
--            usock^.txframes:=0;
--            usock^.txbytes:=0;
            rxframes:=0;
            rxbytes:=0;
          END;
          INC(rxframes);
          INC(rxbytes, len);
          utime:=systime;
          usock^.laststat:=oldi;
        END;
        EXIT
      END;

      IF usock^.stat[i].utime<oldt THEN
        oldt:=usock^.stat[i].utime;
        oldi:=i;
      END;

      INC(i);
    END;

  ELSE RETURN FALSE END;
  RETURN TRUE
END getudp; 
    

PROCEDURE Gettcp(fd:INTEGER; VAR line, buf:FRAMEBUF; VAR pos:INTEGER):INTEGER;
VAR len,i,j:INTEGER;
BEGIN
  i:=pos;
  IF i>=SIZE(line) THEN i:=0 END;                             (* pos>SIZE is overflow mode *)
(*
  len:=RdBin(fd, line, SIZE(line)-i);
  IF len<=0 THEN RETURN -1 END;                               (* disconnected *)
*)
(*
  IF len<0 THEN len:=0 END;
*)
  len:=tcp.readsock(fd, line, SIZE(line)-i);

  IF len<0 THEN RETURN -1 END;

  IF pos>=SIZE(buf) THEN                                      (* hunt mode *)
    i:=0; 
    WHILE (i<len) & (line[i]<>12C) DO INC(i) END;
    IF i>=len THEN RETURN 0 END;                              (* no line start found *)
    pos:=0;
    INC(i);
    j:=0;
    WHILE i<len DO line[j]:=line[i]; INC(j); INC(i) END;
    len:=j;
  END;

  IF pos>0 THEN
    FOR i:=len-1 TO 0 BY -1 DO line[i+pos]:=line[i] END;      (* move up new *)
    FOR i:=0 TO pos-1 DO line[i]:=buf[i] END;                 (* ins buf before *)
    INC(len,pos);
    pos:=0;  
  END;

  i:=0;
  WHILE (i<len) & (line[i]<>12C) DO INC(i) END;
  IF i>=len THEN                                              (* no line end found *)
    WHILE pos<len DO buf[pos]:=line[pos]; INC(pos) END;       (* move to buf *)
    len:=0;  
  ELSE
    j:=i+1;
    WHILE j<len DO buf[pos]:=line[j]; INC(pos); INC(j) END;   (* move rest to buf *)  
    len:=i;
  END;
  line[len]:=0C;
  RETURN len
END Gettcp;

PROCEDURE showpip(ip:IPNUM; port:UDPPORT; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..20] OF CHAR;
BEGIN
  IntToStr(ip DIV 1000000H, 1, s);
  Append(s,".");
  IntToStr(ip DIV 10000H MOD 100H, 1, h);
  Append(s,h);
  Append(s,".");
  IntToStr(ip DIV 100H MOD 100H, 1, h);
  Append(s,h);
  Append(s,".");
  IntToStr(ip MOD 100H, 1, h);
  Append(s,h);
  IF port<>0 THEN
    Append(s,":");
    IntToStr(port, 1, h);
    Append(s,h);
  END;
END showpip;

(*
PROCEDURE clrstr(VAR s:ARRAY OF CHAR);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(s)) & (s[i]<>0C) DO
    IF s[i]<" " THEN s[i]:="." END;
    INC(i);
  END;
END clrstr;
*)

PROCEDURE logline(r:INTEGER; s:ARRAY OF CHAR);
VAR h:ARRAY[0..511] OF CHAR;
    fd:INTEGER;
    i:CARDINAL;
BEGIN
  IF (logframename[0]<>0C) & (logframes+r>1) THEN
    fd:=OpenAppend(logframename);
    IF fd<0 THEN fd:=OpenWrite(logframename) END;
    IF fd>=0 THEN
      DateToStr(systime, h);
      Append(h, " ");
      Append(h, s);
      Append(h,""+LF);
      WrBin(fd, h, Length(h));
      Close(fd);
    ELSE WrStr("cannot write"); WrStr(logframename); WrLn; END;
  END;
  IF verb (* & (r<>-5) *) THEN 
    i:=Length(s);
    IF (i>=2) & (s[i-1]=LF) & (s[i-2]=CR) THEN s[i-2]:=0C END; 
    CtrlHex(s);
    WrStrLn(s);
  END;
END logline;

PROCEDURE writerawlog(b-:FRAMEBUF);
VAR h:ARRAY[0..511] OF CHAR;
    fn:FILENAME;
    l, i:CARDINAL;
    f:INTEGER;
BEGIN
  l:=Length(b);
  WHILE (l>0) & (b[l-1]<=15C) DO DEC(l) END;         (* delete trailing junk *)
  IF l>0 THEN
    DateToStr(systime, h);
    h[4]:=h[5];
    h[5]:=h[6];
    h[6]:=h[8];
    h[7]:=h[9];
    h[8]:=0C;
    h[9]:=h[11];
    h[10]:=h[12];
    h[11]:=h[14];
    h[12]:=h[15];
    h[13]:=h[17];
    h[14]:=h[18];
    h[15]:=" ";
    Assign(fn, rawlogname);
    Append(fn, h);
    h[8]:=":";
 
    f:=OpenAppend(fn);
    IF f<0 THEN f:=OpenWrite(fn) END;
    IF f>=0 THEN
      IF l>=HIGH(h)-16 THEN l:=HIGH(h)-16 END;
      i:=0;
      REPEAT h[i+16]:=b[i]; INC(i) UNTIL i>=l;
      h[i+16]:=LF; INC(i);
  
      WrBin(f, h, i+16);
      Close(f);
    ELSIF verb THEN WrStr("cannot write "); WrStrLn(fn) END;
  END;
END writerawlog;

PROCEDURE showframe(r:INTEGER; sp:pTCPSOCK; su:pUDPSOCK; buf-:ARRAY OF CHAR; pos:POSITION);
VAR h, s:ARRAY[0..511] OF CHAR;
BEGIN
  IF sp=NIL THEN 
    IF su<>NIL THEN
      s:="U:";
      WITH su^ DO 
        IF (stat[laststat].uip<>showip1) OR (stat[laststat].uport<>showport1) THEN
          showip1:=stat[laststat].uip;
          showport1:=stat[laststat].uport;
          showpip(showip1, showport1, h); Append(s,h); Append(s,":");
        END;
      END;
    ELSE s:=" :" END;
  ELSE
    s[0]:=sp^.service; s[1]:=":"; s[2]:=0C; 
    IF (sp^.user.call[0]<>0C) & NOT StrCmp(sp^.user.call, showid) THEN
      Append(s, sp^.user.call); Append(s,":");
      Assign(showid, sp^.user.call);
    END;
  END;
(*
IO.WrFixed(distance(home,pos), 1, 10); IO.WrStr("km"); IO.WrLn;
*)
  CASE r OF
   | 0: IF NOT posvalid(pos) OR NOT posvalid(home) THEN h:="--->" 
        ELSE IntToStr(TRUNC(0.5+distance(home, pos)), 3, h); Append(h, ">") END;
   |-1: h:="syn:";
   |-2: h:="len:";
   |-3: h:="cal:";
   |-4: h:="msg:";
   |-5: h:="dup:";
   |-6: h:="ung:";
  ELSE  h:="   :";
  END;
  Append(s,h);
  Append(s, buf);
  logline(r, s);
END showframe;

PROCEDURE appkib(VAR s:ARRAY OF CHAR; h,l:CARDINAL);
VAR b:ARRAY[0..40] OF CHAR;
BEGIN
  IF h>0 THEN CardToStr(l DIV 1024 + h*4194304, 1, b); Append(s, "kB=");
  ELSE CardToStr(l, 1, b); Append(s, "B=") END;
  Append(s, b);
END appkib; 

PROCEDURE bitsec64(h, l:CARDINAL; t:TIME):CARDINAL;
VAR r:REAL;
BEGIN
  r:=(FLOAT(h)*4294967296.0 + FLOAT(l))*8.0/FLOAT(t);
  IF r>2000000000.0 THEN RETURN 2000000000 END;
  RETURN TRUNC(r)
END bitsec64;


PROCEDURE Statist(cp:pTCPSOCK; t:TIME; VAR s:ARRAY OF CHAR);
VAR h:ARRAY[0..255] OF CHAR;
    n:CARDINAL;
BEGIN
  WITH cp^ DO
    IF connt<t THEN DEC(t, connt) ELSE t:=0 END;
    Assign(s, " t="); TimeToStr(t, h); Append(s, h);
    CardToStr(txframes, 1, h); Append(s, " txf=");Append(s, h);
    CardToStr(rxframes, 1, h); Append(s, " rxf=");Append(s, h);
    Append(s, " tx"); appkib(s, txbytesh, txbytes);
    Append(s, " rx"); appkib(s, rxbytesh, rxbytes);
    IF t>0 THEN
      Append(s, " ");
      CardToStr(bitsec64(txbytesh, txbytes, t),  1, h); Append(s, h); Append(s, "tbit/s "); 
      CardToStr(bitsec64(rxbytesh, rxbytes, t),  1, h); Append(s, h); Append(s, "rbit/s");
    END;
  END;
END Statist;



PROCEDURE showlogout(sp:pTCPSOCK);
VAR h,t:ARRAY[0..255] OF CHAR;
BEGIN
  WITH sp^ DO
    IF slowlink THEN h:="T:slowlink closed " ELSE h:="T:connection closed " END;
    Append(h, user.call); Append(h," "); Append(h, ipnum); 
    IF connt<>0 THEN
      Statist(sp, systime, t);
(*
      ti:=time();
      IF ti<connt THEN ti:=0 ELSE DEC(ti, connt) END;
      Append(h," conntime ");
      TimeToStr(ti, t); 
*)
      Append(h, t); 
    END;
    Append(h,""+LF);
  END;
  logline(1, h);
END showlogout;


PROCEDURE Filter(to:pTCPSOCK; posc:POSCALL; dat-:ARRAY OF CHAR):BOOLEAN;

  PROCEDURE vias():BOOLEAN;
  VAR a,b,i,j:CARDINAL;
  BEGIN
    IF (to^.filters.viacalls[0][0]=0C) OR (dat[0]=0C) THEN RETURN FALSE END;

    b:=0;
    REPEAT
      a:=b+1;
      REPEAT
        INC(b); 
        IF (b>HIGH(dat)) OR (dat[b]=0C) THEN RETURN FALSE END;   (* not normal data *)

      UNTIL (dat[b]=",") OR (dat[b]=":");

      IF a>1 THEN
        j:=0;
        WITH to^.filters DO
          WHILE (j<=HIGH(viacalls)) & (viacalls[j][0]<>0C) DO
            i:=0;
            WHILE (a+i<b) & ((viacalls[j][i]="*") OR (viacalls[j][i]=dat[a+i])) DO
              INC(i);
              IF (i>HIGH(viacalls[0])) OR (viacalls[j][i]=0C) THEN RETURN TRUE END;

            END;
            INC(j);
          END;
        END;
      END;
    UNTIL dat[b]=":";
    RETURN FALSE
  END vias;

  PROCEDURE entrypoint():BOOLEAN;
  VAR a,b,i,j:CARDINAL;
  BEGIN
    IF to^.filters.entrycalls[0][0]=0C THEN RETURN FALSE END;

    i:=0;
    LOOP
      IF (i>HIGH(dat)-5) OR (dat[i]=0C) OR (dat[i]=":") THEN RETURN FALSE END; (* no qA *) 
      IF (dat[i]=",") & (dat[i+1]="q") & (dat[i+2]="A") & (dat[i+4]=",") THEN  (* ,qA., *)
        a:=i+5;
        b:=a;
        WHILE (b<HIGH(dat)) & (dat[b]<>0C) & (dat[b]<>":") DO INC(b) END;      (* call after qA *)
        EXIT
      END;
      INC(i);
    END;

    j:=0;
    WITH to^.filters DO
      WHILE (j<=HIGH(entrycalls)) & (entrycalls[j][0]<>0C) DO
        i:=0;
        WHILE (a+i<b) & ((entrycalls[j][i]="*") OR (entrycalls[j][i]=dat[a+i])) DO
          INC(i);
          IF (i>HIGH(entrycalls[0])) OR (entrycalls[j][i]=0C) THEN RETURN TRUE END;
        END;
        INC(j);
      END;
    END;
    RETURN FALSE
  END entrypoint;


VAR pass:BOOLEAN;
BEGIN
  pass:=FALSE;
  IF vias() THEN 
    IF to^.filters.notvia THEN RETURN FALSE ELSE pass:=TRUE END;   (* exclusion overloads *)
  END;

  IF entrypoint() THEN 
    IF to^.filters.notentry THEN RETURN FALSE ELSE pass:=TRUE END;
  END;

  IF pass OR (posc.typ=cUSERMESSAGE) THEN RETURN TRUE END;          (* pass messages and ack *)

  IF to^.filters.typ="m" THEN
   RETURN posvalid(to^.user.pos) & posvalid(posc.pos) 
         & (distance(to^.user.pos, posc.pos)<=to^.filters.radius)
  ELSIF to^.filters.typ="r" THEN
(*
IO.WrStr("l,b,l,b,d,r:"); IO.WrFixed(to^.filters.base.lat/RAD, 4,10); IO.WrFixed(to^.filters.base.long/RAD, 4,10);  
IO.WrFixed(posc.pos.lat/RAD, 4,10); IO.WrFixed(posc.pos.long/RAD, 4,10);
IO.WrFixed(distance(to^.filters.base, posc.pos), 4,10); IO.WrFixed(to^.filters.radius, 4,10);
IO.WrLn;
*)
    RETURN posvalid(posc.pos) & (distance(to^.filters.base, posc.pos)<=to^.filters.radius)
  ELSIF to^.filters.typ="a" THEN
(*
IO.WrStr("l,b,l,b,l,b,d,r:"); 
IO.WrFixed(to^.filters.base.lat/RAD, 4,10); IO.WrFixed(to^.filters.base.long/RAD, 4,10);  
IO.WrFixed(to^.filters.edge.lat/RAD, 4,10); IO.WrFixed(to^.filters.edge.long/RAD, 4,10);
IO.WrFixed(posc.pos.lat/RAD, 4,10); IO.WrFixed(posc.pos.long/RAD, 4,10);
IO.WrLn;
*)
    RETURN posvalid(posc.pos) & (to^.filters.base.lat>=posc.pos.lat) 
         & (to^.filters.base.long<=posc.pos.long)
         & (to^.filters.edge.lat<=posc.pos.lat) & (to^.filters.edge.long>=posc.pos.long) 
  END;
  RETURN TRUE;
END Filter;


PROCEDURE Sendtcp(to:pTCPSOCK; buf-:FRAMEBUF);
VAR len,i:INTEGER;
BEGIN
  len:=Length(buf);
  WITH to^ DO
    IF tlen+len<SIZE(tbuf) THEN
      FOR i:=0 TO len-1 DO tbuf[tlen]:=buf[i]; INC(tlen) END; 
      INC(txframes);
      INC(txbytes, len); IF txbytes<VAL(CARDINAL,len) THEN INC(txbytesh) END;       (* 32 bit overflow *)
    ELSIF verb THEN WrStrLn("tx buf overflow") END;
  END;
END Sendtcp;

PROCEDURE NetToRf(b-:ARRAY OF CHAR; rfport:CARDINAL);   (* send as 3rd party frame to rf *)
VAR tb:FRAMEBUF;
    i, len, viaend, viaused:CARDINAL;
    outer, ii:INTEGER;

  PROCEDURE filt(s-:ARRAY OF CHAR):BOOLEAN;
  VAR n:INTEGER;
  BEGIN n:=InStr(b, s); RETURN (n>=0) & (n<outer) END filt;
 
BEGIN
  outer:=InStr(b, ":");                                           (* test if gate to rf allowed *)
  IF (outer<0) OR filt("qAX") THEN RETURN END;

  viaend:=outer;
  WHILE (outer<VAL(INTEGER,HIGH(b))) & ((b[outer]<>":") OR (b[outer+1]="}")) DO INC(outer) END; 
  IF filt("TCPXX") OR filt("NOGATE") OR filt("RFONLY") THEN RETURN END;  

  Assign(tb, viacall);
  Append(tb, ">"+TOCALL);
  IF nettorfpath[0]<>0C THEN
    Append(tb, ",");
    Append(tb, nettorfpath);
  END;
  Append(tb, ":}");

  viaused:=0;
  WHILE (viaused<viaend) & (b[viaused]<>",") DO INC(viaused) END; (* find begin of via *)
  ii:=InStr(b, ",TCPIP");
  IF (ii<0) OR (ii>VAL(INTEGER, viaend)) THEN                                     (* remove all via if via TCPIP *) 
    i:=viaused;
    WHILE (i<viaend) & (b[i]<>"*") DO INC(i) END;                 (* used via *)
    IF (i<viaend) THEN viaused:=i END;                            (* used path found remove "*" *)
  END;  

  len:=Length(tb);
  i:=0;
--  WHILE (b[i]<>",") & (i<viaend) & (len<=HIGH(tb)) DO           (* original head remove via*)
  WHILE (i<viaused) & (len<=HIGH(tb)) DO                          (* original head with used via*)
    tb[len]:=b[i];
    INC(i);
    INC(len);
  END;
  IF len<=HIGH(tb) THEN tb[len]:=0C END; 

  Append(tb, ",TCPIP,"); 
  Append(tb, viacall);
  Append(tb, "*");

  len:=Length(tb);
  i:=viaend;
  WHILE (i<=HIGH(b)) & (b[i]<>0C) & (len<=HIGH(tb)) DO            (* original data part *)
    tb[len]:=b[i];
    INC(i);
    INC(len);
  END;
  IF len<=HIGH(tb) THEN tb[len]:=0C END;

  i:=0;
  WHILE (i<HIGH(tb)) & (tb[i]<>0C) & (tb[i]<>CR) & (tb[i]<>LF) DO INC(i) END;
  tb[i]:=0C;
  Sendudp(tb, rfport, FALSE);
END NetToRf;


PROCEDURE Sendall(buf-:FRAMEBUF; fromfd:INTEGER; posc-:POSCALL);
VAR t:pTCPSOCK; 
    u:pUDPSOCK;
    uport:CARDINAL;
(*
    len:INTEGER;
*)
BEGIN
  IF buf[0]<>0C THEN

    t:=tcpsocks;
    WHILE t<>NIL DO
      IF (t^.fd<>fromfd) & (t^.service<>cISWWW) 
      & (t^.connt>0) & Filter(t, posc, buf) THEN Sendtcp(t, buf) END;
      t:=t^.next;
    END;

    IF (fromfd>0) & posvalid(home) & posvalid(posc.pos) THEN
      u:=udpsocks;
      uport:=1;
      WHILE u<>NIL DO 
        IF (u^.torfradius>0.0) & (distance(home, posc.pos)<=u^.torfradius) THEN
          NetToRf(buf, uport);
        END;
        INC(uport);
        u:=u^.next;
      END;
    END;
(*
    IF rfgateport>0 THEN 
      len:=Length(buf);
      len:=udp.udpsend(udpsock.fd, buf, len, rfgateport, rfgateip);
    END;
*)
    IF rawlogname[0]<>0C THEN writerawlog(buf) END;

  END;
END Sendall;



PROCEDURE cmpfrom(a-:ARRAY OF CHAR; from:CARDINAL; b-:ARRAY OF CHAR):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (from<=HIGH(a)) & (b[i]<>0C) DO
    IF a[from]<>b[i] THEN RETURN FALSE END;
    INC(i); 
    INC(from);
  END;
  RETURN TRUE
END cmpfrom;

PROCEDURE beaconmacros(VAR s:ARRAY OF CHAR; VAR del:BOOLEAN);
CONST MSYM="\";
VAR i:CARDINAL;
    len,j:INTEGER;  
    ds,ns:ARRAY[0..255] OF CHAR;
    fn:ARRAY[0..1023] OF CHAR;
    f:INTEGER;
BEGIN
  del:=FALSE;
  i:=0;
  ns[0]:=0C;
  WHILE (i<HIGH(s)) & (s[i]<>0C) DO
    IF (s[i]=MSYM) & (s[i+1]=MSYM) THEN
      INC(i, 2);
      IF s[i]="z" THEN                       (* insert day, hour, min *)
        DateToStr(time(), ds);
        ds[0]:=ds[8]; ds[1]:=ds[9]; ds[2]:=ds[11]; ds[3]:=ds[12]; ds[4]:=ds[14]; ds[5]:=ds[15];
        ds[6]:=0C;
        Append(ns, ds); 
      ELSIF s[i]="h" THEN                    (* insert hour, min, s *)
        DateToStr(time(), ds);
        ds[0]:=ds[11]; ds[1]:=ds[12]; ds[2]:=ds[14]; ds[3]:=ds[15]; ds[4]:=ds[17]; ds[5]:=ds[18];
        ds[6]:=0C;
        Append(ns, ds); 
      ELSIF s[i]=":" THEN                    (* insert file *)
        fn[0]:=0C;
        INC(i);
        WHILE (i<HIGH(s)) & (s[i]<>0C) & (s[i]<>":") DO Append(fn, s[i]); INC(i) END;
        f:=OpenRead(fn);
        IF f>=0 THEN
          len:=RdBin(f, ds, SIZE(ds)-1);
          Close(f);
          j:=0;
          WHILE (j<len) & (ds[j]<>CR) & (ds[j]<>LF) & (ds[j]<>0C) DO 
            Append(ns, ds[j]); 
            INC(j);
          END;
        ELSE
          IF verb THEN WrLn; WrStrLn("beacon macro file not readable "); END;
          s[0]:=0C;
          RETURN

        END; 
      ELSIF (s[i]="r") & (s[i+1]="m") THEN   (* delete beacon file *)
        s[0]:=0C;
        del:=TRUE;
        RETURN

      ELSIF s[i]="\" THEN Append(ns, "\\");
      ELSE
        IF verb THEN WrLn; WrStrLn("bad beacon macro "); END;
        s[0]:=0C;
        RETURN

      END; 
    ELSE Append(ns, s[i]) END;
    INC(i);
  END;
  Assign(s, ns);
END beaconmacros;



PROCEDURE AppQ(VAR h:ARRAY OF CHAR; q-:ARRAY OF CHAR; appcall:BOOLEAN);
BEGIN
  Append(h, ">"+TOCALL+",");
  Append(h, q);
  IF appcall THEN Append(h, servercall) END;
  Append(h, ":");
END AppQ;


PROCEDURE Netbeacon(VAR h:ARRAY OF CHAR; qai, withpath:BOOLEAN);
VAR f, i, valt:INTEGER;
    h1:FRAMEBUF;
    del:BOOLEAN;
    j:CARDINAL;
    vcourse, vspeed,
    compos                : CARDINAL;
    vsym, vsymt           : CHAR;
    postyp                : CHAR;
BEGIN
  h[0]:=0C;
  IF (servercall[0]<>0C) & (netbeaconfn[0]<>0C) THEN
    f:=OpenRead(netbeaconfn);  
    IF f>=0 THEN
      i:=RdBin(f, h1, SIZE(h1)-1);
      IF i>=0 THEN
        h1[i]:=0C;
        i:=0;
        WHILE h1[i]>=" " DO INC(i) END;
        h1[i]:=0C;
        beaconmacros(h1, del);
        IF withpath THEN
          Assign(h, servercall);
          IF qai THEN AppQ(h, "TCPIP*,qAI,", TRUE) ELSE AppQ(h, "TCPIP*", FALSE) END;
          Append(h, h1);
          Append(h, CR+LF);
        ELSE Assign(h, h1) END;                           (* APRSP *)
      END;
      Close(f);

      j:=0; WHILE (j<HIGH(h)-1) & (h[j]<>":") DO INC(j) END; 
      GetPos(home, vspeed, vcourse, valt, vsym, vsymt, h, 0, j+1, compos, postyp); (* find server position *) 

    ELSIF verb THEN WrStrLn("netbeacon file not found") END;
  END;
END Netbeacon;


PROCEDURE Timebeacon(cp:pTCPSOCK);
VAR h:FRAMEBUF;
    qai:BOOLEAN;
BEGIN
  IF (cp^.service<>cISWWW) & (Watchclock(cp^.beacont, netbeaconintervall)) THEN
    qai:=TRUE; 
    IF cp^.service=cISGATEWAY THEN
      IF (qas=1) OR (qas>qasc+1) THEN qai:=FALSE; INC(qasc) ELSE qasc:=0 END;
    END;
    Netbeacon(h, qai, TRUE);
    IF h[0]<>0C THEN Sendtcp(cp, h) END;
  END;
END Timebeacon;

(*
PROCEDURE inetrf(buf-:ARRAY OF CHAR); 
CONST KW="RFONLY,";
VAR p,i:CARDINAL;
    c:CHAR;
    mon:FRAMEBUF;
BEGIN
(* call>RFONLY,igatecall:}txdata *)
  p:=0;
  LOOP
    IF buf[p]=0C THEN RETURN END;
    IF buf[p]=">" THEN EXIT END;
    INC(p);
  END;
  INC(p);
  i:=0;
  LOOP
    IF buf[p]=0C THEN RETURN END;
    IF KW[i]=0C THEN EXIT END;
    IF buf[p]<>KW[i] THEN RETURN END;
    INC(p);
    INC(i);
  END;
  i:=0;
  LOOP
    IF buf[p]=0C THEN RETURN END;
    IF (i>HIGH(servercall)) OR (servercall[i]=0C) THEN EXIT END;
    IF buf[p]<>servercall[i] THEN RETURN END;
    INC(p);
    INC(i);
  END;
  IF buf[p]<>":" THEN RETURN END;
  INC(p);
  IF buf[p]<>cTHIRDPARTY THEN RETURN END;
  INC(p);
  i:=0;  
  LOOP
    c:=buf[p];
    IF (i>=HIGH(mon)) OR (c=CR) THEN c:=0C END;
    mon[i]:=c; 
    IF c=0C THEN EXIT END;
    INC(p); 
    INC(i);
  END; 
  Sendudp(mon);
END inetrf;
*)


<*IF MSG THEN*>


PROCEDURE Showmsg(m:pMESSAGE);
BEGIN
  WITH m^ DO
    WrInt(retryc, 3); WrInt(ORD(acked), 1);
    IF txtime<>0 THEN WrInt(systime-txtime, 5) ELSE WrStr(" notx") END;
    WrStr(":");
    WrStr(from); WrStr(">"); WrStr(to);
    WrStr("|"); WrStr(ack); WrStr(replyack);
    WrStr("|"); WrStr(text); WrStrLn("|");
  END;
END Showmsg;


PROCEDURE cpcall(VAR s:ARRAY OF CHAR; h-:ARRAY OF CHAR; pr:CARDINAL);
VAR c:CHAR;
    VAR i:CARDINAL;
BEGIN
  i:=0;
  LOOP
    c:=h[pr];
    IF (i>=HIGH(s)) OR (c=0C) OR (c=">") OR (c="*")
    OR (c=":") OR (c=",") OR (c=" ") THEN EXIT END;
    s[i]:=c;
    INC(i);
    INC(pr);
  END;
  s[i]:=0C;
END cpcall;


PROCEDURE SendMsg(mp:pMESSAGE; torf:CARDINAL);
VAR s:FRAMEBUF;
    i:CARDINAL;
    h:MONCALL;
(*
    tcp:BOOLEAN;
*)
    poscall:POSCALL;
    srcpath:SOURCE;
    uds:pUDPSOCK;
BEGIN
(* rf: OE2XZR-10>RFONLY,OE2XZR-10:}OE0AAA>TCPIP,OE2XZR-10::OE2WAO-12:hallo{123 *)
(* ip: OE0AAA>TCPIP,OE2XZR-10::OE2WAO-12:hallo{123 *)
IF verb THEN
 IF viacall[0]=0C THEN WrStr("<no via call, to msg tx>") 
 ELSIF torf<>0 THEN WrStr("<send rf>") ELSE WrStr("<send net>") END;
 Showmsg(mp);
END;
  IF mp^.ackackt OR (viacall[0]=0C) THEN RETURN END;

(*
  tcp:=udpsock.fd<0;
  s[0]:=0C;
  IF (torf<>0) & tcp THEN
    Append(s, viacall);
    Append(s, ">RFONLY,");
    Append(s, servercall);
    Append(s, ":}");
  END;
  IF mp^.acked THEN Append(s, mp^.to) ELSE Append(s, mp^.from) END;
*)

  IF mp^.acked THEN Assign(s, mp^.to); srcpath:=mp^.acksrc; 
  ELSE Assign(s, mp^.from); srcpath:=mp^.src; END;

  IF torf<>0 THEN
    Append(s, ">");
    IF srcpath=NET THEN Append(s, netdestcall) ELSE Append(s, rfdestcall) END;
    Append(s, ",");
    Append(s, viacall); Append(s, "*::");
  ELSE 
    IF mp^.queryrep THEN AppQ(s, "qAS,", TRUE) ELSE AppQ(s, "NOGATE*,qAS,", TRUE); END;
    Append(s, ":"); 
  END;
 
  IF mp^.acked THEN h:=mp^.from ELSE h:=mp^.to END;
  FOR i:=Length(h) TO 8 DO Append(h," ") END;
  Append(s, h);
  IF mp^.acked THEN 
    IF mp^.reject THEN Append(s, ":rej") ELSE Append(s, ":ack") END;
  ELSE
    Append(s, ":");
 
    WITH mp^ DO
      i:=0; 
      WHILE (i<=HIGH(text)) & (text[i]<>0C) DO                  (* blank not allowed chars *)      
        IF (text[i]="|") OR (text[i]="~") OR (text[i]="{") OR (text[i]<" ") THEN text[i]:=" " END;   
        INC(i);
      END;

      Append(s, text);
      IF ack[0]<>0C THEN Append(s, "{") END;
    END;
  END;
  Append(s, mp^.ack); Append(s, mp^.replyack);
  INC(mp^.retryc);
  poscall.typ:=cUSERMESSAGE; 
  IF (*NOT tcp &*) torf<>0 THEN Sendudp(s, torf, TRUE)
  ELSE
    Append(s, CR+LF);
    Sendall(s, 0, poscall)
  END;
  mp^.txport:=torf;

  IF verb OR (logframes>1) THEN 
    uds:=porttosock(torf);
    showframe(-4, NIL, uds, s, poscall.pos);
  END;

  IF mp^.acked THEN
    IF torf<>0 THEN INC(mp^.ack2rf) ELSE INC(mp^.ack2net) END;
  ELSIF torf<>0 THEN INC(mp^.msg2rf) ELSE INC(mp^.msg2net) END;

  mp^.txtime:=systime;
END SendMsg;



PROCEDURE FindHeard(ph:pHEARD; c:MONCALL; VAR rfport:CARDINAL):TIME;  (* never heard or too long = 0 else time+1 *)
BEGIN
  WHILE (ph<>NIL) & (ph^.time+heardtime>systime) DO
    IF StrCmp(ph^.call, c) THEN
      IF ph^.time<=systime THEN 
        rfport:=ph^.fromrx; 
        RETURN 1+systime-ph^.time 
      ELSE RETURN 0 END;
    END;
    ph:=ph^.next;
  END;
  RETURN 0
END FindHeard;



PROCEDURE Heard(b-:ARRAY OF CHAR; VAR from:MONCALL; VAR trust:BOOLEAN):BOOLEAN;
VAR p, i, len:CARDINAL;
BEGIN
(* from>to,path,gate:...*)
  p:=0;
  WHILE (p<HIGH(from)) & (b[p]<>">") DO from[p]:=b[p]; INC(p) END;  (* get user call *)
  from[p]:=0C;

  i:=Length(b);
  len:=0;
  WHILE (len<i) & (b[len]<>":") DO INC(len) END;
  trust:=(b[len+1]<>cUSERMESSAGE) & (b[len+1]<>cTHIRDPARTY);    (* not from physical sender *)

(*
  IF NOT udp THEN                                               (* frame is from aprsis *)
    lp:=Length(rfpath);
    IF (lp=0) OR (lp>len) THEN RETURN END;                      (* rfpath not fitting *)

    DEC(len, lp);                                               (* cut rfpath *)
    FOR i:=0 TO lp-1 DO
      IF b[len+i]<>rfpath[i] THEN RETURN END;                   (* wrong rfpath *)
    END;
  END;
*)

  WHILE (p<len) & (b[p]<>",") DO INC(p) END;                    (* skip destination call *)
  IF b[p]="," THEN                                              (* get first via *)
    INC(p);
    i:=p;
    WHILE (p<len) & (b[p]<>",") DO INC(p) END;
    IF b[p-1]="*" THEN RETURN FALSE END;                        (* is repeated *)

    IF (b[i]="W") & (b[i+1]="I") & (b[i+2]="D") & (b[i+3]="E") &
    (i+4<>p) & (b[i+4]<>b[i+6]) THEN RETURN FALSE END;          (* WIDEn-x with n<>x *)

    WHILE p<len DO                                              (* more vias *)
      INC(p);
      WHILE (p<len) & (b[p]<>",") DO INC(p) END;
      IF b[p-1]="*" THEN RETURN FALSE END;                      (* is repeated *)
    END;
  END;
  RETURN TRUE
END Heard;


PROCEDURE IncHeard(ph:pHEARD; up:BOOLEAN; livetime:TIME);
VAR  t:TIME;
BEGIN
  IF livetime>0 THEN
    WITH ph^ DO
      t:=systime DIV (livetime DIV MHSTEPS);
--WrInt(t, 10); WrInt(cntt, 10); WrInt(ORD(up), 10); WrLn;
      IF cntt+(HIGH(cnt)+1)<t THEN cntt:=t-(HIGH(cnt)+1) END;
      WHILE cntt<t DO INC(cntt); cnt[cntt MOD (HIGH(cnt)+1)]:=0 END; 
      t:=cntt MOD (HIGH(cnt)+1);
      IF up & (cnt[t]<MAX(CARD16)) THEN INC(cnt[t]) END;
    END;
  END;
--FOR t:=0 TO HIGH(ph^.cnt) DO WrInt(ORD(ph^.cnt[t]), 2) END; WrLn;
END IncHeard;


PROCEDURE DirectPos(b-:ARRAY OF CHAR; VAR pos:POSITION; VAR sym, symt, typ:CHAR; VAR data:REAL);
VAR p, m        :CARDINAL;
    posn        :POSITION;
    postyp,
    sym1, symt1 :CHAR;
    dc          :MONCALL;

  PROCEDURE Wx(p:CARDINAL);
  VAR t:INTEGER;
      sig:BOOLEAN; 
  BEGIN
    IF (b[p]<>"/") & (b[p]<>"@") & (b[p]<>"!") & (b[p]<>"=") THEN RETURN END;
    IF (b[p]="/") OR (b[p]="@") THEN INC(p,7) END;
    INC(p);
    IF (b[p]>="0") & (b[p]<="9") THEN INC(p, 30) ELSIF b[p]>="/" THEN INC(p, 17) END;
    IF b[p]<>"t" THEN RETURN END;
    t:=0;
    sig:=FALSE;
    IF b[p+1]="-" THEN sig:=TRUE
    ELSIF (b[p+1]>="0") & (b[p+1]<="9") THEN t:=(ORD(b[p+1])-ORD("0"))*100 ELSE RETURN END;
    IF (b[p+2]>="0") & (b[p+2]<="9") THEN INC(t, (ORD(b[p+2])-ORD("0"))*10) ELSE RETURN END;
    IF (b[p+3]>="0") & (b[p+3]<="9") THEN INC(t,  ORD(b[p+3])-ORD("0")) ELSE RETURN END;
    IF sig THEN t:=-t END;
    typ:=tCELSIUS;
    data:=VAL(REAL,t-32)/1.8;
  END Wx;

BEGIN
(* OE0AAA>ABCDEF-2,....:...*)
(*        ^mice         ^payload*) 
  p:=0;
  WHILE (p<HIGH(b)) & (b[p]<>">") DO INC(p) END;
  m:=p+1;
  WHILE (p<HIGH(b)) & (b[p]<>":") DO INC(p) END;
  INC(p);
  IF (p<HIGH(b)) & (b[p]<>";") THEN                                   (* objects say wrong pos *)
    vspeed:=MAX(CARDINAL);
    GetPos(posn, vspeed, vcourse, valt, sym1, symt1, b, m, p, compos, postyp);

    dc[0]:=b[m]; dc[1]:=b[m+1]; dc[2]:=b[m+2]; dc[3]:=b[m+3]; dc[4]:=b[m+4]; dc[5]:=b[m+5]; dc[6]:=0C;
    GetSym(dc, sym1, symt1);

    typ:=0C;
    IF posvalid(posn) THEN 
      pos:=posn; sym:=sym1; symt:=symt1;
      IF sym="_" THEN Wx(p);
      ELSIF vspeed<MAX(CARDINAL) THEN
        typ:=tSPEED;
        data:=VAL(REAL, vspeed)*KNOTS;  
      END;
    END;
  END;
END DirectPos;

PROCEDURE MHcount(ph:pHEARD; maxtime:TIME):CARDINAL;
VAR ci, i:CARDINAL;
BEGIN
  IncHeard(ph, FALSE, maxtime);                                       (* clean count array *)
  WITH ph^ DO
    ci:=0; FOR i:=0 TO HIGH(cnt) DO INC(ci, cnt[i]) END;
  END;
  RETURN ci
END MHcount;

PROCEDURE AddHeard(VAR table:pHEARD; maxtime:TIME; from-:MONCALL; fromport:CARDINAL;
                   buf-:ARRAY OF CHAR; VAR ungat:BOOLEAN; setungat:BOOLEAN);
VAR i, j  :CARDINAL;
    ph, po:pHEARD;
BEGIN
  po:=NIL;
  ph:=table;
  WHILE (ph<>NIL) & NOT StrCmp(ph^.call, from) DO po:=ph; ph:=ph^.next END;

  IF ph<>NIL THEN                                               (* entry found *)  
    IF po<>NIL THEN po^.next:=ph^.next END;                     (* remove from chain *)
  ELSE                                                          (* new entry *)
    po:=NIL;
    ph:=table;
    IF ph<>NIL THEN
      i:=0;
      WHILE ph^.next<>NIL DO INC(i); po:=ph; ph:=ph^.next END;
      IF (i>=MAXHEARD) OR (ph^.time+maxtime<systime) THEN       (* old or table full *) 
        IF po<>NIL THEN po^.next:=ph^.next END;                 (* remove from chain *)
      ELSE ph:=NIL END;
    END;

    IF ph=NIL THEN 
      ALLOCATE(ph, SIZE(ph^));
      IF (ph=NIL) & (po<>NIL) THEN ph:=po^.next; po^.next:=NIL END;
    END;

    IF ph<>NIL THEN
      WITH ph^ DO
        call:=from;
        cntt:=0;
        position.long:=0.0;
        position.lat:=0.0;
        sym:=0C;
        symt:=0C;
        datatyp:=0C;
        ungate:=FALSE;
        fromrx:=0;
        head[0]:=0C;
        data:=0.0; 
      END;
    END;
  END;

  IF ph<>NIL THEN
    IF ph<>table THEN
      ph^.next:=table;
      table:=ph;
    END;

    IncHeard(ph, NOT setungat, maxtime);
    WITH ph^ DO
      time:=systime;
      IF setungat THEN 
        ungate:=ungat;
        IF NOT ungat & (MHcount(ph, maxtime)=0) THEN ph^.time:=0 END; (* delete 0 count entry *) 
      ELSE
        ungat:=ph^.ungate; 
        DirectPos(buf, position, sym, symt, datatyp, data);
        i:=0;
        WHILE (i<HIGH(buf)) & (buf[i]<>">") DO INC(i) END;
        INC(i);
        j:=0;
        WHILE (j<HIGH(head)) & (i<HIGH(buf)) & (buf[i]<>":") & (buf[i]<>0C)
        & NOT ((buf[i]=",") & (buf[i+1]="q")) DO head[j]:=buf[i]; INC(j); INC(i) END;
        head[j]:=0C;
        fromrx:=fromport;
      END;
    END;
  ELSE ungat:=FALSE END;
END AddHeard;



PROCEDURE delmsg(md:pMESSAGE);
VAR mp:pMESSAGE;
BEGIN
  IF md=messages THEN messages:=md^.next;
  ELSE
    mp:=messages;   
    LOOP
      IF mp=NIL THEN RETURN END; 

      IF mp^.next=md THEN mp^.next:=md^.next; EXIT END;

      mp:=mp^.next;
    END;
  END;
  IF verb THEN WrStrLn("---delete:"); Showmsg(md) END;
  DEALLOCATE(md, SIZE(md^));
END delmsg;


PROCEDURE RfTimer;
VAR mo, mp:pMESSAGE;
    try:BOOLEAN;
    oldest,ht:TIME;
    maxi, totx:CARDINAL;

 PROCEDURE exp(n:CARDINAL):CARDINAL;
 BEGIN IF n>0 THEN DEC(n) END; IF n>9 THEN n:=9 END; RETURN CAST(CARDINAL,BITSET{n}) END exp; 


BEGIN
  IF lastrfsent+rfquiet<=systime THEN
    maxi:=0;
    LOOP
      oldest:=MAX(TIME);
      mp:=NIL;
      mo:=messages;
      WHILE mo<>NIL DO
        IF (mo^.chkt<>systime) & (mo^.txtime<oldest) THEN mp:=mo; oldest:=mp^.txtime END;
        mo:=mo^.next;
      END;
      IF mp=NIL THEN EXIT END;

      WITH mp^ DO
        chkt:=systime;
        try:=(gentime+msgsendtime>systime) & (txtime + rfquiet*exp(retryc)<systime);
        totx:=0;
        IF try THEN  
          IF acked THEN try:=(acksrc<>OBSOLET) & (retryc=0) & (FindHeard(hearddir, from, totx)>0);
          ELSE 
            ht:=FindHeard(hearddir, to, totx);
            try:=FALSE;
            IF ht>0 THEN
              IF ack[0]=0C THEN try:=(retryc<UNACKRET);              (* msg with no ack *)
              ELSE
                IF retryc<2 THEN try:=ht<3600;
                ELSIF retryc<3 THEN try:=ht<1800;
                ELSIF retryc<4 THEN try:=ht<900;
                ELSE try:=ht<60 END;
              END;

              IF try THEN
                mo:=messages;
                LOOP
                  IF mo=mp THEN EXIT END;
                  IF StrCmp(mo^.to, to) 
                  & ((mo^.ack[0]<>0C) & NOT mo^.acked OR (mo^.ack[0]=0C) & (mo^.retryc<UNACKRET)) THEN
                    try:=FALSE;
                    EXIT
                  END;
                  mo:=mo^.next;
                END;
              END;
 
            END;
          END;
        END;
        IF try THEN
          SendMsg(mp, totx);
          lastrfsent:=systime;
(*
          mo:=messages;
          WHILE mo<>NIL DO
            IF StrCmp(mo^.to, to) & NOT acked THEN mo^.chkt:=systime END; (* 1 msg to 1 call *)
            mo:=mo^.next;
          END;
*)
          INC(maxi);
        END;
(*
        IF (ack[0]=0C) & (retryc>=UNACKRET) OR acked & (msg2rf+msg2net+ack2rf+ack2net=0) 
        THEN ht:=purgeunack ELSE ht:=purgemsg END; (* fast if unack & retried out or acked & never sent *)
*)
        IF ack[0]=0C THEN
          IF retryc>=1 THEN ht:=purgeunacksent ELSE ht:=purgeunack END;  
        ELSIF acked THEN ht:=purgeacked ELSE ht:=purgemsg END;

        IF gentime+ht<systime THEN delmsg(mp) END;                          (* purge message *)

      END;
      IF maxi>=maxatonce THEN EXIT END;
    END;
  END;
END RfTimer;


PROCEDURE SendNet;
VAR mp:pMESSAGE;
BEGIN
  WHILE netmhout<>netmhin DO
    mp:=messages;
    WHILE mp<>NIL DO
      IF mp^.retryc=0 THEN
        IF mp^.acked THEN
          IF (mp^.acksrc=DIR) & StrCmp(mp^.from, netmh[netmhout]) THEN SendMsg(mp, 0); RETURN END;                        (* send only 1 a time *) 

        ELSIF ((mp^.src=DIR) OR (StrCmp(servercall, mp^.from))) & StrCmp(mp^.to, netmh[netmhout]) THEN 
          SendMsg(mp, 0);
          IF mp^.ack[0]<>0C THEN                                  (* no more to this user if unack *) 
            netmhout:=(netmhout+1) MOD (HIGH(netmh)+1);
          END;
          RETURN
        END;
      END;                                                      (* send only 1 a time *)
      mp:=mp^.next;
    END;
    netmhout:=(netmhout+1) MOD (HIGH(netmh)+1);
  END;
END SendNet;

PROCEDURE Stoack(mp:pMESSAGE; rej:BOOLEAN; path:SOURCE);
BEGIN
  WITH mp^ DO
    IF NOT acked THEN                                      (* ack first time *)
      acked:=TRUE;
      reject:=rej;
      acksrc:=path;
      retryc:=0;
      txtime:=0;
    ELSIF path>acksrc THEN acksrc:=path END;                     (* set directest path *)
  END;
END Stoack;

PROCEDURE Ackback(tomp:pMESSAGE);               (* mark all older messages before an now acked *)
VAR mp:pMESSAGE;
BEGIN
  mp:=messages;
  WHILE mp<>tomp DO
    WITH mp^ DO
      IF StrCmp(tomp^.from, from) & StrCmp(tomp^.to, to) & (gentime+dupetime < systime) THEN
        IF NOT acked THEN
          acked:=TRUE;
          acksrc:=OBSOLET;
        END;
        ackackt:=TRUE;
      END; 
      mp:=next;
    END;
  END;
END Ackback;

PROCEDURE cmpmsg(a,b:MSGTEXT):BOOLEAN;           (* compare visable characters *)
VAR i,j:CARDINAL;
BEGIN
  i:=0;
  j:=0;
  WHILE (i<=HIGH(a)) & (a[i]<>0C) DO
    IF a[i]>" " THEN a[j]:=a[i]; INC(j) END;
    INC(i)
  END;
  IF j<=HIGH(a) THEN a[j]:=0C END;
  i:=0;
  j:=0;
  WHILE (i<=HIGH(b)) & (b[i]<>0C) DO
    IF b[i]>" " THEN b[j]:=b[i]; INC(j) END;
    INC(i)
  END;
  IF j<=HIGH(b) THEN b[j]:=0C END;
  RETURN StrCmp(a, b)
END cmpmsg;

PROCEDURE Stomsg(fromcall, tocall:MONCALL;  msg:MSGTEXT; ackt:ACKTEXT;
                 isak, rej, query:BOOLEAN; path:SOURCE);
CONST REPACK="}";
VAR mp, mi:pMESSAGE;
    cnt:CARDINAL;
    rack:REPLYACK;
BEGIN

IF verb & isak THEN WrStrLn("---isak"); END;

  IF StrCmp(fromcall, tocall) THEN RETURN END;                (* msg to him self ... *)  

  msg[HIGH(msg)]:=0C;

  rack[0]:=0C; 
  IF (Length(ackt)>=3) & (ackt[2]=REPACK) THEN                (* replyack xx}xx *)
    rack[0]:=ackt[3]; rack[1]:=ackt[4]; ackt[3]:=0C           (* split ack text xx}yy to xx} yy *)
  END;


  mp:=NIL;
  cnt:=0;
  mi:=messages;
  WHILE mi<>NIL DO
    WITH mi^ DO
      IF StrCmp(ackt, ack) & StrCmp(fromcall, from) & StrCmp(tocall, to) 
      & (isak OR (text[0]=0C) OR cmpmsg(msg, text)) THEN 
        mp:=mi;
        replyack:=rack;                                          (* may change in retransmissions *)
        IF isak THEN 
          Stoack(mi, rej, path);
          Ackback(mi);
        ELSE
          IF acked & (path=DIR) THEN                             (* is acked resend ack *)
            IF retryc>0 THEN DEC(retryc) END;
            txtime:=0;
          END;
          IF text[0]=0C THEN                                     (* ack came before message *)  
            text:=msg; 
            IF acked THEN Ackback(mi) END;
          END;
          IF path>src THEN src:=path END;                        (* set directest path *)
        END;
      END;

      IF (rack[0]<>0C) & (rack[0]=ack[0]) & ((rack[1]=ack[1]) OR (rack[1]=0C) & (ack[1]=REPACK)) 
      & StrCmp(fromcall, to) & StrCmp(tocall, from) THEN Stoack(mi, rej, path) END;

      mi:=next;
    END;
    INC(cnt);
  END;


IF verb & (mp<>NIL) THEN WrStr("msg found "); Showmsg(mp) END;

  IF mp=NIL THEN                                                       (* new msg *)
    IF cnt<maxmsg THEN ALLOCATE(mp, SIZE(mp^)) END;
    IF (mp=NIL) & (messages<>NIL) THEN mp:=messages; messages:=messages^.next END; (* recycle oldest *)
    IF mp<>NIL THEN                                                    (* append to end of list *)  
      FILL(mp, 0C, SIZE(mp^)); mp^.next:=NIL;
      IF messages=NIL THEN messages:=mp
      ELSE
        mi:=messages;
        WHILE mi^.next<>NIL DO mi:=mi^.next END;
        mi^.next:=mp;
      END;
      WITH mp^ DO
        from:=fromcall;
        to:=tocall;
        text:=msg;
        ack:=ackt;
        replyack:=rack; 
        gentime:=systime;
        IF path=DIR THEN txtime:=systime ELSE txtime:=0 END;
        acked:=isak;
        reject:=rej;
        src:=path;  
        acksrc:=path;
        queryrep:=query;
      END;
    END;   

IF verb THEN IF path=DIR THEN WrStr("new direct") 
 ELSIF path=INDIR THEN WrStr("new rf") ELSE WrStr("new net") END; 
 WrStr(" msg#"); WrInt(cnt,1); WrStr(" "); Showmsg(mp);
END;

  END;
(*
  IF mp<>NIL THEN Ackback(mp) END;      (* all before is thru and ack is at home so mark as done *)
*)
END Stomsg;

PROCEDURE degtostr(VAR s:ARRAY OF CHAR; d:REAL; posc, negc:CHAR);
VAR n:CARDINAL;
    c:CHAR;
BEGIN
  d:=d/RAD;
  IF d<0 THEN d:=-d; c:=negc ELSE c:=posc END;
  n:=TRUNC(d);
  IntToStr(n, 1, s);
  Append(s, ".");
  n:=TRUNC((d-FLOAT(n))*3600.0);
  Append(s, CHR(48+n DIV 600));
  Append(s, CHR(48+n MOD 600 DIV 60));
  Append(s, ".");
  Append(s, CHR(48+n MOD 60 DIV 10));
  Append(s, CHR(48+n MOD 10));
  Append(s, c);
END degtostr;

(*
PROCEDURE SortMH(VAR ho:pHEARD):BOOLEAN;
VAR hp, hn :pHEARD;
    eq, ok :BOOLEAN;
BEGIN
  eq:=FALSE;
  hp:=heard;
  hn:=NIL;
  WHILE hp<>NIL DO
    IF hp^.time+heardtimew>systime THEN
      ok:=ho=NIL;
      IF NOT ok THEN
        IF hp^.time=ho^.time THEN
          IF eq THEN ok:=TRUE; eq:=FALSE;
          ELSIF hp=ho THEN eq:=TRUE END;
        ELSIF hp^.time<ho^.time THEN ok:=TRUE END;
      END;
      IF ok & ((hn=NIL) OR (hp^.time>hn^.time)) THEN hn:=hp END;
    END;
    hp:=hp^.next;
  END;
  ho:=hn;
  RETURN ho<>NIL
END SortMH;
*)
(*
PROCEDURE MHtimes(a,b:pHEARD):INTEGER;
BEGIN 
  IF a^.time>b^.time THEN RETURN 1 
  ELSIF a^.time=b^.time THEN RETURN 0 END; 
  RETURN -1 
END MHtimes; 
*)

PROCEDURE Ungate(mycall-:MONCALL; msg-:ARRAY OF CHAR; path:SOURCE);
CONST PARPOS=6;
VAR i,n,p:CARDINAL;
    h,hn:MONCALL;
    answ:MSGTEXT;
    un:BOOLEAN;
    ph:pHEARD;
BEGIN
(* ?APRS#, ?APRS# -9, ?APRS# 9, ?APRS# CALL*)
  h:=mycall;
  i:=0;
  LOOP
    IF i>HIGH(h) THEN EXIT END;
    IF h[i]="-" THEN h[i]:=0C; EXIT END;
    INC(i);
  END;
  hn:=h;
  i:=PARPOS;
  skipblank(msg, i);   
  p:=i;
  un:=msg[i]="-";
  IF un THEN INC(i) END;
  IF (GetSec(msg, i, n)=0) & (n<=15) THEN
    IF n>0 THEN
      Append(h,"-");
      IF n>=10 THEN Append(h,"1") END;
      Append(h, CHR(n MOD 10 + ORD("0")));
    END;
    AddHeard(hearddir, Max(heardtime, heardtimew), h, 0, "", un, TRUE);

  ELSE
    n:=Length(msg);
    i:=0;
    WHILE (i<=HIGH(hn)) & (p<n) & (msg[p]>" ") DO hn[i]:=msg[p]; INC(i); INC(p) END; 
    IF (i>0) & (i<=HIGH(hn)) THEN hn[i]:=0C END;
  END;

  answ:="Not Gated:";
  un:=TRUE;
  ph:=hearddir;
  LOOP
    IF ph=NIL THEN EXIT END;
    IF ph^.ungate & (InStr(ph^.call, hn)=0) THEN
      IF Length(answ)+Length(ph^.call)>=MSGLEN-3 THEN
        Append(answ, "...");
        EXIT
      END;

      Append(answ, " ");
      Append(answ, ph^.call);       
      un:=FALSE;
    END;
    ph:=ph^.next;
  END;
  IF un THEN 
    Append(answ, " None");
    IF n<=PARPOS THEN Append(answ, " (igate your ssid off/on: ?APRS# -5 / 5)") END;
  END;
  Stomsg(servercall, mycall,  answ, "", FALSE, FALSE, TRUE, path);


END Ungate;


PROCEDURE Query(fromcall:MONCALL; msg, buf-:ARRAY OF CHAR; path:SOURCE);
VAR mp:pMESSAGE;
    no:BOOLEAN;
    mh,s:MSGTEXT; 
    callh:MONCALL;
    i, len:CARDINAL;
    hp, hn:pHEARD;
    cmd:CHAR;
    dist, maxdist:REAL;
BEGIN
  cmd:=0C;
  len:=Length(msg);
  i:=1; WHILE i<len DO msg[i]:=CAP(msg[i]); INC(i); END;
  IF (msg[1]="A") & (msg[2]="P") & (msg[3]="R") & (msg[4]="S") 
     & ((msg[6]=0C) OR (msg[6]=" ")) THEN cmd:=msg[5]
  ELSIF (msg[1]="M") & (msg[2]="H") & ((msg[3]=0C) OR (msg[3]="?")) THEN cmd:="D";
  ELSIF (msg[1]="P") & (msg[2]="I") & (msg[3]="N") & (msg[4]="G") & (msg[5]="?") & (msg[6]=0C) THEN cmd:="T";
  ELSIF (msg[1]="H") & (msg[2]="E") & (msg[3]="L") & (msg[4]="P") & (msg[5]=0C) THEN cmd:="h";
  ELSIF (msg[1]="V") & (msg[2]="E") & (msg[3]="R") & ((msg[4]=0C) OR (msg[4]="?")) THEN cmd:="v";
  ELSIF (msg[1]="D") & (msg[2]="X") & (msg[3]=0C) THEN cmd:="x" END;

  IF cmd="M" THEN                                       (* activate messages for user *)
    no:=verb;
    mp:=messages;
    WHILE mp<>NIL DO
      IF NOT mp^.acked & StrCmp(fromcall, mp^.to) THEN 
        mp^.retryc:=0;
        IF verb THEN no:=FALSE; WrStr("query msg activated:"); Showmsg(mp) END;
      END;
      mp:=mp^.next;
    END;
    IF no THEN WrStrLn("query msg not found") END;

  ELSIF cmd="T" THEN                                    (* return message path *)
    i:=0;
    mh:="Path - ";
    WHILE (i+7<HIGH(mh)) & (buf[i]<>":") & (buf[i]<>0C) DO mh[i+7]:=buf[i]; INC(i) END;
    mh[i+7]:=0C;
    Stomsg(servercall, fromcall,  mh, "", FALSE, FALSE, TRUE, path);

  ELSIF cmd="D" THEN                                    (* return mh table *)
    mh:="Directs=";
    hn:=hearddir;
    WHILE (hn<>NIL) & (hn^.time+heardtimew>systime) & (Length(mh)+Length(hn^.call)+1<HIGH(mh)) DO
      IF NOT hn^.ungate THEN
        Append(mh, " ");
        Append(mh, hn^.call);  
      END;
      hn:=hn^.next;
    END; 
    Stomsg(servercall, fromcall,  mh, "", FALSE, FALSE, TRUE, path);


  ELSIF (cmd="x") OR (cmd="H") THEN
    IF cmd="H" THEN FOR i:=0 TO HIGH(callh) DO callh[i]:=CAP(msg[i+7]) END; END;
    maxdist:=0.0;
    hn:=NIL;
    hp:=hearddir;
    WHILE hp<>NIL DO
      IF (hp^.time+heardtimew>systime) & NOT hp^.ungate 
      & posvalid(hp^.position) & posvalid(home) THEN
        dist:=distance(home, hp^.position);
        IF cmd="H" THEN 
          IF StrCmp(callh, hp^.call) THEN hn:=hp; maxdist:=dist END;
        ELSIF dist>maxdist THEN maxdist:=dist; hn:=hp END; 
      END;
      hp:=hp^.next;
    END;
    IF hn<>NIL THEN
      mh:="DX: ";
      Append(mh, hn^.call); Append(mh, " ");
      degtostr(s, hn^.position.lat, "N", "S"); Append(mh, s); Append(mh, " ");
      degtostr(s, hn^.position.long,"E", "W"); Append(mh, s); Append(mh, " ");
      IntToStr(TRUNC(maxdist+0.5), 1, s); Append(mh, s);
      Append(mh, "km ");
      TimeToStr(hn^.time MOD 86400, s); Append(mh, s);
    ELSE mh:="No position available" END;
    Stomsg(servercall, fromcall,  mh, "", FALSE, FALSE, TRUE, path);

  ELSIF cmd="S" THEN 
    Stomsg(servercall, fromcall,  VERS+" Msg S&F Relay", "", FALSE, FALSE, TRUE, path);

  ELSIF cmd="v" THEN 
    Stomsg(servercall, fromcall,  VERS, "", FALSE, FALSE, TRUE, path);

  ELSIF cmd="h" THEN 
     Stomsg(servercall, fromcall,  "Cmd: ?APRS[D/H/M/P/S/T/#] ?DX ?MH ?VER? ?PING?", "", FALSE, FALSE, TRUE, path);

  ELSIF cmd="P" THEN
    Netbeacon(mh, FALSE, FALSE); 
    Stomsg(servercall, fromcall,  mh, "", FALSE, FALSE, TRUE, path);

  ELSIF cmd="#" THEN Ungate(fromcall, msg, path); 
 
  END;
END Query;

PROCEDURE gatetoviaheard(b-:ARRAY OF CHAR; fromcall-, tocall-:MONCALL);
VAR u:pUDPSOCK;
    po, void:CARDINAL;
BEGIN
  IF NOT StrCmp(fromcall, tocall) & (FindHeard(heardvia, tocall, po)>0) THEN
    u:=porttosock(po);
    IF (u<>NIL) & (u^.torfradius>0.0) & (FindHeard(hearddir, tocall, void)=0) THEN
      NetToRf(b, po);
    END;
  END;
END gatetoviaheard;


PROCEDURE iscall(b-:ARRAY OF CHAR; p:CARDINAL):BOOLEAN;
VAR li, nu, i:CARDINAL;
    c:CHAR;
BEGIN
  li:=0;
  nu:=0;
  FOR i:=0 TO 2 DO
    c:=b[p+i];
    IF (c>="A") & (c<="Z") THEN INC(li) ELSIF (c>="0") & (c<="9")
    THEN IF i=0 THEN INC(li) ELSE INC(nu) END END;     (* 0AA is no call *)
  END;  
(*
IO.WrCard(li,9);IO.WrCard(nu,9); IO.WrStrLn("<3>");
*)
  RETURN (nu+li=3) & (nu>=1) & (nu<=2) 
END iscall;

PROCEDURE getack(s-:ARRAY OF CHAR; p:CARDINAL; VAR a:ACKTEXT);
VAR i:CARDINAL;
BEGIN
  i:=0;
  WHILE (p<=HIGH(s)) & (s[p]>" ") & (s[p]<200C) DO 
    a[i]:=s[p];  
    INC(p);
    INC(i);
    IF i>HIGH(a) THEN RETURN END;
  END;
  a[i]:=0C;
END getack;

PROCEDURE Getmsg(b-:ARRAY OF CHAR; rxport:CARDINAL; goodpath:BOOLEAN; VAR ungate:BOOLEAN);  (* get user msg and ack out of aprsis stream *)
CONST 
      HEADEREND=":";
      FROMEND=">";
      USERACK="{";
      NOARCHIVE="!x!";

VAR pm, pf, len, p, void, po:CARDINAL; 
    msg                     :MSGTEXT;
    ack                     :ACKTEXT;
    fromcall, tocall, hfrom :MONCALL;
    c                       :CHAR;
    isack, isrej, trust, dir, tomh:BOOLEAN;
    path                    :SOURCE;
BEGIN
  ungate:=FALSE;
  IF (b[0]=0C) OR (rxport<>0) & NOT iscall(b, 0) OR (InStr(b, NOARCHIVE)>=0) THEN RETURN END;

  dir:=Heard(b, hfrom, trust);
  IF (rxport<>0) & (hfrom[0]<>0C) THEN
    IF (heardtime>0) & dir & trust THEN 
      AddHeard(hearddir, Max(heardtime, heardtimew), hfrom, rxport, b, ungate, FALSE);
    ELSIF heardtimevia>0 THEN AddHeard(heardvia, heardtimevia, hfrom, rxport, b, ungate, FALSE) END;
  END;
  IF (maxmsg=0) & (viacall[0]=0C) THEN RETURN END;              (* mh server only *)

  len:=Length(b);
  pm:=0;
  REPEAT
    pf:=pm;
    LOOP
      IF pm>=len THEN RETURN END;

      IF b[pm]=HEADEREND THEN EXIT END;

      INC(pm);
    END;
    INC(pm, 2);
  UNTIL (pm>len) OR (b[pm-1]<>cTHIRDPARTY);                     (* skip thirdparty headers *)
  DEC(pm);

  tomh:=sendnetmsg;

  IF (pm+10<len) & (b[pm]=cUSERMSG) & (b[pm+10]=cUSERMSG) & iscall(b, pm+1) THEN (* user message *)

(* to *)
    cpcall(tocall, b, pm+1);

    IF iscall(b, pf) & (maxmsg<>0) THEN       (* mail storage on & not from a special (no)call *)

(* from *)
      cpcall(fromcall, b, pf);

(* text *)
      p:=0;
      INC(pm, 11);
      LOOP
        IF pm>=len THEN EXIT END;
        c:=b[pm];
        IF (p>=HIGH(msg)) OR (c<" ") OR (c=USERACK) THEN EXIT END; 
        msg[p]:=c;
        INC(p);
        INC(pm);
      END;
      msg[p]:=0C;

(* ack *)
      isack:=FALSE;
      ack[0]:=0C;
      isrej:=(msg[0]="r") & (msg[1]="e") & (msg[2]="j");
      IF (msg[0]="a") & (msg[1]="c") & (msg[2]="k") OR isrej THEN          (* is ack or rej *)
        getack(msg, 3, ack);
        msg[0]:=0C;
        isack:=TRUE;
      ELSIF (pm<len) & (b[pm]=USERACK) THEN getack(b, pm+1, ack) END;      (* msg with ack *)

      path:=NET;
      IF rxport<>0 THEN 
        path:=INDIR;
        IF dir & goodpath & (FindHeard(hearddir, fromcall, void)>0) 
        THEN path:=DIR END;                                     (* udp and direct heard before *)
      END;
      IF msg[0]="?" THEN 
        IF StrCmp(tocall, viacall) OR StrCmp(tocall, servercall) THEN 
          Query(fromcall, msg, b, path);
          tomh:=TRUE;
        END;

      ELSIF isack THEN Stomsg(tocall, fromcall, msg, ack, TRUE, isrej, FALSE, path);
      ELSIF (rxport<>0) OR goodpath
      THEN Stomsg(fromcall, tocall, msg, ack, FALSE, isrej, FALSE, path) END; 

      gatetoviaheard(b, fromcall, tocall);
    ELSIF goodpath & (FindHeard(hearddir, tocall, po)>0) THEN NetToRf(b, po) END;  (* not call from to local user *) 

IF verb THEN 
 WrStr(" <");
 p:=0;
 WHILE (p<HIGH(b)) & (b[p]<>0C) DO 
  IF b[p]>=" " THEN WrStr(b[p]) END;
  INC(p);
 END;
 WrStrLn(">");
END;
  END;

  IF tomh & (hfrom[0]<>0C) & (rxport=0) & ((netmhin+1) MOD (HIGH(netmh)+1)<>netmhout) THEN 
    netmh[netmhin]:=hfrom;
    netmhin:=(netmhin+1) MOD (HIGH(netmh)+1);
  END;
END Getmsg;


PROCEDURE getportname(n:CARDINAL; VAR s:ARRAY OF CHAR); (* if not found return port number *)
VAR u:pUDPSOCK;
    i:CARDINAL;
BEGIN
  u:=udpsocks;
  i:=1;
  WHILE (u<>NIL) & (i<n) DO INC(i); u:=u^.next END;
  IF (u=NIL) OR (u^.portname[0]=0C) THEN IntToStr(n, 1, s) ELSE Assign(s, u^.portname) END;
END getportname;



PROCEDURE MHtoFile;
CONST SEP="|";                                    (* field separator *)
      SEPESC=" ";                                 (* set instead of SEP *)
      TEMPFN="~";                                 (* append to filename for temp file *)
      LINELEN=99;                                 (* fill up lines to equal size *)

VAR h:ARRAY[0..255] OF CHAR;
    h1:ARRAY[0..15] OF CHAR;
    fn:FILENAME;
    hn:pHEARD;
    t:TIME;
    fd:INTEGER;
    p, cnt:CARDINAL;

  PROCEDURE App(s:ARRAY OF CHAR);
  VAR i:CARDINAL;
  BEGIN
    i:=0;
    WHILE (i<=HIGH(s)) & (s[i]<>0C) DO 
      IF s[i]<>SEP THEN h[p]:=s[i] ELSE h[p]:=SEPESC END;
      INC(p);
      INC(i);
    END; 
  END App;

BEGIN
  Assign(fn, mhfilename);
  Append(fn, TEMPFN);
  fd:=OpenWrite(fn);
  IF fd<0 THEN RETURN END;

  cnt:=mhfilelines;
  hn:=hearddir;
  WHILE (cnt>0) & (hn<>NIL) DO
    p:=0;
    IF (hn^.time+heardtimew>systime) & NOT hn^.ungate THEN
      App(hn^.call);  
      h[p]:=SEP; INC(p); 

      App(hn^.symt);
      App(hn^.sym);
      h[p]:=SEP; INC(p);

--      IntToStr(hn^.fromrx, 1, h1); App(h1);
      getportname(hn^.fromrx, h1); App(h1);
      h[p]:=SEP; INC(p);

      t:=hn^.time;
      IF (systime<t) OR (t=0) THEN t:=0 ELSE t:=systime-t END;
      IntToStr(t, 1, h1); App(h1);
      h[p]:=SEP; INC(p);

      IntToStr(MHcount(hn, heardtimew), 1, h1); App(h1);
      h[p]:=SEP; INC(p);

      IF posvalid(hn^.position) & posvalid(home) THEN
        FixToStr(distance(home, hn^.position)+0.05, 2, h1);
        App(h1);
      END;
      h[p]:=SEP; INC(p);

      IF hn^.datatyp=tCELSIUS THEN FixToStr(hn^.data, 2, h1); Append(h1, 260C+"C");
      ELSIF hn^.datatyp=tSPEED THEN FixToStr(hn^.data, 0, h1); Append(h1, "kmh");
      ELSE h1:="" END;
      App(h1);
      h[p]:=SEP; INC(p);

      App(hn^.head);
      h[p]:=LF; INC(p);

      WrBin(fd, h, p);
    END;
    hn:=hn^.next;
    DEC(cnt);
  END; 
  Close(fd);
  Rename(fn, mhfilename);
END MHtoFile;


<*END*>


PROCEDURE AprsIs(VAR buf:ARRAY OF CHAR; datafilt, msgfilt:GFILTSET; logcall-:ARRAY OF CHAR; 
                 udpchan:CARDINAL; valid:BOOLEAN; VAR poscall:POSCALL):INTEGER;
VAR i,p,len,pins,pssid,psum0,psum1,ilen,ha,payload,micedest,qpos:CARDINAL;
    hashl, hashh:SET8;
    qtext :ARRAY[0..31] OF CHAR;
    ungat :BOOLEAN;
    postyp:CHAR;
    unset :GFILTSET;

  PROCEDURE callchk(withstar, iscall:BOOLEAN):INTEGER;
  VAR i, j, num, lit:CARDINAL;
      c   :CHAR;
      u   :GATEFILT;
  BEGIN
    pssid:=0;
    FOR u:=MIN(GATEFILT) TO MAX(GATEFILT) DO
      j:=0;
      i:=p;
      WHILE ungates[u][j]=buf[i] DO
        INC(i);
        INC(j);
        IF ungates[u][j]=0C THEN INCL(unset, u) END;
      END;
    END;

    IF iscall THEN                                                      (* we want a callsign *)
      num:=0;
      lit:=0;
      c:=buf[p];
      IF (c>="A") & (c<="Z") THEN INC(lit) ELSIF (c<"0") OR (c>"9") THEN RETURN -1 END;

      INC(p);
      LOOP
        c:=buf[p];
        IF (c>="0") & (c<="9") THEN INC(num) ELSIF (c>="A") & (c<="Z") THEN INC(lit) ELSE EXIT END; 
        INC(p);
      END;
      IF (lit<2) OR (num=0) OR (num>2) THEN RETURN -1 END;

      pssid:=p;
      IF buf[p]="-" THEN
        INC(p);
        IF buf[p]="1" THEN 
          INC(p);
          IF (buf[p]>="0") & (buf[p]<="5") THEN INC(p) END;
        ELSIF (buf[p]<"1") OR (buf[p]>"9") THEN RETURN -1 ELSE INC(p) END;

      END;

    ELSIF (buf[p]="q") & (buf[p+1]="A") & (buf[p+2]>="A") THEN          (* qAx *)
      qpos:=p+2;
      INC(p, 3);

    ELSE                                                                (* we skip any text *)
      LOOP
        c:=buf[p];
        IF c="-" THEN pssid:=p END;
        IF (c<=" ") OR (c=">") OR (c="*") OR (c=",") OR (c=":") THEN EXIT END;
        INC(p);
      END;
    END;

    IF pssid=0 THEN pssid:=p END;
    IF withstar & (buf[p]="*") THEN INC(p) END;
--WrStrLn("chk=0");
    RETURN 0
  END callchk;

  PROCEDURE Iconstruct;
  VAR i,j,k:CARDINAL;
  BEGIN
    IF (p<=4) OR (buf[p-2]<>"I") THEN RETURN END;       (* ,CALL,I: *)
    i:=p-4;
    WHILE buf[i]<>"," DO                                (* hop back call *)  
      IF i=0 THEN RETURN END;
      DEC(i);
    END;
    k:=i;                                               (* "," before call *)
    INC(i);
    j:=0;
    WHILE (j<=HIGH(logcall)) & (logcall[j]<>0C) DO
      IF logcall[j]<>buf[i] THEN RETURN END;
      INC(i);
      INC(j);
    END;                                                (* logcall = call,I *)
    pins:=k;
    i:=p-1;
    p:=k+1;                                             (* payload *)
    LOOP
      buf[k]:=buf[i];
      IF (i>=HIGH(buf)) OR (buf[i]=0C) THEN EXIT END;
      INC(k);
      INC(i);
    END;                                                (* delete ,call,I *)
    qtext:=",qAR,"; Append(qtext, logcall);             (* insert ,qAR,call *)
(*
OE0AAA-9>T8SV40,WIDE1-1,DB0WGS,I:test
OE0AAA-9>T8SV40,WIDE1-1:test
OE0AAA-9>T8SV40,WIDE1-1,qAR,DB0WGS:test 
*)

  END Iconstruct;

BEGIN
  hashl:=SET8{};
  hashh:=SET8{};
  p:=0;
  pins:=0;
  pssid:=0;                                            (* for savety *)
  len:=0;
  WHILE (len<HIGH(buf)) & (buf[len]<>0C) & (buf[len]<>CR) DO INC(len) END;
  IF (len=0) OR (len+(SIZE(qtext)+3)>HIGH(buf)) THEN RETURN -2 END;

  unset:=GFILTSET{};
  qpos:=0;
  LOOP                                                           (* thirdparty loop *)
    psum0:=p;
    IF callchk(FALSE, (udpchan<>0) OR callsrc)<>0 THEN RETURN -3 END;  (* src call *)

    IF buf[p]<>">" THEN RETURN -1 END;

    i:=0; 
    WHILE (i<HIGH(poscall.call)) & (i<p) DO poscall.call[i]:=buf[i]; INC(i) END;
    poscall.call[i]:=0C;    

    INC(p);
    micedest:=p;  
    IF callchk(FALSE, FALSE)<>0 THEN RETURN -3 END;                    (* dest call *)
    psum1:=pssid;
    WHILE buf[p]="," DO
      INC(p);
      IF callchk(TRUE, FALSE)<>0 THEN RETURN -3 END;                   (* via calls *)
    END;
    IF buf[p]<>":" THEN RETURN -1 END;

    IF pins=0 THEN pins:=p END;
    INC(p);
    IF buf[p]<>cTHIRDPARTY THEN EXIT END;
    INC(p);
  END;
  
  IF p>=len THEN RETURN -2 END; 

  qtext[0]:=0C;
  IF qpos>0 THEN                                                              (* qA *)
    IF CAP(buf[qpos])="Z" THEN RETURN -3                                      (* qAZ *) 

    ELSIF CAP(buf[qpos])="I" THEN qtext:=","; Append(qtext, servercall) END;  (* qAI *)
  ELSE
    IF udpchan<>0 THEN qtext:=",qAU,"; Append(qtext, servercall);
    ELSIF logcall[0]<>0C THEN
      IF cmpfrom(buf, 0, logcall) THEN qtext:=",qAC," ELSE qtext:=",qAS," END;
      Append(qtext, servercall);
      Iconstruct;
    END;
  END;
(*
IO.WrStr(" <");FOR i:=0 TO Length(buf)-1 DO IO.WrHex(ORD(buf[i]),3) END;
IO.WrStr("> "); IO.WrLn; IO.WrCard(pins, 10); IO.WrCard(p, 10); IO.WrLn;
*)           
  payload:=p;
  poscall.typ:=buf[p];
  IF buf[p]="?" THEN RETURN -4 END;

<*IF MSG THEN*>
  IF (udpchan<>0) OR valid THEN
    Getmsg(buf, udpchan, unset*msgfilt=GFILTSET{}, ungat);
    IF ungat THEN RETURN -6 END;
  END;
<*END*>
  IF unset*datafilt<>GFILTSET{} THEN RETURN -3 END;

  FOR i:=psum0 TO psum1-1 DO HashCh(buf[i], hashl, hashh) END;
  WHILE (p<len) & (buf[p]<>15C) & (buf[p]<>12C) DO HashCh(buf[p], hashl, hashh); INC(p) END;
  ha:=(ORD(CAST(CHAR, hashl)) + ORD(CAST(CHAR, hashh))*256) MOD HASHSIZE;
  IF timehash[ha]+dupetime>systime THEN RETURN -5 END;                       (* a duplicate *)

  IF (udpchan<>0) OR valid THEN timehash[ha]:=systime END;

  GetPos(poscall.pos, vspeed, vcourse, valt, vsym, vsymt, buf, micedest, payload, compos, postyp); 
  IF (udpchan=0) & NOT valid THEN RETURN -1 END;
  
  buf[p]:=15C; INC(p);
  buf[p]:=12C; INC(p);
  buf[p]:=0C;  INC(p);

  ilen:=Length(qtext);
  IF ilen>0 THEN
    WHILE p>pins DO DEC(p); buf[p+ilen]:=buf[p] END;
    i:=0;

    WHILE i<ilen DO buf[p]:=qtext[i]; INC(p); INC(i) END;
  END;
  RETURN 0
END AprsIs;

PROCEDURE GetFilters(VAR filters:FILTERS; s-:ARRAY OF CHAR; p:CARDINAL);

  PROCEDURE getfix(VAR x:REAL; mul:REAL):BOOLEAN;
  VAR i:CARDINAL;
      h:FRAMEBUF;
  BEGIN
    IF s[p]="/" THEN 
      INC(p);
      i:=0;
      WHILE (s[p]>" ") & (s[p]<>"/") & (i<HIGH(h)) DO h[i]:=s[p]; INC(i); INC(p) END;
      h[i]:=0C;
      IF StrToFix(x, h) THEN
(*
IO.WrFixed(x, 4,10); IO.WrStr("   fix<"); IO.WrStr(h); IO.WrStrLn(">");
*)
        x:=x*mul;
        RETURN TRUE
      END;
    END;
    RETURN FALSE
  END getfix;

  PROCEDURE getcalls(VAR table:ARRAY OF MONCALL);
  VAR i,j:CARDINAL;
  BEGIN
    INC(p);
    j:=0;
    WHILE s[p]="/" DO
      INC(p);
      i:=0;
      WHILE (p<=HIGH(s)) & (s[p]>" ") & (s[p]<>"/") DO
        IF (j<=HIGH(table)) & (i<=HIGH(table[0])) THEN
          table[j][i]:=s[p];
        END;
        INC(p);
        INC(i);
      END;
      INC(j);
    END;
  END getcalls;


VAR not:BOOLEAN;

BEGIN
  skipblank(s,p);
  IF cmpfrom(s, p, "filter ") THEN 
    INC(p,7);
    skipblank(s,p);
    not:=FALSE;
    WHILE s[p]>=" " DO
      IF s[p]=" " THEN not:=FALSE END;
      skipblank(s,p);
      IF s[p]="m" THEN
        INC(p);
        IF getfix(filters.radius, 1.0) THEN filters.typ:="m" ELSE RETURN END;

      ELSIF s[p]="r" THEN
        INC(p);
        IF NOT getfix(filters.base.lat, RAD) THEN RETURN END;
        IF NOT getfix(filters.base.long, RAD) THEN RETURN END;
        IF NOT getfix(filters.radius, 1.0) THEN RETURN END;
        IF NOT posvalid(filters.base) THEN RETURN END;
        filters.typ:="r";

      ELSIF s[p]="a" THEN
        INC(p);
        IF NOT getfix(filters.base.lat, RAD) THEN RETURN END;
        IF NOT getfix(filters.base.long, RAD) THEN RETURN END;
        IF NOT getfix(filters.edge.lat, RAD) THEN RETURN END;
        IF NOT getfix(filters.edge.long, RAD) THEN RETURN END;
        IF NOT posvalid(filters.base) THEN RETURN END;
        IF NOT posvalid(filters.edge) THEN RETURN END;
        filters.typ:="a";

      ELSIF s[p]="d" THEN
        getcalls(filters.viacalls);
        filters.notvia:=not;

      ELSIF s[p]="e" THEN
        getcalls(filters.entrycalls);
        filters.notentry:=not;

      ELSIF s[p]="-" THEN
        not:=TRUE;
        INC(p);

      ELSE RETURN END;

    END;
  END;
END GetFilters;


PROCEDURE Auth(mbuf-:ARRAY OF CHAR; pu:pTCPSOCK):BOOLEAN;
VAR i,j:CARDINAL;
    h, h1:FRAMEBUF;
BEGIN
  WITH pu^ DO
    i:=0;
    WHILE mbuf[i]<=" " DO INC(i) END;
    IF mbuf[i]="#" THEN
      GetFilters(filters, mbuf, 1);
      RETURN TRUE

    END;
    IF mbuf[i]<>"u" THEN RETURN FALSE END;                   (* quick test *)

    IF cmpfrom(mbuf,i,"user ") THEN
      INC(i,5);
      skipblank(mbuf,i);
      j:=0;
      WHILE (j<HIGH(user.call)) & (mbuf[i]>" ") DO user.call[j]:=CAP(mbuf[i]); INC(i); INC(j); END;
      user.call[j]:=0C;

      skipblank(mbuf,i);

      IF cmpfrom(mbuf,i,"pass ") THEN
        INC(i,5);
        skipblank(mbuf,i);
        j:=0;
        WHILE (mbuf[i]>="0") & (mbuf[i]<="9") & (j<32768) DO 
          j:=j*10+ORD(mbuf[i])-ORD("0"); 
          INC(i); 
        END;
        valid:=(Length(user.call)>=3) & (j=call2pass(user.call));

        skipblank(mbuf,i);
      END;

      IF cmpfrom(mbuf,i,"vers ") THEN
        INC(i,5);
        skipblank(mbuf,i);
        j:=0;
        WHILE (mbuf[i]>=" ") & NOT cmpfrom(mbuf, i, "filter") DO
          IF j<HIGH(vers) THEN vers[j]:=mbuf[i]; INC(j) END; 
          INC(i);
        END;
        WHILE (j>0) & (vers[j-1]=" ") DO DEC(j) END;
        vers[j]:=0C;
      END;

      GetFilters(filters, mbuf, i);

      Assign(h, "# logresp ");  Append(h, user.call);
      IF valid THEN Append(h, " verified") END;
      Append(h, " server "); Append(h, servercall);
      FiltToStr(filters, h1); 
      IF h1[0]<>0C THEN Append(h, " filter "); Append(h, h1) END;
      Assign(h1,h);
      IF vers[0]<>0C THEN Append(h1, " vers: "); Append(h1, vers); END;
      logline(1, h1);

      Append(h, CR+LF);
      Sendtcp(pu, h);

    END;  
  END;
  RETURN TRUE
END Auth;




PROCEDURE closetcp(VAR w:pTCPSOCK; fin:BOOLEAN);
VAR pb:pWWWBUF;
BEGIN
  WITH w^ DO
    WHILE txbuf<>NIL DO
      pb:=txbuf;
      txbuf:=txbuf^.next;
(*
IO.WrStrLn("deallocw");
*)
      DEALLOCATE(pb, SIZE(pb^));
      IF NOT fin & (txbuf<>NIL) THEN RETURN END;

    END;
    IF fd>=0 THEN Close(fd) END;
    fd:=-1;
  END;
END closetcp;

PROCEDURE sendwww(VAR w:pTCPSOCK; VAR b:WWWB; len:INTEGER; push:BOOLEAN);
VAR pb, pp:pWWWBUF;
BEGIN
  IF len=0 THEN RETURN END;
(*
IO.WrStrLn("allocw");
*)
  ALLOCATE(pb, SIZE(pb^));
  IF pb=NIL THEN RETURN END;

  pb^.buf:=b;
  pb^.tlen:=len;
  pb^.push:=push;
  pb^.next:=NIL;
  IF w^.txbuf=NIL THEN w^.txbuf:=pb
  ELSE
    pp:=w^.txbuf;
    WHILE pp^.next<>NIL DO pp:=pp^.next END;
    pp^.next:=pb;
  END;
END sendwww;



PROCEDURE Www(wsock:pTCPSOCK);
CONST RELURL="?reload=";

      SORTURL="?sort=";
      sortTIME="t";
      sortCALL="c";
      sortPORT="p";
      sortHEARD="h";
      sortDIST="d";
      sortUP="u";
      sortDOWN="d";

VAR wbuf : WWWB;
    h1   : ARRAY[0..255] OF CHAR;
    fdw,
    flen,
    res  : INTEGER;
    tt,ut: TIME;
    ss   : pTCPSOCK;
    us   : pUDPSOCK;
    i    : CARDINAL;

<*IF MSG THEN*>
    mp     : pMESSAGE;
    tp     : SOURCE;
    hok    : BOOLEAN;
<*END*>

  PROCEDURE Appwww(s-:ARRAY OF CHAR);
  VAR wlen, slen, i:CARDINAL;
  BEGIN
(*
    len:=Length(wbuf);
    IF len+Length(s)>=HIGH(wbuf) THEN
      sendwww(wsock, wbuf, len, FALSE);
      wbuf[0]:=0C;
    END;
    Append(wbuf, s);
*)
    wlen:=Length(wbuf);
    slen:=Length(s);
    i:=0;
    WHILE i<slen DO 
      IF wlen>=HIGH(wbuf) THEN 
        sendwww(wsock, wbuf, wlen, FALSE);
        wlen:=0;
      END; 
      wbuf[wlen]:=s[i];
      INC(i);
      INC(wlen);
    END;
    wbuf[wlen]:=0C;
  END Appwww;




  PROCEDURE AppCall(c:MONCALL; ungate:BOOLEAN; link-:ARRAY OF CHAR);
  VAR b:ARRAY[0..4095] OF CHAR;
      i, j, k:CARDINAL;
  BEGIN
    Appwww('<td style=text-align:left>');
    
    j:=0;
    i:=0;
    WHILE link[i]>=" " DO
      IF link[i]="$" THEN
        INC(i);
        IF link[i]="c" THEN
          k:=0;
          WHILE (k<=HIGH(c)) & (c[k]<>0C) & (j<HIGH(b)) DO b[j]:=c[k]; INC(j); INC(k) END;
        ELSIF link[i]="$" THEN
          b[j]:="$";
          IF j<HIGH(b) THEN INC(j) END;
        END;  
      ELSE
        b[j]:=link[i];
        IF j<HIGH(b) THEN INC(j) END;
      END;
      INC(i);   
    END;        
    b[j]:=0C;    

    IF b[0]<>0C THEN
      Appwww('<a href=');
      Appwww(b);
      Appwww('>');
    END;

    IF ungate THEN Appwww('#') END;
    Appwww(c);

    IF b[0]<>0C THEN Appwww('</a>') END;

    Appwww('</td>');
  END AppCall;

  PROCEDURE AppTime(t:TIME; tab:BOOLEAN);
  VAR  h1:ARRAY[0..255] OF CHAR;
  BEGIN
    IF tab THEN Appwww("<td>") END;
    IF (systime<t) OR (t=0) THEN t:=0 ELSE t:=systime-t END;
    TimeToStr(t, h1);
    Appwww(h1);
    IF tab THEN Appwww("</td>") END;
  END AppTime;

  PROCEDURE AppMinSec(t:TIME);
  VAR  h1:ARRAY[0..20] OF CHAR;
  BEGIN
(*
    Appwww("<td>");
*)
    IF (systime<t) OR (t=0) THEN t:=0 ELSE t:=systime-t END;
    IF t DIV 3600>0 THEN
      IntToStr(t DIV 3600,1,h1);
      Appwww(h1); Appwww("h");
      t:=t MOD 3600;
    END;
    IF t DIV 60>0 THEN
      IntToStr(t DIV 60,1,h1);
      Appwww(h1); Appwww("m");
      t:=t MOD 60;
    END;
    IntToStr(t,1,h1);
    IF h1[1]=0C THEN Appwww("&nbsp;") END;
    Appwww(h1); Appwww("s");
(*
    Appwww("</td>");
*)
  END AppMinSec;

  PROCEDURE AppInt(n:INTEGER);
  VAR  h1:ARRAY[0..255] OF CHAR;
  BEGIN
    Appwww("<td>");
    IntToStr(n, 1, h1);
    Appwww(h1);
    Appwww("</td>");
  END AppInt;

  PROCEDURE AppTxt(style-, s-:ARRAY OF CHAR);
  VAR c:CHAR;
      i:INTEGER;
      h1:ARRAY[0..255] OF CHAR;
  BEGIN
    Appwww(style);
    FOR i:=0 TO VAL(INTEGER, Length(s))-1 DO
      c:=s[i];
      CASE c OF
        " ",".",",","0".."9","A".."Z","a".."z":Appwww(c);
       |0C..37C:;
      ELSE Appwww("&#"); IntToStr(ORD(c), 1, h1); Appwww(h1); Appwww(";"); END;
    END;
    Appwww('</td>');
  END AppTxt;

  PROCEDURE hex(n:CARDINAL):CHAR;
  BEGIN
    IF n>9 THEN INC(n, ORD("A")-10-ORD("0")) END;
    RETURN CHR(n+ORD("0"))
  END hex;

  PROCEDURE setcol(c, n:CARDINAL);
  BEGIN
    IF n>100 THEN n:=100 END;
    INC(n,155);
    h1[c]:=hex(n DIV 16);
    h1[c+1]:=hex(n MOD 16);
  END setcol;

  PROCEDURE green(cnt:CARDINAL; maxt:TIME; driving:BOOLEAN);
  VAR t:TIME;
  BEGIN
    t:=systime-uptime;
    IF t>maxt THEN t:=maxt END;
    IF driving THEN cnt:=cnt*2000 ELSE cnt:=cnt*20000 END;
    cnt:=cnt DIV (t+300);
    IF cnt<100 THEN setcol(0, cnt); setcol(2, 100);
    ELSE 
      IF cnt>200 THEN cnt:=200 END;
      setcol(0, 100); setcol(2, 200-cnt);
    END;
  END green;

  PROCEDURE wcard64(hi, lo:CARDINAL);
  VAR h1:ARRAY[0..15] OF CHAR;
  BEGIN
    IF hi>0 THEN CardToStr(lo DIV 1024 + hi*4194304, 1, h1); Append(h1, "k");
    ELSE CardToStr(lo, 1, h1) END;
    Appwww('<TD style="text-align:right">');
    Appwww(h1);
    Appwww("</TD>");
  END wcard64;

  PROCEDURE wint(n:INTEGER);
  VAR h1:ARRAY[0..15] OF CHAR;
  BEGIN 
    IntToStr(n,  1, h1);
    Appwww('<TD style="text-align:right">'); 
    Appwww(h1);
    Appwww("</TD>");
  END wint;

  PROCEDURE openfile(fn:ARRAY OF CHAR; VAR fd, flen:INTEGER):BOOLEAN;
  VAR h:ARRAY[0..4096] OF CHAR;
      hh:ARRAY[0..1] OF CHAR;
(*
      s:stat_t;
*)
      i:CARDINAL;
  BEGIN
    IF fn[0]="/" THEN RETURN FALSE END;
    i:=0;
    LOOP
      IF (i+2>=HIGH(fn)) OR (fn[i]=0C) THEN EXIT END;
      IF (fn[i]<=" ") OR (fn[i]>=200C) THEN RETURN FALSE END;
      IF (fn[i]=".") & (fn[i+1]=".") & (fn[i+2]="/") THEN RETURN FALSE END;
      INC(i);
    END;
    Assign(h, wwwdir);
    Append(h, fn);
    fd:=OpenRead(h);
    IF (fd<0) OR (RdBin(fd,hh,1)<>1) THEN RETURN FALSE END; (* test read if regular file *)
   
    Seek(fd, 0);
(*
    fstat(fd, s);
    IF CAST(BITSET, s.st_mode)*CAST(BITSET,170000B)<>CAST(BITSET,100000B) THEN RETURN FALSE END;
*)
    flen:=Size(fd);
    IF (flen<=0) OR (flen>=wwwsizelimit) THEN RETURN FALSE END;
    RETURN TRUE
  END openfile;

  PROCEDURE appsorturl(sortby-:ARRAY OF CHAR);
  VAR h:ARRAY[0..2] OF CHAR;
  BEGIN
    IF sortby[0]<>0C THEN
      Appwww(SORTURL);
      h[0]:=sortby[0];
      h[1]:=sortby[1];
      h[2]:=0C;
      Appwww(h);
    END;
  END appsorturl;

  PROCEDURE appreloadurl(time:CARDINAL);
  VAR h:ARRAY[0..31] OF CHAR;
  BEGIN
    IF time<>0 THEN
      Appwww(RELURL);
      IntToStr(time, 1, h);
      Appwww(h);
    END;
  END appreloadurl;

  PROCEDURE klick(path, text:ARRAY OF CHAR; sort:CHAR);
  VAR s:ARRAY[0..1] OF CHAR;
  BEGIN 
    Assign(s, wsock^.sortby);
    IF sort<>0C THEN
      IF s[0]=sort THEN
        IF s[1]<>sortUP THEN s[1]:=sortUP ELSIF s[1]<>sortDOWN THEN s[1]:=sortDOWN END;
      ELSE s[0]:=sort; s[1]:=sortUP END;  
    END; 
    Appwww('<a href="'); Appwww(path);
    appsorturl(s);
    appreloadurl(wsock^.reload);
    Appwww('">'); Appwww(text); Appwww('</a> ');
  END klick; 

<*IF MSG THEN*>
  PROCEDURE iconf(sym, symt:CHAR; VAR fn:ARRAY OF CHAR; VAR overlay:CHAR):BOOLEAN;
  VAR h:ARRAY[0..255] OF CHAR;
      i:CARDINAL;
  BEGIN
    i:=ORD(sym);
    IF (i<33) OR (i>127) THEN RETURN FALSE END;
    Assign(fn, ICONDIR+"/");
    IntToStr(i+(100-33), 3, h); 
    overlay:=0C;
    CASE symt OF
      "0".."9","A".."Z": h[0]:="2"; overlay:=symt;
     |"\": h[0]:="2";
     |"/":;
      ELSE RETURN FALSE;
    END;
    Append(fn, h); Append(fn, ".gif");
    Assign(h, wwwdir);
    Append(h, fn);
    RETURN Exists(h)
  END iconf;

  PROCEDURE sortindex(ph:pHEARD; maxtime:TIME; sortby-:ARRAY OF CHAR); (* make LONGREAL of sort key *)
  VAR homevalid :BOOLEAN;
      i         :CARDINAL;
      s, c      :CHAR;
      xs        :LONGREAL;

  BEGIN
    xs:=0.0;
    homevalid:=posvalid(home);
    s:=sortby[0];
    WHILE ph<>NIL DO
      CASE s OF
       sortTIME: xs:=xs+1.0;                             (* sort by time as it is *)

      |sortCALL:  xs:=0.0;                                (* sort by call *)
          FOR i:=0 TO HIGH(ph^.call) DO
            c:=ph^.call[i];
            xs:=xs*128.0+FLOAT(ORD(c)); 
          END;

      |sortPORT:  xs:=FLOAT(ph^.fromrx);                  (* sort by port *)

      |sortHEARD: xs:=FLOAT(MHcount(ph, maxtime));        (* sort by count *)

      |sortDIST:                                          (* sort by km *)
          IF homevalid & posvalid(ph^.position) THEN xs:=distance(home, ph^.position);
          ELSE xs:=0.0 END;
      ELSE END;

      IF sortby[1]="d" THEN ph^.sortval:=-xs ELSE ph^.sortval:=xs END;      
      ph:=ph^.next;
    END;
  END sortindex;


  PROCEDURE getlinkfile(VAR b:ARRAY OF CHAR);
  VAR fd, len:INTEGER;
  BEGIN
    Assign(b, wwwdir); Append(b, CALLINKFN);
    fd:=OpenRead(b);
    b[0]:=0C;
    IF fd>=0 THEN
      len:=RdBin(fd, b, SIZE(b)-1);
      IF len<0 THEN len:=0 END;
      b[len]:=0C;
      Close(fd);
    END;
  END getlinkfile;


  PROCEDURE showmh(ph0:pHEARD; maxtime:TIME; title:ARRAY OF CHAR; sortby-:ARRAY OF CHAR);
  VAR withport,
      withicon  :BOOLEAN;
      ci        :CARDINAL;
      hch       :CHAR;
      ph, phs   :pHEARD;
      xs        :LONGREAL;
      callink   :ARRAY[0..1023] OF CHAR;
  BEGIN
    getlinkfile(callink);

    withport:=(udpsocks<>NIL) & (udpsocks^.next<>NIL);
    Assign(h1, wwwdir); Append(h1, ICONDIR); withicon:=Exists(h1);    

    Appwww('<table id=mheard border=0 align=center CELLPADDING=3 CELLSPACING=1'
          +' BGCOLOR=#FFFFFF><tr class=tab-mh-titel BGCOLOR=#A9EEFF><th colspan=');
    Appwww(CHR(ORD("6")+ORD(withicon)+ORD(withport)));
    Appwww('>'); Appwww(title);
    IF maxtime MOD 3600=0 THEN IntToStr(maxtime DIV 3600, 1, h1); Append(h1, "h");
    ELSE IntToStr(maxtime DIV 60, 1, h1); Append(h1, "min") END; 
    Appwww(h1);
--    Appwww('</th></tr><tr class=tab-mh-head BGCOLOR=#E0C080><th>Call</th>');

    Appwww('</th></tr><tr class=tab-mh-head BGCOLOR=#E0C080><th>');
    klick("mh", "Call", sortCALL);
    Appwww('</th>');

    IF withicon THEN Appwww('<th>Icon</th>') END;
--    IF withport THEN Appwww('<th>Port</th>') END;
    IF withport THEN
      Appwww('<th>');
      klick("mh", "Port", sortPORT);
      Appwww('</th>');
    END;

--    Appwww('<th>Last Heard</th><th>Pack</th><th>QRB km</th><th>Data</th><th>Path</th></tr>');
    Appwww('<th>');
    klick("mh", "Last Heard", sortTIME);
    Appwww('</th><th>');
    klick("mh", "Pack", sortHEARD);
    Appwww('</th><th>');
    klick("mh", "QRB km", sortDIST);
    Appwww('</th><th>Data</th><th>Path</th></tr>');

    sortindex(ph0, maxtime, sortby);    

    LOOP
      phs:=ph0;
      xs:=MAX(LONGREAL);
      ph:=NIL;
      WHILE phs<>NIL DO
        IF phs^.sortval<xs THEN xs:=phs^.sortval; ph:=phs END;
        phs:=phs^.next;
      END;
      IF ph=NIL THEN EXIT END;
 
      ph^.sortval:=MAX(LONGREAL);
      IF ph^.time+maxtime>systime THEN

        ci:=MHcount(ph, maxtime);
        Appwww('<tr style="background-color:#90FF90; text-align:right">');
        AppCall(ph^.call, ph^.ungate, callink);
        IF withicon THEN
(*
          Appwww('<td class=tab-mh-icon ');
*)
          Appwww('<td');
          IF iconf(ph^.sym, ph^.symt, h1, hch) THEN
            Appwww(' style="background-image:url(/'); Appwww(h1);
            Appwww('); background-repeat:no-repeat;background-position:center center;');
            IF hch<>0C THEN Appwww('text-align:center">'); Appwww(hch) ELSE Appwww('">') END;
          ELSE Appwww('>') END; 
(*
          Appwww('background-color:#C0FFC0');
          IF hch<>0C THEN Appwww(';text-align:center">'); Appwww(hch) ELSE Appwww('">') END;
*)
          Appwww('</td>');
        END;

        IF withport THEN
          Appwww('<td>');
          getportname(ph^.fromrx, h1); Appwww(h1);
          Appwww('</td>');
        END;

        Appwww('<td>'); AppMinSec(ph^.time); Appwww('</td>');
(*
        Appwww('<td>'); 
*)
        Appwww('<td style="background-color:#'); 
        h1:="80FF80"; green(ci, maxtime, ph^.datatyp=tSPEED); Appwww(h1); Appwww('">');
        IntToStr(ci, 1, h1); Appwww(h1); Appwww('</td>');

        h1[0]:=0C;
        IF posvalid(ph^.position) & posvalid(home) THEN
          FixToStr(distance(home, ph^.position)+0.05, 2, h1);
        END;

        Appwww('<td>'); Appwww(h1); Appwww('</td>');
(*
        IF ph^.datatyp=tCELSIUS THEN 
          Appwww('<td style=background-color:#'); tempcol(ph^.data); Appwww('>'); 
          FixToStr(ph^.data, 2, h1); Append(h1, 260C+"C");
        ELSIF ph^.datatyp=tSPEED THEN 
          Appwww('<td style=background-color:#'); tempcol(ph^.data*0.2); Appwww('>');
          FixToStr(ph^.data, 0, h1); Append(h1, "kmh");
        ELSE h1:='<td>' END;
*)
        Appwww('<td>');  
        IF ph^.datatyp=tCELSIUS THEN FixToStr(ph^.data, 2, h1); Append(h1, 260C+"C");
        ELSIF ph^.datatyp=tSPEED THEN  FixToStr(ph^.data, 0, h1); Append(h1, "kmh");
        ELSE h1:="" END;
        Appwww(h1); 
        Appwww('</td>');

        AppTxt('<td style=text-align:left>', ph^.head);
        Appwww("</tr>"+CR+LF);
      END;
    END;
    Appwww("</table>&nbsp;");

  END showmh;


<*END*>

  PROCEDURE getreload(VAR s:ARRAY OF CHAR; VAR r:CARDINAL);
  VAR i,j,len:INTEGER;
      n:CARDINAL;
  BEGIN  
    n:=0;
    i:=InStr(s, RELURL);
    IF i>=0 THEN 
      len:=Length(s);
      j:=i;
      INC(i,Length(RELURL));
      WHILE (i<len) & (s[i]>="0") & (s[i]<="9") DO n:=n*10 + ORD(s[i])-ORD("0"); INC(i) END; 
      WHILE i<=len DO s[j]:=s[i]; INC(i); INC(j) END;      
    END;
    IF n>0 THEN r:=n END;
  END getreload;

  PROCEDURE getmh(VAR s:ARRAY OF CHAR; VAR sortby:ARRAY OF CHAR);
  VAR i,j,len:INTEGER;
  BEGIN
    sortby[0]:=0C;
    sortby[1]:=0C;
    i:=InStr(s, SORTURL);
    IF i>=0 THEN
      len:=Length(s);
      j:=i;
      INC(i,Length(SORTURL));
      sortby[0]:=s[i]; INC(i);
      sortby[1]:=s[i]; INC(i);
      WHILE i<=len DO s[j]:=s[i]; INC(i); INC(j) END;
    END;
  END getmh;

  PROCEDURE appreload(time:CARDINAL);
  VAR h:ARRAY[0..31] OF CHAR;
  BEGIN
    IF time<>0 THEN
      Appwww('<meta http-equiv="refresh" content="');
      IntToStr(time*60, 1, h);
      Appwww(h);
      Appwww('">');
    END;
  END appreload;

  PROCEDURE reloadklick;
  VAR h1:ARRAY[0..15] OF CHAR; 
  BEGIN
(*
    Appwww('<form method="get">reload min:<input type="text" value="');
*)
    Appwww('Reload (min):<input type="text" value="');
    IntToStr(wsock^.reload, 1, h1); Appwww(h1); 
    Appwww('" name="reload" size="4" maxlength="3"><input type="submit" value="set reload time"/></form>');
  END reloadklick;

  PROCEDURE klicks;
  BEGIN
(*
    Appwww('<div style="text-align:center" class="nav">');
*)
    Appwww('<div style="text-align:center" class="nav"><form method="get">');

    klick("/", "CONNECTS", 0C);
    klick("mh", "HEARD", 0C);
    IF maxmsg>0 THEN klick("msg", "MSGRELAY", 0C) END;
    klick("info.html", "INFO", 0C);
    reloadklick;
    Appwww('</div>');
  END klicks;

  PROCEDURE conthead;
  BEGIN
    wbuf:='HTTP/1.0 200 OK'+CR+LF
    +'Content-Type: text/html; charset=iso-8859-1'+CR+LF+CR+LF;
    sendwww(wsock, wbuf, Length(wbuf), TRUE);

    wbuf:='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"'+CR+LF
    +'"http://www.w3.org/TR/html4/loose.dtd">'+CR+LF+'<HTML><HEAD>';
    appreload(wsock^.reload);
  END conthead;

  PROCEDURE title(VAR cnt:CARDINAL);
  VAR h:ARRAY[0..31] OF CHAR;
  BEGIN
    INC(cnt);
    Appwww('<TITLE>');
    Appwww(viacall);
    Appwww(' Message Relay</TITLE>'
    +'<link href="style.css" rel="stylesheet" type="text/css"></HEAD>'+CR+LF
    +'<BODY><div style="text-align:center"><H3>'+CR+LF);
    IF viacall[0]<>0C THEN Appwww(" MsgCall "); Appwww(viacall) END;
    Appwww(" ["+VERS+"] http#");
    IntToStr(cnt, 1, h);
    Appwww(h);
    Appwww(" Uptime "); AppTime(uptime, FALSE);
    Appwww("</H3></div>"+CR+LF);
  END title;


BEGIN  (* Www *)
  res:=tcp.readsock(wsock^.fd, wbuf, SIZE(wbuf));
  i:=0;
  LOOP
    IF VAL(INTEGER,i)>=res THEN
      IF res<=0 THEN Close(wsock^.fd); wsock^.fd:=-1 END;
      RETURN
    END;

    WITH wsock^ DO
      get[wwwst]:=wbuf[i];    
      IF wwwst<HIGH(get) THEN INC(wwwst); 
      ELSE
        get[wwwst-4]:=get[wwwst-3];
        get[wwwst-3]:=get[wwwst-2];
        get[wwwst-2]:=get[wwwst-1];
        get[wwwst-1]:=get[wwwst];
      END;
      get[wwwst]:=0C;
(*
IO.WrCard(wwwst, 10); FOR tt:=0 TO wwwst DO IO.WrHex(ORD(get[tt]), 3); END; IO.WrLn;
*)
      IF (wwwst>=4) & (get[wwwst-4]=CR) & (get[wwwst-3]=LF) & (get[wwwst-2]=CR) 
      & (get[wwwst-1]=LF) & cmpfrom(get, 0, "GET /") THEN EXIT END;

      INC(i);
    END; 
  END;
  WITH wsock^ DO
    i:=5;
    WHILE (i<=HIGH(get)) & (get[i]>" ") DO get[i-5]:=get[i]; INC(i) END;
    get[i-5]:=0C;
    getreload(get, reload);
    getmh(get, sortby);
  END;


  IF wsock^.get[0]=0C THEN
    INC(httpcount);
    conthead;

    Appwww('<TITLE>');
    Appwww(servercall);
    Appwww(' Status Report</TITLE>'
    +'<link href="style.css" rel="stylesheet" type="text/css"></HEAD>'+CR+LF
    +'<BODY><div style="text-align:center"><H3>'+CR+LF);
    IF servercall[0]<>0C THEN Appwww("Server "); Appwww(servercall) END;
    IF tcpbindport[0]<>0C THEN Appwww("  Port "); Appwww(tcpbindport) END; 
    Appwww(" ["+VERS+"] Maxusers ");
    IntToStr(maxusers, 1, h1); Appwww(h1);
    Appwww(" http#");
    IntToStr(httpcount, 1, h1); Appwww(h1);
(*
    IF QWatch.qsize>0 THEN
      Appwww(" txq ");
      IntToStr(QWatch.qsize, 1, h1); Appwww(h1); Appwww("s");
    END;
*)
    Appwww(" Uptime "); AppTime(uptime, FALSE); 
    Appwww("</H3></div>"+CR+LF);

    klicks;

(* udp ports*)
    Appwww('<TABLE id=connections BORDER="0" CELLPADDING=3 CELLSPACING=1 BGCOLOR=#000000 align=center SUMMARY="Connection Table">'+CR+LF
      +'<TR class=tab-con-titel VALIGN="BASELINE" BGCOLOR="#A999CC">'
      +'<TH COLSPAN=14 style="text-align:center">Server Connections</TH></TR>'+CR+LF
      +'<TR class=tab-con-head BGCOLOR="#CCCCFF">'+CR+LF+'<TH>Dir</TH><TH>IPnum</TH><TH>Port</TH><TH>Call/Port</TH>'
      +'<TH>V</TH> <TH>Software</TH> <TH NOWRAP>Range Filter</TH>'
      +'<TH>TxByte</TH> <TH>TxFr</TH><TH NOWRAP>bit/s</TH>'
      +'<TH>RxByte</TH> <TH>RxFr</TH><TH NOWRAP>bit/s</TH><TH>Up</TH></TR>');
(*
    us:=udpsocks;
    WHILE us<>NIL DO
      FOR i:=0 TO HIGH(us^.stat) DO
        WITH us^.stat[i] DO  
          IF utime+UDPSHOWTIME>systime THEN
            showpip(uip, 0, h1);
            Appwww('<TR class=tab-con-udp BGCOLOR=#E0E0F0 style="text-align:center">'+CR+LF+'<TD>udp</TD><TD>');
            Appwww(h1); Appwww("</TD>");
            wint(uport); 
            Appwww("<TD></TD><TD></TD><TD></TD><TD></TD>");
            wint(us^.txbytes);
            wint(us^.txframes);
            IF dtime<systime THEN ut:=systime-dtime ELSE ut:=1 END;
            wint(us^.txbytes*8 DIV ut);
            wint(rxbytes);
            wint(rxframes);
            wint(rxbytes*8 DIV ut); Appwww("<TD>");
            TimeToStr(ut, h1); Appwww(h1);
            Appwww("</TD></TR>");  
          END;
        END;
      END; 
      us:=us^.next;
    END;
*)
    us:=udpsocks;
    WHILE us<>NIL DO
      IF us^.txbytes>0 THEN
        showpip(us^.ip, 0, h1);
        Appwww('<TR class=tab-con-udp BGCOLOR=#E0E0F0 style="text-align:center">'+CR+LF+'<TD>udp</TD><TD>');
        Appwww(h1); Appwww("</TD>");
        wint(us^.dport); 
        Appwww('<TD style="text-align:left">T:'); 
        Appwww(us^.portname);
        Appwww("</TD><TD></TD><TD></TD>");
        IF (us^.torfradius>=1.0) OR (us^.maxbytes>0) THEN 
          Appwww("<td>");
          IF us^.torfradius>=1.0 THEN
            IntToStr(TRUNC(us^.torfradius), 1, h1);
            Appwww(h1); Appwww("km ");
          END;
          IF us^.maxbytes>0 THEN
            IntToStr(us^.maxbytes, 1, h1);
            Appwww(h1); Appwww("b/s");
          END;

          Appwww("</td>");
        ELSE Appwww("<TD></TD>") END;
        wint(us^.txbytes);
        wint(us^.txframes);
        IF uptime<systime THEN ut:=systime-uptime ELSE ut:=1 END;
        wint(us^.txbytes*8 DIV ut);
        wint(0);
        wint(0);
        wint(0); Appwww("<TD>");
        TimeToStr(ut, h1); Appwww(h1);
        Appwww("</TD></TR>");  
      END;
      FOR i:=0 TO HIGH(us^.stat) DO
        WITH us^.stat[i] DO  
          IF utime+UDPSHOWTIME>systime THEN
            showpip(uip, 0, h1);
            Appwww('<TR class=tab-con-udp BGCOLOR=#E0E0F0 style="text-align:center">'+CR+LF+'<TD>udp</TD><TD>');
            Appwww(h1); Appwww("</TD>");
            wint(uport);
            Appwww('<TD style="text-align:left">R:');
            Appwww(us^.portname);
            Appwww("</TD><TD></TD><TD></TD><TD></TD>");
            wint(0);
            wint(0);
            IF dtime<systime THEN ut:=systime-dtime ELSE ut:=1 END;
            wint(0);
            wint(rxbytes);
            wint(rxframes);
            wint(rxbytes*8 DIV ut); Appwww("<TD>");
            TimeToStr(ut, h1); Appwww(h1);
            Appwww("</TD></TR>");  
          END;
        END;
      END; 
      us:=us^.next;
    END;

(* tcp ports *)
    ss:=tcpsocks;
    WHILE ss<>NIL DO
      WITH ss^ DO
        IF (service=cISSERVER) OR (service=cISGATEWAY) THEN
          IF (connt>0) & (connt<systime) THEN tt:=systime-connt ELSE tt:=1 END;
(*
          Appwww('<TR class=tab-con-tcp style="text-align:center" ');
*)
          IF service=cISSERVER THEN 
            Appwww('<TR class=tab-con-in style="text-align:center" BGCOLOR="#C0E0C0"><TD>in'); 
          ELSE 
            Appwww('<TR class=tab-con-out style="text-align:center" BGCOLOR="#D0C0C0"><TD>out');
          END; 
          Appwww('</TD><TD style="text-align:center">');
          Appwww(ipnum); Appwww('</TD><TD style="text-align:right">');
          IF service=cISSERVER THEN Appwww(tcpbindport) ELSE Appwww(port) END;
          Appwww('</TD><TD style="text-align:left">');
          Appwww(user.call);

          IF (service=cISGATEWAY) & (qwatch.qsize>0) THEN
            Appwww(" q=");
            IntToStr(qwatch.qsize, 1, h1); Appwww(h1); Appwww("s");

          END;
          Appwww("</TD><TD>");
          IF connt>0 THEN 
            IF valid THEN Appwww("v") END; 
            IF posvalid(user.pos) THEN Appwww("p") END;
          END; 
          Appwww("</TD><TD WIDTH=50>");
          Appwww(vers); Appwww('</TD><TD WIDTH=50>');
          IF service=cISSERVER THEN FiltToStr(filters, h1) ELSE Assign(h1, actfilter) END;
          Appwww(h1); Appwww('</TD>');
          wcard64(txbytesh, txbytes);
          wint(txframes);
          wint(bitsec64(txbytesh, txbytes, tt));
          wcard64(rxbytesh, rxbytes);
          wint(rxframes);
          wint(bitsec64(rxbytesh, rxbytes, tt)); Appwww("<TD>");
          IF connt>0 THEN TimeToStr(tt, h1); Appwww(h1) END; Appwww("</TD></TR>");
        END;
        ss:=next;
      END;
    END;


    Appwww('</TABLE></BODY></HTML>'+CR+LF);

<*IF MSG THEN*>

  ELSIF StrCmp(wsock^.get,"mh") THEN
    conthead;
    title(mhhttpcount);
    klicks;

    IF heardtimew>0 THEN 
      showmh(hearddir, heardtimew, "Direct Heard Stations Since Last ", wsock^.sortby) END;
    IF heardtimevia>0 THEN 
      showmh(heardvia, heardtimevia, "Via RF Heard Stations Since Last ", wsock^.sortby) END;

  ELSIF StrCmp(wsock^.get,"msg") THEN
    conthead;
    title(msghttpcount);
    klicks;

    FOR tp:=DIR TO NET BY -1 DO 
      Appwww('<table id=msg border=0 align=center CELLPADDING=3 CELLSPACING=1 BGCOLOR="#FFFFFF">');
      IF viacall[0]=0C THEN 
        IF tp=DIR      THEN h1:='Direct Heard Messages (tx off)';
        ELSIF tp=INDIR THEN h1:='Via Digi Heard Messages (tx off)';
        ELSE                h1:='Via Net Heard Messages (tx off)'; END;
      ELSE
        IF tp=DIR      THEN h1:='Direct Heard Messages (Relayed to direct heard and Net)';
        ELSIF tp=INDIR THEN h1:='Via Digi Heard Messages (Relayed to direct heard)';
        ELSE                h1:='Via Net Heard Messages (Relayed to direct heard)'; END;
      END;
      Appwww('<tr class=tab-msg-titel BGCOLOR="#A9EEFF"><th colspan=13>');
      Appwww(h1);   
      Appwww('</th></tr>');

      hok:=FALSE;
      mp:=messages;
      WHILE mp<>NIL DO
        IF mp^.src=tp THEN
          IF NOT hok THEN
              
            Appwww('<tr class=tab-msg-head BGCOLOR="#F0A070"><th>From</th><th>To</th>'
                  +'<th>hms ago</th>'
                  +'<th>hms tx</th><th>po</th><th>retr</th><th>m>r</th><th>m>n</th>'
                  +'<th>a>r</th><th>a>n</th><th>A</th><th>Ack</th><th>Text</th></tr>');
 
            hok:=TRUE;
          END; 
          Appwww('<tr class=tab-msg-body BGCOLOR="#DDCC88">');
          AppCall(mp^.from, FALSE, 0C); AppCall(mp^.to, FALSE, 0C);

          AppTime(mp^.gentime, TRUE);      
          IF (mp^.retryc>0) & (mp^.txtime>0) THEN AppTime(mp^.txtime, TRUE) 
          ELSE Appwww("<td></td>");END;

          AppInt(mp^.txport);
          AppInt(mp^.retryc);
          AppInt(mp^.msg2rf);
          AppInt(mp^.msg2net);
          AppInt(mp^.ack2rf);
          AppInt(mp^.ack2net);
          Appwww("<td>");
          IF mp^.acked THEN 
            IF mp^.acksrc=DIR THEN h1:="D" 
            ELSIF mp^.acksrc=INDIR THEN h1:="V" 
            ELSIF mp^.acksrc=NET THEN h1:="N"
            ELSE h1:="X" END;
            IF mp^.reject THEN Append(h1,"R") END;
            IF NOT mp^.ackackt THEN h1[0]:=CHR(ORD(h1[0])+32) END;
            Appwww(h1);
          END; 
          Appwww("</td>");
          Assign(h1, mp^.ack); Append(h1, mp^.replyack); AppTxt("<td>", h1);
          AppTxt("<td>", mp^.text);
          Appwww("</tr>"+CR+LF);
        END;
        mp:=mp^.next;
      END;
      IF hok THEN Appwww("</table>&nbsp;") END;
    END;

    Appwww("</BODY></HTML>"+CR+LF);

<*END*>
  ELSIF (wwwdir[0]<>0C) & openfile(wsock^.get, fdw, flen) THEN
    wbuf:='HTTP/1.0 200 OK'+CR+LF
(*
    +'Content-Type: text/html; charset=iso-8859-1'+CR+LF+'Content-Length: ';
*)
    +'Content-Length: ';
    IntToStr(flen, 1, h1);
    Append(wbuf, h1);
    Append(wbuf, CR+LF+CR+LF);
    sendwww(wsock, wbuf, Length(wbuf), TRUE);
    WHILE flen>0 DO
      res:=RdBin(fdw, wbuf, SIZE(wbuf));
      IF res>0 THEN sendwww(wsock, wbuf, res, FALSE); DEC(flen, res) ELSE flen:=0 END;
    END;
    Close(fdw); 
    wbuf[0]:=0C;

  ELSE wbuf:='HTTP/1.1 404'+CR+LF END;

  IF wbuf[0]<>0C THEN sendwww(wsock, wbuf, Length(wbuf), FALSE) END;
END Www;

PROCEDURE Wwwtx(VAR w:pTCPSOCK);
VAR len, i:INTEGER;
BEGIN
  WITH w^ DO
    IF txbuf<>NIL THEN
      IF txbuf^.push THEN len:=tcp.sendsock(fd, txbuf^.buf, txbuf^.tlen)
      ELSE len:=tcp.sendmore(fd, txbuf^.buf, txbuf^.tlen) END;
      IF len>0 THEN
        FOR i:=len TO txbuf^.tlen-1 DO txbuf^.buf[i-len]:=txbuf^.buf[i] END; (* delete the sent *)
        DEC(txbuf^.tlen, len);
        IF connt=0 THEN connt:=systime END;
      ELSE txbuf^.tlen:=0 END;                                 (* should not happen *)
      IF txbuf^.tlen<=0 THEN closetcp(w, FALSE) END;
    END;
  END;
END Wwwtx;


PROCEDURE saybusy(VAR fd:INTEGER; s:ARRAY OF CHAR);
VAR res:INTEGER;
BEGIN
  IF fd>=0 THEN
    res:=tcp.sendsock(fd, s, Length(s));
    Close(fd);
    fd:=-1;
  END;
END saybusy;


PROCEDURE KillDoubleUser(u:pTCPSOCK);
VAR v:pTCPSOCK;
BEGIN
  v:=u^.next;
  WHILE v<>NIL DO
    IF (v^.service=cISSERVER) & (v^.user.call[0]<>0C) 
    & StrCmp(u^.user.call, v^.user.call) THEN 
      IF v^.valid & NOT u^.valid THEN saybusy(u^.fd, "# unvalidated double login"+CR+LF);
      ELSE saybusy(v^.fd, "# double login"+CR+LF) END;        (* kill older or the unvalid *)
    END;
    v:=v^.next;
  END;
END KillDoubleUser;


PROCEDURE tcpconn(VAR sockchain:pTCPSOCK; f:INTEGER; cservice:CHAR):BOOLEAN;
VAR cp:pTCPSOCK;
    h,h1,h2:FRAMEBUF;
    res:INTEGER;
BEGIN

  IF f<0 THEN RETURN FALSE END;

  ALLOCATE(cp, SIZE(cp^));
  IF cp=NIL THEN
    Close(f);
    IF verb THEN WrStrLn("tcp conn out of memory") END;
    RETURN FALSE

  END;
  FILL(cp, 0C, SIZE(cp^));
  WITH cp^ DO
    fd:=f;
    valid:=cservice=cISGATEWAY;
    service:=cservice;
    res:=udp.socknonblock(f);
    txbuf:=NIL;
  END;
  cp^.next:=sockchain;
  sockchain:=cp;


  IF cservice=cISGATEWAY THEN


    IF servercall[0]<>0C THEN
      Assign(h, "user ");
      Append(h, servercall);
      IF passwd[0]<>0C THEN Append(h, " pass "); Append(h, passwd) END;
      Append(h, " vers ");
      Append(h, VERS);
      IF actfilter[0]<>0C THEN Append(h, " filter "); Append(h, actfilter) END;
      Append(h, ""+CR+LF);
      Sendtcp(cp, h);
    END;
(*
cp^.txbytes:=4294967200;
cp^.txbytesh:=0;
cp^.rxbytes:=4294965296;
cp^.rxbytesh:=0;
*)

  ELSIF cservice=cISSERVER THEN

    res:=SIZE(h1);
    res:=tcp.getpeeripnum(f, h1, res);
    IF res>=0 THEN
(*
          tcp.ipnum2str(h1, h, SIZE(h));
*)
      tcp.ipnumport2str(h1, SIZE(h1), h, SIZE(h), h2, SIZE(h2));

      Assign(cp^.ipnum, h);
      Assign(cp^.port, h2);
      h1:="T:connect to: "; Append(h1, h); Append(h1, " "); Append(h1, h2);
      logline(1, h1);
    END;

    Assign(h,"# "+VERS+CR+LF);
    Sendtcp(cp, h);
  END;
  RETURN TRUE
END tcpconn;


PROCEDURE Gateconn(VAR cp:pTCPSOCK);
VAR fd:INTEGER;
    p, act, try, kill:pTCPSOCK;
    h:FRAMEBUF;
    hh:ARRAY[0..20] OF CHAR;
    max:CARDINAL;
BEGIN
  act:=NIL;
  try:=NIL;
  p:=cp;
  WHILE p<>NIL DO
    IF p^.service=cISGATEWAY THEN
      IF p^.connt>0 THEN                                            (* we have gate connect *)
        IF act<>NIL THEN                                            (* we have 2 connects *)
          IF act^.gatepri>p^.gatepri THEN (* stop second best *)
            kill:=act; 
            act:=p;
          ELSE kill:=p END;                                         (* stop second best *)
          saybusy(kill^.fd, "# remove double connect"+CR+LF)  
        ELSE act:=p END;
      ELSE try:=p END;                                              (* trying to connect *)
    END;
    p:=p^.next;
  END;
--IF (try=NIL) & Watchclock(connecttime, gateconndelay) THEN
  IF try=NIL THEN
    IF act=NIL THEN max:=HIGH(gateways) ELSE max:=act^.gatepri END; (* try only better *)
    IF (trygate>=max) OR (trygate>HIGH(gateways)) 
    OR (gateways[trygate].url[0]=0C) THEN trygate:=0 END;           (* loop thru table *) 

    IF lastdnstime>systime THEN lastdnstime:=systime END;
    IF (trygate<max) & Watchclock(gateways[trygate].connecttime, gateconndelay)
    & (lastdnstime+gateways[trygate].resolvtime*5<=systime) THEN
      WITH gateways[trygate] DO
        IF url[0]<>0C THEN

--check dns time 
          lastdnstime:=time();
--WrStrLn("start resolve");
          fd:=tcp.connectto(url, port);
          resolvtime:=time()-lastdnstime;
          IF resolvtime>5 THEN 
            h:="T:slow DNS "; IntToStr(resolvtime, 1, hh); Append(h, hh); Append(h, "s");
            logline(1, h);
            IF resolvtime>300 THEN resolvtime:=120 END;
          END;          
--check dns time

          IF fd>=0 THEN
            IF filterst[0]<>0C THEN Assign(actfilter, filterst)
            ELSE Assign(actfilter, serverrangefilter) END;
            IF tcpconn(cp, fd, cISGATEWAY) THEN
              Assign(cp^.ipnum, url);
              Assign(cp^.port, port);
              cp^.gatepri:=trygate;
              h:="T:connect to: "; Append(h, url); Append(h, " "); Append(h, port);
              logline(1, h);
            END;
          END; 
        END;
      END;
    END;
    INC(trygate);

  END;
END Gateconn;

PROCEDURE WatchTXQ(sock:pTCPSOCK);
VAR qb, acked, rb, i, j, sent:INTEGER;
    rest:BOOLEAN;
BEGIN
  qb:=tcp.getunack(sock^.fd);                               (* tcp unack sendqueue in byte *)
  sent:=sock^.txbytes-sock^.qwatch.lasttb;                  (* last second sent bytes *)
  IF (qb<=0) OR (sent<0) THEN sock^.qwatch.qsize:=0;        (* all ack  or error so stop tracing *)
  ELSE                                                      (* we have unack bytes *)
    acked:=sock^.qwatch.lastqb-qb+sent;                     (* acked bytes in last s *)
    j:=0;
    rest:=FALSE;
    FOR i:=0 TO sock^.qwatch.qsize-1 DO
      rb:=sock^.qwatch.txbyte[i]-acked;
      sock^.qwatch.txbyte[j]:=rb;
      IF rb>0 THEN rest:=TRUE ELSE acked:=-rb END;
      IF rest THEN
        acked:=0;
        INC(j);
      END;
    END;
    sock^.qwatch.qsize:=j;
    IF sock^.qwatch.qsize<=HIGH(sock^.qwatch.txbyte) THEN
      sock^.qwatch.txbyte[sock^.qwatch.qsize]:=sent;
      INC(sock^.qwatch.qsize);
      IF sock^.qwatch.qsize>qmaxtime THEN 
        tcp.stoptxrx(sock^.fd, 2);                          (* delete unsent data *)
        saybusy(sock^.fd, CR+LF);                           (* close tcp immediately *) 
        sock^.slowlink:=TRUE;                               (* for log message *)
      END;
    END;
  END;
  sock^.qwatch.lastqb:=qb;
  sock^.qwatch.lasttb:=sock^.txbytes;
END WatchTXQ;






VAR listensock,
    wwwsock               : INTEGER;
    mbuf                  : FRAMEBUF;
    res, i                : INTEGER;
    acttcp, acttmp        : pTCPSOCK;
    actudp                : pUDPSOCK;
    usercnt, lenh         : CARDINAL; 
    poscall               : POSCALL;
    rfhered               : BOOLEAN;
    keepconn, lasttime    : TIME;

PROCEDURE addsock(fd:INTEGER; wtoo:BOOLEAN);                (* insert socket in fdset for select *)
BEGIN
  IF fd>=0 THEN
    fdsetr(fd);
    IF wtoo THEN fdsetw(fd) END;
  END;
END addsock;



BEGIN
<*IF MSG THEN*>

  rfdestcall:="RFONLY";
  netdestcall:="NOGATE";
  viacall[0]:=0C;
  nettorfpath[0]:=0C;
  heardtime:=7200;
  heardtimew:=86400;
  heardtimevia:=1800;

  purgemsg:=86400;
  purgeacked:=86400;
  purgeunack:=3600;
  purgeunacksent:=30;
  gateconndelay:=GATECONNDELAY;
  msgsendtime:=3600*6;

  rfquiet:=10;
  maxatonce:=2;
  maxmsg:=1000;
  messages:=NIL;
  hearddir:=NIL;
  heardvia:=NIL;
  lastrfsent:=0;
  sendnetmsg:=TRUE;
  mhfilelines:=0;
<*END*>

  FILL(ADR(gateways), 0C, SIZE(gateways));
  qmaxtime:=15;
  ungates[gUNGATE]:="";
  ungates[gRFONLY]:="RFONLY";
  ungates[gNOGATE]:="NOGATE";
  ungates[gTCPIP]:="TCPIP";
  ungates[gTCPXX]:="TCPXX";
  ungates[gQ]:="q";
  dupetime:=60;
  lastdnstime:=0;
  netbeaconfn[0]:=0C;
  maxusers:=50;
  logframename[0]:=0C;
  rawlogname[0]:=0C;
  logframes:=6;  
  tcpbindport[0]:=0C;
  servercall[0]:=0C; 
  passwd[0]:=0C;
  serverrangefilter[0]:=0C;
  actfilter[0]:=0C;
  rfhered:=FALSE;
  wwwbindport:="";
  wwwdir[0]:=0C;
  wwwsizelimit:=1024*1024;
  udpsocks:=NIL;
  callsrc:=FALSE;
  qas:=0;
  qasc:=0;
  parms;

<*IF MSG THEN*>
  IF StrCmp(viacall,"-") THEN viacall[0]:=0C
  ELSIF viacall[0]=0C THEN viacall:=servercall END;
  msghttpcount:=0;
  mhhttpcount:=0;
  netmhout:=0;
  netmhin:=0;
<*END*>

  Assign(ungates[MIN(GATEFILT)], servercall);
  systime:=time(); 
  uptime:=systime;
  udpdonetime:=systime;
  keepconn:=0;
  trygate:=0;
  httpcount:=0;

  Netbeacon(mbuf, FALSE, TRUE);
(*
  i:=0; WHILE (i<HIGH(mbuf)-1) & (mbuf[i]<>":") DO INC(i) END; 
  IF verb THEN WrLn; WrStrLn(mbuf) END;;
  GetPos(home, vspeed, vcourse, valt, vsym, vsymt, mbuf, 0, i+1, compos, postyp); (* find server position *) 
*)  
  listensock:=-1;
  wwwsock:=-1;
  tcpsocks:=NIL;

  LOOP
    systime:=time();
    IF systime<>lasttime THEN
      IF (listensock<0) & (tcpbindport[0]<>0C) THEN            (* open listensocket tcp connects *)
        listensock:=tcp.waitconnect(tcpbindport,APRSLISTENSOCKS);
        IF verb & (listensock<0) THEN WrStr("cant bind to port "); WrStrLn(tcpbindport) END;  
      END;
      IF (wwwsock<0) & (wwwbindport[0]<>0C) THEN               (* open listensocket www connects *)
        wwwsock:=tcp.waitconnect(wwwbindport,WWWLISTENSOCKS);
        IF verb & (wwwsock<0) THEN WrStr("cant bind to port "); WrStrLn(wwwbindport) END;
      END;
    END;

    fdclr;

    actudp:=udpsocks;
    WHILE actudp<>NIL DO addsock(actudp^.fd, FALSE); actudp:=actudp^.next END;
    addsock(listensock, FALSE);
    addsock(wwwsock, FALSE);

    IF systime<>lasttime THEN                                (* once a second is enough *)  
<*IF MSG THEN*>
      RfTimer;
      SendNet;
      IF mhfilelines>0 THEN MHtoFile END;
<*END*>
      rfhered:=(keeptime=0) OR (keepconn>systime);
      acttcp:=tcpsocks;
      WHILE acttcp<>NIL DO
        WITH acttcp^ DO
          IF beacont<systime THEN Timebeacon(acttcp) END;

          IF service=cISGATEWAY THEN 
            IF (keeptime>0) & (keepconn<=systime) THEN saybusy(fd, "# timeout"+CR+LF);
            ELSIF qmaxtime>0 THEN WatchTXQ(acttcp) END;

          ELSIF service=cISWWW THEN
            IF connt=0 THEN connt:=systime
            ELSIF connt+HTTPTIMEOUT<systime THEN saybusy(fd, "timeout"+CR+LF) END;

          ELSIF service=cISSERVER THEN 
            KillDoubleUser(acttcp); 
            keepconn:=systime+keeptime;                          (* connect to gateway *)
          END;

          acttcp:=next;
        END; 
      END;
    END;
    IF systime<>lasttime THEN
      IF rfhered THEN Gateconn(tcpsocks) ELSE trygate:=0 END;
    END;
    lasttime:=systime;

    usercnt:=0;
    acttcp:=tcpsocks;
    WHILE acttcp<>NIL DO
      addsock(acttcp^.fd, (acttcp^.tlen>0) OR (acttcp^.txbuf<>NIL));
      INC(usercnt);
      acttcp:=acttcp^.next;
    END;
    mbuf[0]:=0C;
    res:=selectrw(2, 0);

    IF (listensock>=0) & issetr(listensock) THEN
      res:=SIZE(mbuf);
      res:=tcp.acceptconnect(listensock, mbuf, res);
      IF res>=0 THEN 
        IF (usercnt>=maxusers) OR NOT tcpconn(tcpsocks, res, cISSERVER) 
        THEN saybusy(res, "# server full"+CR+LF) END;
      END;
    END;

    IF (wwwsock>=0) & issetr(wwwsock) THEN
      res:=SIZE(mbuf);
      res:=tcp.acceptconnect(wwwsock, mbuf, res);
      IF res>=0 THEN
        IF (usercnt>=maxusers+1) OR NOT tcpconn(tcpsocks, res, cISWWW) 
        THEN saybusy(res, "server full"+CR+LF) END;
      END;
    END;

    systime:=time();
    actudp:=udpsocks;
    i:=1; 
    WHILE actudp<>NIL DO
      IF issetr(actudp^.fd) THEN
        WHILE getudp(actudp, mbuf) DO
          IF systime<udpdonetime+MAXINTERNALDELAY THEN (* last time all data read is no too long *)
            res:=AprsIs(mbuf, GFILTSET{gUNGATE, gRFONLY, gNOGATE, gTCPIP, gTCPXX, gQ},
                        GFILTSET{gUNGATE, gRFONLY, gNOGATE, gTCPIP, gTCPXX, gQ}, 0C, i, FALSE, poscall);
            IF res>=0 THEN
              Sendall(mbuf, 0, poscall); 
              keepconn:=systime+keeptime;                              (* connect to gateway *)
            END;
          ELSE                                                         (*task was blocked too long *)
            IF verb THEN WrStrLn("AXUDP-frames thrown away - too long program delay") END;
            logline(1, "Frame discarded - too long program delay");
          END;
          IF verb OR (logframes>1) THEN showframe(res, NIL, actudp, mbuf, poscall.pos) END;
        END;
      END;
      INC(i);
      actudp:=actudp^.next;
    END;
    udpdonetime:=time();                              (* store realtime of last all read input *)

    acttcp:=tcpsocks;
    WHILE acttcp<>NIL DO  

      IF (acttcp^.fd>=0) & issetw(acttcp^.fd) THEN
        WITH acttcp^ DO
          IF service=cISWWW THEN Wwwtx(acttcp) 
          ELSE
            res:=tcp.sendsock(fd, tbuf, tlen);
            IF res>0 THEN
              FOR i:=res TO tlen-1 DO tbuf[i-res]:=tbuf[i] END;
              DEC(tlen,res); 
              IF connt=0 THEN connt:=systime END;
            ELSE tlen:=0 END;                        (* should not happen *)
          END;
        END;
      END;

      IF (acttcp^.fd>=0) & issetr(acttcp^.fd) THEN
        IF acttcp^.service=cISWWW THEN Www(acttcp); 
        ELSE
          LOOP
            res:=Gettcp(acttcp^.fd, mbuf, acttcp^.rbuf, acttcp^.rpos);
            IF res<0 THEN
              Close(acttcp^.fd);
              acttcp^.fd:=-1;
              EXIT
            END;
            IF res<=0 THEN EXIT END;
            INC(acttcp^.rxframes);
            lenh:=Length(mbuf);
            INC(acttcp^.rxbytes, lenh); IF acttcp^.rxbytes<lenh THEN INC(acttcp^.rxbytesh) END;

            IF acttcp^.valid OR (acttcp^.service=cISGATEWAY) OR NOT Auth(mbuf, acttcp) THEN 
              IF mbuf[0]="#" THEN GetFilters(acttcp^.filters, mbuf, 1); res:=-7
              ELSE res:=AprsIs(mbuf, GFILTSET{gUNGATE, gRFONLY},
                               GFILTSET{gUNGATE, gRFONLY, gNOGATE, gTCPXX},
                               acttcp^.user.call, 0, acttcp^.valid, poscall) END;
              IF posvalid(poscall.pos) & StrCmp(poscall.call, acttcp^.user.call) THEN 
                acttcp^.user.pos:=poscall.pos; 
              END;
              IF acttcp^.valid THEN
                IF res>=0 THEN Sendall(mbuf, acttcp^.fd, poscall) END;      
                IF verb OR (logframes>1) THEN showframe(res, acttcp, NIL, mbuf, poscall.pos) END;
              END;
            END;
          END;
        END; 
      END;

      IF acttcp^.fd<0 THEN                                                (* connection lost *)
        IF (acttcp^.connt<>0) & (acttcp^.service<>cISWWW) THEN showlogout(acttcp) END;

        closetcp(acttcp, TRUE);                                           (* free www buffers *)
        IF acttcp=tcpsocks THEN tcpsocks:=tcpsocks^.next;
        ELSE
          acttmp:=tcpsocks;
          WHILE acttmp^.next<>acttcp DO acttmp:=acttmp^.next END;
          acttmp^.next:=acttcp^.next;
        END;
        DEALLOCATE(acttcp, SIZE(acttcp^));
        acttcp:=tcpsocks;

      ELSE acttcp:=acttcp^.next END;  

    END;
  END;
END udpgate4.
