<*+M2EXTENSIONS *>
<*-CHECKDIV *>
<*-CHECKRANGE *>
<*-COVERFLOW *>
<*-IOVERFLOW*>
<*-PROCINLINE*>
<*+NOPTRALIAS*>
<*-GENHISTORY*>
<*-CHECKNIL *>
<*-GENDEBUG*>
<*-LINENO*>
<*-CHECKINDEX*>
<*-CHECKDINDEX *>
<*-CHECKSET*>
<*CPU="PENTIUM"*>
<*+COMMENT*>
<* IF __GEN_C__ THEN *>
  <*+GENCTYPES*>
<* END *>

MODULE udphub; (* axudp bidirectional digi - user hub by OE5DXL *)

FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM osi IMPORT WrInt, WrLn, WrStr, WrStrLn;
IMPORT udp, Select;
FROM SYSTEM IMPORT CAST, ADR, CARD8, ADDRESS;
FROM Lib IMPORT NextArg;
FROM TimeConv IMPORT time; 
(*
FROM FIO IMPORT OpenMode, Close, oRDONLY, oAPPEND, oWRONLY, oNONBLOCK, Create, WrBin, RdBin, File;
*)
CONST CALLLEN=7;
      MAXLEN=256+7*10+10+2;
      MINLEN=7*2+1+2;
      POLYNOM=BITSET{3,10,15};
      CRCINIT=BITSET{0..15};
      SOURCECALL=CALLLEN;
      DESTCALL=0;
      MAXFD=31;

TYPE  UDPPORT=CARDINAL;
      IPNUM=CARDINAL;
      TIME=CARDINAL;
      SET8=SET OF [0..7];
      RAWCALL=ARRAY[0..CALLLEN-1] OF CHAR; 
      FILENAME=ARRAY[0..1023] OF CHAR;
      FDSET=SET OF [0..MAXFD];
      TIMEVAL=RECORD
                tvsec : INTEGER;
                tvusec: INTEGER;
              END;

      pUSER=POINTER TO USER;
      USER=RECORD
        next       : pUSER;
        call       : RAWCALL;
        uip        : IPNUM;
        dport      : UDPPORT;
        htime      : TIME;
      END;


VAR CRCL, CRCH            : ARRAY[0..255] OF SET8;
    show, checkdigiip     : BOOLEAN;
    users                 : pUSER;
    systime, lifetime     : TIME;
    touserport,
    todigiport            : UDPPORT;
    digiip                : IPNUM;
    digisock, usersock    : INTEGER;
    maxentries            : CARDINAL;

(*
PROCEDURE ["C"] / select(n: INTEGER; readfds: ADDRESS; writefds: ADDRESS;
                         exceptfds: ADDRESS; timeout: ADDRESS) : INTEGER;
*)

PROCEDURE Err(text-:ARRAY OF CHAR);
BEGIN
  WrStr("udphub: "); WrStr(text); WrStrLn(" error abort");
  HALT
END Err;


PROCEDURE Gencrctab;
CONST POLINOM=08408H;
VAR i,crc,c:CARDINAL;
BEGIN
  FOR c:=0 TO 255 DO
    crc:=255-c;
    FOR i:=0 TO 7 DO
      IF ODD(crc) THEN crc:=CAST(CARDINAL, CAST(BITSET, ASH(crc, -1))/CAST(BITSET,POLINOM))
      ELSE crc:=ASH(crc, -1) END;
    END;
    CRCL[c]:=CAST(SET8, crc);
    CRCH[c]:=CAST(SET8, 255 - ASH(crc, -8));
  END;
END Gencrctab;


PROCEDURE testCRC(VAR frame:ARRAY OF CHAR; size:INTEGER):BOOLEAN;
VAR l,h:SET8;
    b:CARD8;
    i:INTEGER;
BEGIN
  l:=SET8{};
  h:=SET8{};
  FOR i:=0 TO size-3 DO
    b:=CAST(CARD8, CAST(SET8, frame[i]) / l);
    l:=CRCL[b] / h;
    h:=CRCH[b];
  END;
  RETURN (frame[size-2]=CAST(CHAR, l)) & (frame[size-1]=CAST(CHAR, h))
END testCRC;


PROCEDURE getudp(fd:INTEGER; VAR buf:ARRAY OF CHAR; VAR fromip:IPNUM; VAR fromport:UDPPORT; checkip:BOOLEAN):INTEGER;
VAR ip:IPNUM;
    len:INTEGER;
BEGIN
  len:=udp.udpreceive(fd, buf, SIZE(buf), fromport, ip);
  IF (len<2) OR NOT testCRC(buf,len) THEN
    IF show THEN WrStrLn(" axudp crc error ") END;
    RETURN -1
  END;
  IF checkip & (fromip<>ip) THEN RETURN -2 END;
  fromip:=ip;
  RETURN len
END getudp; 


PROCEDURE Call2Str(r-:ARRAY OF CHAR; VAR t:ARRAY OF CHAR; pos:CARDINAL; VAR len:CARDINAL):BOOLEAN;
VAR i,e,ssid:CARDINAL;
    c:CHAR;
BEGIN
  e:=pos;
  FOR i:=pos TO pos+5 DO 
    IF r[i]<>100C THEN e:=i END;
  END; 
  FOR i:=pos TO e DO 
    c:=CHR(ASH(ORD(r[i]), -1));
    IF c<=" " THEN t[len]:=0C; len:=0; RETURN FALSE END;
    t[len]:=c;
    INC(len);
  END;
  ssid:=ASH(ORD(r[pos+6]), -1) MOD 16;
  IF ssid>0 THEN 
    t[len]:="-"; INC(len); 
    IF ssid>9 THEN t[len]:="1"; INC(len); END;
    t[len]:=CHR(ssid MOD 10 + ORD("0")); INC(len);
  END;
  RETURN TRUE
END Call2Str;



PROCEDURE GetIp(h:ARRAY OF CHAR; VAR ip:IPNUM; VAR dp, lp:UDPPORT; VAR fd:INTEGER; VAR check:BOOLEAN):INTEGER;
VAR i,n,p:CARDINAL;
    ok:BOOLEAN;
BEGIN
  p:=0;
  h[HIGH(h)]:=0C;
  ip:=0;
  FOR i:=0 TO 5 DO
    n:=0;
    ok:=FALSE;
    WHILE (h[p]>="0") & (h[p]<="9") DO
      ok:=TRUE;
      n:=n*10+ORD(h[p])-ORD("0");
      INC(p);
    END;
    IF NOT ok THEN RETURN -1 END;
    IF i<3 THEN
      IF (h[p]<>".") OR (n>255) THEN RETURN -1 END;
      ip:=ip*256+n;
    ELSIF i=3 THEN
      ip:=ip*256+n;
      IF (h[p]<>":")OR (n>255) THEN RETURN -1 END;
    ELSIF i=4 THEN
      check:=h[p]<>"/";
      IF (h[p]<>":") & (h[p]<>"/") OR (n>65535) THEN RETURN -1 END;
      dp:=n;
    ELSIF n>65535 THEN RETURN -1 END;
    lp:=n;
    INC(p);
  END;  

  fd:=udp.openudp();
  IF (fd<0) OR (udp.bindudp(fd, lp)<0) (*OR (udp.udpnonblock(fd)<0)*) THEN RETURN -1 END;
  RETURN 0
END GetIp;

PROCEDURE GetNum(h-:ARRAY OF CHAR; VAR n:CARDINAL):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  n:=0;
  i:=0;
  WHILE (h[i]>="0") & (h[i]<="9") DO
    n:=n*10+ORD(h[i])-ORD("0");
    INC(i);
  END;
  RETURN h[i]=0C
END GetNum;


PROCEDURE parms;
VAR err:BOOLEAN;
    h:ARRAY[0..1023] OF CHAR;
    VAR i:CARDINAL;
    fromdigiport:UDPPORT;
BEGIN
  err:=FALSE;
  LOOP
    NextArg(h);
    IF h[0]=0C THEN EXIT END;
    IF (h[0]="-") & (h[1]<>0C) & (h[2]=0C) THEN

      IF h[1]="l" THEN
        NextArg(h);
        IF NOT GetNum(h, i) THEN Err("-l minutes") END;
        lifetime:=i*60;

      ELSIF h[1]="m" THEN
        NextArg(h);
        IF NOT GetNum(h, maxentries) THEN Err("-m number") END;

      ELSIF h[1]="p" THEN 
        NextArg(h);
        IF NOT GetNum(h, touserport) THEN Err("-p portnumber") END;

      ELSIF h[1]="u" THEN 
        NextArg(h);
        IF GetIp(h, digiip, todigiport, fromdigiport, digisock, checkdigiip)<0 THEN 
          Err("cannot open digi udp socket");
        END;

      ELSIF h[1]="v" THEN show:=TRUE;

      ELSIF h[1]="h" THEN
        WrLn;
        WrStrLn(" -l <time>                         minutes lifetime (default 1 week)");
        WrStrLn(" -m <maxentries>                   else delete old entries (default 1000)");
        WrStrLn(" -p <userport>                     udp port for users"); 
        WrStrLn(" -u <x.x.x.x:destport:listenport>  axudp to digi /listenport no check ip");
        WrStrLn(" -v                                verbous");
        WrStrLn(" -h                                this");
        WrLn;
        HALT

      ELSE err:=TRUE END;
(*
      h[0]:=0C;
*)
    ELSE err:=TRUE END;
    IF err THEN EXIT END;
  END;
  IF err THEN WrStr(">"); WrStr(h); WrStrLn("< use -h"); HALT END;
END parms;




PROCEDURE showpip(ip:IPNUM; port:UDPPORT);
BEGIN
  WrInt(ip DIV 1000000H,1); WrStr(".");
  WrInt(ip DIV 10000H MOD 100H ,1); WrStr(".");
  WrInt(ip DIV 100H MOD 100H ,1); WrStr(".");
  WrInt(ip MOD 100H ,1); WrStr(":");
  WrInt(port, 1);
END showpip;


PROCEDURE showcall(b-:ARRAY OF CHAR; start:CARDINAL);
VAR h:ARRAY[0..15] OF CHAR;
    l:CARDINAL;
BEGIN
   l:=0;
   IF Call2Str(b, h, start, l) THEN h[l]:=0C; WrStr(h) END;
END showcall;

PROCEDURE showframe(s-, b-:ARRAY OF CHAR);
BEGIN
  WrStr(s); showcall(b, 7); WrStr(">"); showcall(b, 0); WrLn;
END showframe;



PROCEDURE cmpcall(c-:RAWCALL; b-:ARRAY OF CHAR; start:CARDINAL):BOOLEAN;
VAR i:CARDINAL;
BEGIN
  FOR i:=0 TO 5 DO
    IF c[i]<>b[i+start] THEN RETURN FALSE END;
  END;
  RETURN ORD(c[6]) DIV 2 MOD 16=ORD(b[start+6]) DIV 2 MOD 16
END cmpcall;


PROCEDURE Realloc():pUSER;
VAR cnt:CARDINAL;
    u, last, new:pUSER;
BEGIN
  cnt:=0;
  last:=NIL;
  new:=NIL;
  u:=users;
  LOOP
    IF u=NIL THEN EXIT END;
    IF (u^.htime+lifetime<systime) OR (cnt>=maxentries) THEN   (* old oder too much entries *)
      IF last=NIL THEN users:=NIL ELSE last^.next:=NIL END;    (* break chain here *)
      REPEAT                                                   (* free rest of chain *) 
        last:=u;
        u:=u^.next;
        IF new=NIL THEN new:=last ELSE DEALLOCATE(last, SIZE(last^)) END; (* reuse 1 entry *)
      UNTIL u=NIL;
      EXIT;
    END;
    last:=u;
    u:=u^.next;
    INC(cnt);
  END;
  IF new=NIL THEN ALLOCATE(new, SIZE(new^)) END;
  IF show THEN WrStr(" Table entries="); WrInt(cnt, 1); WrLn; END;
  RETURN new
END Realloc;


PROCEDURE AddIp(ip:IPNUM; dp:UDPPORT; buf-:ARRAY OF CHAR);
VAR u, last:pUSER;
    i:CARDINAL;
BEGIN
  u:=users;
  last:=NIL;
  WHILE u<>NIL DO
    IF cmpcall(u^.call, buf, SOURCECALL) THEN  
      IF last<>NIL THEN 
        last^.next:=u^.next;
        u^.next:=users;
        users:=u;
      END;                                         (* for fast find, rechain to first position*)
      WITH u^ DO
        htime:=systime;
        uip:=ip;                                                     (* store if ip changed *)
        dport:=dp;
      END;
      IF show THEN
        WrStr("Found User "); showcall(buf, SOURCECALL);
        WrStr(" IP:"); showpip(u^.uip, dp); WrLn;
      END;

      RETURN 
    END;
    last:=u;
    u:=u^.next;
  END;

  IF u=NIL THEN

    IF show THEN
      WrStr("Add User "); showcall(buf, SOURCECALL);
      WrStr(" IP:"); showpip(ip, dp); WrLn;
    END;

    u:=Realloc();
    IF u=NIL THEN
      IF show THEN WrStrLn(" user add out of memory") END; 
    ELSE
      WITH u^ DO
        FOR i:=0 TO HIGH(call) DO call[i]:=buf[SOURCECALL+i] END; 
        call[HIGH(call)]:=CHR(ORD(call[HIGH(call)]) DIV 2 MOD 16*2);      (* extract pure ssid *)
        uip:=ip;
        dport:=dp;
        htime:=systime;
      END;
      u^.next:=users;
      users:=u;
    END;
  END;
END AddIp;

PROCEDURE FindIp(VAR toip:IPNUM; VAR toport:UDPPORT; buf-:ARRAY OF CHAR):BOOLEAN;
VAR u:pUSER;
BEGIN
  u:=users;
  WHILE u<>NIL DO
    IF cmpcall(u^.call, buf, DESTCALL) THEN toip:=u^.uip; toport:=u^.dport; RETURN TRUE END;
    u:=u^.next;                              
  END;
  RETURN FALSE
END FindIp;


 
VAR 
    ubuf                  : ARRAY[0..MAXLEN-1] OF CHAR;
    blen, res             : INTEGER;
    fromip, toip          : IPNUM;
    userdport             : UDPPORT;

BEGIN
  Gencrctab;

  show:=FALSE;
  touserport:=0;
  digisock:=-1;
  maxentries:=1000;
  lifetime:=3600*24*7;
  parms;

  IF digisock<0 THEN Err("need -u parameter") END;
  users:=NIL;

  usersock:=udp.openudp();
  IF (touserport=0) OR (usersock<0) OR (udp.bindudp(usersock, touserport)<0) THEN 
    Err("cannot bind userport (-p userport)");
  END;
  systime:=time();

  LOOP
    Select.fdclr;
    Select.fdsetr(digisock);
    Select.fdsetr(usersock);
    IF Select.selectrw(10 ,0)>0 THEN
      IF Select.issetr(digisock) THEN                                  (* data from digi *)
        fromip:=digiip;
        blen:=getudp(digisock, ubuf, fromip, userdport, checkdigiip);
        IF blen>=MINLEN THEN
          IF show THEN showframe("from digi ", ubuf) END; 
          IF FindIp(toip, userdport, ubuf) THEN
            res:=udp.udpsend(usersock, ubuf, blen, userdport, toip);
          ELSIF show THEN WrStrLn(" digi out user not found") END;
        END;
      END;
      IF Select.issetr(usersock) THEN                            (* data from user *)
        fromip:=0;
        blen:=getudp(usersock, ubuf, fromip, userdport, FALSE);
        IF blen>=MINLEN THEN
          IF show THEN showpip(fromip, touserport); showframe(" from user ", ubuf) END;
          AddIp(fromip, userdport, ubuf);
          res:=udp.udpsend(digisock, ubuf, blen, todigiport, digiip);
        END;
      END;
    ELSE systime:=time() END;
  END;
END udphub.
